SystemOrganization addCategory: #'Tweak-Widgets-Basic'!
SystemOrganization addCategory: #'Tweak-Widgets-Basic-Costumes'!
SystemOrganization addCategory: #'Tweak-Widgets-Behaviors'!
SystemOrganization addCategory: #'Tweak-Widgets-Buttons'!
SystemOrganization addCategory: #'Tweak-Widgets-Buttons-Costumes'!
SystemOrganization addCategory: #'Tweak-Widgets-EToy'!
SystemOrganization addCategory: #'Tweak-Widgets-FileDialog'!
SystemOrganization addCategory: #'Tweak-Widgets-FileDialog-Costumes'!
SystemOrganization addCategory: #'Tweak-Widgets-Halo'!
SystemOrganization addCategory: #'Tweak-Widgets-Lists'!
SystemOrganization addCategory: #'Tweak-Widgets-Lists-Costumes'!
SystemOrganization addCategory: #'Tweak-Widgets-Menus'!
SystemOrganization addCategory: #'Tweak-Widgets-Menus-Costumes'!
SystemOrganization addCategory: #'Tweak-Widgets-Misc'!
SystemOrganization addCategory: #'Tweak-Widgets-Obsolete'!
SystemOrganization addCategory: #'Tweak-Widgets-Scrolling'!
SystemOrganization addCategory: #'Tweak-Widgets-Scrolling-Costumes'!
SystemOrganization addCategory: #'Tweak-Widgets-Sprites'!
SystemOrganization addCategory: #'Tweak-Widgets-Support'!
SystemOrganization addCategory: #'Tweak-Widgets-Text'!
SystemOrganization addCategory: #'Tweak-Widgets-Text-Converters'!
SystemOrganization addCategory: #'Tweak-Widgets-Text-Costumes'!
SystemOrganization addCategory: #'Tweak-Widgets-Trees'!
SystemOrganization addCategory: #'Tweak-Widgets-Trees-Costumes'!

CHolder subclass: #CEToyHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-EToy'!

!CEToyHolder commentStamp: 'sw 4/28/2005 01:25' prior: 0!
A custom UI widget corresponding to the "Holder" of the Morphic-based etoy systems of 1997-2005.!

CEToyHolder defineFields: '<?xml  version="1.0" ?>
<fields>
	<field virtual="true" serializable="false" toGet="firstElement" toSet="firstElement:">firstElement</field>
	<field virtual="true" serializable="false" toGet="lastElement" toSet="lastElement:">lastElement</field>
	<field virtual="true" serializable="false" toGet="graphicAtCursor" toSet="graphicAtCursor:">graphicAtCursor</field>
	<field virtual="true" serializable="false" toGet="numberAtCursor" toSet="numberAtCursor:">numberAtCursor</field>
	<field virtual="true" serializable="false" toGet="playerAtCursor" toSet="playerAtCursor:">playerAtCursor</field>
</fields>'!

!CEToyHolder class methodsFor: 'instance creation' stamp: 'sw 5/17/2005 18:16'!
newSample
	"Answer a new sample instance"

	| sample |
	sample := self new.
	sample color:  (Color r: 1.0 g: 0.907 b: 0.767).
	sample borderWidth: 1.
	sample borderColor: (Color r: 1.0 g: 0.612 b: 0.03).
	sample extent: (160@110).
	^ sample! !

!CEToyHolder methodsFor: 'utilities' stamp: 'sw 5/17/2005 03:07'!
acceptableCursorFrom: proposedCursor
	"Answer an acceptable cursor value, respecting the wrapCursor flag"

	| aSize acceptableCursor |
	acceptableCursor := proposedCursor.
	aSize := self collection size.
	self wrapCursor
		ifTrue:
			[proposedCursor > aSize ifTrue: [acceptableCursor := 1].
			proposedCursor <= 0 ifTrue: [acceptableCursor := aSize]]
		ifFalse:
			[[acceptableCursor > aSize] whileTrue: [acceptableCursor := acceptableCursor - aSize].  "honor fractional acceptbleValue values"
			acceptableCursor < 1 ifTrue: [acceptableCursor := 1]].  "but seemingly  not for  negatives???"

	^ acceptableCursor! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 5/17/2005 05:05'!
cursor: aValue
	"Set the receiver's cursor."

	| acceptableValue |
	acceptableValue := self acceptableCursorFrom: aValue.
	super cursor: acceptableValue.
	self signal: #cursorChanged! !

!CEToyHolder methodsFor: 'display' stamp: 'sw 5/17/2005 18:16'!
drawOn: aCanvas in: box
	"Draw the receiver on the canvas in the given box"

	|  item index |
	super drawOn: aCanvas in: box.		"border & background"
	
	elements size > 0 ifTrue:
			[index := ((cursor asInteger - 1) \\ (elements size)) + 1.
			item := elements at: index.
			aCanvas frameRectangle: (item bounds insetBy: -2) width: 1 color: Color blue darker]
! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 5/17/2005 05:35'!
firstElement
	"Answer the firstElement of the receiver"

	^ self collection at: 1 ifAbsent: [nil]
	
! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 4/28/2005 03:45'!
firstElement: aPlayer
	"Make the receiver's first element be the given object"

	 self addFirst: aPlayer.
	^ aPlayer! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 5/17/2005 12:56'!
graphicAtCursor
	"Answer the graphicAtCursor of the receiver"
	
	| aPlayer |
	aPlayer := self playerAtCursor.
	^ aPlayer ifNotNil:
		[aPlayer asForm]! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 5/17/2005 15:38'!
graphicAtCursor: aValue
	"Modify the receiver's graphicAtCursor"

	"Not well defined at the moment"! !

!CEToyHolder methodsFor: 'initialization' stamp: 'sw 5/17/2005 05:02'!
initialize
	"Initialize the holde"

	super initialize.
	self userDraw: true.
	self color:  (Color r: 1.0 g: 0.907 b: 0.767).
	self borderStyle: #simple.
	self borderWidth: 2.
	self borderColor: (Color r: 1.0 g: 0.612 b: 0.03).
	self extent: (160@54).

	layout := CTableLayout new.
	layout listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		hResizing: #rigid;
		vResizing: #shrinkWrap;
		layoutInset: 6@6;
		cellInset: 6.

	name := 'Holder' translated

! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 5/17/2005 05:31'!
lastElement
	"Answer the lastElement of the receiver"

	^ self collection at: self collection size ifAbsent: [nil]
	
! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 4/28/2005 03:45'!
lastElement: aPlayer
	"Set the receiver's lastElement"

	self addLast: aPlayer.
	^ aPlayer! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 5/17/2005 04:28'!
numberAtCursor
	"Answer the numberAtCursor of the receiver.  Answer 0 for messy conditions."
	
	cursor = 0 ifTrue: [^ 0].
	^ (self collection at: cursor asInteger ifAbsent: [^ 0]) numericValue.
! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 4/28/2005 03:52'!
numberAtCursor: aValue
	"Set the receiver's numberAtCursor"

	self playerAtCursor ifNotNilDo:
		[:aPlayer |
			aPlayer numericValue: aValue].
	^ aValue! !

!CEToyHolder methodsFor: 'events' stamp: 'sw 5/17/2005 13:02'!
onCursorChanged
	"When the cursor has changed, get the display right, and make sure my virtual fields are updated in case any open viewers care."

	<on: cursorChanged>

	self rectifyCursor.
	self invalidate.
	self signal: #playerAtCursorChanged.
	self signal: #numberAtCursorChanged.
	self signal: #graphicAtCursorChanged.
	self signal: #firstElementChanged.
	self signal: #lastElementChanged! !

!CEToyHolder methodsFor: 'events' stamp: 'sw 5/17/2005 04:12'!
onDragLeave: event
	"Try to clean up mouse turds l left by my cursor feedback when an object is grabbed from my interior" 
	<on: dragLeave>
	self invalidate.
	self signal: #cursorChanged! !

!CEToyHolder methodsFor: 'events' stamp: 'sw 5/17/2005 05:30'!
onDrop: aPlayer
	"Upon drop over me, accept the proffered player"

	<on: dragDrop>
	self add: aPlayer.
	aPlayer signal: #dropAccept with: self.
	self rectifyCursor.

"The above is per a pattern suggested by Bert.  Andreas's suggestion, with comment 	'not sure if this is right, might be composedWithGlobal:...' was:

MyPlayer>>onDrop: aPlayer
	<on: dragDrop>

	tfm := self globalToLocal composedWithLocal: aPlayer localToGlobal.
	aPlayer tranform: tfm.
	self add: aPlayer.
	aPlayer signal: #dropAccept with: self."

! !

!CEToyHolder methodsFor: 'events' stamp: 'sw 5/17/2005 18:16'!
onMouseDown
	"Handle a mouse-down"

	<on: mouseDown>

	(self findPlayerAt: self cursorPoint) ifNotNilDo:
		[:aPlayer | hand grab: aPlayer]
! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 5/17/2005 05:31'!
playerAtCursor
	"Answer the playerAtCursor of the receiver"
	
	^ self collection at: cursor asInteger ifAbsent: [nil]! !

!CEToyHolder methodsFor: 'accessing' stamp: 'sw 5/17/2005 05:34'!
playerAtCursor: aValue
	"Set the receiver's playerAtCursor.  But what exactly would this mean? Replace the current playerAtCursor with a different player?  Move the cursor so that it points the the given player?  Still open for debate; at present does nothing."
	
	! !

!CEToyHolder methodsFor: 'utilities' stamp: 'sw 5/17/2005 03:38'!
rectifyCursor
	"Force the cursor within accepable range."

	| existing |
	existing := cursor.
	cursor := self acceptableCursorFrom: cursor.
	cursor ~= existing ifTrue: [self invalidate]
	! !

CHolder subclass: #CList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

!CList commentStamp: 'tk 10/31/2004 11:08' prior: 0!
A List is the basic way to show a list of choices.  It carries its own list of items which (contrary to its elements) can be shared with another object.  This allows a list to automatically provide a view of an arbitrary collection.  
A List can have an itemMaker to specify how the items will be shown.  By default a CListItem is used which merely uses the #displayText representation of the object.  A different itemMaker could display the items as images.

### Allow Users to see the above explanation ###

To implement a new kind of list item, all that needs to be provided is a player which can take a value to display (see also CListItem). If more complex behavior is required (for example to treat the list as a set of costumes) the itemMaker can implement #listItemValue: to handle the request for displaying the particular value (see CPlayer>>listItemValue:).!

CList subclass: #CDropDownList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

!CDropDownList commentStamp: 'ar 4/21/2005 21:10' prior: 0!
A DropDownList presents the user with an input field and a drop down list.  When the user selects an item, the list's selection and its value will change to the selected item.  If the list is editable, then the user can type into the input field.  However, upon accepting the input, the list will NOT automatically add the new accepted value. To achieve this behavior use something like here:

onListValueAccept
	"The user accepted input the drop down list. Add the new item to list."
	<on: accept in: dropDownList>
	dropDownList add: dropDownList value.

### Allow Users to see the above explanation ###!

CDropDownList defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="allowEditing" toSet="allowEditing:" changeEvent="allowEditingChanged">allowEditing</field>
	<field toGet="autoRevert" toSet="autoRevert:" changeEvent="autoRevertChanged">autoRevert</field>
	<field toGet="autoAccept" toSet="autoAccept:" changeEvent="autoAcceptChanged">autoAccept</field>
	<field toGet="converter" toSet="converter:" changeEvent="converterChanged">converter</field>
</fields>'!

!CDropDownList methodsFor: 'accessing' stamp: 'ar 12/19/2004 20:50'!
allowEditing
	"Answer the allowEditing of the receiver"
	<bewareOf: #allowEditingChanged>
	^self propertyValueAt: #allowEditing! !

!CDropDownList methodsFor: 'accessing' stamp: 'ar 12/19/2004 20:50'!
allowEditing: aValue
	"Modify the receiver's allowEditing"
	^self propertyValueAt: #allowEditing put: aValue with: #allowEditingChanged! !

!CDropDownList methodsFor: 'accessing' stamp: 'ar 12/19/2004 20:50'!
autoAccept
	"Answer the autoAccept of the receiver"
	<bewareOf: #autoAcceptChanged>
	^self propertyValueAt: #autoAccept! !

!CDropDownList methodsFor: 'accessing' stamp: 'ar 12/19/2004 20:50'!
autoAccept: aValue
	"Modify the receiver's autoAccept"
	^self propertyValueAt: #autoAccept put: aValue with: #autoAcceptChanged! !

!CDropDownList methodsFor: 'accessing' stamp: 'ar 12/19/2004 20:50'!
autoRevert
	"Answer the autoRevert of the receiver"
	<bewareOf: #autoRevertChanged>
	^self propertyValueAt: #autoRevert! !

!CDropDownList methodsFor: 'accessing' stamp: 'ar 12/19/2004 20:50'!
autoRevert: aValue
	"Modify the receiver's autoRevert"
	^self propertyValueAt: #autoRevert put: aValue with: #autoRevertChanged! !

!CDropDownList methodsFor: 'accessing' stamp: 'ar 12/19/2004 21:02'!
converter
	"Answer the converter of the receiver"
	<bewareOf: #converterChanged>
	^self propertyValueAt: #converter! !

!CDropDownList methodsFor: 'accessing' stamp: 'ar 12/19/2004 21:02'!
converter: aValue
	"Modify the receiver's converter"
	^self propertyValueAt: #converter put: aValue with: #converterChanged! !

!CDropDownList methodsFor: 'initialize' stamp: 'ar 3/7/2004 18:03'!
defaultCostume
	^CWidgetLibrary default dropDownListCostume! !

!CDropDownList methodsFor: 'initialize' stamp: 'ar 8/12/2009 16:16'!
initialize
	super initialize.
	"Order is important here. allowEditing should be set before anything 
	causes the costume to be created which will ask for #allowEditing."
	allowEditing := false.
	self font: (CWidgetLibrary default menuFont).! !

!CDropDownList methodsFor: 'events' stamp: 'ar 4/21/2005 21:10'!
onCursorChanged: newCursor
	"Update my value in addition to setting the cursor"
	value := items selection.
	super onCursorChanged: newCursor.! !

!CDropDownList methodsFor: 'events' stamp: 'ar 4/21/2005 21:10'!
onValueChanged
	"My value has changed. Set the list selection appropriately."
	<on: valueChanged>
	"Note: The following prevents resetting our value if the new value was entered by the user and is therefore not in the list - in this case the list selection must be (correctly) reset to nil but doing so might trigger an update of our value."
	self pauseScript: #onCursorChanged:.
	items selection: value.
	self resumeScript: #onCursorChanged:.! !

CList defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="allowDeselect" toSet="allowDeselect:" changeEvent="allowDeselectChanged">allowDeselect</field>
	<field toGet="keepCursorInView" toSet="keepCursorInView:" changeEvent="keepCursorInViewChanged">keepCursorInView</field>
	<field toGet="itemMaker" toSet="itemMaker:" changeEvent="itemMakerChanged">itemMaker</field>
	<field toGet="items" toSet="items:" changeEvent="itemsChanged">items</field>
</fields>'!

!CList class methodsFor: 'instance creation' stamp: 'ar 2/6/2005 19:26'!
newSample
	| sample |
	sample := self new.
	sample addAll: {'Item 1'. 'Item 2'. 'Item 3'}.
	^sample! !

!CList methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:10'!
allowDeselect
	"This method was automatically generated"
	<bewareOf: #allowDeselectChanged>
	^(self propertyValueAt: #allowDeselect) ifNil:[false]! !

!CList methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:22'!
allowDeselect: aValue
	"This method was automatically generated"
	^self propertyValueAt: #allowDeselect put: aValue with: #allowDeselectChanged! !

!CList methodsFor: 'accessing' stamp: 'ar 3/14/2005 20:10'!
collection
	"Answer the delegate responsible for receiving collection messages."
	^items! !

!CList methodsFor: 'accessing' stamp: 'ar 3/14/2005 20:16'!
contents
	^self collection contents! !

!CList methodsFor: 'accessing' stamp: 'ar 3/14/2005 20:16'!
contents: aCollection
	self collection contents: aCollection! !

!CList methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:48'!
defaultCostume
	^CWidgetLibrary default listCostume! !

!CList methodsFor: 'private' stamp: 'ar 4/24/2005 17:59'!
drawAction
	"Support for StringList"
	^nil! !

!CList methodsFor: 'initialize' stamp: 'bgf 2/20/2007 16:26'!
initialize
	super initialize.
	items := CCollection new.
	hScrollable := false.
	vScrollable := true.
	allowDeselect := false.  "Brad strikes a blow for the Rest of Us."! !

!CList methodsFor: 'accessing' stamp: 'ar 3/24/2004 15:01'!
itemMaker
	"Answer the itemMaker of the receiver"
	<bewareOf: #itemMakerChanged>
	^self propertyValueAt: #itemMaker! !

!CList methodsFor: 'accessing' stamp: 'ar 3/24/2004 15:01'!
itemMaker: aValue
	"Modify the receiver's itemMaker"
	^self propertyValueAt: #itemMaker put: aValue with: #itemMakerChanged! !

!CList methodsFor: 'accessing' stamp: 'ar 3/25/2004 11:32'!
items
	"Answer the items of the receiver"
	<bewareOf: #itemsChanged>
	^self propertyValueAt: #items! !

!CList methodsFor: 'accessing' stamp: 'ar 3/25/2004 11:32'!
items: aValue
	"Modify the receiver's items"
	^self propertyValueAt: #items put: aValue with: #itemsChanged! !

!CList methodsFor: 'accessing' stamp: 'bgf 1/24/2008 23:48'!
keepCursorInView
	"Answer the keepCursorInView of the receiver"
	<bewareOf: #keepCursorInViewChanged>
	^self propertyValueAt: #keepCursorInView! !

!CList methodsFor: 'accessing' stamp: 'bgf 1/24/2008 23:52'!
keepCursorInView: yesNo
	"Modify the receiver's keepCursorInView"
	^self propertyValueAt: #keepCursorInView put: yesNo with: #keepCursorInViewChanged! !

!CList methodsFor: 'events' stamp: 'jl 5/24/2005 14:31'!
onChangedInItems
	<on: changed in: items>
	self signal: #itemContentChanged! !

!CList methodsFor: 'events' stamp: 'ar 3/25/2004 11:32'!
onCursorChanged: newCursor
	"Resignal changes from our elements so that clients can listen to them."
	<on: cursorChanged in: items>
	self signal: #cursorChanged with: newCursor! !

!CList methodsFor: 'events' stamp: 'ar 3/25/2004 11:32'!
onElementsChanged: typeOfChange from: firstIndex to: lastIndex event: thisEvent
	"Resignal changes from our elements so that clients can listen to them."
	<on: changed in: items>
	(self handlesEvent: #changed) ifFalse:[^nil].
	thisEvent withDroppedEvents do:[:each|
		each setSender: self.
		self signalEvent: each.
	].
! !

!CList methodsFor: 'events' stamp: 'ar 3/25/2004 11:32'!
onWrapCursorChanged: newValue
	"Resignal changes from our elements so that clients can listen to them."
	<on: wrapCursorChanged in: items>
	self signal: #wrapCursorChanged with: newValue.! !

!CList methodsFor: 'scrolling' stamp: 'ar 11/10/2006 10:56'!
scrollToShow: aRectangleOrPlayer
	"Scroll the receiver to show the given player"
	^costume scrollToShow: aRectangleOrPlayer! !

!CList methodsFor: 'selecting' stamp: 'bgf 8/14/2008 15:07'!
selectUnderPointer
	"If the pointer is over an item in the tree, select it; else do nothing;
	 return true if the cursor was changed."
	| st item idx |
	st := costume scrollTarget ifNil: [ ^ false ].
	item := st findPlayerAt: st cursorPoint.
	item ifNotNil: [
		idx := st elements indexOf: item.
		(idx > 0 and: [ self cursor ~= idx]) ifTrue: [
			self cursor: idx.
			^ true
		].
	].
	^ false! !

!CList methodsFor: 'events' stamp: 'bgf 7/14/2009 12:56'!
updateAll
	"Induce a value-changed update for every item.

	 This is useful when my entries and items are known to be in agreements,
	 but when there have been internal changes in entries that should trigger repainting.
	 (If we try to make items listen for update signals for minutia in complex values,
	 the overall scripting burden becomes intolerable.) "

	self invalidate.
	self contents ifNotEmpty: [
		"(That check helps prevent doing this before I'm fully assembled.)"
		self costume scrollTarget elements 
				do: [ :e | e value ifNotNil: [ e onValueChanged ]].
	].! !

CList subclass: #CMultiColumnList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

!CMultiColumnList commentStamp: 'ar 3/27/2004 19:24' prior: 0!
CMultiColumnList displays a multi-column list of strings. My columns are specified by a CMultiColumnListSpec.!

CMultiColumnList defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="columns" toSet="columns:" changeEvent="columnsChanged">columns</field>
</fields>'!

!CMultiColumnList methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:50'!
addColumn: colLabel for: colOwner width: colWidth color: colColor action: colAction draw: colDraw
	| colSpec |
	colSpec := CMultiColumnListSpec new.
	colSpec
		label: colLabel;
		width: colWidth;
		color: colColor;
		action: (colAction ifNotNil:[MessageSend receiver: colOwner selector: colAction]);
		drawer: colOwner;
		drawSelector: colDraw.
	self addColumnSpec: colSpec.! !

!CMultiColumnList methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:51'!
addColumnSpec: colSpec
	columns := columns copyWith: colSpec.! !

!CMultiColumnList methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:06'!
columns
	"Answer the columns of the receiver"
	<bewareOf: #columnsChanged>
	^self propertyValueAt: #columns! !

!CMultiColumnList methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:51'!
columns: aValue
	"Modify the receiver's columns"
	^self propertyValueAt: #columns put: aValue with: #columnsChanged! !

!CMultiColumnList methodsFor: 'initialize' stamp: 'ar 3/12/2004 21:45'!
defaultCostume
	^CMultiColumnListCostume! !

!CMultiColumnList methodsFor: 'initialize' stamp: 'ar 3/12/2004 10:51'!
initialize
	super initialize.
	columns := #().! !

CList subclass: #CPopUpList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

!CPopUpList commentStamp: '<historical>' prior: 0!
A PopUpList presents the user with a list of items. The chosen item will be displayed in the pop up list.!

CPopUpList defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CPopUpList methodsFor: 'initialize' stamp: 'ar 5/24/2005 12:17'!
defaultCostume
	^CWidgetLibrary default popUpListCostume! !

!CPopUpList methodsFor: 'events' stamp: 'ar 5/24/2005 12:21'!
onCursorChanged: newCursor
	"Update my value in addition to setting the cursor"
	value := items selection.
	super onCursorChanged: newCursor.! !

!CPopUpList methodsFor: 'events' stamp: 'ar 5/24/2005 12:21'!
onValueChanged
	"My value has changed. Set the list selection appropriately."
	<on: valueChanged>
	"Note: The following prevents resetting our value if the new value was entered by the user and is therefore not in the list - in this case the list selection must be (correctly) reset to nil but doing so might trigger an update of our value."
	self pauseScript: #onCursorChanged:.
	items selection: value.
	self resumeScript: #onCursorChanged:.! !

CList subclass: #CSpinnerList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

!CSpinnerList commentStamp: 'tk 9/13/2004 15:35' prior: 0!
A Spinner is an object with up and down buttons.  A SpinnerList shows the currently selected item from a hidden list of choices.  The arrow buttons move the selection up or down the list to a new item.  The SpinnerList's cursor changes accordingly.

### Allow Users to see the above explanation ###!

CSpinnerList defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CSpinnerList methodsFor: 'initialize' stamp: 'ar 3/7/2004 20:08'!
defaultCostume
	^CWidgetLibrary default spinnerListCostume! !

CList subclass: #CStringList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

!CStringList commentStamp: '<historical>' prior: 0!
A StringList shows all of its elements in a list.  Each shows what it returns from the message #displayText, usually its name.

### Allow Users to see the above explanation ###

Fields:
	drawAction	<MessageSend | Block>	A message/block to draw the items in the list.!

CStringList defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="drawAction" toSet="drawAction:" changeEvent="drawActionChanged">drawAction</field>
</fields>'!

!CStringList methodsFor: 'initialize' stamp: 'ar 4/24/2005 17:56'!
defaultCostume
	^CWidgetLibrary default stringListCostume! !

!CStringList methodsFor: 'accessing' stamp: 'ar 4/24/2005 17:48'!
drawAction
	"Answer the drawAction of the receiver"
	<bewareOf: #drawActionChanged>
	^self propertyValueAt: #drawAction! !

!CStringList methodsFor: 'accessing' stamp: 'ar 4/24/2005 17:48'!
drawAction: aValue
	"Modify the receiver's drawAction"
	^self propertyValueAt: #drawAction put: aValue with: #drawActionChanged! !

CList subclass: #CTabButtonList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

!CTabButtonList commentStamp: 'ar 3/24/2004 23:30' prior: 0!
I represent a list of tabs which can be selected. My selection is represented as my value so clients can just stuff some objects responding to #displayText into me and get the currently selected tab value back by asking for my selection.!

CTabButtonList defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CTabButtonList class methodsFor: 'example' stamp: 'ar 3/13/2004 04:43'!
example1
	"CTabList example1"
	| list |
	list := self new.
	list add: 'Overview'.
	list add: 'Details'.
	list add: 'More stuff...'.
	^list! !

!CTabButtonList class methodsFor: 'example' stamp: 'ar 3/13/2004 05:39'!
example2
	"CTabList example1"
	| list |
	list := self new.
	list add: 'Projects'.
	list add: 'Objects'.
	list add: 'Images'.
	list add: 'Music'.
	list add: 'Movies'.
	list add: 'All'.
	^list! !

!CTabButtonList methodsFor: 'initialize' stamp: 'ar 3/13/2004 22:35'!
defaultCostume
	^CTabButtonListCostume! !

!CTabButtonList methodsFor: 'initialize' stamp: 'ar 6/22/2005 16:23'!
initialize
	"Initialize me to use a CTabButton as the default item maker"
	super initialize.
	allowDeselect := false.! !

CList subclass: #CTreeWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Trees'!

!CTreeWidget commentStamp: 'ar 3/27/2004 19:33' prior: 0!
A tree widget displays a set of tree items. See the class side for some examples.!

CTreeWidget defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="treeNodes" toSet="treeNodes:" changeEvent="treeNodesChanged">treeNodes</field>
	<field toGet="rootNodes" toSet="rootNodes:" changeEvent="rootNodesChanged">rootNodes</field>
</fields>'!

!CTreeWidget class methodsFor: 'examples' stamp: 'ar 3/13/2004 01:16'!
example1
	"CTreeWidget example1"
	| tree |
	tree := self new.
	tree rootNode: (CFileDirectoryTreeItem on: FileDirectory default).
	^tree! !

!CTreeWidget class methodsFor: 'examples' stamp: 'ar 3/13/2004 01:16'!
example2
	"CTreeWidget example2"
	| tree |
	tree := self new.
	tree rootNodes: (CFileDirectoryTreeItem on: FileDirectory root) getChildren.
	^tree! !

!CTreeWidget class methodsFor: 'examples' stamp: 'ar 3/13/2004 01:13'!
example3
	"CTreeWidget example3"
	| tree roots |
	tree := self new.
	roots := ServerDirectory serverNames collect:[ :n | ServerDirectory serverNamed: n].
	roots := roots, ServerDirectory localProjectDirectories.
	tree roots: roots.
	^tree! !

!CTreeWidget methodsFor: 'private-tree' stamp: 'ar 3/14/2005 20:44'!
addTreeNodes: newChildren at: firstIndex
	treeNodes addAll: newChildren at: firstIndex.
	items addAll: (newChildren collect:[:each| each value]) at: firstIndex.! !

!CTreeWidget methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:16'!
allowDeselect
	"This method was automatically generated"
	<bewareOf: #allowDeselectChanged>
	^self propertyValueAt: #allowDeselect! !

!CTreeWidget methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:27'!
allowDeselect: aValue
	"This method was automatically generated"
	^self propertyValueAt: #allowDeselect put: aValue with: #allowDeselectChanged! !

!CTreeWidget methodsFor: 'initialize' stamp: 'ar 3/9/2004 02:31'!
defaultCostume
	^CWidgetLibrary default treeCostume! !

!CTreeWidget methodsFor: 'operations' stamp: 'ar 2/12/2005 03:40'!
expandLabelPath: aCollection
	"aCollection describes a PATH OF LABELS to one of the receiver's nodes. 
	Expand the receiver along this path."
	| node item pathIndex rootIndex |
	pathIndex := aCollection findFirstIndex:[:any| 
		rootIndex := (CCollection withAll: self rootNodes)
			findFirstIndex:[:dir| dir getLabel = any].
		rootIndex > 0].
	pathIndex = 0 ifTrue:[^nil]. "not in our list"
	node := self rootNodes at: rootIndex.
	pathIndex+1 to: aCollection size do:[:i|
		node expanded ifFalse:[node expand; waitTick].
		item := aCollection at: i.
		node := node children detect:[:any| any getLabel = item] ifNone:[nil].
		node ifNil:[^nil].
	].
	^node! !

!CTreeWidget methodsFor: 'operations' stamp: 'ar 2/12/2005 03:47'!
expandPath: aCollection
	"aCollection describes a 'path' to one of the receiver's nodes. 
	Expand the receiver along this path."
	| node item pathIndex rootIndex |
	pathIndex := (CCollection withAll: aCollection) findFirstIndex:[:any| 
		rootIndex := self roots indexOf: any.
		rootIndex > 0].
	pathIndex = 0 ifTrue:[^nil]. "not in our list"
	node := self rootNodes at: rootIndex.
	pathIndex+1 to: aCollection size do:[:i|
		node expanded ifFalse:[node expand].
		item := aCollection at: i.
		node := node children detect:[:any| any value = item] ifNone:[nil].
		node ifNil:[^nil].
	].
	^node! !

!CTreeWidget methodsFor: 'queries' stamp: 'bgf 5/3/2008 11:20'!
expandedLeaves

	"A depthmost list of expanded item nodes, minimally sufficient
	 so that if all are expanded (and their parents expanded),
	 this describes the expansion state of the tree"

	| result |
	result := CCollection new.
	self rootNodes do: [ : r |
		r expanded ifTrue: [
			result addAll: (r expandedLeaves )
		].
	].
	^ result! !

!CTreeWidget methodsFor: 'queries' stamp: 'bgf 5/3/2008 11:19'!
expandedPaths

	"A minimal collection of label-paths (collections of labels)
	 such that, if all entries are expanded via expandLabelPaths: , 
	 all the currently-expanded label paths will once again be expanded.
	 Can be used to restore the user-level view of the tree 
	 after event-driven reconstruction of arbitrary substructure."

	^ self expandedLeaves collect: [  : leaf | leaf labelPath ]! !

!CTreeWidget methodsFor: 'private-tree' stamp: 'ar 3/13/2004 00:44'!
indexOfTreeNode: aNode
	^treeNodes indexOf: aNode! !

!CTreeWidget methodsFor: 'initialize' stamp: 'bgf 1/9/2010 11:27'!
initialize
	super initialize.
	treeNodes := CCollection new.
	allowDeselect := false. 
	hScrollable := false.
	keepCursorInView := true.
! !

!CTreeWidget methodsFor: 'private-tree' stamp: 'ar 3/13/2004 00:54'!
isRootNode: aNode
	"Is aNode one of our roots?"
	^false! !

!CTreeWidget methodsFor: 'events' stamp: 'ar 3/15/2005 13:09'!
onRootNodesChanged
	| selected |
	selected := self selection.
	treeNodes removeAll.
	items removeAll.
	rootNodes do:[:each| each tree: self].
	self addTreeNodes: rootNodes at: 1.
	self selection: selected.! !

!CTreeWidget methodsFor: 'private-tree' stamp: 'ar 3/14/2005 20:44'!
removeTreeNodesFrom: firstIndex to: lastIndex
	items removeFrom: firstIndex to: lastIndex.
	^treeNodes removeFrom: firstIndex to: lastIndex.
! !

!CTreeWidget methodsFor: 'private-tree' stamp: 'ar 3/14/2005 20:44'!
replaceTreeNodesFrom: firstIndex to: lastIndex with: nodeList
	treeNodes replaceFrom: firstIndex to: lastIndex with: nodeList.
	items replaceFrom: firstIndex to: lastIndex with: (nodeList collect:[:each| each value]).! !

!CTreeWidget methodsFor: 'accessing' stamp: 'ar 3/13/2004 01:02'!
rootNode
	^self rootNodes anyOne! !

!CTreeWidget methodsFor: 'accessing' stamp: 'ar 3/13/2004 01:02'!
rootNode: aNode
	self rootNodes: (Array with: aNode)! !

!CTreeWidget methodsFor: 'accessing' stamp: 'ar 3/13/2004 00:51'!
rootNodes
	"Answer the rootNodes of the receiver"
	<bewareOf: #rootNodesChanged>
	^self propertyValueAt: #rootNodes! !

!CTreeWidget methodsFor: 'accessing' stamp: 'bf 3/30/2004 14:02'!
rootNodes: aValue
	"Modify the receiver's rootNodes"
	self propertyValueAt: #rootNodes put: aValue with: #rootNodesChanged.
	self onRootNodesChanged.
	^aValue! !

!CTreeWidget methodsFor: 'accessing' stamp: 'ar 3/13/2004 01:10'!
roots
	^self rootNodes collect:[:each| each value]! !

!CTreeWidget methodsFor: 'accessing' stamp: 'ar 3/13/2004 01:10'!
roots: aCollection
	self rootNodes: (aCollection collect:[:each| each asTreeItem]).
! !

!CTreeWidget methodsFor: 'operations' stamp: 'ar 2/12/2005 03:42'!
selectLabelPath: aCollection
	"aCollection describes a PATH OF LABELS to one of the receiver's nodes. 
	Expand the receiver along this path; select the last item if present."
	^self cursor: (self treeNodes indexOf: (self expandLabelPath: aCollection))! !

!CTreeWidget methodsFor: 'operations' stamp: 'ar 2/12/2005 03:42'!
selectPath: aCollection
	"aCollection describes a 'path' to one of the receiver's nodes. 
	Expand the receiver along this path; select the last item if present."
	^self cursor: (self treeNodes indexOf: (self expandPath: aCollection))! !

!CTreeWidget methodsFor: 'selecting' stamp: 'bgf 8/14/2008 15:06'!
selectUnderPointer
	"If the pointer is over an item in the tree, select it; else do nothing."
	^ costume selectUnderPointer! !

!CTreeWidget methodsFor: 'private-tree' stamp: 'ar 3/13/2004 00:42'!
treeNodes
	"Answer the treeNodes of the receiver"
	<bewareOf: #treeNodesChanged>
	^self propertyValueAt: #treeNodes! !

!CTreeWidget methodsFor: 'private-tree' stamp: 'ar 3/13/2004 00:42'!
treeNodes: aValue
	"Modify the receiver's treeNodes"
	^self propertyValueAt: #treeNodes put: aValue with: #treeNodesChanged! !

CHolder subclass: #CPlayfield
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-EToy'!

CPlayfield defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CPlayfield methodsFor: 'events' stamp: 'ar 6/27/2005 23:02'!
onDragDrop: aPlayer
	<on: dragDrop>
	aPlayer transformBy: self worldToLocal.
	self add: aPlayer.
	aPlayer signal: #dropAccept with: self.
! !

!CPlayfield methodsFor: 'events' stamp: 'ar 6/22/2005 12:12'!
onMouseDown
	| dragChild |
	<on: mouseDown>
	dragChild := (self findDraggablePlayerAt: self cursorPoint) ifNil:[self].
	dragChild onDrag.! !

!CPlayfield methodsFor: 'initialize' stamp: 'ar 6/22/2005 19:37'!
setupCostume
	super setupCostume.
	self color := CWidgetLibrary default paneColor.
	self borderWidth := 1.
	self borderStyle: #simple.
	self borderColor := CWidgetLibrary default frameColor.
	self roundCorners := true.
	self extent := 300@200.
	self clipping := true.
	self indicatePenTrails: true.
! !

!Color methodsFor: '*Tweak-Widgets' stamp: 'bgf 12/28/2008 11:33'!
itemSelectionGradient
	"For Tweak lists...  	
	 use this color as the basis of a 3-entry gradient to highlight an tem in a list.
	 The gradient is a gentle strengthening of the color.
	 For light base colors, a gentle lightening is done
	 (very light colors look muddy when darkened.)"

	self brightness >= 0.9 ifTrue: [
		^ { self . self slightlyLighter . self } .
	] ifFalse: [ 
		^ { self . self darker . self slightlyDarker } .
	].! !

CEventBehavior subclass: #CWindowResizeBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Behaviors'!

!CWindowResizeBehavior commentStamp: 'ar 5/3/2004 22:45' prior: 0!
CWindowResizeBehavior is a simple event behavior which allows any object to be resized in a "window style" that is showing appropriate resize cursors when the mouse enters the object and resizing by the appropriate edge when the mouse is pressed. When a window resize behavior is attached to a player the player should not handle mouse down events nor use any of its own cursors.

Instance variables:
	resizeWithContents	<Boolean>	If true, the object will be resized with its contents shown, if false, a frame is shown instead of the object.
	automaticDragging	<Boolean>	If true, the object will be automatically dragged when the user clicks outside the resizer border area.
!

CWindowResizeBehavior subclass: #CPaneResizeBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Behaviors'!

!CPaneResizeBehavior commentStamp: '<historical>' prior: 0!
Attach this to a pane in a window to allow the pane boundary to be moved.  Stores into layoutFrame: in all effected panes.  For now, the pane's container (the window) must use ProportionalLayout.!

CPaneResizeBehavior defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CPaneResizeBehavior methodsFor: 'initialize' stamp: 'tk 5/9/2005 11:21'!
initialize
	super initialize.
	automaticDragging := false.
	resizeWithContents := false.! !

!CPaneResizeBehavior methodsFor: 'events' stamp: 'bgf 9/14/2008 20:51'!
onResize
	"Change the proportion of panes in a window.  target is a pane."
	| box newBox sideName resizeTarget oldPorp scalar setter |
	<on: mouseDown in: target>
	target container layout isProportionalLayout ifFalse: [^ self]. 	"later loosen this!!"
	sideName := self resizerEdge ifNil:[^self].
	sideName == #rightCenter ifTrue: [scalar := #right.  setter := #rightCenter:].
	sideName == #bottomCenter ifTrue: [scalar := #bottom.  setter := #bottomCenter:].
	oldPorp := target layoutFrame fractions perform: scalar.
	oldPorp = 1.0 ifTrue: [^ self].	"we don't do the outside edges"
	"oldPorp = 0.0 ifTrue: [^ self].  	Not doing top or left"

	resizeTarget := CPlayer new.
	resizeTarget borderStyle: #simple.
	resizeTarget borderWidth: 4.
	target borderColor isTransparent
		ifTrue:[resizeTarget borderColor: (Color white alpha: 0.5)]
		ifFalse:[resizeTarget borderColor: target borderColor].
	resizeTarget roundCornerSpec: target roundCornerSpec.
	resizeTarget extent: target extent.
	resizeTarget mouseCursor := target mouseCursor.
	resizeTarget openIn: target world at: (target localToGlobal: 0@0).
	target hand mouseFocus: resizeTarget.

	target hand forEach: #mouseMove do:[
		box := resizeTarget localBounds.
		newBox := box perform: setter with: resizeTarget cursorPoint.
		resizeTarget resizeMoveBy: newBox origin 
				       width: newBox width 
					 height: newBox height.
	] until: #mouseUp.

	target container layout moveEdge: scalar of: target 
			to: (resizeTarget globalBounds perform: sideName).
		"do the work"
	resizeTarget close.
! !

!CPaneResizeBehavior methodsFor: 'events' stamp: 'tk 5/10/2005 12:03'!
resizerEdge
	"Answer the edge of the receiver we wish to move.  For panes, only need to move the right or bottom, since another pane can move the top and left."

	| pt box |
	pt := target cursorPoint.
	box := target localBounds.

	(box right - pt x) < 4 ifTrue:[^#rightCenter].
	(box bottom - pt y) < 4 ifTrue:[^#bottomCenter].
	^nil! !

CWindowResizeBehavior defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="resizeWithContents" toSet="resizeWithContents:" changeEvent="resizeWithContentsChanged">resizeWithContents</field>
	<field toGet="automaticDragging" toSet="automaticDragging:" changeEvent="automaticDraggingChanged">automaticDragging</field>
	<field toGet="priorCursor" toSet="priorCursor:" changeEvent="priorCursorChanged">priorCursor</field>
	<field toGet="currentCursor" toSet="currentCursor:" changeEvent="currentCursorChanged">currentCursor</field>
	<field toGet="cursorChanged" toSet="cursorChanged:" changeEvent="cursorChangedChanged">cursorChanged</field>
</fields>'!

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 4/30/2004 18:10'!
automaticDragging
	"Answer the automaticDragging of the receiver"
	<bewareOf: #automaticDraggingChanged>
	^self propertyValueAt: #automaticDragging! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 4/30/2004 18:10'!
automaticDragging: aValue
	"Modify the receiver's automaticDragging"
	^self propertyValueAt: #automaticDragging put: aValue with: #automaticDraggingChanged! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 8/20/2007 15:53'!
currentCursor
	"Answer the currentCursor of the receiver"
	<bewareOf: #currentCursorChanged>
	^self propertyValueAt: #currentCursor! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 8/20/2007 15:53'!
currentCursor: aValue
	"Modify the receiver's currentCursor"
	^self propertyValueAt: #currentCursor put: aValue with: #currentCursorChanged! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 8/20/2007 14:39'!
cursorChanged
	"Answer the cursorChanged of the receiver"
	<bewareOf: #cursorChangedChanged>
	^self propertyValueAt: #cursorChanged! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 8/20/2007 14:39'!
cursorChanged: aValue
	"Modify the receiver's cursorChanged"
	^self propertyValueAt: #cursorChanged put: aValue with: #cursorChangedChanged! !

!CWindowResizeBehavior methodsFor: 'initialize' stamp: 'ar 8/20/2007 14:41'!
initialize
	super initialize.
	automaticDragging := true.
	cursorChanged := false.
	"resizeWithContents := Preferences resizeWithContents." "done lazily"! !

!CWindowResizeBehavior methodsFor: 'events' stamp: 'bgf 9/27/2008 16:56'!
onResize
	"Resize me"
	| box newBox sideName resizeTarget |
	<on: mouseDown in: target>
	sideName := self resizerEdge ifNil:[
		automaticDragging ifTrue:[^target onDrag].
		^self].
	self resizeWithContents ifTrue:[
		resizeTarget := target.
		self pauseScript: #onResizeTrack.
		target mouseCursor == currentCursor ifTrue:[
			currentCursor := currentCursor ifNotNil:[currentCursor asForm].
			target mouseCursor := currentCursor.
		].
	] ifFalse:[
		resizeTarget := CPlayer new.
		resizeTarget borderStyle: #simple.
		resizeTarget borderWidth: 4.
		target borderColor isTransparent
			ifTrue:[resizeTarget borderColor: (Color white alpha: 0.5)]
			ifFalse:[resizeTarget borderColor: target borderColor].
		resizeTarget roundCornerSpec: target roundCornerSpec.
		resizeTarget extent: target extent.
		resizeTarget mouseCursor := target mouseCursor.
		resizeTarget openIn: target container at: (target localToGlobal: 0@0).
		target hand mouseFocus: resizeTarget.
	].
	target hand forEach: #mouseMove do:[
		box := resizeTarget localBounds.
		newBox := box perform: (sideName, ':') asSymbol with: resizeTarget cursorPoint.
		resizeTarget resizeMoveBy: newBox origin 
				       width: newBox width 
					 height: newBox height.
	] until: #mouseUp.
	resizeTarget == target ifTrue:[
		self resumeScript: #onResizeTrack.
		target signal: #resizeComplete.
	] ifFalse:[
		target topLeft: resizeTarget topLeft.
		target extent: resizeTarget extent.
		target signal: #resizeComplete.
		resizeTarget close.
	].
! !

!CWindowResizeBehavior methodsFor: 'events' stamp: 'ar 8/20/2007 17:09'!
onResizeTrack
	| side |
	<on: mouseMove in: target>
	side := self resizerEdge.
	side ifNil:[
		"restore the prior cursor if we've modified it but only if the target hasn't changed it"
		(cursorChanged and:[target mouseCursor == currentCursor]) 
			ifTrue:[target mouseCursor := priorCursor].
		cursorChanged := false.
		currentCursor := nil.
	] ifNotNil:[
		"if we don't have the target's current cursor or if it has changed, remember it"
		(cursorChanged and:[currentCursor == target mouseCursor]) ifFalse:[
			priorCursor := target mouseCursor.
			cursorChanged := true
		].
		currentCursor := CCursorLibrary resizeForEdge: side.
		target mouseCursor := currentCursor.
	].! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 8/20/2007 14:37'!
priorCursor
	"Answer the priorCursor of the receiver"
	<bewareOf: #priorCursorChanged>
	^self propertyValueAt: #priorCursor! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 8/20/2007 14:37'!
priorCursor: aValue
	"Modify the receiver's priorCursor"
	^self propertyValueAt: #priorCursor put: aValue with: #priorCursorChanged! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 12/20/2004 21:35'!
resizeWithContents
	"Answer the resizeWithContents of the receiver"
	<bewareOf: #resizeWithContentsChanged>
	^self propertyValueAt: #resizeWithContents ifAbsent:[	Preferences resizeWithContents].! !

!CWindowResizeBehavior methodsFor: 'accessing' stamp: 'ar 4/30/2004 18:09'!
resizeWithContents: aValue
	"Modify the receiver's resizeWithContents"
	^self propertyValueAt: #resizeWithContents put: aValue with: #resizeWithContentsChanged! !

!CWindowResizeBehavior methodsFor: 'events' stamp: 'ar 4/30/2004 18:16'!
resizerEdge
	"Answer the edge of the receiver we wish to resize"
	| pt box |
	pt := target cursorPoint.
	box := target localBounds.
	#(topLeft topRight bottomLeft bottomRight) do:[:cc|
		((box perform: cc) - pt) r < 10 ifTrue:[^cc].
	].
	(pt x - box left) < 4 ifTrue:[^#leftCenter].
	(box right - pt x) < 4 ifTrue:[^#rightCenter].
	(pt y - box top) < 4 ifTrue:[^#topCenter].
	(box bottom - pt y) < 4 ifTrue:[^#bottomCenter].
	^nil! !

CPlayer subclass: #CBalloonHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Misc'!

CBalloonHelp defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="labelHolder" toSet="labelHolder:" changeEvent="labelHolderChanged">labelHolder</field>
</fields>'!

!CBalloonHelp methodsFor: 'events' stamp: 'bgf 11/3/2007 13:16'!
getBestLocation: box preferredAlignment: aSymbol

	"Return the preferred bounds for the help balloon,
 	 offset from the current hand (along north, south, east or west).
	 Picks the placement with the least clipping against the current world,
	 favoring the given preferredAlignment"

	| rect maxArea rectPoint a usableArea result focalArea handPoint |

	maxArea := -1.
	result := box.
	usableArea := (target world ifNil:[self world]) localBounds.
	focalArea := hand worldBounds insetBy: (-16@-12).
	1 to: 4 do: [:i |

		"Corresponding points to align, from the balloon rect and the hand position."
		rectPoint := #(bottomCenter topCenter leftCenter rightCenter) at: i.
		handPoint := #(topCenter bottomCenter rightCenter leftCenter) at: i.

		rect := box align: (box perform: rectPoint) with: (focalArea perform: handPoint).
		a := (rect intersect: usableArea) area.
		(a > maxArea or: [a = box area and: [rectPoint = aSymbol]]) ifTrue:
			[maxArea := a.
			 result := rect]
	].
	^ result! !

!CBalloonHelp methodsFor: 'initialize' stamp: 'bgf 7/11/2009 15:52'!
initialize
	super initialize.
	self define: #labelHolder as: CLabel new.
	self
		borderColor: ((Color gray: 0.4) alpha: (0.85));
		fillColor: (Color r: 0.96 g: 0.96 b: 0.65 alpha: (0.95)).
	self borderStyle: #simple.
	self borderWidth: 1.
	self dropShadowEnabled: true.! !

!CBalloonHelp methodsFor: 'accessing' stamp: 'ar 6/19/2005 11:27'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CBalloonHelp methodsFor: 'accessing' stamp: 'ar 6/19/2005 11:27'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CBalloonHelp methodsFor: 'accessing' stamp: 'tk 2/17/2005 16:11'!
labelHolder
	"Answer the labelHolder of the receiver"
	<bewareOf: #labelHolderChanged>
	^self propertyValueAt: #labelHolder! !

!CBalloonHelp methodsFor: 'accessing' stamp: 'tk 2/17/2005 16:11'!
labelHolder: aValue
	"Modify the receiver's labelHolder"
	^self propertyValueAt: #labelHolder put: aValue with: #labelHolderChanged! !

!CBalloonHelp methodsFor: 'events' stamp: 'ar 6/19/2005 11:27'!
onLabelChanged
	<on: labelChanged>
	labelHolder value: label.! !

!CBalloonHelp methodsFor: 'events' stamp: 'bgf 6/5/2007 15:51'!
onLabelHolderSizeChanged
	<on: extentChanged in: labelHolder>

	target ifNil: [ ^ self ].
	(target world ifNil:[self world]) ifNil: [ ^ self ].	"Dodge async troubles."
	self updateGeometry.! !

!CBalloonHelp methodsFor: 'events' stamp: 'bgf 6/5/2007 15:51'!
onTargetChanged
	<on: targetChanged>

	target ifNil: [ ^ self ].
	(target world ifNil:[self world]) ifNil: [ ^ self ].	"Dodge async troubles."
	self updateGeometry! !

!CBalloonHelp methodsFor: 'events' stamp: 'ar 6/19/2005 11:28'!
onTargetFrameChanged
	<on: frameChanged in: target>
	self onTargetChanged. "cheesy way out"! !

!CBalloonHelp methodsFor: 'initialize' stamp: 'bgf 7/11/2009 15:51'!
setupCostume
	super setupCostume.
	labelHolder font: (CWidgetLibrary default balloonFont).
	labelHolder hResizing: #shrinkWrap.
	labelHolder textAnchorPoint: #center.
	labelHolder textColor: (Color r: 0.05 g:0.05 b:0.04 alpha: 1.0).
	labelHolder layoutInset: 8@6.
	labelHolder topLeft: 0@0.
	self addLast: labelHolder.! !

!CBalloonHelp methodsFor: 'accessing' stamp: 'ar 2/6/2005 20:42'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CBalloonHelp methodsFor: 'accessing' stamp: 'ar 2/6/2005 20:42'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

!CBalloonHelp methodsFor: 'events' stamp: 'bgf 11/2/2007 21:36'!
updateGeometry
	| box newBox |

	"Position the help in the best available position near the mouse pointer."

	(target isNil or: [target container isNil])
		ifTrue: [^self close].
	box := labelHolder bounds.
	newBox := self getBestLocation: box preferredAlignment: #bottomCenter.

	self bounds: newBox.! !

CPlayer subclass: #CColorPicker
	instanceVariableNames: ''
	classVariableNames: 'StandardColorPalette'
	poolDictionaries: ''
	category: 'Tweak-Widgets-Misc'!

CColorPicker defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="colorValues" toSet="colorValues:" changeEvent="colorValuesChanged">colorValues</field>
	<field toGet="primaryPicker" toSet="primaryPicker:" changeEvent="primaryPickerChanged">primaryPicker</field>
</fields>'!

!CColorPicker methodsFor: 'private' stamp: 'ar 5/30/2005 02:10'!
colorPalette
	StandardColorPalette ifNil:[
		StandardColorPalette := self colorPaletteForDepth: 32 extent: 120@60.
	].
	self flag: #fixMe.
	"veryDeepCopy is just so that project writing works - need to move this to a resource island"
	^StandardColorPalette deepCopy! !

!CColorPicker methodsFor: 'private' stamp: 'ar 3/27/2004 20:50'!
colorPaletteForDepth: depth extent: chartExtent
	"Note: It is slow to build this palette, so it should be cached for quick access."
	| basicHue xx yy c startHue palette transHt vSteps grayWidth hSteps |
	palette := Form extent: chartExtent depth: depth.
	transHt := -1.
	palette fillWhite: (0@0 extent: palette width@transHt).
	palette fillBlack: (0@transHt extent: palette width@1).
	grayWidth := 10.
	startHue := 338.0.
	vSteps := palette height - transHt // 2.
	hSteps := palette width - grayWidth.
	xx := 0.
	startHue to: startHue + 360.0 by: 360.0/hSteps do: [:h |
		basicHue := Color h: h asFloat s: 1.0 v: 1.0.
		yy := transHt+1.
		0 to: vSteps do: [:n |
 			c := basicHue mixed: (n asFloat / vSteps asFloat) with: Color white.
			palette fill: (xx@yy extent: 1@1) fillColor: c.
			yy := yy + 1].
		1 to: vSteps do: [:n |
 			c := Color black mixed: (n asFloat / vSteps asFloat) with: basicHue.
			palette fill: (xx@yy extent: 1@1) fillColor: c.
			yy := yy + 1].
		xx := xx + 1].
	yy := transHt + 1.
	1 to: vSteps * 2 do: [:n |
 		c := Color black mixed: (n asFloat / (vSteps*2) asFloat) with: Color white.
		palette fill: (xx@yy extent: 10@1) fillColor: c.
		yy := yy + 1].
	^ palette
! !

!CColorPicker methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:01'!
colorValues
	"Answer the colorValues of the receiver"
	<bewareOf: #colorValuesChanged>
	^self propertyValueAt: #colorValues! !

!CColorPicker methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:01'!
colorValues: aValue
	"Modify the receiver's colorValues"
	^self propertyValueAt: #colorValues put: aValue with: #colorValuesChanged! !

!CColorPicker methodsFor: 'accessing' stamp: 'ar 3/26/2004 23:43'!
colors
	"Answer a list of all colors"
	^colorValues collect:[:aPlayer| aPlayer value]! !

!CColorPicker methodsFor: 'accessing' stamp: 'ar 3/26/2004 23:43'!
colors: colorList
	"Install a list of colors"
	| max |
	self newPrimaryPicker: nil.
	max := colorList size min: colorValues size.
	1 to: max do:[:i|
		| aPlayer aColor |
		aPlayer := colorValues at: i.
		aColor := colorList at: i.
		aPlayer value: aColor.
		aPlayer center: (self positionOfColor: aColor).
	].
	colorValues size > max ifTrue:[
		"remove some of the indicators"
		max+1 to: colorValues size do:[:i|
			(colorValues at: i) destroy.
		].
		colorValues := colorValues copyFrom: 1 to: max.
	].
	colorList size > max ifTrue:[
		"add some color indicators"
		max+1 to: colorList size do:[:i|
			colorValues := colorValues copyWith: (self playerForColor: (colorList at: i)).
		].
	].
	colorValues size > 0 ifTrue:[
		self newPrimaryPicker: colorValues first.
	].


! !

!CColorPicker methodsFor: 'initialize' stamp: 'ar 3/14/2004 00:39'!
initialize
	super initialize.
	graphicForm := self colorPalette.
	graphicFit := #rigid.
	"Need some room for the pickers around me so fake a transparent border"
	extent := graphicForm extent + 8.
	borderWidth := 4.
	borderColor := Color transparent.

	self setupPicker.! !

!CColorPicker methodsFor: 'private' stamp: 'ar 3/14/2004 00:41'!
newPrimaryColor: aColor
	primaryPicker value: aColor.
	primaryPicker center: (self positionOfColor: aColor).
	self onColorsChanged.! !

!CColorPicker methodsFor: 'private' stamp: 'ar 3/13/2004 23:18'!
newPrimaryPicker: aPlayer
	primaryPicker ifNotNil:[primaryPicker borderColor: Color white].
	primaryPicker := aPlayer.
	primaryPicker ifNotNil:[primaryPicker borderColor: Color red].! !

!CColorPicker methodsFor: 'events' stamp: 'ar 3/13/2004 23:21'!
onColorsChanged
	self value: primaryPicker value.! !

!CColorPicker methodsFor: 'events' stamp: 'ar 3/13/2004 23:18'!
onMouseDown
	<on: mouseDown>
	primaryPicker ifNil:[^self].
	self pickColorFor: primaryPicker.! !

!CColorPicker methodsFor: 'events' stamp: 'ar 3/13/2004 23:18'!
onValueChanged
	<on: valueChanged>
	primaryPicker ifNil:[^self].
	primaryPicker value: value.
	primaryPicker center: (self positionOfColor: value).! !

!CColorPicker methodsFor: 'picking' stamp: 'ar 3/21/2004 19:38'!
pickColor
	self pickColorFor: primaryPicker.
	self close.! !

!CColorPicker methodsFor: 'picking' stamp: 'ar 3/13/2004 22:58'!
pickColorAt: aPoint
	| aWorld |
	aWorld := self world.
	aWorld ifNil:[^Color transparent].
	^aWorld colorAt: aPoint! !

!CColorPicker methodsFor: 'picking' stamp: 'ar 3/23/2004 23:16'!
pickColorFor: aPlayer
	self newPrimaryPicker: aPlayer.
	self pauseScript: #onValueChanged.
	aPlayer visible: false.
	hand mouseFocus: self.
	self waitTick. "for mouse cursor to restore and player to hide"
	self mouseCursor: Cursor crossHair.
	hand forEach: #mouseMove do:[
		| show |
		show := (self containsPoint: self cursorPoint) not.
		show = aPlayer visible ifFalse:[aPlayer visible: show].
		self newPrimaryColor: (self pickColorAt: world cursorPoint).
	] until: #mouseUp.
	self mouseCursor: nil.
	aPlayer visible: true.
	self resumeScript: #onValueChanged.! !

!CColorPicker methodsFor: 'private' stamp: 'ar 3/27/2004 20:50'!
playerForColor: aColor
	| aPlayer |
	aPlayer := CPlayer on: aColor.
	aPlayer fill: Color transparent.
	aPlayer borderWidth: 1.
	aPlayer borderStyle: #simple.
	aPlayer borderColor: Color white.
	aPlayer extent: 6@6.
	aPlayer center: (self positionOfColor: aColor).
	aPlayer mouseCursor: Cursor crossHair.
	self startScript: #pickColorFor: 
		withArguments:{aPlayer} 
		when:{aPlayer. #mouseDown}.
	self add: aPlayer.
	^aPlayer! !

!CColorPicker methodsFor: 'private' stamp: 'ar 3/27/2004 20:51'!
positionInPalette: aColor
	"Compute the position of the given color in the color chart form.
	Note: This assumes that the costume's graphicForm was created by
	colorPaletteForDepth: depth extent: chartExtent"
	| rgbRect xx yy h s v |
	rgbRect := 0@0 extent: graphicForm extent - (10@0).
	h := aColor hue.
	s := aColor saturation.
	v := aColor brightness.
	h = 0.0 ifTrue:["gray"
		^(rgbRect right + 6) @ (rgbRect height * (1.0 - v) + rgbRect top)].
	xx := (h + 22 \\ 360 / 360.0 * rgbRect width) rounded.
	yy := 0.5.
	s < 1.0 ifTrue:[yy := yy - (1.0 - s * 0.5)].
	v < 1.0 ifTrue:[yy := yy + (1.0 - v * 0.5)].
	yy := (yy * rgbRect height) rounded.
	^xx@yy! !

!CColorPicker methodsFor: 'private' stamp: 'ar 3/14/2004 00:40'!
positionOfColor: aColor
	^borderWidth + (self positionInPalette: aColor)! !

!CColorPicker methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:17'!
primaryPicker
	"Answer the primaryPicker of the receiver"
	<bewareOf: #primaryPickerChanged>
	^self propertyValueAt: #primaryPicker! !

!CColorPicker methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:17'!
primaryPicker: aValue
	"Modify the receiver's primaryPicker"
	^self propertyValueAt: #primaryPicker put: aValue with: #primaryPickerChanged! !

!CColorPicker methodsFor: 'initialize' stamp: 'ar 3/13/2004 23:22'!
setupPicker
	colorValues := #().
	primaryPicker := self playerForColor: Color white.
	self value: Color white.! !

CPlayer subclass: #CCustomDrawListTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

CCustomDrawListTarget defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="list" toSet="list:" changeEvent="listChanged">list</field>
</fields>'!

!CCustomDrawListTarget methodsFor: 'drawing' stamp: 'ar 6/28/2005 21:29'!
drawOn: aCanvas in: drawingBounds
	super drawOn: aCanvas in: drawingBounds.
	list ifNotNil:[list drawListOn: aCanvas in: drawingBounds].! !

!CCustomDrawListTarget methodsFor: 'accessing' stamp: 'ar 3/25/2004 11:36'!
list
	"Answer the list of the receiver"
	<bewareOf: #listChanged>
	^self propertyValueAt: #list! !

!CCustomDrawListTarget methodsFor: 'accessing' stamp: 'ar 3/25/2004 11:36'!
list: aValue
	"Modify the receiver's list"
	^self propertyValueAt: #list put: aValue with: #listChanged! !

CPlayer subclass: #CCustomDrawingArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

!CCustomDrawingArea commentStamp: '<historical>' prior: 0!
I am a custom drawing area that clients can use to paint a particular portion on the screen.!

CCustomDrawingArea defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="drawAction" toSet="drawAction:" changeEvent="drawActionChanged">drawAction</field>
</fields>'!

!CCustomDrawingArea methodsFor: 'accessing' stamp: 'ar 6/29/2005 19:26'!
drawAction
	"Answer the drawAction of the receiver"
	<bewareOf: #drawActionChanged>
	^self propertyValueAt: #drawAction! !

!CCustomDrawingArea methodsFor: 'accessing' stamp: 'ar 6/29/2005 19:26'!
drawAction: aValue
	"Modify the receiver's drawAction"
	^self propertyValueAt: #drawAction put: aValue with: #drawActionChanged! !

!CCustomDrawingArea methodsFor: 'drawing' stamp: 'ar 6/29/2005 19:28'!
drawOn: aCanvas in: drawingBounds
	"Draw the receiver"
	drawAction ifNil:[^super drawOn: aCanvas in: drawingBounds].
	^drawAction valueWithArguments: (Array with: self with: aCanvas with: drawingBounds)! !

!CCustomDrawingArea methodsFor: 'initialize' stamp: 'ar 6/29/2005 19:26'!
setupCostume
	super setupCostume.
	self userDraw := true.! !

CPlayer subclass: #CDefaultWidgetLibrary
	instanceVariableNames: ''
	classVariableNames: 'ImparaColors QwaqColors'
	poolDictionaries: ''
	category: 'Tweak-Widgets-Support'!

!CDefaultWidgetLibrary commentStamp: '<historical>' prior: 0!
For the Qwaq style variant...

	QwaqColors := true!

CDefaultWidgetLibrary defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CDefaultWidgetLibrary class methodsFor: 'accessing' stamp: 'bgf 2/24/2008 22:20'!
initialize
	"CDefaultWidgetLibrary initialize."
	ImparaColors := false.
	QwaqColors := true.
	self initializePreferences.
	CWidgetLibrary default: self new.
! !

!CDefaultWidgetLibrary class methodsFor: 'accessing' stamp: 'ar 1/22/2005 15:28'!
initializePreferences
	Preferences addPreference: #automaticLookAdjustments categories: #('Tweak' 'Windows') default: true balloonHelp: 'When true, update after a look preference changes' projectLocal: false  changeInformee: nil changeSelector: nil.
	Preferences addPreference: #texturedWindowFrame categories: #('Tweak' 'Windows') default: true balloonHelp: 'When true, use textured window frames' projectLocal: false  changeInformee: self changeSelector: #updateWindowFrame.
	Preferences addPreference: #thickWindowFrame categories: #('Tweak' 'Windows') default: false balloonHelp: 'When true, use 4px instead of 2px borders' projectLocal: false  changeInformee: self changeSelector: #updateBorderWidth.
	Preferences addPreference: #innerBorderStyle categories: #('Tweak' 'Windows') default: false balloonHelp: 'When true, use #inner borders for window elements' projectLocal: false  changeInformee: self changeSelector: #updateBorderStyle.
	Preferences addPreference: #defaultWindowCloseBox categories: #('Tweak' 'Windows') default: true balloonHelp: 'When true, add a close button by default' projectLocal: false  changeInformee: self changeSelector: #updateCloseBox.
	Preferences addPreference: #defaultWindowExpandBox categories: #('Tweak' 'Windows') default: false balloonHelp: 'When true, add an expand button by default' projectLocal: false  changeInformee: self changeSelector: #updateExpandBox.
	Preferences addPreference: #defaultWindowCollapseBox categories: #('Tweak' 'Windows') default: true balloonHelp: 'When true, add a collapse button by default' projectLocal: false  changeInformee: self changeSelector: #updateCollapseBox.
	Preferences addPreference: #doubleClickOnLabelToEdit categories: #('Tweak' 'Windows') default: false balloonHelp: 'When true, double clicking on a window label will allow editing' projectLocal: false  changeInformee: nil changeSelector: nil.
	Preferences addPreference: #resizeWithContents categories: #('Tweak' 'Windows') default: false balloonHelp: 'When true, resize windows showing their contents' projectLocal: false  changeInformee: nil changeSelector: nil.! !

!CDefaultWidgetLibrary class methodsFor: 'private' stamp: 'ar 1/22/2005 15:28'!
updateBorderStyle
	Preferences automaticLookAdjustments ifFalse:[^self].
	CWindow allInstancesDo:[:each|each decorate: each elements color: each windowColor].! !

!CDefaultWidgetLibrary class methodsFor: 'private' stamp: 'ar 1/22/2005 15:28'!
updateBorderWidth
	Preferences automaticLookAdjustments ifFalse:[^self].
	CWindow allInstancesDo:[:each|
		each decorate: each elements color: each windowColor.
		each borderWidth: CWidgetLibrary default windowBorderWidth.
	].! !

!CDefaultWidgetLibrary class methodsFor: 'accessing' stamp: 'ar 1/22/2005 15:28'!
updateCloseBox
	| bool |
	Preferences automaticLookAdjustments ifFalse:[^self].
	bool := Preferences defaultWindowCloseBox.
	CWindow allInstancesDo:[:each| each closeBox: bool].! !

!CDefaultWidgetLibrary class methodsFor: 'accessing' stamp: 'ar 1/22/2005 15:28'!
updateCollapseBox
	| bool |
	Preferences automaticLookAdjustments ifFalse:[^self].
	bool := Preferences defaultWindowCollapseBox.
	CWindow allInstancesDo:[:each| each minimizeBox: bool].! !

!CDefaultWidgetLibrary class methodsFor: 'accessing' stamp: 'ar 1/22/2005 15:28'!
updateExpandBox
	| bool |
	Preferences automaticLookAdjustments ifFalse:[^self].
	bool := Preferences defaultWindowExpandBox.
	CWindow allInstancesDo:[:each| each maximizeBox: bool].! !

!CDefaultWidgetLibrary class methodsFor: 'private' stamp: 'ar 1/22/2005 15:28'!
updateWindowFrame
	Preferences automaticLookAdjustments ifFalse:[^self].
	CWindowCostume allInstancesDo:[:each|
		each windowFrame destroy.
		each windowFrame: CWidgetLibrary default windowFrame new.
	].! !

!CDefaultWidgetLibrary methodsFor: 'basic' stamp: 'bgf 7/11/2009 15:41'!
balloonFont
	(TextConstants includesKey: #'Lucida Grande') ifTrue: [
		^ (TextConstants at: #'Lucida Grande')  fontOfPointSize: 10
	].
	^ BalloonMorph balloonFont! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 9/12/2009 02:01'!
baseColor
	"The base color for this scheme"
	ImparaColors ifTrue:[^Color r: 0.341 g: 0.638 b: 0.741].
	QwaqColors ifTrue: [ ^ Color r:0.936 g:0.938 b:0.922 ].

	^(Color r: 0.9 g: 0.9 b: 0.9)

	" ^(Color r: 1.0 g: 0.677 b: 0.032) "! !

!CDefaultWidgetLibrary methodsFor: 'buttons' stamp: 'ar 1/22/2005 15:28'!
buttonCostume
	^CPushButtonCostume! !

!CDefaultWidgetLibrary methodsFor: 'buttons' stamp: 'ar 1/22/2005 15:28'!
checkBoxCostume
	^CCheckBoxCostume! !

!CDefaultWidgetLibrary methodsFor: 'lists' stamp: 'ar 1/22/2005 15:28'!
dropDownListCostume
	^CDropDownListCostume! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 9/5/2009 18:10'!
frameColor
	"This is the color to be used for 1px borders (framing)"
	ImparaColors ifTrue:[^(Color r: 0.341 g: 0.638 b: 0.741)].
	QwaqColors ifTrue:[ ^ Color r: 0.683 g: 0.68 b: 0.68 ].

	^ self baseColor 

	"^(Color r: 1.0 g: 0.807 b: 0.442) "! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 9/12/2009 12:52'!
gradientColors
	"This describes the colors to use for any gradients,
	 such as push buttons and scroll bar elements."

	QwaqColors ifTrue: [ 
		^ { (Color r: 0.995 g: 0.99 b: 0.975) . 
			(Color r: 0.837 g: 0.83 b: 0.82)} ].

	^{Color white. self baseColor}! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 8/21/2007 22:30'!
insertionPointColor
	^Display depth <= 2
		ifTrue: [Color black]
		ifFalse: [Color r: 0.25 g: 0.3 b: 0.35]! !

!CDefaultWidgetLibrary methodsFor: 'basic' stamp: 'ar 1/22/2005 15:28'!
labelCostume
	^CLabelCostume! !

!CDefaultWidgetLibrary methodsFor: 'lists' stamp: 'ar 1/22/2005 15:28'!
listCostume
	^CListCostume! !

!CDefaultWidgetLibrary methodsFor: 'menus' stamp: 'ar 1/22/2005 17:20'!
menuClass
	^CMenu! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 9/5/2009 17:56'!
menuColor
	"Answer the color for menu backgrounds "
	QwaqColors ifTrue: [ ^ (Color r: 0.985 g: 0.98 b: 0.975) ].
	^ Color white! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 9/12/2009 13:09'!
menuColors
	"Answer the gradient to be used for menu bar backgrounds"
	QwaqColors ifTrue: [ 
		^ { (Color r: 0.988 g: 0.983 b: 0.981) .  (Color r: 0.845 g: 0.837 b: 0.834) } ].

	^{Color white. self paneColor }! !

!CDefaultWidgetLibrary methodsFor: 'menus' stamp: 'ar 8/18/2005 23:25'!
menuCostume
	^CMenuCostume2! !

!CDefaultWidgetLibrary methodsFor: 'menus' stamp: 'bgf 7/10/2009 22:58'!
menuFont
	^ (TextConstants includesKey: #'Lucida Grande') ifTrue: [
		 (TextConstants at: #'Lucida Grande') fontOfPointSize: 12.
	] ifFalse: [
		StrikeFont familyName: #BitstreamVeraSans pointSize: 10
	]! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 8/24/2007 23:53'!
menuFrameColor
	"This is the color to be used for 1px borders (framing) around menus."
	^ Color gray: 0.6! !

!CDefaultWidgetLibrary methodsFor: 'menus' stamp: 'ar 3/14/2005 21:13'!
menuItemCostume
	^CMenuItemCostume! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'ar 8/18/2005 22:10'!
menuLabelColor
	"Answer the color of text in menu labels"
	^self baseColor mixed: 0.5 with: Color white! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'ar 8/18/2005 22:10'!
menuLabelTextColor
	"Answer the color of text in menu labels"
	^self baseColor mixed: 0.3 with: Color black! !

!CDefaultWidgetLibrary methodsFor: 'buttons' stamp: 'bgf 9/11/2009 14:17'!
mouseOverHighlightForButton: aButton
	"A gentle warming effect on mouseover."
	^ (CFillingHighlight new)
		name: #mouseOverHighlight;
		fill: ((CCostumeFill new)
				colors: { (Color r:0.98 g:0.92 b:0.7) . (Color r:0.7 g:0.45 b:0.28) };
				style: #verticalGradient;
				frame: (aButton bounds);
				alpha: 0.11;
				yourself )
		yourself! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'ar 1/22/2005 15:28'!
noColor
	"noColor exists only to describe that we *mean* to use a symbolic color from the library"
	^Color transparent! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 9/12/2009 13:10'!
paneColor
	"This is a much lighter variant of the base color, used for interior panes"
	ImparaColors ifTrue:[^(Color r: 0.98 g: 0.98 b: 0.99)].
	QwaqColors ifTrue: [ ^ (Color r: 0.943 g: 0.938 b: 0.927)  ].

	^(Color r: 0.95 g: 0.96 b: 0.97)

	" ^(Color r: 1.0 g: 0.936 b: 0.827)" ! !

!CDefaultWidgetLibrary methodsFor: 'lists' stamp: 'ar 5/24/2005 12:18'!
popUpListCostume
	^CPopUpListCostume! !

!CDefaultWidgetLibrary methodsFor: 'basic' stamp: 'ar 1/22/2005 15:28'!
progressBarCostume
	^CProgressBarCostume! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 4/29/2007 13:45'!
progressColors
	"The colors for the moving part of progress indicators,
	 a gentle gradient with a warmer green at the leading edge."
	^ {  Color r: 0.12 g: 0.9 b: 0.32 . Color r: 0.18 g: 0.9 b: 0.02 }! !

!CDefaultWidgetLibrary methodsFor: 'buttons' stamp: 'ar 1/22/2005 15:28'!
pushButtonCostume
	^CPushButtonCostume! !

!CDefaultWidgetLibrary methodsFor: 'buttons' stamp: 'ar 1/22/2005 15:28'!
radioButtonCostume
	^CRadioButtonCostume! !

!CDefaultWidgetLibrary methodsFor: 'scrolling' stamp: 'ar 1/22/2005 15:28'!
scrollBarCostume
	^CScrollBarCostume! !

!CDefaultWidgetLibrary methodsFor: 'scrolling' stamp: 'bgf 6/23/2010 13:00'!
scrollBarHeight
	"Answer the default height for scrollbars"
	^16! !

!CDefaultWidgetLibrary methodsFor: 'scrolling' stamp: 'ar 1/22/2005 15:28'!
scrollPaneCostume
	^CScrollPaneCostume! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 9/5/2009 17:54'!
scrollbarGradientColors
	"This describes the colors to use for any gradients,
	 such as push buttons and scroll bar elements."

	QwaqColors ifTrue: [ 
		^ { (Color r: 0.965 g: 0.95 b: 0.933) . 
			(Color r: 0.85 g: 0.825 b: 0.815)} ].

	^{Color white. self baseColor}! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 8/10/2008 20:14'!
selectionColor
	"The base color for this scheme"
	ImparaColors ifTrue:[^Color r: 0.341 g: 0.638 b: 0.741].
	^(Color r: 0.44 g: 0.55 b: 0.85)

	" ^(Color r: 1.0 g: 0.677 b: 0.032) "! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 8/25/2007 00:08'!
separatorColor
	"The color of menu separators"
	^ Color gray: 0.7! !

!CDefaultWidgetLibrary methodsFor: 'basic' stamp: 'ar 1/22/2005 15:28'!
sliderCostume
	^CSliderCostume! !

!CDefaultWidgetLibrary methodsFor: 'scrolling' stamp: 'ar 1/22/2005 15:28'!
spinnerCostume
	^CSpinnerCostume! !

!CDefaultWidgetLibrary methodsFor: 'lists' stamp: 'ar 1/22/2005 15:28'!
spinnerListCostume
	^CSpinnerListCostume! !

!CDefaultWidgetLibrary methodsFor: 'lists' stamp: 'ar 1/22/2005 15:28'!
stringListCostume
	^CStringListCostume! !

!CDefaultWidgetLibrary methodsFor: 'styling' stamp: 'ar 7/7/2005 09:21'!
styleSheetFor: aWidget
	"Answer the default style sheet applicable to aWidget"
	^nil! !

!CDefaultWidgetLibrary methodsFor: 'buttons' stamp: 'ar 1/22/2005 15:28'!
tabButtonCostume
	^CTabButtonCostume! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'bgf 6/22/2008 20:13'!
textSelectionColor
	^Display depth <= 2
		ifTrue: [Color black]
		ifFalse: [Color r: 0.75 g: 0.8 b: 0.9 "(Color r: 1 g: 0.8 b: 0.45)"]! !

!CDefaultWidgetLibrary methodsFor: 'lists' stamp: 'ar 1/22/2005 15:28'!
treeCostume
	^CTreeWidgetCostume! !

!CDefaultWidgetLibrary methodsFor: 'windows' stamp: 'ar 1/22/2005 15:28'!
windowBorderStyle
	"window border style is style used for borders inside the window"
	Preferences innerBorderStyle
		ifTrue:[^#inner]
		ifFalse:[^#inset]! !

!CDefaultWidgetLibrary methodsFor: 'windows' stamp: 'ar 1/22/2005 15:28'!
windowBorderWidth
	"Answer the width to be used for windows and their elements"
	^Preferences thickWindowFrame ifTrue:[4] ifFalse:[2]! !

!CDefaultWidgetLibrary methodsFor: 'colors' stamp: 'ar 1/22/2005 15:28'!
windowColor
	^self baseColor! !

!CDefaultWidgetLibrary methodsFor: 'windows' stamp: 'ar 1/22/2005 15:28'!
windowCostume
	^CWindowCostume! !

!CDefaultWidgetLibrary methodsFor: 'windows' stamp: 'ar 1/22/2005 15:28'!
windowFrame
	^Preferences texturedWindowFrame
		ifTrue:[CTexturedWindowFrame]
		ifFalse:[CWindowCostumeFrame]! !

CPlayer subclass: #CFileDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-FileDialog'!

CFileDialog defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="directory" toSet="directory:" changeEvent="directoryChanged">directory</field>
	<field toGet="fileList" toSet="fileList:" changeEvent="fileListChanged">fileList</field>
	<field toGet="fileName" toSet="fileName:" changeEvent="fileNameChanged">fileName</field>
	<field toGet="selectedPattern" toSet="selectedPattern:" changeEvent="selectedPatternChanged">selectedPattern</field>
	<field toGet="filePatternList" toSet="filePatternList:" changeEvent="filePatternListChanged">filePatternList</field>
	<field toGet="showDirectories" toSet="showDirectories:" changeEvent="showDirectoriesChanged">showDirectories</field>
	<field toGet="window" toSet="window:" changeEvent="windowChanged">window</field>
	<field toGet="fullName" toSet="fullName:" changeEvent="fullNameChanged">fullName</field>
	<field toGet="sorter" toSet="sorter:" changeEvent="sorterChanged">sorter</field>
	<field toGet="rootDirectories" toSet="rootDirectories:" changeEvent="rootDirectoriesChanged">rootDirectories</field>
</fields>'!

!CFileDialog class methodsFor: 'defaults' stamp: 'ar 3/13/2004 16:36'!
defaultImageSpec
	^#(
		('Images' ('*.png' '*.jpg' '*.jpeg' '*.gif' '*.bmp'))
		('PNG' ('*.png'))
		('JPG' ('*.jpg' '*.jpeg'))
		('GIF' ('*.gif'))
		('BMP' ('*.bmp'))
	)! !

!CFileDialog class methodsFor: 'defaults' stamp: 'ar 3/13/2004 16:37'!
defaultProjectDirectories
	"CFileDialog defaultProjectDirectories"
	^{FileDirectory default},
	(ServerDirectory serverNames collect:[ :n | ServerDirectory serverNamed: n]),
		ServerDirectory localProjectDirectories.! !

!CFileDialog class methodsFor: 'utilities' stamp: 'ar 3/14/2004 02:25'!
iconForDirectoryEntry: dirEntry
	| types mimeType |
	dirEntry isDirectory ifTrue:[^nil].
	types := FileDirectory default mimeTypesFor: dirEntry name.
	types isEmptyOrNil ifTrue:[^nil].
	mimeType := types first.
	('image/gif' = mimeType) ifTrue:[^self imageIconFrom: dirEntry].
	('image/bmp' = mimeType) ifTrue:[^self imageIconFrom: dirEntry].
	('image/png' = mimeType) ifTrue:[^self imageIconFrom: dirEntry].
	('image/jpeg' = mimeType) ifTrue:[^self imageIconFrom: dirEntry].
	('image/*' match: mimeType) ifTrue:[^nil].
	('audio/*' match: mimeType) ifTrue:[^nil].
	('video/*' match: mimeType) ifTrue:[^nil].
	('application/*' match: mimeType) ifTrue:[^nil].
	('model/*' match: mimeType) ifTrue:[^nil].
	('text/*' match: mimeType) ifTrue:[^nil].
	^nil! !

!CFileDialog class methodsFor: 'utilities' stamp: 'ar 3/14/2004 02:25'!
imageIconFrom: dirEntry
	"Answer the appropriate image icon for the given directory entry"
! !

!CFileDialog class methodsFor: 'instance creation' stamp: 'ar 3/12/2004 23:20'!
new
	^super new
	"| dialog |
	dialog := CPlayer loadPlayerFrom: #('Tweak' 'Dialogs' 'FileDialog.sqp').
	dialog gotoDirectory: FileDirectory default.
	^dialog"! !

!CFileDialog class methodsFor: 'file opening' stamp: 'ar 3/13/2004 15:55'!
openFile
	^self openFile: #(
		('All Files' ('*'))
	) label: nil! !

!CFileDialog class methodsFor: 'file opening' stamp: 'ar 3/13/2004 15:55'!
openFile: fileSpec
	^self openFile: fileSpec label: nil! !

!CFileDialog class methodsFor: 'file opening' stamp: 'ar 3/13/2004 16:24'!
openFile: fileSpec label: aString
	^self new openFile: fileSpec label: aString! !

!CFileDialog class methodsFor: 'file opening' stamp: 'ar 3/13/2004 16:35'!
openImageFile
	"An example for using file specs"
	"CFileDialog openImageFile"
	^self openFile: self defaultImageSpec! !

!CFileDialog methodsFor: 'events' stamp: 'tk 1/4/2005 15:08'!
accept
	"Accept the current file name and proceed"
	| pattern newName |
	fileName isEmpty ifTrue:[^self].
	pattern := filePatternList selection.
	pattern
		ifNil:[newName := fileName asString]
		ifNotNil:[newName := pattern forceMatch: fileName asString].
	(self acceptFile: newName) == true ifFalse:[^self].
	fullName := directory fullNameFor: newName.
	(window ifNil:[self]) close.! !

!CFileDialog methodsFor: 'events' stamp: 'ar 3/13/2004 16:05'!
acceptFile: aString
	"Answer whether it is okay to accept the given (local) file name."
	^true! !

!CFileDialog methodsFor: 'events' stamp: 'ar 3/12/2004 23:16'!
cancel
	"Cancel the operation"
	fullName := nil.
	(window ifNil:[self]) close.! !

!CFileDialog methodsFor: 'initialize' stamp: 'ar 3/12/2004 20:42'!
defaultCostume
	^CFileDialogCostume! !

!CFileDialog methodsFor: 'initialize' stamp: 'ar 3/13/2004 16:28'!
defaultLabel
	^self class name allButFirst! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:30'!
directory
	"Answer the directory of the receiver"
	<bewareOf: #directoryChanged>
	^self propertyValueAt: #directory! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:30'!
directory: aValue
	"Modify the receiver's directory"
	^self propertyValueAt: #directory put: aValue with: #directoryChanged! !

!CFileDialog methodsFor: 'events' stamp: 'ar 3/12/2004 23:08'!
doubleClick: entry
	entry ifNil:[^self].
	entry isDirectory ifTrue:[
		directory := directory directoryNamed: entry name.
	] ifFalse:[
		fileName := entry name.
		self accept.
	].! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:28'!
fileList
	"Answer the fileList of the receiver"
	<bewareOf: #fileListChanged>
	^self propertyValueAt: #fileList! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:28'!
fileList: aValue
	"Modify the receiver's fileList"
	^self propertyValueAt: #fileList put: aValue with: #fileListChanged! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:28'!
fileName
	"Answer the fileName of the receiver"
	<bewareOf: #fileNameChanged>
	^self propertyValueAt: #fileName! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:28'!
fileName: aValue
	"Modify the receiver's fileName"
	^self propertyValueAt: #fileName put: aValue with: #fileNameChanged! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:37'!
filePatternList
	"Answer the filePatternList of the receiver"
	<bewareOf: #filePatternListChanged>
	^self propertyValueAt: #filePatternList! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:37'!
filePatternList: aValue
	"Modify the receiver's filePatternList"
	^self propertyValueAt: #filePatternList put: aValue with: #filePatternListChanged! !

!CFileDialog methodsFor: 'initialize' stamp: 'ar 5/10/2005 17:06'!
fileSpec: patternList
	| pattern |
	filePatternList := CCollection withAll:(
		patternList collect:[:spec|
			pattern := CFileDialogPattern new.
			pattern description: spec first.
			pattern patterns: spec last.
			pattern]).
	filePatternList cursor: 1.! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 22:58'!
fullName
	"Answer the fullName of the receiver"
	<bewareOf: #fullNameChanged>
	^self propertyValueAt: #fullName! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 22:58'!
fullName: aValue
	"Modify the receiver's fullName"
	^self propertyValueAt: #fullName put: aValue with: #fullNameChanged! !

!CFileDialog methodsFor: 'initialize' stamp: 'ar 4/3/2004 13:54'!
initialize
	super initialize.
	showDirectories := true.
	self define: #filePatternList as: CCollection new.
	self define: #fileList as: CCollection new.
	rootDirectories := FileDirectory root directories.
	fileName := ''.
	self sorter: CFileDialogSorter new.
	self showDirectories: true.
	directory := FileDirectory default.
! !

!CFileDialog methodsFor: 'events' stamp: 'ar 3/12/2004 23:23'!
onDirectoryChanged
	<on: directoryChanged>
	self updateFileList.! !

!CFileDialog methodsFor: 'events' stamp: 'ar 3/12/2004 22:22'!
onFileListCursorChanged
	| entry |
	<on: cursorChanged in: fileList>
	entry := fileList selection.
	entry ifNil:[^fileName := ''].
	entry isDirectory 
		ifTrue:[fileName := '']
		ifFalse:[fileName := fileList selection fileName].! !

!CFileDialog methodsFor: 'events' stamp: 'ar 3/13/2004 13:32'!
onOpen
	<on: opened>
	self updateFileList.! !

!CFileDialog methodsFor: 'events' stamp: 'ar 3/25/2004 11:22'!
onPatternChanged
	<on: cursorChanged in: filePatternList>
	self onDirectoryChanged.! !

!CFileDialog methodsFor: 'opening' stamp: 'ar 3/13/2004 16:51'!
openFile
	^self openFile: #()! !

!CFileDialog methodsFor: 'opening' stamp: 'ar 3/13/2004 16:29'!
openFile: fileSpec
	^self openFile: fileSpec label: nil! !

!CFileDialog methodsFor: 'opening' stamp: 'ar 3/13/2004 16:51'!
openFile: fileSpec label: aString
	self fileSpec: fileSpec.
	^self openLabel: aString.! !

!CFileDialog methodsFor: 'opening' stamp: 'bgf 1/3/2009 10:09'!
openLabel: label
	"Run the file dialog"

	self define: #window as: CWindow new.
	window player: self.
	window layout: CProportionalLayout new.
	window maximizeBox: false.
	window minimizeBox: false.
	window label: (label ifNil:[self defaultLabel]).
	window floating: true.
	window extent: self extent.
	window add: self.

	self layoutFrame: (0@0 corner: 1@1).

	window openCenteredAt: self hand world dialogCenter..
	window waitUntil: #closed.
	^self fullName! !

!CFileDialog methodsFor: 'sorting' stamp: 'ar 3/13/2004 14:42'!
resort
	fileList contents: (sorter sort: fileList contents)! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:15'!
rootDirectories
	"Answer the rootDirectories of the receiver"
	<bewareOf: #rootDirectoriesChanged>
	^self propertyValueAt: #rootDirectories! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:15'!
rootDirectories: aValue
	"Modify the receiver's rootDirectories"
	^self propertyValueAt: #rootDirectories put: aValue with: #rootDirectoriesChanged! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 16:26'!
rootDirectory
	^self rootDirectories anyOne! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 16:26'!
rootDirectory: aDirectory
	^self rootDirectories: (Array with: aDirectory)! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:37'!
selectedPattern
	"Answer the selectedPattern of the receiver"
	<bewareOf: #selectedPatternChanged>
	^self propertyValueAt: #selectedPattern! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:37'!
selectedPattern: aValue
	"Modify the receiver's selectedPattern"
	^self propertyValueAt: #selectedPattern put: aValue with: #selectedPatternChanged! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 22:05'!
showDirectories
	"Answer the showDirectories of the receiver"
	<bewareOf: #showDirectoriesChanged>
	^self propertyValueAt: #showDirectories! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 22:05'!
showDirectories: aValue
	"Modify the receiver's showDirectories"
	^self propertyValueAt: #showDirectories put: aValue with: #showDirectoriesChanged! !

!CFileDialog methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:12'!
sortByDate
	sorter sortByDate.
	fileList contents: (sorter sort: fileList contents).! !

!CFileDialog methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:12'!
sortByName
	sorter sortByName.
	fileList contents: (sorter sort: fileList contents).! !

!CFileDialog methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:12'!
sortBySize
	sorter sortBySize.
	fileList contents: (sorter sort: fileList contents).! !

!CFileDialog methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:12'!
sortByType
	sorter sortByType.
	fileList contents: (sorter sort: fileList contents).! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:11'!
sorter
	"Answer the sorter of the receiver"
	<bewareOf: #sorterChanged>
	^self propertyValueAt: #sorter! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:11'!
sorter: aValue
	"Modify the receiver's sorter"
	^self propertyValueAt: #sorter put: aValue with: #sorterChanged! !

!CFileDialog methodsFor: 'events' stamp: 'ar 5/10/2005 14:33'!
updateFileList
	| list pattern item |
	self isOpen ifFalse:[^self].
	pattern := filePatternList selection ifNil:['*'].
	directory ifNil:[^fileList contents: #()].
	[Cursor wait showWhile:[
		list := directory entries asArray select:[:each| 
			(pattern match: each name) or:[each isDirectory and:[showDirectories]]
		].
		list := list collect:[:each| 
			item := CDirectoryEntry new.
			item directory: directory.
			item entry: each.
			item].
		fileList contents: (sorter sort: list).
	]] on: Error do:[:ex| self handleError: ex ifNone:[CDialog abortRetryDebug: ex]].! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 22:56'!
window
	"Answer the window of the receiver"
	<bewareOf: #windowChanged>
	^self propertyValueAt: #window! !

!CFileDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 22:56'!
window: aValue
	"Modify the receiver's window"
	^self propertyValueAt: #window put: aValue with: #windowChanged! !

CFileDialog subclass: #CFileOpenDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-FileDialog'!

CFileOpenDialog defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CFileOpenDialog methodsFor: 'initialize' stamp: 'ar 3/13/2004 16:50'!
acceptFile: newName
	"Accept an old file only"
	fileList do:[:entry| entry name = newName ifTrue:[^true]].
	CDialog inform: 'No such file: ', newName printString
			centerAt: self globalBounds center.
	^false! !

!CFileOpenDialog methodsFor: 'initialize' stamp: 'ar 3/13/2004 15:50'!
defaultCostume
	^CFileOpenDialogCostume! !

!CFileOpenDialog methodsFor: 'initialize' stamp: 'ar 3/13/2004 16:03'!
initialize
	super initialize.
	self showDirectories: false.! !

CFileDialog subclass: #CFileSaveDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-FileDialog'!

CFileSaveDialog defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CFileSaveDialog methodsFor: 'initialize' stamp: 'ar 5/10/2005 17:31'!
acceptFile: newName
	"Accept a new file or ask user if it is okay to overwrite"
	fileList do:[:entry| entry name = newName ifTrue:[
		^(CDialog confirm: newName printString,' already exists.\Do you want to overwrite it?' withCRs centerAt: self globalBounds center) ifNil:[false].
	]].
	^true! !

!CFileSaveDialog methodsFor: 'initialize' stamp: 'ar 3/13/2004 15:50'!
defaultCostume
	^CFileSaveDialogCostume! !

!CFileSaveDialog methodsFor: 'initialize' stamp: 'ar 2/21/2007 14:35'!
initialize
	super initialize.
	self showDirectories: true.
	sorter primarySort: #compareTypeNot:with:.
	sorter secondarySort: #compareName:with:.
	fileName := 'type file name here'.! !

CPlayer subclass: #CFileDialogPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-FileDialog'!

!CFileDialogPattern commentStamp: 'ar 3/27/2004 19:34' prior: 0!
CFileDialogPattern describe a particular list of file extension to filter in a file dialog.!

CFileDialogPattern defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="description" toSet="description:" changeEvent="descriptionChanged">description</field>
	<field toGet="patterns" toSet="patterns:" changeEvent="patternsChanged">patterns</field>
</fields>'!

!CFileDialogPattern methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:33'!
description
	"Answer the description of the receiver"
	<bewareOf: #descriptionChanged>
	^self propertyValueAt: #description! !

!CFileDialogPattern methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:33'!
description: aValue
	"Modify the receiver's description"
	^self propertyValueAt: #description put: aValue with: #descriptionChanged! !

!CFileDialogPattern methodsFor: 'accessing' stamp: 'ar 3/13/2004 05:47'!
displayText
	^description! !

!CFileDialogPattern methodsFor: 'matching' stamp: 'ar 3/12/2004 20:35'!
forceMatch: aString
	"force a match between the pattern and aString"
	(self match: aString) ifTrue:[^aString].
	^aString, (patterns first allButFirst)! !

!CFileDialogPattern methodsFor: 'initialize' stamp: 'ar 3/12/2004 20:34'!
initialize
	super initialize.
	description := 'All files'.
	patterns := #('*').
! !

!CFileDialogPattern methodsFor: 'matching' stamp: 'ar 3/12/2004 20:35'!
match: aFilename
	"Answer whether I match the given file name"
	^patterns anySatisfy:[:any| any match: aFilename]! !

!CFileDialogPattern methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:33'!
patterns
	"Answer the patterns of the receiver"
	<bewareOf: #patternsChanged>
	^self propertyValueAt: #patterns! !

!CFileDialogPattern methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:33'!
patterns: aValue
	"Modify the receiver's patterns"
	^self propertyValueAt: #patterns put: aValue with: #patternsChanged! !

!CFileDialogPattern methodsFor: 'printing' stamp: 'ar 3/12/2004 20:35'!
printOn: aStream
	description ifNotNil:[aStream nextPutAll: description].
	aStream nextPutAll: ' ('.
	patterns
		do:[:pattern| aStream nextPutAll: pattern] 
		separatedBy:[aStream nextPutAll:', '].
	aStream nextPutAll: ')'.! !

CPlayer subclass: #CFileDialogSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-FileDialog'!

!CFileDialogSorter commentStamp: 'ar 3/27/2004 19:34' prior: 0!
CFileDialogSorter performs a two-order sort of elements.!

CFileDialogSorter defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="primarySort" toSet="primarySort:" changeEvent="primarySortChanged">primarySort</field>
	<field toGet="secondarySort" toSet="secondarySort:" changeEvent="secondarySortChanged">secondarySort</field>
</fields>'!

!CFileDialogSorter methodsFor: 'comparing' stamp: 'ar 3/13/2004 02:07'!
compareDate: a with: b
	a isDirectory = b isDirectory ifFalse:[
		a isDirectory ifTrue:[^-1] ifFalse:[^1]
	].
	^(a modificationTime - b modificationTime) sign! !

!CFileDialogSorter methodsFor: 'comparing' stamp: 'ar 3/13/2004 02:07'!
compareDateNot: a with: b
	^self compareDate: b with: a! !

!CFileDialogSorter methodsFor: 'comparing' stamp: 'ar 3/13/2004 02:07'!
compareName: a with: b
	a isDirectory = b isDirectory ifFalse:[
		a isDirectory ifTrue:[^-1] ifFalse:[^1]
	].
	^(a fileName compare: b fileName) - 2! !

!CFileDialogSorter methodsFor: 'comparing' stamp: 'ar 3/13/2004 02:07'!
compareNameNot: a with: b
	^self compareName: b with: a! !

!CFileDialogSorter methodsFor: 'comparing' stamp: 'ar 3/13/2004 02:08'!
compareSize: a with: b
	a isDirectory = b isDirectory ifFalse:[
		a isDirectory ifTrue:[^-1] ifFalse:[^1]
	].
	^(a fileSize - b fileSize) sign! !

!CFileDialogSorter methodsFor: 'comparing' stamp: 'ar 3/13/2004 02:08'!
compareSizeNot: a with: b
	^self compareSize: b with: a! !

!CFileDialogSorter methodsFor: 'comparing' stamp: 'ar 3/13/2004 02:08'!
compareType: a with: b
	a isDirectory = b isDirectory ifFalse:[
		a isDirectory ifTrue:[^-1] ifFalse:[^1]
	].
	^(a extension compare: b extension) - 2! !

!CFileDialogSorter methodsFor: 'comparing' stamp: 'ar 3/13/2004 02:08'!
compareTypeNot: a with: b
	^self compareType: b with: a! !

!CFileDialogSorter methodsFor: 'initialize' stamp: 'ar 3/13/2004 02:40'!
initialize
	super initialize.
	self sortBySize.
	self sortByName.! !

!CFileDialogSorter methodsFor: 'testing' stamp: 'ar 3/13/2004 02:08'!
isSortedByDate
	^primarySort == #compareDate:with: or:[ primarySort == #compareDateNot:with:]! !

!CFileDialogSorter methodsFor: 'testing' stamp: 'ar 3/13/2004 02:08'!
isSortedByName
	^primarySort == #compareName:with: or:[ primarySort == #compareNameNot:with:]! !

!CFileDialogSorter methodsFor: 'testing' stamp: 'ar 3/13/2004 02:09'!
isSortedBySize
	^primarySort == #compareSize:with: or:[ primarySort == #compareSizeNot:with:]! !

!CFileDialogSorter methodsFor: 'testing' stamp: 'ar 3/13/2004 02:09'!
isSortedByType
	^primarySort == #compareType:with: or:[ primarySort == #compareTypeNot:with:]! !

!CFileDialogSorter methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:06'!
primarySort
	"Answer the primarySort of the receiver"
	<bewareOf: #primarySortChanged>
	^self propertyValueAt: #primarySort! !

!CFileDialogSorter methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:06'!
primarySort: aValue
	"Modify the receiver's primarySort"
	^self propertyValueAt: #primarySort put: aValue with: #primarySortChanged! !

!CFileDialogSorter methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:07'!
secondarySort
	"Answer the secondarySort of the receiver"
	<bewareOf: #secondarySortChanged>
	^self propertyValueAt: #secondarySort! !

!CFileDialogSorter methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:07'!
secondarySort: aValue
	"Modify the receiver's secondarySort"
	^self propertyValueAt: #secondarySort put: aValue with: #secondarySortChanged! !

!CFileDialogSorter methodsFor: 'private' stamp: 'ar 3/13/2004 02:10'!
setSorter: sorter or: sorterRev
	primarySort == sorter ifTrue:[^primarySort := sorterRev].
	primarySort == sorterRev ifTrue:[^primarySort := sorter].
	secondarySort := primarySort.
	primarySort := sorter.! !

!CFileDialogSorter methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:09'!
sort: aList
	"Resort the elements according to new settings"
	| diff |
	^aList sort:[:itemA :itemB|
		diff := self perform: primarySort with: itemA with: itemB.
		diff = 0 ifTrue:[diff := self perform: secondarySort with: itemA with: itemB].
		diff <= 0].! !

!CFileDialogSorter methodsFor: 'private' stamp: 'ar 3/13/2004 02:10'!
sortBy: sorter or: sorterRev
	self setSorter: sorter or: sorterRev.
! !

!CFileDialogSorter methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:10'!
sortByDate
	self sortBy: #compareDate:with: or: #compareDateNot:with:! !

!CFileDialogSorter methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:10'!
sortByName
	self sortBy: #compareName:with: or: #compareNameNot:with:! !

!CFileDialogSorter methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:10'!
sortBySize
	self sortBy: #compareSize:with: or: #compareSizeNot:with:! !

!CFileDialogSorter methodsFor: 'sorting' stamp: 'ar 3/13/2004 02:11'!
sortByType
	self sortBy: #compareType:with: or: #compareTypeNot:with:! !

CPlayer subclass: #CHalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Halo'!

CHalo defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="labelHolder" toSet="labelHolder:" changeEvent="labelHolderChanged">labelHolder</field>
	<field toGet="multiSelections" toSet="multiSelections:" changeEvent="multiSelectionsChanged">multiSelections</field>
	<field toGet="rootContext" toSet="rootContext:" changeEvent="rootContextChanged">rootContext</field>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="magicAlpha" toSet="magicAlpha:" changeEvent="magicAlphaChanged">magicAlpha</field>
	<field toGet="pivotHolder" toSet="pivotHolder:" changeEvent="pivotHolderChanged">pivotHolder</field>
	<field toGet="noseHolder" toSet="noseHolder:" changeEvent="noseHolderChanged">noseHolder</field>
</fields>'!

!CHalo methodsFor: 'private' stamp: 'ar 6/26/2005 12:06'!
adjustPivot
	pivotHolder ifNil:[^self].
	noseHolder ifNil:[^self].
	pivotHolder position: (self globalToLocal: (target localToGlobal: target pivot)).
	noseHolder position: pivotHolder position.
	noseHolder endPoint: (noseHolder globalToLocal: (target localToGlobal: target pivot + target nose)).
! !

!CHalo methodsFor: 'initialize' stamp: 'ar 5/22/2005 19:16'!
beHalo
	"Mark me as being actually used as a halo"
	self userDraw: true.
	self visible: false.! !

!CHalo methodsFor: 'testing' stamp: 'ar 12/3/2003 14:25'!
containsPoint: aPoint
	"hide me from clicks and other"
	^false! !

!CHalo methodsFor: 'queries' stamp: 'ar 4/19/2005 17:46'!
handleNamed: aSymbol do: aBlock
	elements do:[:h| h value == aSymbol ifTrue:[aBlock value: h]].! !

!CHalo methodsFor: 'initialize' stamp: 'sw 5/18/2005 12:11'!
handleSpecs
	"Answer specs defining the halo handles to use."

	^ Preferences debugHaloHandle
	 	ifFalse:
			[{{#haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.5.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.5.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 'r'. 		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.5.		Color cyan. 'v'. 	'Open Viewer'	}}]
		ifTrue:
			[{{ #haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.66667.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.66667.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloDebug.  1.0.		0.33333.		Color cyan muchLighter. 'D'. 'Debug'}.
			{ #haloTile.      0.0.		0.33333.	Color orange.	 't'.		'Tile'			}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 'r'. 		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.66667.		Color cyan. 'v'. 	'Open Viewer'	}}]
	! !

!CHalo methodsFor: 'initialize' stamp: 'ar 6/25/2005 22:30'!
initialize
	"Note: CHalo should be set to be custom draw by user, so it is possible to edit it."
	| handle frame cc haloLabel |
	super initialize.
	magicAlpha := 1.0.

	labelHolder:= (haloLabel := CInputField new).
	labelHolder autoAccept: true.
	"haloLabel roundCorners: true."
	haloLabel hResizing: #shrinkWrap.
	haloLabel color: Color white.
	haloLabel mouseCursor: Cursor normal.
	haloLabel dropShadowEnabled: true.
	haloLabel balloonHelp: 'Click to rename'.
	self add: haloLabel.

	self initializeNose.
	self initializePivot.

	self layout: CProportionalLayout new.
	self multiSelections: CMultiSelectionHalo new.
	self handleSpecs do:[:spec|
		handle := CHaloButton new.
		handle value: spec first.
		frame := CLayoutFrame new.
		frame leftFraction: spec second.
		frame leftOffset: 32 * (spec second - 0.5) - (handle width // 2).
		frame topFraction: spec third.
		frame topOffset: 32 * (spec third - 0.5) - (handle height // 2).
		handle layoutFrame: frame.
		cc := spec fourth.
		cc luminance > 0.5 ifTrue:[
			handle fillColors: {cc. cc mixed: 0.5 with: Color black}.
		] ifFalse:[
			handle textColor: Color white.
			handle fillColors: {cc mixed: 0.5 with: Color white. cc}.
		].
		handle textFont: (TextStyle named: 'HaloFont') defaultFont.
		handle text: spec fifth.
		handle balloonHelp: spec sixth.
		self add: handle.
	].
! !

!CHalo methodsFor: 'initialize' stamp: 'ar 6/25/2005 22:31'!
initializeNose
	noseHolder := CHaloNoseIndicator new.
	noseHolder extent: 100@100.
	noseHolder balloonHelp: 'Which way is ''forward''?'.
	noseHolder mouseCursor: Cursor crossHair.
	self add: noseHolder.
! !

!CHalo methodsFor: 'initialize' stamp: 'ar 6/25/2005 22:38'!
initializePivot
	pivotHolder := CPlayer new.
	pivotHolder graphicForm: (CIconLibrary at: #CenterOfRotation).
	pivotHolder extent: pivotHolder graphicForm extent.
	pivotHolder balloonHelp: 'Where is my ''position''?'.
	pivotHolder mouseCursor: Cursor crossHair.
	self add: pivotHolder.
! !

!CHalo methodsFor: 'accessing' stamp: 'tk 2/17/2005 16:01'!
labelHolder
	"Answer the labelHolder of the receiver"
	<bewareOf: #labelHolderChanged>
	^self propertyValueAt: #labelHolder! !

!CHalo methodsFor: 'accessing' stamp: 'tk 2/17/2005 16:01'!
labelHolder: aValue
	"Modify the receiver's labelHolder"
	^self propertyValueAt: #labelHolder put: aValue with: #labelHolderChanged! !

!CHalo methodsFor: 'accessing' stamp: 'ar 4/20/2005 11:47'!
magicAlpha
	"Answer the magicAlpha of the receiver"
	<bewareOf: #magicAlphaChanged>
	^self propertyValueAt: #magicAlpha! !

!CHalo methodsFor: 'accessing' stamp: 'ar 4/20/2005 11:47'!
magicAlpha: aValue
	"Modify the receiver's magicAlpha"
	^self propertyValueAt: #magicAlpha put: aValue with: #magicAlphaChanged! !

!CHalo methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:07'!
multiSelections
	"This method was automatically generated"
	<bewareOf: #multiSelectionsChanged>
	^self propertyValueAt: #multiSelections! !

!CHalo methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:21'!
multiSelections: aValue
	"This method was automatically generated"
	^self propertyValueAt: #multiSelections put: aValue with: #multiSelectionsChanged! !

!CHalo methodsFor: 'accessing' stamp: 'ar 6/25/2005 21:19'!
noseHolder
	"Answer the noseHolder of the receiver"
	<bewareOf: #noseHolderChanged>
	^self propertyValueAt: #noseHolder! !

!CHalo methodsFor: 'accessing' stamp: 'ar 6/25/2005 21:19'!
noseHolder: aValue
	"Modify the receiver's noseHolder"
	^self propertyValueAt: #noseHolder put: aValue with: #noseHolderChanged! !

!CHalo methodsFor: 'events' stamp: 'ar 6/19/2005 13:14'!
onBlueButtonDown
	| pos dragThreshold |
false ifTrue:["disabled for now"
	dragThreshold := 10. "pixels before drag"
	pos := self hand position.
	self hand forEach: #mouseMove do:[:event|
		(self hand position dist: pos) > dragThreshold 
			ifTrue:[^self onDragSelect: pos].
	] until: #mouseUp.
].
	^self onSelectTarget! !

!CHalo methodsFor: 'events' stamp: 'ar 6/24/2005 21:04'!
onDragSelect: startPos
	| selections |
	self target: nil.
	self topLeft: startPos.
	self extent: self hand position - startPos.
	self multiSelections bounds: self bounds.

	self borderColor: Color black.
	self elements do:[:each| each visible: false].
	self labelHolder visible: true.

	self hand world add: self multiSelections.
	self hand world add: self.
	self hand forEach: #mouseMove do:[
		self bounds: (self hand position rect: startPos).
		self multiSelections bounds: self bounds.
		self selectMultipleTargetsIn: (self rootContext ifNil:[self container]).
	] until: #mouseUp.

	self elements do:[:each| each visible: true].
	self borderColor: Color transparent.
	self close.

	selections := self multiSelections value.
	selections size <= 1 ifTrue:[
		selections size = 0 
			ifTrue:[self target: nil]
			ifFalse:[self target: selections anyOne].
		self multiSelections value: #().
		self multiSelections close.
		^self].

	self target: self multiSelections.! !

!CHalo methodsFor: 'events' stamp: 'ar 4/20/2005 12:02'!
onFadeIn
	"Fade in for magic halos"
	| max |
	<on: fadeIn>
	max := 0.3. "self isMagicHalo ifTrue:[0.3] ifFalse:[1.0]."
	[magicAlpha >= max] whileFalse:[
		magicAlpha := ((magicAlpha + (max * 0.1)) min: max).
		self waitTick.
	].! !

!CHalo methodsFor: 'events' stamp: 'ar 4/20/2005 12:08'!
onFadeOut
	"Fade in for magic halos"
	<on: fadeOut>
	[magicAlpha <= 0.05] whileTrue:[
		magicAlpha <= 0.3 
			ifTrue:[magicAlpha := magicAlpha - 0.03 max: 0.0]
			ifFalse:[magicAlpha := (magicAlpha * 0.5) max: 0.0].
		self waitTick.
	].
	visible := false.! !

!CHalo methodsFor: 'events' stamp: 'ar 6/25/2005 16:27'!
onGeometryChanged
	"geometryChanged may indicate pivot point change"
	<on: geometryChanged in: target>
	self adjustPivot.! !

!CHalo methodsFor: 'events' stamp: 'ar 6/25/2005 21:43'!
onMagicAlphaChanged
	<on: magicAlphaChanged>
	magicAlpha = 1.0 ifTrue:[
		elements do:[:each| 
			each textHolder ifNotNil:[
				each fillAlpha: magicAlpha.
				each borderColor: (each borderColor alpha: magicAlpha).
				each textColor: (each textColor alpha: magicAlpha).
				each dropShadowEnabled: true.
				each asPrimCostume localCache: CFormCache new.
			].
		].
	] ifFalse:[
		elements do:[:each| 
			each textHolder ifNotNil:[
				each fillAlpha: magicAlpha.
				each borderColor: (each borderColor alpha: magicAlpha).
				each textColor: (each textColor alpha: magicAlpha).
				each dropShadowEnabled: false.
				each asPrimCostume localCache: nil.
			].
		].
	].! !

!CHalo methodsFor: 'events' stamp: 'ar 4/19/2005 21:50'!
onNameChangedInTarget
	"Make certain that my label shows the correct name"
	<on: nameChanged in: target>
	self setLabel.! !

!CHalo methodsFor: 'events' stamp: 'ar 6/26/2005 12:06'!
onNoseMouseDown
	"Change the object's pivot point"
	| endPoint |
	<on: mouseDown in: noseHolder>
	self hand forEach: #mouseMove do:[
		endPoint := target globalToLocal: (self localToGlobal: self cursorPoint).
		target nose: (endPoint - target pivot).
	] until: #mouseUp.
! !

!CHalo methodsFor: 'events' stamp: 'ar 6/26/2005 12:08'!
onPivotMouseDown
	"Change the object's pivot point"
	<on: mouseDown in: pivotHolder>
	noseHolder visible: false.
	self hand forEach: #mouseMove do:[
		target pivot: (target globalToLocal: (self localToGlobal: self cursorPoint)).
	] until: #mouseUp.
	noseHolder visible: true.! !

!CHalo methodsFor: 'events' stamp: 'ar 4/19/2005 22:03'!
onRenameTarget
	"Rename my target"
	<on: valueChanged in: labelHolder>
	target ifNotNil:[target name: labelHolder value].! !

!CHalo methodsFor: 'events' stamp: 'pe 7/13/2005 16:50'!
onSelectTarget
	| index list cc aHand |
	aHand := self hand.
	list := aHand playersUnder: aHand world.
	list isEmpty ifTrue:[^self].
	cc := self target ifNotNil:[self target asPrimCostume].
	index := list identityIndexOf: (cc ifNil:[self rootContext]).
	index = 0 ifTrue:[
		aHand shiftPressed 
			ifTrue:[index := 1]
			ifFalse:[index := list size - 1]
	] ifFalse:[
		aHand shiftPressed
			ifTrue:[index := index+1]
			ifFalse:[index := index-1].
	].
	"@@@@: Fix this. Later figure out how to wrap and ask guys for interest"
	self target: (list atWrap: index) asPlayer haloTarget! !

!CHalo methodsFor: 'events' stamp: 'ar 6/25/2005 16:26'!
onTargetChanged: newTarget from: oldTarget
	<on: targetChanged>
	"A temporary workaround from an age where not all costumes had players"
	newTarget isPrimitiveCostume ifTrue:[self target: newTarget asPlayer].
	self stopScript: #onTargetFrameChanged.
	oldTarget ifNotNil:[
		oldTarget signal: #haloLost with: self.
		self hand releaseKeyboardFocus: self.
	].
	visible := target notNil.
	newTarget ifNotNil:[
		(newTarget == self or:[newTarget isIn: self]) ifTrue:[^self target: nil].
		self target signal: #haloObtained with: self.
		self setLabel.
		self startScript: #onTargetFrameChanged 
			when:{self target. #frameChanged}.
		self setupRepaintHandle.
		self onTargetFrameChanged.
	].
! !

!CHalo methodsFor: 'events' stamp: 'ar 1/12/2005 22:50'!
onTargetClosed
	"Hide the halo when the target is going away"
	<on: closed in: target>
	target := nil.
! !

!CHalo methodsFor: 'events' stamp: 'ar 6/25/2005 16:26'!
onTargetFrameChanged
	| trial box minExtent |
	self target ifNil:[^self].
	self visible ifFalse:[^self].
	minExtent := 70@70.
	self comeToFront.
	trial := target globalBounds expandBy: 25.
	trial extent x < minExtent x 
		ifTrue:[trial := trial expandBy: (minExtent x - trial extent x) // 2 @ 0].
	trial extent y < minExtent y 
		ifTrue:[trial := trial expandBy: 0 @ (minExtent y - trial extent y) // 2].
	box := (target world ifNil:[^self]) globalBounds.
	self globalBounds: ((trial intersect: box) insetBy: 25).
	self positionLabel.
	self adjustPivot.! !

!CHalo methodsFor: 'accessing' stamp: 'ar 6/25/2005 21:18'!
pivotHolder
	"Answer the pivotHolder of the receiver"
	<bewareOf: #pivotHolderChanged>
	^self propertyValueAt: #pivotHolder! !

!CHalo methodsFor: 'accessing' stamp: 'ar 6/25/2005 21:18'!
pivotHolder: aValue
	"Modify the receiver's pivotHolder"
	^self propertyValueAt: #pivotHolder put: aValue with: #pivotHolderChanged! !

!CHalo methodsFor: 'events' stamp: 'ar 4/19/2005 21:40'!
positionLabel
	"Position the label appropriately"
	<on: extentChanged in: labelHolder>
	labelHolder top: height+8.
	labelHolder left: width - labelHolder bounds width // 2.! !

!CHalo methodsFor: 'printing' stamp: 'bf 7/22/2004 12:40'!
roleNameFor: aPlayer
	"Describe aPlayer's role"
	| binding basePlayer |
	(binding := aPlayer componentBinding) ifNotNil:[
		^(binding home name),'''s ', binding key.
	].
	basePlayer := aPlayer player ifNil:[^aPlayer name].
	basePlayer getCostume == aPlayer ifFalse:[^aPlayer name].
	aPlayer class == CPlayer ifTrue:[
		^(basePlayer name),'''s costume'
	].
	^(basePlayer name), '''s ', aPlayer class nameForDisplay withFirstCharacterDownshifted! !

!CHalo methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:07'!
rootContext
	"This method was automatically generated"
	<bewareOf: #rootContextChanged>
	^self propertyValueAt: #rootContext! !

!CHalo methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:21'!
rootContext: aValue
	"This method was automatically generated"
	^self propertyValueAt: #rootContext put: aValue with: #rootContextChanged! !

!CHalo methodsFor: 'events' stamp: 'ar 6/19/2005 12:51'!
selectMultipleTargetsIn: aPlayer
	"Drag-select targets in aCostume"
	| selections |
	selections := IdentitySet new.
	aPlayer elements do:[:pp|
		(self worldBounds containsRect: pp worldBounds) ifTrue:[
			selections add: pp.
		].
	].
	selections remove: self ifAbsent:[].
	selections remove: multiSelections ifAbsent:[].
	selections := selections asArray sort:[:c1 :c2|
		(aPlayer asPrimCostume indexOf: c1) <= (aPlayer asPrimCostume indexOf: c2)
	].
	multiSelections value: selections.
	labelHolder value: selections size printString, ' object(s) selected'! !

!CHalo methodsFor: 'private' stamp: 'ar 6/25/2005 20:52'!
setLabel
	| labelString |
	labelString := self roleNameFor: self target.
	"Note: #contents: not #value: or else this would trigger a rename"
	labelHolder contents: labelString.! !

!CHalo methodsFor: 'events' stamp: 'ar 4/19/2005 17:58'!
setupRepaintHandle
	"Make repaint/recolor handles appear correctly"
	self target graphicForm ifNil:[
		self handleNamed: #haloRepaint do:[:h| h visible: false].
		self handleNamed: #haloRecolor do:[:h| h visible: true].
	] ifNotNil:[
		self handleNamed: #haloRepaint do:[:h| h visible: true].
		self handleNamed: #haloRecolor do:[:h| h visible: false].
	].
! !

!CHalo methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:08'!
target
	"This method was automatically generated"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CHalo methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:21'!
target: aValue
	"This method was automatically generated"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CPlayer subclass: #CHaloButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Halo'!

CHaloButton defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CHaloButton methodsFor: 'initialize' stamp: 'ar 3/24/2004 14:23'!
initialize
	super initialize.
	self extent: 16@16.
	self roundCorners: true.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: Color black.
	self fillStyle: #radialGradient.
	self fillOffset: -4@-4.
	self fillAngle: 45.
	self dropShadowEnabled: true.
	self dropShadowColor: (Color black alpha: 0.5).! !

!CHaloButton methodsFor: 'events' stamp: 'ar 2/17/2004 00:53'!
onButtonFocusLost
	<on: buttonFocusLost>
	self onMouseUp.
	self onMouseLeave.! !

!CHaloButton methodsFor: 'events' stamp: 'ar 5/22/2005 19:14'!
onMouseDown
	<on: mouseDown>
	self fillColors: self fillColors reversed.
	container signal: #haloEvent with: self.
! !

!CHaloButton methodsFor: 'events' stamp: 'ar 2/16/2004 21:20'!
onMouseEnter
	<on: mouseEnter>
	self borderColor: Color white.

! !

!CHaloButton methodsFor: 'events' stamp: 'ar 2/16/2004 21:21'!
onMouseLeave
	<on: mouseLeave>
	self borderColor: Color black.
! !

!CHaloButton methodsFor: 'events' stamp: 'ar 3/23/2004 23:44'!
onMouseUp
	<on: mouseUp>
	self fillColors: self fillColors reversed.
	(self containsPoint: self cursorPoint)
		ifTrue:[self fire]
		ifFalse:[self signal: #abortFire].

! !

!CHaloButton methodsFor: 'initialize' stamp: 'tk 7/14/2004 11:24'!
setupCostume
	super setupCostume.
	self textEnabled: true.
	self asPrimCostume localCache: CFormCache new.! !

CPlayer subclass: #CHaloNoseIndicator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Halo'!

!CHaloNoseIndicator commentStamp: '<historical>' prior: 0!
An indicator for a player's nose direction.!

CHaloNoseIndicator defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="endPoint" toSet="endPoint:" changeEvent="endPointChanged">endPoint</field>
	<field toGet="arrowSpec" toSet="arrowSpec:" changeEvent="arrowSpecChanged">arrowSpec</field>
</fields>'!

!CHaloNoseIndicator methodsFor: 'accessing' stamp: 'ar 6/25/2005 22:15'!
arrowSpec
	"Answer the arrowSpec of the receiver"
	<bewareOf: #arrowSpecChanged>
	^self propertyValueAt: #arrowSpec! !

!CHaloNoseIndicator methodsFor: 'accessing' stamp: 'ar 6/25/2005 22:15'!
arrowSpec: aValue
	"Modify the receiver's arrowSpec"
	^self propertyValueAt: #arrowSpec put: aValue with: #arrowSpecChanged! !

!CHaloNoseIndicator methodsFor: 'drawing' stamp: 'ar 6/26/2005 12:07'!
containsPoint: aPoint
	| dir end base mid |
	endPoint ifNil:[^super containsPoint: aPoint].
	"Only accept positions close to the arrow tip"
	dir := (endPoint - self pivot) normalized.
	end := (width min: height) // 2 * dir + self pivot.
	base := end - (Point r: borderWidth * arrowSpec x degrees: dir degrees).
	mid := base + end * 0.5.
	^(aPoint dist: mid) <= (base dist: end)! !

!CHaloNoseIndicator methodsFor: 'drawing' stamp: 'ar 6/26/2005 12:07'!
drawOn: aCanvas in: drawingBounds
	"Draw me"
	| cc r start end pts dir base bw deg |
	endPoint ifNil:[^super drawOn: aCanvas in: drawingBounds].
	dir := (endPoint - self pivot) normalized.
	cc := self pivot.
	r := (width min: height) // 2.
	start := cc - (r * 0.75 * dir).
	end := cc + (r * dir).

	deg := (end-start) degrees.
	bw := borderWidth.
	base := end - (Point r: bw * arrowSpec x degrees: deg).
	pts := {
		"start + (Point r: bw degrees: deg + 90)."
		start.
		base + (Point r: bw degrees: deg + 90).
		base + (Point r: bw * arrowSpec y degrees: deg + 125.0).
		end.
		base + (Point r: bw * arrowSpec y degrees: deg - 125.0).
		base + (Point r: bw degrees: deg - 90).
		"start + (Point r: bw degrees: deg - 90)."
	}.

	aCanvas drawPolygon: pts 
			color: color
			borderWidth: 1
			borderColor: borderColor.

! !

!CHaloNoseIndicator methodsFor: 'accessing' stamp: 'ar 6/25/2005 21:41'!
endPoint
	"Answer the endPoint of the receiver"
	<bewareOf: #endPointChanged>
	^self propertyValueAt: #endPoint! !

!CHaloNoseIndicator methodsFor: 'accessing' stamp: 'ar 6/25/2005 21:41'!
endPoint: aValue
	"Modify the receiver's endPoint"
	^self propertyValueAt: #endPoint put: aValue with: #endPointChanged! !

!CHaloNoseIndicator methodsFor: 'initialize' stamp: 'ar 6/25/2005 22:15'!
initialize
	super initialize.
	arrowSpec := 10@5.! !

!CHaloNoseIndicator methodsFor: 'events' stamp: 'ar 6/25/2005 22:25'!
onEndPointChanged
	<on: endPointChanged>
	self invalidate.! !

!CHaloNoseIndicator methodsFor: 'events' stamp: 'ar 6/25/2005 22:21'!
onMouseEnter
	<on: mouseEnter>
	color := Color green.! !

!CHaloNoseIndicator methodsFor: 'events' stamp: 'ar 6/25/2005 22:21'!
onMouseLeave
	<on: mouseLeave>
	color := Color white.! !

!CHaloNoseIndicator methodsFor: 'initialize' stamp: 'ar 6/25/2005 22:07'!
setupCostume
	super setupCostume.
	self userDraw := true.
	self aspectRatio := 1.
	self color := Color white.
	self borderStyle := #simple.
	self borderWidth := 2.
	self borderColor := Color black.
! !

CPlayer subclass: #CHaloResizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Halo'!

CHaloResizer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
</fields>'!

!CHaloResizer methodsFor: 'private' stamp: 'ar 3/13/2004 21:46'!
bottomCenterCursor
	^CCursorLibrary topBottomCursor! !

!CHaloResizer methodsFor: 'private' stamp: 'ar 3/13/2004 21:47'!
bottomLeftCursor
	^CCursorLibrary bottomLeftCursor! !

!CHaloResizer methodsFor: 'private' stamp: 'ar 3/13/2004 21:47'!
bottomRightCursor
	^CCursorLibrary bottomRightCursor! !

!CHaloResizer methodsFor: 'initialize' stamp: 'ar 4/2/2004 14:51'!
initialize
	super initialize.
	target := nil.
	self borderWidth: 8.
	self borderColor: (Color blue alpha: 0.2).
	self borderStyle: #simple.
	self mouseCursor: CCursorLibrary dragCursor.
	self layout: CProportionalLayout new.

	#(topLeft topCenter topRight rightCenter 
	bottomRight bottomCenter bottomLeft leftCenter) do:[:pos|
		| handle cc |
		handle := CPlayer new.
		handle extent: 8@8.
		handle color: Color white.
		handle borderWidth: 1; borderColor: Color black; borderStyle: #simple.
		handle value: pos.
		handle mouseCursor: (self perform: (pos,'Cursor') asSymbol).
		self startScript: #onResizeTarget: withArguments:{handle} when:{handle. #mouseDown}.
		handle layoutFrame: CLayoutFrame new.
		pos := (0@0 corner: 100@100) perform: pos.
		pos x = 0 ifTrue:[handle layoutFrame leftFraction: 0; leftOffset: -8].
		pos x = 50 ifTrue:[handle layoutFrame leftFraction: 0.5; leftOffset: -4].
		pos x = 100 ifTrue:[handle layoutFrame rightFraction: 1; rightOffset: 8].
		pos y = 0 ifTrue:[handle layoutFrame topFraction: 0; topOffset: -8].
		pos y = 50 ifTrue:[handle layoutFrame topFraction: 0.5; topOffset: -4].
		pos y = 100 ifTrue:[handle layoutFrame bottomFraction: 1; bottomOffset: 8].
		self add: handle.
	].
! !

!CHaloResizer methodsFor: 'private' stamp: 'ar 3/13/2004 21:46'!
leftCenterCursor
	^CCursorLibrary leftRightCursor! !

!CHaloResizer methodsFor: 'events' stamp: 'ar 5/28/2005 21:42'!
onMoveTarget
	| offset delta aTarget |
	<on: #mouseDown>
	self comeToFront.
	aTarget := target ifNil:[self].
	offset := aTarget cursorPoint.
	hand forEach: #mouseMove do:[
		delta := aTarget cursorPoint - offset.
		aTarget moveBy: delta.
	] until: #mouseUp.! !

!CHaloResizer methodsFor: 'events' stamp: 'ar 3/13/2004 21:48'!
onResizeTarget: aHandle
	| align pt box offset aTarget |
	aTarget := target ifNil:[self].
	align := (aHandle value, ':') asSymbol.
	offset := aTarget container cursorPoint - (aTarget bounds perform: aHandle value).
	hand forEach: #mouseMove do:[
		pt := aTarget container cursorPoint - offset.
		box := aTarget bounds perform: align with: pt.
		aTarget bounds: box.
	] until: #mouseUp.! !

!CHaloResizer methodsFor: 'events' stamp: 'ar 3/13/2004 21:49'!
onTargetChanged
	<on: targetChanged>
	target ifNotNil:[self onUpdateGeometry]! !

!CHaloResizer methodsFor: 'events' stamp: 'ar 3/13/2004 21:49'!
onUpdateGeometry
	| box |
	<on: frameChanged in: target>
	target == self ifTrue:[^self].
	box := target localToGlobal: target costume localBounds.
	box := container globalToLocal: box.
	self bounds: (box expandBy: borderWidth).
! !

!CHaloResizer methodsFor: 'private' stamp: 'ar 3/13/2004 21:46'!
rightCenterCursor
	^CCursorLibrary leftRightCursor! !

!CHaloResizer methodsFor: 'accessing' stamp: 'ar 3/13/2004 21:39'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CHaloResizer methodsFor: 'accessing' stamp: 'ar 3/13/2004 21:39'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

!CHaloResizer methodsFor: 'private' stamp: 'ar 3/13/2004 21:46'!
topCenterCursor
	^CCursorLibrary topBottomCursor! !

!CHaloResizer methodsFor: 'private' stamp: 'ar 3/13/2004 21:46'!
topLeftCursor
	^CCursorLibrary topLeftCursor! !

!CHaloResizer methodsFor: 'private' stamp: 'ar 3/13/2004 21:46'!
topRightCursor
	^CCursorLibrary topRightCursor! !

CPlayer subclass: #CMenuItemSeparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus-Costumes'!

CMenuItemSeparator defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CMenuItemSeparator methodsFor: 'accessing' stamp: 'ar 3/6/2004 23:07'!
action
	^nil! !

!CMenuItemSeparator methodsFor: 'accessing' stamp: 'ar 3/6/2004 23:07'!
deselect
	"do nothing"! !

!CMenuItemSeparator methodsFor: 'drawing' stamp: 'bgf 8/24/2007 23:23'!
drawOn: aCanvas in: itemBox
	| |
	super drawOn: aCanvas in: itemBox.
	"Centerline across the 9-pixel high region reserved by my preferred extent"
	aCanvas fillRectangle: (itemBox topLeft+(0@4) extent: itemBox width @ 1)
			color: CWidgetLibrary default separatorColor.! !

!CMenuItemSeparator methodsFor: 'initialize' stamp: 'bgf 8/24/2007 21:30'!
initialize
	super initialize.
	self borderWidth: 0.
	self extent: self preferredExtent.
	self color: Color transparent.
	self hResizing: #spaceFill; vResizing: #rigid.
	self userDraw: true.! !

!CMenuItemSeparator methodsFor: 'accessing' stamp: 'ar 3/13/2004 18:53'!
isSeparator
	^true! !

!CMenuItemSeparator methodsFor: 'accessing' stamp: 'bgf 8/24/2007 22:06'!
preferredExtent
	"Hieght is odd so that the 1-pixel line we draw amidships is centered."
	^10@9! !

!CMenuItemSeparator methodsFor: 'accessing' stamp: 'ar 3/6/2004 23:07'!
select
	"do nothing"! !

!CMenuItemSeparator methodsFor: 'accessing' stamp: 'ar 3/6/2004 23:06'!
subMenu
	^nil! !

CPlayer subclass: #CMultiSelectionHalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Halo'!

CMultiSelectionHalo defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CMultiSelectionHalo methodsFor: 'halo actions' stamp: 'sw 5/1/2005 06:11'!
dismissViaHalo
	"Group throw-away."

	| aProjectBuilder |
	aProjectBuilder := self world activeProject.
	self value do:
		[:aPlayer |
			aProjectBuilder addToTrash: aPlayer player. "gulp"
			aPlayer close].
	self close! !

!CMultiSelectionHalo methodsFor: 'initialize' stamp: 'ar 3/23/2004 18:09'!
initialize
	super initialize.
	self borderWidth: 1.
	self borderStyle: #simple.
	self borderColor: CWidgetLibrary default frameColor.
	self color: CWidgetLibrary default paneColor.
	self fillAlpha: 0.5.
! !

!CMultiSelectionHalo methodsFor: 'initialize' stamp: 'sw 5/13/2005 23:33'!
playersForTrash
	"Answer the list of the players to be thrown away when the receiver is sent to the trash."

	^ self value collect: [:p | p player]! !

CPlayer subclass: #CPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

!CPanel commentStamp: '<historical>' prior: 0!
Panels are graphical objects which we typically think about as being used in conjunction with a window. CPanel provides a number of utility methods for dealing with various window-related aspects. The 'window' field of a panel will typically refer to the costume but if the panel is displayed outside of a Tweak environment (either native or Morphic or whatever) it may not point to its costume.!

CPanel defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="window" toSet="window:" changeEvent="windowChanged">window</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
</fields>'!

!CPanel methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:46'!
collapse
	"Collapse the window"
	window ifNil:[^nil].
	^window collapse! !

!CPanel methodsFor: 'initialize' stamp: 'ar 5/26/2005 14:16'!
decorate: items color: aColor
	| style bw |
	style := CWidgetLibrary default windowBorderStyle.
	bw := CWidgetLibrary default windowBorderWidth.
	items do:[:each|
		each borderWidth: bw.
		each borderStyle: style.
		each borderColor: aColor.
		each windowColor: aColor.
	].
	window ifNotNil:[window windowColor: aColor].! !

!CPanel methodsFor: 'initialize' stamp: 'ar 5/26/2005 14:19'!
defaultCostume
	"If a window has been given to us just use a primitive costume"
	^window ifNil:[CWindow] ifNotNil:[super defaultCostume].! !

!CPanel methodsFor: 'initialize' stamp: 'ar 5/26/2005 13:59'!
defaultWindowColor
	"Answer the receiver's default window color"
	^CWidgetLibrary default windowColor! !

!CPanel methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:46'!
expand
	"Expand the window"
	window ifNil:[^nil].
	^window expand! !

!CPanel methodsFor: 'initialize' stamp: 'ar 5/29/2005 16:01'!
initialize
	super initialize.
	label := self class name.! !

!CPanel methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:42'!
isCollapsed
	window ifNil:[^false].
	^window isCollapsed! !

!CPanel methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:45'!
isExpanded
	window ifNil:[^false].
	^window isExpanded! !

!CPanel methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:45'!
isNormal
	window ifNil:[^true].
	^window isNormal! !

!CPanel methodsFor: 'accessing' stamp: 'ar 5/29/2005 15:56'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CPanel methodsFor: 'accessing' stamp: 'ar 5/29/2005 15:56'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CPanel methodsFor: 'events' stamp: 'ar 5/29/2005 15:57'!
onLabelChanged
	<on: labelChanged>
	label ifNil:[^self].
	window ifNil:[^self].
	window label: label.! !

!CPanel methodsFor: 'events' stamp: 'ar 5/29/2005 15:57'!
onWindowChanged
	<on: windowChanged>
	window ifNil:[^self].
	label ifNotNil:[window label: label].
	self onWindowColorChanged: window windowColor.! !

!CPanel methodsFor: 'events' stamp: 'ar 5/26/2005 13:55'!
onWindowColorChanged: newColor
	<on: windowColorChanged in: window>
	elements do:[:each| each windowColor: newColor].! !

!CPanel methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:46'!
restore
	"Restore the window"
	window ifNil:[^nil].
	^window restore! !

!CPanel methodsFor: 'initialize' stamp: 'ar 5/26/2005 13:54'!
setupCostume
	window ifNil:[window := costume].! !

!CPanel methodsFor: 'accessing' stamp: 'ar 5/26/2005 13:52'!
window
	"Answer the window of the receiver"
	<bewareOf: #windowChanged>
	^self propertyValueAt: #window! !

!CPanel methodsFor: 'accessing' stamp: 'ar 5/26/2005 13:52'!
window: aValue
	"Modify the receiver's window"
	^self propertyValueAt: #window put: aValue with: #windowChanged! !

CPlayer subclass: #CPlayerIconList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Sprites'!

!CPlayerIconList commentStamp: '<historical>' prior: 0!
I show a list of players as icons. Other players can be dropped on me and dragged out of me.!

CPlayerIconList defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="list" toSet="list:" changeEvent="listChanged">list</field>
	<field toGet="labelHolder" toSet="labelHolder:" changeEvent="labelHolderChanged">labelHolder</field>
	<field virtual="true" serializable="false" toGet="label" toSet="label:">label</field>
</fields>'!

!CPlayerIconList methodsFor: 'initialize' stamp: 'ar 6/22/2005 11:49'!
initialize
	super initialize.
	self define: #list as: CList new.
	self define: #labelHolder as: CLabel new.

	list allowDeselect: false.
	list itemMaker := CPlayerIconListItem.
	list vScrollable: nil.
! !

!CPlayerIconList methodsFor: 'accessing' stamp: 'ar 6/22/2005 11:44'!
label
	"Answer the label of the receiver"
	^labelHolder value! !

!CPlayerIconList methodsFor: 'accessing' stamp: 'ar 6/22/2005 11:45'!
label: aValue
	"Modify the receiver's label"
	^labelHolder value: aValue! !

!CPlayerIconList methodsFor: 'accessing' stamp: 'ar 6/22/2005 11:44'!
labelHolder
	"Answer the labelHolder of the receiver"
	<bewareOf: #labelHolderChanged>
	^self propertyValueAt: #labelHolder! !

!CPlayerIconList methodsFor: 'accessing' stamp: 'ar 6/22/2005 11:44'!
labelHolder: aValue
	"Modify the receiver's labelHolder"
	^self propertyValueAt: #labelHolder put: aValue with: #labelHolderChanged! !

!CPlayerIconList methodsFor: 'accessing' stamp: 'ar 6/22/2005 11:39'!
list
	"Answer the list of the receiver"
	<bewareOf: #listChanged>
	^self propertyValueAt: #list! !

!CPlayerIconList methodsFor: 'accessing' stamp: 'ar 6/22/2005 11:39'!
list: aValue
	"Modify the receiver's list"
	^self propertyValueAt: #list put: aValue with: #listChanged! !

!CPlayerIconList methodsFor: 'events' stamp: 'ar 6/22/2005 11:41'!
onDragDrop: aPlayer
	"Add the player as a new costume to the animation"
	<on: dragDrop>
	aPlayer == target ifTrue:[^aPlayer signal: #dropReject].
	aPlayer close.
	list items add: aPlayer.
	self makeSound: 'scritch'.! !

!CPlayerIconList methodsFor: 'events' stamp: 'ar 6/22/2005 11:39'!
onDragStart
	| dragTarget |
	<on: mouseDrag in: list>
	dragTarget := list removeAt: list cursor.
	self waitTick.
	^self hand attach: dragTarget! !

!CPlayerIconList methodsFor: 'events' stamp: 'ar 6/22/2005 11:41'!
onTargetChanged
	"Subclasses may override this"
	<on: targetChanged>
	target ifNil:[^self].
	list items: target elements.! !

!CPlayerIconList methodsFor: 'initialize' stamp: 'ar 6/22/2005 11:48'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self layoutInset: 0@2.
	self layout cellPositioning: #topLeft.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.

	labelHolder hResizing: #shrinkWrap.
	labelHolder textEmphasis: 1.
	self addLast: labelHolder.

	list roundCorners: true.
	list borderWidth := 1.
	list borderColor := CWidgetLibrary default frameColor.
	list borderStyle: #simple.

	list layout layoutInset: 4; cellInset: 4.
	list layout listDirection: #leftToRight.
	list layout wrapDirection: #topToBottom.
	self addLast: list.

	self vResizing: #rigid.
	self height: 82.! !

!CPlayerIconList methodsFor: 'accessing' stamp: 'ar 6/22/2005 11:39'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CPlayerIconList methodsFor: 'accessing' stamp: 'ar 6/22/2005 11:39'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CPlayerIconList subclass: #CSpriteCostumeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Sprites'!

!CSpriteCostumeList commentStamp: '<historical>' prior: 0!
I am a sprite costume list for a viewer!

CSpriteCostumeList defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CSpriteCostumeList methodsFor: 'events' stamp: 'ar 6/21/2005 20:34'!
onTargetChanged
	<on: targetChanged>
	target ifNil:[^self].
	list items: target spriteCostumes.
! !

CPlayer subclass: #CStopStepGoControls
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-EToy'!

!CStopStepGoControls commentStamp: 'sw 5/14/2005 17:49' prior: 0!
A group of buttons that can govern the ticking status of a project.!

CStopStepGoControls defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="scriptManager" toSet="scriptManager:" changeEvent="scriptManagerChanged">scriptManager</field>
	<field toGet="stopButton" toSet="stopButton:" changeEvent="stopButtonChanged">stopButton</field>
	<field toGet="stepButton" toSet="stepButton:" changeEvent="stepButtonChanged">stepButton</field>
	<field toGet="goButton" toSet="goButton:" changeEvent="goButtonChanged">goButton</field>
</fields>'!

!CStopStepGoControls methodsFor: 'accessing' stamp: 'sw 4/27/2005 01:51'!
goButton
	"Answer the goButton of the receiver"
	<bewareOf: #goButtonChanged>
	^self propertyValueAt: #goButton! !

!CStopStepGoControls methodsFor: 'accessing' stamp: 'sw 4/27/2005 01:51'!
goButton: aValue
	"Modify the receiver's goButton"
	^self propertyValueAt: #goButton put: aValue with: #goButtonChanged! !

!CStopStepGoControls methodsFor: 'initialize' stamp: 'ar 6/1/2005 11:22'!
initialize
	"Initialize the receiver"

	super initialize.
	self define: #stopButton as: CImageButton new.
	self define: #stepButton as: CImageButton new.
	self define: #goButton as: CImageButton new.
	scriptManager := Processor activeProject scriptManager.! !

!CStopStepGoControls methodsFor: 'events' stamp: 'ar 5/29/2005 19:32'!
onMouseDownInGoButton
	"Handle a mouseDown in the go button"

	<on: mouseDown in: goButton>

	scriptManager ifNotNil: [scriptManager newTickingStatus: #ticking]
	! !

!CStopStepGoControls methodsFor: 'events' stamp: 'ar 5/29/2005 19:32'!
onMouseDownInStepButton
	"Handle a mouseDown in my step button"

	<on: mouseDown in: stepButton>

	scriptManager ifNotNil:
		[scriptManager newTickingStatus: #paused]  "mouseStillDown does the individual steps"! !

!CStopStepGoControls methodsFor: 'events' stamp: 'ar 5/29/2005 19:32'!
onMouseDownInStopButton
	"Handele a mouseDown in the stop button"

	<on: mouseDown in: stopButton>

	scriptManager ifNotNil: [scriptManager newTickingStatus: #paused]
	! !

!CStopStepGoControls methodsFor: 'events' stamp: 'ar 5/29/2005 19:30'!
onMouseStillDownInStepButton
	"Handle a mouseStillDown in my step button"
	<on: mouseStillDown in: stepButton>

	scriptManager ifNotNil:
		[scriptManager allScriptorsPausedOrTicking do:
			[:scr | scr eval]]! !

!CStopStepGoControls methodsFor: 'events' stamp: 'ar 5/29/2005 19:31'!
onTickingStatusChangedInWorld: newStatus
	"The ticking status changed in the project; make certain my buttons reflect that change"

	<on: tickingStatusChanged in: scriptManager>

	goButton selected: (newStatus ~= #ticking)
! !

!CStopStepGoControls methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:28'!
scriptManager
	"Answer the scriptManager of the receiver"
	<bewareOf: #scriptManagerChanged>
	^self propertyValueAt: #scriptManager! !

!CStopStepGoControls methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:28'!
scriptManager: aValue
	"Modify the receiver's scriptManager"
	^self propertyValueAt: #scriptManager put: aValue with: #scriptManagerChanged! !

!CStopStepGoControls methodsFor: 'initialize' stamp: 'ar 6/3/2005 14:13'!
setupCostume
	"Set up the costume"

	| pic onPic |
	super setupCostume.
	self color: Color white..
	layout := CTableLayout new.
	layout hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	layout listDirection: #leftToRight.
	layout layoutInset: 2@2.
	layout cellInset: 2.
	self borderStyle: #simple..
	self borderWidth: 4; borderColor: Color brown; roundCorners: true.
	pic := (ScriptingSystem formAtKey: 'StopPic') deepCopy.
	onPic := (ScriptingSystem formAtKey: 'StopPicOn') deepCopy.
	stopButton 
		normalImage:  pic;
		disabledImage: pic;
		pressedImage:  onPic;
		balloonHelp: 'Pause all ticking scripts.' translated.
	self add: stopButton.

	pic := (ScriptingSystem formAtKey: 'StepPic') deepCopy.
	onPic := (ScriptingSystem formAtKey: 'StepPicOn') deepCopy.
	stepButton 
		normalImage:  pic;
		disabledImage: pic;
		pressedImage:  onPic;
		balloonHelp: 'Step all paused scripts.' translated.
	self add: stepButton.

	pic := (ScriptingSystem formAtKey: 'GoPic') deepCopy.
	onPic := (ScriptingSystem formAtKey: 'GoPicOn') deepCopy.
	goButton 
		normalImage:  onPic;
		disabledImage: pic;
		pressedImage:  pic;
		balloonHelp: 'Run all paused scripts.' translated.
	self add: goButton.
	! !

!CStopStepGoControls methodsFor: 'accessing' stamp: 'sw 4/27/2005 01:51'!
stepButton
	"Answer the stepButton of the receiver"
	<bewareOf: #stepButtonChanged>
	^self propertyValueAt: #stepButton! !

!CStopStepGoControls methodsFor: 'accessing' stamp: 'sw 4/27/2005 01:51'!
stepButton: aValue
	"Modify the receiver's stepButton"
	^self propertyValueAt: #stepButton put: aValue with: #stepButtonChanged! !

!CStopStepGoControls methodsFor: 'accessing' stamp: 'sw 4/27/2005 01:51'!
stopButton
	"Answer the stopButton of the receiver"
	<bewareOf: #stopButtonChanged>
	^self propertyValueAt: #stopButton! !

!CStopStepGoControls methodsFor: 'accessing' stamp: 'sw 4/27/2005 01:51'!
stopButton: aValue
	"Modify the receiver's stopButton"
	^self propertyValueAt: #stopButton put: aValue with: #stopButtonChanged! !

CPlayer subclass: #CTextConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text-Converters'!

!CTextConverter commentStamp: 'ar 3/27/2004 19:14' prior: 0!
I convert between objects and text representations. My subclasses must implement two methods - the method #printValue: which takes an object as argument and answers an appropriate text representation as well as #readValue: which takes a text as an argument and answers an appropriate object. If the input can not be converted into an appropriate object (say, when trying to read a number from something like 'foo') I am expected to raise an Error. My users will handle such error conditions. Also note that I am a role rather than a type - any object can act in my role if it implements the messages which can be found in my protocol.!

CTextConverter subclass: #CDateConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text-Converters'!

!CDateConverter commentStamp: 'ar 3/27/2004 19:13' prior: 0!
I convert between text and dates.!

CDateConverter defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="format" toSet="format:" changeEvent="formatChanged">format</field>
</fields>'!

!CDateConverter methodsFor: 'accessing' stamp: 'ar 3/19/2004 17:45'!
format
	"Answer the format of the receiver"
	<bewareOf: #formatChanged>
	^self propertyValueAt: #format! !

!CDateConverter methodsFor: 'accessing' stamp: 'ar 3/19/2004 17:45'!
format: aValue
	"Modify the receiver's format"
	^self propertyValueAt: #format put: aValue with: #formatChanged! !

!CDateConverter methodsFor: 'converting' stamp: 'ar 3/19/2004 17:46'!
printValue: aValue
	"Answer the text representation of aValue"
	format ifNil:[^aValue displayText].
	^aValue printFormat: format! !

!CDateConverter methodsFor: 'converting' stamp: 'ar 10/31/2004 15:27'!
readValue: aText
	"Answer the object representation of aText"
	"Hm... where the hell is #readFrom:format: when you need it???"
	^Date readFrom: aText asString readStream! !

CTextConverter subclass: #CNumberConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text-Converters'!

!CNumberConverter commentStamp: 'ar 3/27/2004 19:13' prior: 0!
I convert between text and numbers.!

CNumberConverter defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CNumberConverter methodsFor: 'converting' stamp: 'ar 3/19/2004 17:44'!
readValue: aText
	"Answer the object representation of aText"
	^Number readFrom: aText asString! !

CTextConverter subclass: #CStringConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text-Converters'!

!CStringConverter commentStamp: 'ar 3/27/2004 19:13' prior: 0!
I convert between text and strings. Really. For example, I strip out text formatting.!

CStringConverter defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CStringConverter methodsFor: 'converting' stamp: 'ar 3/19/2004 17:43'!
printValue: aValue
	"Answer the text representation of aValue"
	^aValue displayText asString! !

!CStringConverter methodsFor: 'converting' stamp: 'ar 3/19/2004 17:43'!
readValue: aText
	"Answer the object representation of aText"
	^aText asString! !

CTextConverter defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CTextConverter methodsFor: 'converting' stamp: 'ar 3/19/2004 17:24'!
printValue: aValue
	"Answer the text representation of aValue"
	^aValue displayText! !

!CTextConverter methodsFor: 'converting' stamp: 'ar 3/19/2004 17:25'!
readValue: aText
	"Answer the object representation of aText"
	^aText! !

CPlayer subclass: #CTextEditorPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text'!

CTextEditorPane defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="oldBorder" toSet="oldBorder:" changeEvent="oldBorderChanged">oldBorder</field>
	<field toGet="editor" toSet="editor:" changeEvent="editorChanged">editor</field>
</fields>'!

!CTextEditorPane methodsFor: 'accessing' stamp: 'ar 6/2/2004 14:57'!
editor
	"Answer the editor of the receiver"
	<bewareOf: #editorChanged>
	^self propertyValueAt: #editor! !

!CTextEditorPane methodsFor: 'accessing' stamp: 'ar 6/2/2004 14:57'!
editor: aValue
	"Modify the receiver's editor"
	^self propertyValueAt: #editor put: aValue with: #editorChanged! !

!CTextEditorPane methodsFor: 'accessing' stamp: 'ar 6/2/2004 13:09'!
oldBorder
	"Answer the oldBorder of the receiver"
	<bewareOf: #oldBorderChanged>
	^self propertyValueAt: #oldBorder! !

!CTextEditorPane methodsFor: 'accessing' stamp: 'ar 6/2/2004 13:09'!
oldBorder: aValue
	"Modify the receiver's oldBorder"
	^self propertyValueAt: #oldBorder put: aValue with: #oldBorderChanged! !

!CTextEditorPane methodsFor: 'events' stamp: 'ar 5/4/2007 16:00'!
onKeyboardFocusEnter
	"only accept input while having the keyboard focus"
	<on: keyboardFocusEnter in: editor>
	oldBorder := border copy.
	editor readOnly ifTrue:[^nil].
	oldBorder width > 0 ifTrue:[
		borderStyle := #inset.
		borderWidth := 1 max: oldBorder width.
		borderColor isTransparent 
			ifTrue:[borderColor := Color gray: 0.5].
	].
! !

!CTextEditorPane methodsFor: 'events' stamp: 'ar 6/2/2004 14:58'!
onKeyboardFocusLeave
	"only accept input while having the keyboard focus"
	<on: keyboardFocusLeave in: editor>
	border := oldBorder.
! !

!CTextEditorPane methodsFor: 'initialize' stamp: 'ar 5/19/2004 15:16'!
setupCostume
	super setupCostume.
	self text: ''.
	self mouseCursor: Cursor text.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self borderStyle: #simple.
	self textAnchorPoint: #topLeft.
	self textWrap: true.! !

CPlayer subclass: #CUserDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

!CUserDialog commentStamp: 'tk 9/13/2004 17:43' prior: 0!
A UserDialog handles various common user requests, such as asking the user for some input, and informing the user of something.
After the user types in the input field, and presses Return, the UserDialog returns a value and disappears.

### Allow Users to see the above explanation ###!

CUserDialog defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="dialogLabel" toSet="dialogLabel:" changeEvent="dialogLabelChanged">dialogLabel</field>
	<field toGet="group" toSet="group:" changeEvent="groupChanged">group</field>
	<field toGet="buttonRow" toSet="buttonRow:" changeEvent="buttonRowChanged">buttonRow</field>
	<field toGet="messageText" toSet="messageText:" changeEvent="messageTextChanged">messageText</field>
</fields>'!

!CUserDialog class methodsFor: 'instance creation' stamp: 'ar 2/6/2005 19:37'!
newSample
	| sample |
	sample := self new.
	sample label: sample name.
	sample message: '<message text goes here>'.
	sample addButton: 'OK' value: nil.
	^sample! !

!CUserDialog methodsFor: 'requests' stamp: 'bgf 3/15/2007 11:28'!
abortRetryDebug: anException label: labelString centerAt: aPoint
	| result |
	self costume. "XXX fixMe"
	dialogLabel value: labelString.
	messageText contents: anException description asText.
	messageText allowEditing: false.
	messageText hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	"Error messages can be long so make button row stick to left edge"
	buttonRow layout listCentering: #topLeft.
	buttonRow removeAll.
	self addButton: 'Abort' value: #abort.
	self addButton: 'Retry' value: #retry.
	self addButton: 'Debug' value: #debug.
	result := self run: nil centerAt: aPoint.
	result == #retry ifTrue:[^anException retry].
	result == #debug ifTrue:[^anException debug].
	^anException return	! !

!CUserDialog methodsFor: 'construction' stamp: 'bgf 2/21/2008 21:22'!
addButton: labelString
	| button |
	button := CPushButton new.
	button label: labelString.
	button hResizing: #rigid; vResizing: #rigid.
	button extent: 80@22.
	button roundCorners: true.
	button borderStyle: #simple.
	button borderColor: CWidgetLibrary default frameColor.
	buttonRow add: button.
	^button! !

!CUserDialog methodsFor: 'construction' stamp: 'ar 3/10/2004 00:50'!
addButton: labelString value: aValue
	| button |
	button := self addButton: labelString.
	self startScript: #endDialog: withArguments:{aValue} 
		when:{button. #fire}.
	^button! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:12'!
buttonRow
	"Answer the buttonRow of the receiver"
	<bewareOf: #buttonRowChanged>
	^self propertyValueAt: #buttonRow! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/11/2004 20:36'!
buttonRow: aValue
	"Modify the receiver's buttonRow"
	^self propertyValueAt: #buttonRow put: aValue with: #buttonRowChanged! !

!CUserDialog methodsFor: 'requests' stamp: 'bgf 12/7/2008 15:46'!
confirm: aString yes: yesLabel no: noLabel cancel: canLabel label: labelString centerAt: aPoint
	"Modal yes/no dialog with two buttons labeled as specifed.
	 The result is either true or false, 
	 or nil if the user cancels."

	dialogLabel value: labelString.
	buttonRow removeAll.
	messageText contents: aString asText.
	messageText allowEditing: false.
	messageText hResizing: #shrinkWrap; vResizing: #shrinkWrap.

	self addButton: yesLabel value: true.
	self addButton: noLabel value: false.
	self addButton: canLabel value: nil.

	"Test-harness hook... make this an observable occurrence.
	 (An automated demon may need to acknowledge this to proceed normally.)
	 We use Smalltalk here as simply a well-known global object."
	Smalltalk signal: #ConfirmDialog with: self.

	"Place this at center (if aPoint is nil) unless otherwise directed."
	^self run: nil centerAt: aPoint! !

!CUserDialog methodsFor: 'requests' stamp: 'bgf 5/2/2008 14:36'!
confirm: aString yes: yesLabel no: noLabel label: labelString centerAt: aPoint
	"Modal yes/no dialog with two buttons labeled as specifed.
	 The result is either true or false, 
	 or nil if the user somehow and closes the dialog without pressing a dialog button."

	dialogLabel value: labelString.
	buttonRow removeAll.
	messageText contents: aString asText.
	messageText allowEditing: false.
	messageText hResizing: #shrinkWrap; vResizing: #shrinkWrap.

	self addButton: yesLabel value: true.
	self addButton: noLabel value: false.

	"Test-harness hook... make this an observable occurrence.
	 (An automated demon may need to acknowledge this to proceed normally.)
	 We use Smalltalk here as simply a well-known global object."
	Smalltalk signal: #ConfirmDialog with: self.

	"Place this at center (if aPoint is nil) unless otherwise directed."
	^self run: nil centerAt: aPoint! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:12'!
dialogLabel
	"Answer the dialogLabel of the receiver"
	<bewareOf: #dialogLabelChanged>
	^self propertyValueAt: #dialogLabel! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/11/2004 20:35'!
dialogLabel: aValue
	"Modify the receiver's dialogLabel"
	^self propertyValueAt: #dialogLabel put: aValue with: #dialogLabelChanged! !

!CUserDialog methodsFor: 'running' stamp: 'ar 3/10/2004 00:50'!
endDialog: aValue
	self value: aValue.
	self close.! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 12/19/2006 15:20'!
group
	"Answer the group of the receiver"
	<bewareOf: #groupChanged>
	^self propertyValueAt: #group! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 12/19/2006 15:20'!
group: aValue
	"Modify the receiver's group"
	^self propertyValueAt: #group put: aValue with: #groupChanged! !

!CUserDialog methodsFor: 'requests' stamp: 'bgf 5/2/2008 14:37'!
inform: aString label: labelString centerAt: aPoint
	dialogLabel textEmphasis: 1.
	dialogLabel value: labelString.
	messageText contents: aString asText.
	messageText allowEditing: false.
	messageText hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	buttonRow removeAll.
	self addButton: 'OK' value: nil.

	"Test-harness hook. make this an observable occurrence.
	 (An automated demon may need to acknowledge this to proceed normally.)
	 We use Smalltalk here as simply a well-known global object."
	Smalltalk signal: #InformDialog with: self.

	^self run: nil centerAt: aPoint! !

!CUserDialog methodsFor: 'initialize' stamp: 'ar 12/19/2006 15:21'!
initialize
	super initialize.
	self define: #dialogLabel as: CLabel new.
	self define: #messageText as: CInputField new.
	self define: #group as: CPlayer new.
	self define: #buttonRow as: CPlayer new.! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:49'!
label
	^dialogLabel value! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 02:49'!
label: aString
	dialogLabel value: aString! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 13:58'!
message
	^messageText value! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 13:58'!
message: aString
	messageText value: aString! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 13:54'!
messageText
	"Answer the messageText of the receiver"
	<bewareOf: #messageTextChanged>
	^self propertyValueAt: #messageText! !

!CUserDialog methodsFor: 'accessing' stamp: 'ar 3/13/2004 13:54'!
messageText: aValue
	"Modify the receiver's messageText"
	^self propertyValueAt: #messageText put: aValue with: #messageTextChanged! !

!CUserDialog methodsFor: 'events' stamp: 'ar 3/13/2004 15:05'!
onAccept
	<on: accept in: messageText>
	self value: true.
	self close.! !

!CUserDialog methodsFor: 'events' stamp: 'ar 3/13/2004 15:05'!
onCancel
	<on: cancel in: messageText>
	self value: false.
	self close.! !

!CUserDialog methodsFor: 'events' stamp: 'bgf 5/30/2007 23:58'!
onMouseDown
	<on: mouseDown>
	self onDrag.	"Be movable."! !

!CUserDialog methodsFor: 'events' stamp: 'ar 4/4/2004 16:59'!
onOpen
	<on: opened>
	messageText allowEditing 
		ifTrue:[hand keyboardFocus: messageText]
		ifFalse:[hand keyboardFocus: self].! !

!CUserDialog methodsFor: 'requests' stamp: 'bgf 4/7/2009 15:16'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint
	"self request: 'Enter your name' initialAnswer: 'Joe Doe'"
	| w |
	dialogLabel value: queryString.
	dialogLabel hResizing: #shrinkWrap.
	messageText contents: (defaultAnswer ifNil:['']).
	messageText hResizing: #spaceFill; vResizing: #spaceFill.
	messageText borderColor: CWidgetLibrary default frameColor.
	messageText selectAll.
	buttonRow removeAll.
	self addButton: 'OK' value: true.
	self addButton: 'Cancel' value: false.
	self fullBounds.
	"No that we're laid out, fix the label width in case it is too small for;
 	 there is no #hResizing option that allows something to apply its own lower-bound,
	 but also grow to fill space, so we're faking that here."
	w := self width.
	dialogLabel hResizing: #rigid; width: w.

	(self run: false centerAt: aPoint) ifFalse:[^nil].
	^messageText contents asString! !

!CUserDialog methodsFor: 'requests' stamp: 'ar 12/6/2005 14:51'!
requestPassword: queryString centerAt: aPoint
	"self requestPassword: 'Enter your name'"
	messageText editor font: (StrikeFont passwordFontSize: 16).
	^self request: queryString initialAnswer: '' centerAt: aPoint! !

!CUserDialog methodsFor: 'running' stamp: 'ar 3/10/2004 00:49'!
run
	^self run: nil.! !

!CUserDialog methodsFor: 'running' stamp: 'ar 3/13/2004 15:16'!
run: defaultValue
	^self run: defaultValue centerAt: self hand position.! !

!CUserDialog methodsFor: 'running' stamp: 'bgf 1/3/2009 10:08'!
run: defaultValue centerAt: aPoint
	"Wait until this dialog is completed (ultimately by deleting my costume from the world)"
	| oldFocus |
	self value: defaultValue.
	self openCenteredAt: (aPoint ifNil:[hand world dialogCenter]).
	oldFocus := hand keyboardFocus.
	self mouseCursor: (Cursor normal).
	self waitUntil: #closed.
	hand keyboardFocus: oldFocus.
	^self value "whatever it is"! !

!CUserDialog methodsFor: 'initialize' stamp: 'bgf 3/20/2009 09:04'!
setupCostume

	super setupCostume.
	self floating: true.
	self color: CWidgetLibrary default paneColor.
	self fillAlpha: 0.95.		"Just a hit of xparency... gives depth"
	self minWidth: 240.
	self dropShadowEnabled: true.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor muchDarker.
	self borderStyle: #simple.
	self roundCorners: true.
	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.

	dialogLabel fillStyle: #verticalGradient.
	dialogLabel fillAlpha: 1.0.
	dialogLabel fillColors: CWidgetLibrary default gradientColors.
	dialogLabel layoutInset: 5.
	dialogLabel roundCornerSpec: #(1 4).
	dialogLabel textInset: 10@1.
	self add: dialogLabel.

	group layout: CTableLayout new.
	group hResizing: #spaceFill; vResizing: #spaceFill.
	group layout layoutInset: 13@8; cellInset: 0@10; cellPositioning: #topLeft.

	messageText fillColor: Color transparent.
	messageText borderWidth: 1.
	messageText borderColor: Color transparent.
	messageText borderStyle: #simple.
	messageText asPrimCostume minHeight: 20.
	messageText textWrap: false.

	group add: messageText.

	buttonRow layout: CTableLayout new.
	buttonRow hResizing: #spaceFill; vResizing: #shrinkWrap.
	buttonRow layout listDirection: #leftToRight.
	buttonRow layoutInset: (4@4).
	buttonRow layout cellInset: 16@4; listCentering: #center.

	group add: buttonRow.
	self add: group.! !

CPlayer subclass: #CWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

!CWidget commentStamp: 'ar 3/27/2004 18:55' prior: 0!
CWidget is the abstract superclass for all 'widget-like' elements. It isn't fully formed out yet.!

CWidget subclass: #CButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons'!

!CButton commentStamp: 'ar 7/11/2005 11:08' prior: 0!
Buttons are little state machines where the state of a button is managed by user interactions with their costume. Many costumes also control the visual appearance when the button is in any particular state, but the basic button costume simply controls the state based on user interaction.

Instance variables:
	state	<Symbol> 	The button state, one of: #normal, #over, #pressed, or #disabled.
	label	<String>		The label to be displayed for this button.
	image 	<Form>		The image to be displayed for this button.
	group	<Collection>	The group to which the button belongs.
	selected	<Boolean|nil>	The selection state of this button (nil == undefined).

If a button is in a group, then it will be the only selected item in this group. Some buttons (such as radio) will be implicitly part of the group formed by their container unless given an explicit group, others (such as check boxes) require the group to be set explicitly.

Change the text of a button using label:.  This also sets the button's text.  The button's costume has a field 'buttonLabel', which points back at the costume.  Subclasses may store a CLabel in buttonLabel, and add it to the button's elements.  This allows the label to be in any position, not just the button's center.!

CButton defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="state" toSet="state:" changeEvent="stateChanged">state</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="image" toSet="image:" changeEvent="imageChanged">image</field>
	<field toGet="group" toSet="group:" changeEvent="groupChanged">group</field>
	<field toGet="selected" toSet="selected:" changeEvent="selectedChanged">selected</field>
</fields>'!

!CButton class methodsFor: 'instance creation' stamp: 'ar 2/6/2005 19:22'!
newSample
	| sample |
	sample := self new.
	sample label: sample name.
	^sample! !

!CButton methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:45'!
defaultCostume
	^CWidgetLibrary default buttonCostume! !

!CButton methodsFor: 'initialize' stamp: 'ar 3/30/2004 02:53'!
defaultGroup
	"Answer the default group this button should use if none was explicitly assigned"
	^nil! !

!CButton methodsFor: 'selecting' stamp: 'ar 3/29/2004 21:49'!
deselect
	"Deselect the receiver"
	selected := false.! !

!CButton methodsFor: 'selecting' stamp: 'ar 3/26/2004 19:39'!
disable
	state := #disabled.! !

!CButton methodsFor: 'selecting' stamp: 'ar 3/28/2004 22:38'!
disabled
	"Answer whether this button is disabled"
	<bewareOf: #stateChanged>
	^state == #disabled! !

!CButton methodsFor: 'selecting' stamp: 'ar 3/26/2004 19:39'!
enable
	self disabled ifFalse:[^self].
	state := #normal.! !

!CButton methodsFor: 'selecting' stamp: 'bgf 6/26/2008 09:45'!
enabled
	^ self disabled not! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/30/2004 02:52'!
group
	"Answer the group of the receiver"
	<bewareOf: #groupChanged>
	^self propertyValueAt: #group ifAbsent:[self defaultGroup].! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/13/2004 04:54'!
group: aValue
	"Modify the receiver's group"
	^self propertyValueAt: #group put: aValue with: #groupChanged! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:02'!
image
	"This button's image"
	<bewareOf: #imageChanged>
	^self propertyValueAt: #image! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:18'!
image: aValue
	^self propertyValueAt: #image put: aValue with: #imageChanged! !

!CButton methodsFor: 'initialize' stamp: 'ar 3/29/2004 21:58'!
initialize
	super initialize.
	state := #normal.! !

!CButton methodsFor: 'selecting' stamp: 'ar 7/11/2005 11:00'!
isSelected
	"This always returns a boolean even if selected is in third state (nil)"
	^self selected == true! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/24/2004 16:37'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CButton methodsFor: 'accessing' stamp: 'tk 8/17/2004 17:23'!
label: aValue
	"The label is a short piece of text that appears inside a button.  It should tell the user what the button does.[general]
	open a viewer by using the aqua-blue halo handle.  Click on the title of the viewer and choose the 'button' category.  Find the row for label, and click in the value box on the right.  Type words for the label and press Return or Enter.[viewer]"

	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CButton methodsFor: 'selecting' stamp: 'bgf 1/10/2009 10:02'!
mouseOverHighlight
	"The CCostumeHighlight to apply when the mouse is over an enabled button."
	^ CWidgetLibrary default mouseOverHighlightForButton: self! !

!CButton methodsFor: 'selecting' stamp: 'ar 3/30/2004 02:51'!
select
	"Select the receiver"
	| myGroup |
	myGroup := group.
	myGroup ifNotNil:[
		myGroup selection deselect.
		myGroup selection: self.
	].
	selected := true.
! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/29/2004 22:57'!
selected
	"Answer the selected of the receiver"
	<bewareOf: #selectedChanged>
	^self propertyValueAt: #selected ifAbsent:[false]! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/29/2004 21:48'!
selected: aValue
	"Modify the receiver's selected"
	^self propertyValueAt: #selected put: aValue with: #selectedChanged! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/26/2004 17:39'!
state
	"Answer the state of the receiver"
	<bewareOf: #stateChanged>
	^self propertyValueAt: #state! !

!CButton methodsFor: 'accessing' stamp: 'ar 3/26/2004 19:38'!
state: aValue
	"Modify the receiver's state"
	^self propertyValueAt: #state put: aValue with: #stateChanged! !

CButton subclass: #CCheckBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons'!

!CCheckBox commentStamp: 'tk 8/18/2004 13:33' prior: 0!
A CheckBox is a simple button that toggles its value between true and false.  It shows a check mark when its value is true.  Adding a label is easy. [general]
	Note that a check box can have ANY value it wants, so it can be used as a three-state display.  The default fire response will simply switch from true to false and back. [range]
	You can easily implement your own CheckBox behavior by using a check box costume with a regular button.  Handle the 'fire' event to cycle between whatever values you'd like.  [extend]

click on it.  In a CheckBox, the value field is true when the checkmark shows. [value-ui]

### Allow Users to see the above explanation ###!

CCheckBox defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CCheckBox methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:45'!
defaultCostume
	^CWidgetLibrary default checkBoxCostume! !

!CCheckBox methodsFor: 'events' stamp: 'ar 2/28/2005 14:22'!
deselect
	super deselect.
	value := false.! !

!CCheckBox methodsFor: 'initialize' stamp: 'ar 7/11/2005 10:58'!
initialize
	super initialize.
	value := false.
	selected := false.! !

!CCheckBox methodsFor: 'events' stamp: 'ar 7/11/2005 11:08'!
onFire
	"Fire this button. Check boxes simply toggle their selection state."
	<on: fire>
	self isSelected ifTrue:[self deselect] ifFalse:[self select].! !

!CCheckBox methodsFor: 'events' stamp: 'ar 7/11/2005 10:53'!
onValueChanged
	"Update the selection state from the value"
	| check |
	<on: valueChanged>
	value ifNil:[^selected := nil].
	check := value == true.
	check == selected ifFalse:[
		check ifTrue:[self select] ifFalse:[self deselect].
	].! !

!CCheckBox methodsFor: 'events' stamp: 'ar 2/28/2005 14:21'!
select
	super select.
	value := true.! !

CButton subclass: #CImageButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons'!

!CImageButton commentStamp: '<historical>' prior: 0!
An ImageButton is a simple button which takes a number of images (organized in CImageButtonSet) to display depending on its state. Clients can use image buttons by either:
- providing all the required images explicitly for parametrization or,
- set up (reusable) image button sets to use with a button
!

CImageButton defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="standardImageSet" toSet="standardImageSet:" changeEvent="standardImageSetChanged">standardImageSet</field>
	<field toGet="selectedImageSet" toSet="selectedImageSet:" changeEvent="selectedImageSetChanged">selectedImageSet</field>
</fields>'!

!CImageButton methodsFor: 'initialize' stamp: 'ar 4/3/2004 14:06'!
defaultCostume
	^CButtonCostume! !

!CImageButton methodsFor: 'initialize' stamp: 'ar 12/18/2006 12:43'!
defaultImage: aForm
	"Initialize all the button states with the given image"
	standardImageSet defaultImage: aForm.
	selectedImageSet defaultImage: aForm.
! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:29'!
disabledImage
	"Answer the disabled, non-selected image for this button"
	^standardImageSet disabledImage! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:29'!
disabledImage: aForm
	"Set the disabled, non-selected image for this button"
	^standardImageSet disabledImage: aForm! !

!CImageButton methodsFor: 'initialize' stamp: 'ar 12/18/2006 12:27'!
initialize
	super initialize.
	standardImageSet := CImageButtonSet new.
	selectedImageSet := CImageButtonSet new.! !

!CImageButton methodsFor: 'selecting' stamp: 'bgf 1/10/2009 09:52'!
mouseOverHighlight
	"No over-highlighting for image buttons, which can set up their own.."
	^ nil! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:28'!
normalImage
	"Answer the regular (non-selected, non-emphasized) image for this button"
	^standardImageSet normalImage! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:28'!
normalImage: aForm
	"Set the regular (non-selected, non-emphasized) image for this button"
	^standardImageSet normalImage: aForm! !

!CImageButton methodsFor: 'events' stamp: 'ar 12/18/2006 12:55'!
onButtonStateChanged
	| imageSet |
	<on: stateChanged>
	self isSelected 
		ifTrue:[imageSet := selectedImageSet]
		ifFalse:[imageSet := standardImageSet].
	(state == #normal) 
		ifTrue:[image := imageSet normalImage].
	(state == #over) 
		ifTrue:[image := imageSet overImage ifNil:[imageSet normalImage]].
	(state == #pressed) 
		ifTrue:[image := imageSet pressedImage ifNil:[imageSet normalImage]].
	(state == #disabled) 
		ifTrue:[image := imageSet disabledImage ifNil:[imageSet normalImage]].
! !

!CImageButton methodsFor: 'events' stamp: 'ar 12/18/2006 12:46'!
onNormalImageChanged
	"Make sure we display the right stuff"
	<on: normalImageChanged in: standardImageSet>
	self onButtonStateChanged.! !

!CImageButton methodsFor: 'events' stamp: 'ar 12/18/2006 12:49'!
onNormalImageSetChanged
	"Make sure we display the right stuff"
	<on: normalImageSetChanged>
	self onButtonStateChanged.! !

!CImageButton methodsFor: 'events' stamp: 'ar 12/18/2006 12:46'!
onSelectedChanged
	<on: selectedChanged>
	self onButtonStateChanged.! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:30'!
overImage
	"Answer the mouse-over, non-selected image for this button"
	^standardImageSet overImage! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:30'!
overImage: aForm
	"Set the mouse-over, non-selected image for this button"
	^standardImageSet overImage: aForm! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:30'!
pressedImage
	"Answer the pressed, non-selected image for this button"
	^standardImageSet pressedImage! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:29'!
pressedImage: aForm
	"Set the pressed, non-selected image for this button"
	^standardImageSet pressedImage: aForm! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:33'!
selectedDisabledImage
	"Answer the disabled, selected image for this button"
	^selectedImageSet disabledImage! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:33'!
selectedDisabledImage: aForm
	"Set the disabled, selected image for this button"
	^selectedImageSet disabledImage: aForm! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:31'!
selectedImage
	"Answer the regular, selected image for this button"
	^selectedImageSet normalImage! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:31'!
selectedImage: aForm
	"Set the regular, selected image for this button"
	^selectedImageSet normalImage: aForm! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:20'!
selectedImageSet
	"Answer the selectedImageSet of the receiver"
	<bewareOf: #selectedImageSetChanged>
	^self propertyValueAt: #selectedImageSet! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:20'!
selectedImageSet: aValue
	"Modify the receiver's selectedImageSet"
	^self propertyValueAt: #selectedImageSet put: aValue with: #selectedImageSetChanged! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:31'!
selectedOverImage
	"Answer the mouse-over, selected image for this button"
	^selectedImageSet overImage! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:32'!
selectedOverImage: aForm
	"Set the mouse-over, selected image for this button"
	^selectedImageSet overImage: aForm! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:32'!
selectedPressedImage
	"Answer the pressed, selected image for this button"
	^selectedImageSet pressedImage! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:32'!
selectedPressedImage: aForm
	"Set the pressed, selected image for this button"
	^selectedImageSet pressedImage: aForm! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:20'!
standardImageSet
	"Answer the standardImageSet of the receiver"
	<bewareOf: #standardImageSetChanged>
	^self propertyValueAt: #standardImageSet! !

!CImageButton methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:20'!
standardImageSet: aValue
	"Modify the receiver's standardImageSet"
	^self propertyValueAt: #standardImageSet put: aValue with: #standardImageSetChanged! !

CButton subclass: #CPushButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons'!

!CPushButton commentStamp: 'tk 9/13/2004 14:48' prior: 0!
A PushButton is just like any other Button, except that it uses a system-default costume.  It is shaded from top to bottom, going from white to dark yellow.  Pressing a button causes it to 'fire'.  You can decide which event will fire the button , such as mouseUp or mouseDown.  You can define a script that will tell the button what to do when it fires.

### Allow Users to see the above explanation ###!

CPushButton defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CPushButton methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:48'!
defaultCostume
	^CWidgetLibrary default pushButtonCostume! !

CButton subclass: #CRadioButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons'!

!CRadioButton commentStamp: 'tk 8/12/2004 10:18' prior: 0!
A RadioButton finds the other RadioButtons in the same container.  When any one is pressed, it turns the others off.  The one that is pressed stays on and highlighted.

### Allow Users to see the above explanation ###!

CRadioButton defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CRadioButton methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:48'!
defaultCostume
	^CWidgetLibrary default radioButtonCostume! !

!CRadioButton methodsFor: 'initialize' stamp: 'ar 5/11/2007 12:23'!
defaultGroup
	"Answer the default group this button should use if none was explicitly assigned"
	^container ifNotNil:[container elements]! !

!CRadioButton methodsFor: 'events' stamp: 'ar 3/30/2004 18:17'!
onFire
	<on: fire>
	self select.! !

CButton subclass: #CTabButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons'!

!CTabButton commentStamp: 'tk 8/12/2004 10:17' prior: 0!
A TabButton is a horizontal row of buttons that look like tabs.  It is used for tabbed palettes (e.g., a TabButtonList).  [general]

Example:
	tabs := CTabButtonList new.
	tabs addAll: #('Tab 1' 'Tab 2' 'Tab 3').
	tabs open.
[example]

### Allow Users to see the above explanation ###!

CTabButton defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CTabButton methodsFor: 'initialize' stamp: 'ar 3/13/2004 04:16'!
defaultCostume
	^CWidgetLibrary default tabButtonCostume! !

!CTabButton methodsFor: 'initialize' stamp: 'ar 5/11/2007 12:23'!
defaultGroup
	"Answer the default group this button should use if none was explicitly assigned"
	^container ifNotNil:[container elements]! !

!CTabButton methodsFor: 'events' stamp: 'ar 3/29/2004 23:03'!
onFire
	<on: fire>
	self select.! !

CButton subclass: #CToolBarButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons'!

CToolBarButton defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CToolBarButton methodsFor: 'initialize' stamp: 'ar 4/4/2004 18:08'!
defaultCostume
	^CToolBarButtonCostume! !

CButton subclass: #CWindowButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

CWindowButton defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="normalBorderColor" toSet="normalBorderColor:" changeEvent="normalBorderColorChanged">normalBorderColor</field>
	<field toGet="normalTextColor" toSet="normalTextColor:" changeEvent="normalTextColorChanged">normalTextColor</field>
	<field toGet="pressedBorderColor" toSet="pressedBorderColor:" changeEvent="pressedBorderColorChanged">pressedBorderColor</field>
	<field toGet="pressedTextColor" toSet="pressedTextColor:" changeEvent="pressedTextColorChanged">pressedTextColor</field>
</fields>'!

!CWindowButton methodsFor: 'initialize' stamp: 'ar 12/19/2004 00:32'!
defaultCostume
	^CWindowButtonCostume! !

!CWindowButton methodsFor: 'accessing' stamp: 'ar 12/19/2004 00:32'!
normalBorderColor
	"Answer the normalBorderColor of the receiver"
	<bewareOf: #normalBorderColorChanged>
	^self propertyValueAt: #normalBorderColor! !

!CWindowButton methodsFor: 'accessing' stamp: 'ar 12/19/2004 00:32'!
normalBorderColor: aValue
	"Modify the receiver's normalBorderColor"
	^self propertyValueAt: #normalBorderColor put: aValue with: #normalBorderColorChanged! !

!CWindowButton methodsFor: 'accessing' stamp: 'ar 12/19/2004 00:32'!
normalTextColor
	"Answer the normalTextColor of the receiver"
	<bewareOf: #normalTextColorChanged>
	^self propertyValueAt: #normalTextColor! !

!CWindowButton methodsFor: 'accessing' stamp: 'ar 12/19/2004 00:32'!
normalTextColor: aValue
	"Modify the receiver's normalTextColor"
	^self propertyValueAt: #normalTextColor put: aValue with: #normalTextColorChanged! !

!CWindowButton methodsFor: 'accessing' stamp: 'ar 12/19/2004 00:32'!
pressedBorderColor
	"Answer the pressedBorderColor of the receiver"
	<bewareOf: #pressedBorderColorChanged>
	^self propertyValueAt: #pressedBorderColor! !

!CWindowButton methodsFor: 'accessing' stamp: 'ar 12/19/2004 00:32'!
pressedBorderColor: aValue
	"Modify the receiver's pressedBorderColor"
	^self propertyValueAt: #pressedBorderColor put: aValue with: #pressedBorderColorChanged! !

!CWindowButton methodsFor: 'accessing' stamp: 'ar 12/19/2004 00:32'!
pressedTextColor
	"Answer the pressedTextColor of the receiver"
	<bewareOf: #pressedTextColorChanged>
	^self propertyValueAt: #pressedTextColor! !

!CWindowButton methodsFor: 'accessing' stamp: 'ar 12/19/2004 00:32'!
pressedTextColor: aValue
	"Modify the receiver's pressedTextColor"
	^self propertyValueAt: #pressedTextColor put: aValue with: #pressedTextColorChanged! !

!CWindowButton methodsFor: 'events' stamp: 'ar 12/19/2004 08:47'!
windowColor: aColor
	super windowColor: aColor.
	normalTextColor := normalBorderColor := aColor mixed: 0.5 with: Color black.! !

CWidget subclass: #CConstraintValueWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling'!

!CConstraintValueWidget commentStamp: 'ar 3/28/2004 19:59' prior: 0!
CConstraintValueWidget is an example of how to synchronously constrain #value: messages. Since this isn't always trivial in the Tweak architecture, it acts as an example as well as documentation for "how to do it right".!

CConstraintValueWidget defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CConstraintValueWidget methodsFor: 'private' stamp: 'ar 3/28/2004 19:57'!
adoptValue: aValue
	"Constrain the given value to whatever is required by the receiver"
	^aValue! !

!CConstraintValueWidget methodsFor: 'accessing' stamp: 'sw 5/17/2005 04:56'!
numericValue
	"Answer the number associated with the receiver"

	^ value! !

!CConstraintValueWidget methodsFor: 'accessing' stamp: 'sw 5/17/2005 04:57'!
numericValue: aValue
	"Set my numeric value"

	^ self value: aValue! !

!CConstraintValueWidget methodsFor: 'accessing' stamp: 'ar 9/8/2004 16:21'!
value: unconstraintValue
	"Modify the receiver's value"
	| newValue |

	"First check if the value is the same as the current one"
	value = unconstraintValue ifTrue:[^unconstraintValue].

	"Now compute the constraint value"
	newValue := self adoptValue: unconstraintValue.

	"Even if the constraint value is the same as the current value 
	we MUST signal valueChanged here to inform any costume that 
	it should update its value, so that the costume sees the constraint value.
	Signaling valueChanged below basically says that we did something like:
		value := unconstraintValue.
		value := newValue.
	but this way it's a lot more efficient."

	newValue = value 
		ifTrue:[self signalChanged: #valueChanged from: unconstraintValue to: newValue]
		ifFalse:[super value: newValue].

	"field setters must return their argument unmodified"
	^unconstraintValue! !

CConstraintValueWidget subclass: #CSlider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling'!

!CSlider commentStamp: 'tk 9/13/2004 15:45' prior: 0!
A Slider is a bar with a marker in it.  The marker's position indicates a value that is somewhere between two extreme values.  A ScrollBar is a kind of Slider.


### Allow Users to see the above explanation ###!

CSlider subclass: #CScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling'!

!CScrollBar commentStamp: 'tk 9/13/2004 15:48' prior: 0!
A ScrollBar is the slider you see at the edge of a window.  It lets you move the contents of a pane inside the pane.
(How do you hook up a new scrollBar using the mouse?)


### Allow Users to see the above explanation ###!

CScrollBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="buttonHeight" toSet="buttonHeight:" changeEvent="buttonHeightChanged">buttonHeight</field>
</fields>'!

!CScrollBar methodsFor: 'accessing' stamp: 'ar 3/27/2004 19:19'!
buttonHeight
	<bewareOf: #buttonHeightChanged>
	^(self propertyValueAt: #buttonHeight) ifNil:[CWidgetLibrary default scrollBarHeight]! !

!CScrollBar methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:25'!
buttonHeight: aValue
	"This method was automatically generated"
	^self propertyValueAt: #buttonHeight put: aValue with: #buttonHeightChanged! !

!CScrollBar methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:50'!
defaultCostume
	^CWidgetLibrary default scrollBarCostume! !

!CScrollBar methodsFor: 'initialize' stamp: 'ar 2/26/2004 16:50'!
initialize
	super initialize.
	self pageStep: 10.! !

CSlider defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="max" toSet="max:" changeEvent="maxChanged">max</field>
	<field toGet="min" toSet="min:" changeEvent="minChanged">min</field>
	<field toGet="orientation" toSet="orientation:" changeEvent="orientationChanged">orientation</field>
	<field toGet="pageStep" toSet="pageStep:" changeEvent="pageStepChanged">pageStep</field>
	<field toGet="step" toSet="step:" changeEvent="stepChanged">step</field>
	<field toGet="visibleFraction" toSet="visibleFraction:" changeEvent="visibleFractionChanged">visibleFraction</field>
</fields>'!

!CSlider methodsFor: 'private' stamp: 'ar 2/18/2004 12:32'!
adoptValue: aValue
	"Take aValue and constrain it to the settings"
	| newValue |
	aValue ifNil:[^self value].
	newValue := aValue.
	self min ifNil:[
		self max ifNotNil:[newValue := newValue max: self max].
	] ifNotNil:[
		self max ifNil:[
			newValue := newValue min: self min.
		] ifNotNil:[
			"Allow for negative directions"
			self min <= self max
				ifTrue:[newValue := newValue min: self max max: self min]
				ifFalse:[newValue := newValue min: self min max: self max].
		].
	].
	"self step ifNotNil:[newValue := newValue truncateTo: self step]."
	^newValue! !

!CSlider methodsFor: 'streaming' stamp: 'ar 3/28/2004 22:30'!
atEnd
	"answer whether the receiver is at its end"
	max ifNil:[^false].
	^value >= max! !

!CSlider methodsFor: 'streaming' stamp: 'ar 3/28/2004 22:31'!
atStart
	"answer whether the receiver is at its start"
	min ifNil:[^false].
	^value <= min! !

!CSlider methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:49'!
defaultCostume
	^CWidgetLibrary default sliderCostume! !

!CSlider methodsFor: 'accessing' stamp: 'ar 2/8/2004 20:20'!
fraction
	self min = self max ifTrue:[^0].
	^(self value - self min) / self range! !

!CSlider methodsFor: 'initialize' stamp: 'ar 2/8/2004 22:21'!
initialize
	super initialize.
	self value: 0.
	self min: 0.
	self max: 100.
	self step: 1.
! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
max
	"This method was automatically generated"
	<bewareOf: #maxChanged>
	^self propertyValueAt: #max! !

!CSlider methodsFor: 'accessing' stamp: 'bf 3/30/2004 14:03'!
max: aValue
	self propertyValueAt: #max put: aValue with: #maxChanged.
	self value: (self adoptValue: self value).
	^aValue! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
min
	"This method was automatically generated"
	<bewareOf: #minChanged>
	^self propertyValueAt: #min! !

!CSlider methodsFor: 'accessing' stamp: 'bf 3/30/2004 14:04'!
min: aValue
	self propertyValueAt: #min put: aValue with: #minChanged.
	self value: (self adoptValue: self value).
	^aValue! !

!CSlider methodsFor: 'streaming' stamp: 'ar 3/28/2004 22:31'!
next
	"go to the next element in the receiver"
	value := value + (step ifNil:[1])! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
orientation
	"This method was automatically generated"
	<bewareOf: #orientationChanged>
	^self propertyValueAt: #orientation! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:25'!
orientation: aValue
	"This method was automatically generated"
	^self propertyValueAt: #orientation put: aValue with: #orientationChanged! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
pageStep
	"This method was automatically generated"
	<bewareOf: #pageStepChanged>
	^self propertyValueAt: #pageStep! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:25'!
pageStep: aValue
	"This method was automatically generated"
	^self propertyValueAt: #pageStep put: aValue with: #pageStepChanged! !

!CSlider methodsFor: 'streaming' stamp: 'ar 3/28/2004 22:31'!
peek
	"answer the element at the receiver's cursor"
	^value! !

!CSlider methodsFor: 'streaming' stamp: 'ar 3/28/2004 22:32'!
prev
	"go to the previous element in the receiver"
	value := value - (step ifNil:[1]).! !

!CSlider methodsFor: 'accessing' stamp: 'ar 2/8/2004 20:22'!
range
	"Answer the range used for scrolling"
	^(self max - self min) abs
! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
step
	"This method was automatically generated"
	<bewareOf: #stepChanged>
	^self propertyValueAt: #step! !

!CSlider methodsFor: 'accessing' stamp: 'bf 3/30/2004 14:04'!
step: aValue
	self propertyValueAt: #step put: aValue with: #stepChanged.
	self value: (self adoptValue: self value).
	^aValue! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
visibleFraction
	"This method was automatically generated"
	<bewareOf: #visibleFractionChanged>
	^self propertyValueAt: #visibleFraction! !

!CSlider methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:25'!
visibleFraction: aValue
	"This method was automatically generated"
	^self propertyValueAt: #visibleFraction put: aValue with: #visibleFractionChanged! !

CSlider subclass: #CWheelWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling'!

!CWheelWidget commentStamp: 'tk 9/13/2004 17:08' prior: 0!
What is this class used for, anyway?  --Ted.!

CWheelWidget defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

CConstraintValueWidget subclass: #CSpinner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling'!

!CSpinner commentStamp: 'tk 9/13/2004 17:14' prior: 0!
A Spinner is a display with up and down arrows to change its value.  Look in the ColorTool at the Fill Alpha: control to see a Spinner.

### Allow Users to see the above explanation ###!

CSpinner defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="max" toSet="max:" changeEvent="maxChanged">max</field>
	<field toGet="min" toSet="min:" changeEvent="minChanged">min</field>
	<field toGet="step" toSet="step:" changeEvent="stepChanged">step</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
</fields>'!

!CSpinner methodsFor: 'private' stamp: 'ar 3/8/2004 15:28'!
adoptValue: aValue
	"Take aValue and constrain it to the settings"
	| newValue |
	aValue ifNil:[^self value].
	newValue := aValue.
	self min ifNil:[
		self max ifNotNil:[newValue := newValue max: self max].
	] ifNotNil:[
		self max ifNil:[
			newValue := newValue min: self min.
		] ifNotNil:[
			"Allow for negative directions"
			self min <= self max
				ifTrue:[newValue := newValue min: self max max: self min]
				ifFalse:[newValue := newValue min: self min max: self max].
		].
	].
	^newValue! !

!CSpinner methodsFor: 'initialize' stamp: 'ar 3/7/2004 20:13'!
defaultCostume
	^CWidgetLibrary default spinnerCostume! !

!CSpinner methodsFor: 'initialize' stamp: 'ar 3/26/2004 04:20'!
initialize
	super initialize.
	label := self class name allButFirst.
	self value: 0.
	self min: 0.
	self max: 100.
	self step: 1.
! !

!CSpinner methodsFor: 'accessing' stamp: 'ar 3/24/2004 16:37'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CSpinner methodsFor: 'accessing' stamp: 'ar 3/24/2004 16:37'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CSpinner methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
max
	"This method was automatically generated"
	<bewareOf: #maxChanged>
	^self propertyValueAt: #max! !

!CSpinner methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:26'!
max: aValue
	"This method was automatically generated"
	^self propertyValueAt: #max put: aValue with: #maxChanged! !

!CSpinner methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
min
	"This method was automatically generated"
	<bewareOf: #minChanged>
	^self propertyValueAt: #min! !

!CSpinner methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:26'!
min: aValue
	"This method was automatically generated"
	^self propertyValueAt: #min put: aValue with: #minChanged! !

!CSpinner methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:14'!
step
	"This method was automatically generated"
	<bewareOf: #stepChanged>
	^self propertyValueAt: #step! !

!CSpinner methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:26'!
step: aValue
	"This method was automatically generated"
	^self propertyValueAt: #step put: aValue with: #stepChanged! !

CWidget subclass: #CItemWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

!CItemWidget commentStamp: '<historical>' prior: 0!
Item widgets are objects representing items in lists or menus. Items can be selected but their selection state is generally managed by the list/menu they are contained in (this is for example different from buttons which handle a one-in-many selection by themselves). Items can also be disabled but disabling items (for example in menus) does not prevent them from becoming selected, only from being fired.!

CItemWidget defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="selected" toSet="selected:" changeEvent="selectedChanged">selected</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="icon" toSet="icon:" changeEvent="iconChanged">icon</field>
	<field toGet="state" toSet="state:" changeEvent="stateChanged">state</field>
	<field toGet="labelBlock" toSet="labelBlock:" changeEvent="labelBlockChanged">labelBlock</field>
	<field toGet="emphasis" toSet="emphasis:" changeEvent="emphasisChanged">emphasis</field>
</fields>'!

!CItemWidget methodsFor: 'initialize' stamp: 'ar 7/7/2005 11:22'!
defaultCostume
	^CItemWidgetCostume! !

!CItemWidget methodsFor: 'selecting' stamp: 'ar 7/6/2005 19:01'!
deselect
	self selected: false! !

!CItemWidget methodsFor: 'enabling' stamp: 'ar 7/7/2005 09:50'!
disable
	state := #disabled.! !

!CItemWidget methodsFor: 'enabling' stamp: 'ar 7/7/2005 09:50'!
disabled
	"Answer whether this button is disabled"
	<bewareOf: #stateChanged>
	^state == #disabled! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 1/11/2008 11:16'!
emphasis
	"Answer the emphasis of the receiver"
	<bewareOf: #emphasisChanged>
	^self propertyValueAt: #emphasis! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 1/11/2008 11:16'!
emphasis: aValue
	"Modify the receiver's emphasis"
	^self propertyValueAt: #emphasis put: aValue with: #emphasisChanged! !

!CItemWidget methodsFor: 'enabling' stamp: 'ar 7/7/2005 09:50'!
enable
	self disabled ifFalse:[^self].
	state := #normal.! !

!CItemWidget methodsFor: 'enabling' stamp: 'ar 7/7/2005 09:50'!
enabled
	"Answer whether this button is disabled"
	<bewareOf: #stateChanged>
	^self disabled not! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 7/6/2005 19:10'!
icon
	"Answer the icon of the receiver"
	<bewareOf: #iconChanged>
	^self propertyValueAt: #icon! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 7/6/2005 19:10'!
icon: aValue
	"Modify the receiver's icon"
	^self propertyValueAt: #icon put: aValue with: #iconChanged! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 1/29/2009 23:05'!
iconOffset
	"The offset by which an icon should be inset from the left edge"
	^2! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 7/6/2005 19:09'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 7/6/2005 19:09'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 9/10/2005 11:22'!
labelBlock
	"Answer the labelBlock of the receiver"
	<bewareOf: #labelBlockChanged>
	^self propertyValueAt: #labelBlock! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 9/10/2005 11:22'!
labelBlock: aValue
	"Modify the receiver's labelBlock"
	^self propertyValueAt: #labelBlock put: aValue with: #labelBlockChanged! !

!CItemWidget methodsFor: 'events' stamp: 'ar 9/10/2005 11:24'!
onUpdateLabel
	"Update my label"
	labelBlock ifNil:[^nil].
	label := labelBlock value.! !

!CItemWidget methodsFor: 'printing' stamp: 'ar 5/18/2007 10:01'!
printOn: aStream
	"Print the receiver on aStream"
	super printOn: aStream.
	aStream nextPut: $(; print: label; nextPut: $).
! !

!CItemWidget methodsFor: 'selecting' stamp: 'ar 7/6/2005 19:01'!
select
	self selected: true! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 7/7/2005 11:09'!
selected
	"Answer the selected of the receiver"
	<bewareOf: #selectedChanged>
	^(self propertyValueAt: #selected) ifNil:[false]! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 7/6/2005 19:01'!
selected: aValue
	"Modify the receiver's selected"
	^self propertyValueAt: #selected put: aValue with: #selectedChanged! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 7/7/2005 09:47'!
state
	"Answer the state of the receiver"
	<bewareOf: #stateChanged>
	^self propertyValueAt: #state! !

!CItemWidget methodsFor: 'accessing' stamp: 'ar 7/7/2005 09:47'!
state: aValue
	"Modify the receiver's state"
	^self propertyValueAt: #state put: aValue with: #stateChanged! !

!CItemWidget methodsFor: 'initialize' stamp: 'ar 9/10/2005 11:23'!
updateLabel: aBlock when: eventSpec
	"Update the checked state of the receiver from aBlock when the given event spec occurs. For example:
		item := menu addItem: 'some label'.
		item updateLabel:[itemLabel] when:{self. #itemLabelChanged}.
	"
	labelBlock := aBlock.
	label := aBlock value.
	self startScript: #onUpdateLabel when: eventSpec.! !

CItemWidget subclass: #CListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

!CListItem commentStamp: 'ar 3/25/2004 12:08' prior: 0!
CListItem represents a simple list item which does nothing but displaying the #displayText of its value. It knows how to select and how to deselect itself and that's it.!

CListItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CListItem methodsFor: 'initialize' stamp: 'ar 7/7/2005 09:53'!
defaultCostume
	^CListItemCostume! !

!CListItem methodsFor: 'events' stamp: 'ar 7/6/2005 19:10'!
onValueChanged
	<on: valueChanged>
	label := value displayText.! !

CItemWidget subclass: #CMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus'!

CMenuItem subclass: #CListMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus'!

CListMenuItem subclass: #CListMenuFontItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

!CListMenuFontItem commentStamp: '<historical>' prior: 0!
This is an expample itemMaker for CPopUpListCostume:

l := CDropDownList new.
l items := CCollection withAll: StrikeFont actualFamilyNames.
l itemMaker := CListMenuFontItem.
l costume := CPopUpListCostume.
l openInHand.
!

CListMenuFontItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CListMenuFontItem methodsFor: 'events' stamp: 'ar 5/24/2005 11:42'!
onValueChanged
	label := self textFrom: value font: value.! !

!CListMenuFontItem methodsFor: 'events' stamp: 'jl 5/24/2005 17:53'!
textFrom: aString font: aFontName
	| text aTextStyle aFontRef |
	text := aString asText.
	aTextStyle :=  (TextStyle named: aFontName) copy.
	aTextStyle ifNotNil: [
		aFontRef := TextFontReference toFont: (aTextStyle defaultFont).
		text addAttribute: aFontRef].
	^text	! !

CListMenuItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CListMenuItem class methodsFor: 'instance creation' stamp: 'jl 5/24/2005 11:54'!
item: aListItem list: aList
	^self new: aListItem target: aList action: #selection: argument: aListItem! !

!CListMenuItem class methodsFor: 'instance creation' stamp: 'jl 5/24/2005 11:10'!
new: aString target: anObject action: aSelector 
	^self new: aString target: anObject action: aSelector arguments: #()! !

!CListMenuItem class methodsFor: 'instance creation' stamp: 'jl 5/24/2005 11:25'!
new: aString target: anObject action: aSelector argument: arg
	^self new: aString target: anObject action: aSelector arguments: {arg}! !

!CListMenuItem class methodsFor: 'instance creation' stamp: 'jl 5/24/2005 11:57'!
new: anItem target: anObject action: aSelector arguments: args
	| menuItem |
	menuItem := self new.
	menuItem value: anItem.
	menuItem action: (MessageSend receiver: anObject selector: aSelector arguments: args).
	(anObject respondsTo: aSelector) ifFalse:[menuItem enabled: false].
	^menuItem! !

!CListMenuItem methodsFor: 'events' stamp: 'ar 5/24/2005 11:42'!
onValueChanged
	<on: valueChanged>
	label := value displayText.! !

CMenuItem defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="action" toSet="action:" changeEvent="actionChanged">action</field>
	<field toGet="checked" toSet="checked:" changeEvent="checkedChanged">checked</field>
	<field toGet="enabled" toSet="enabled:" changeEvent="enabledChanged">enabled</field>
	<field toGet="separator" toSet="separator:" changeEvent="separatorChanged">separator</field>
	<field toGet="subMenu" toSet="subMenu:" changeEvent="subMenuChanged">subMenu</field>
	<field toGet="checkedBlock" toSet="checkedBlock:" changeEvent="checkedBlockChanged">checkedBlock</field>
	<field toGet="enabledBlock" toSet="enabledBlock:" changeEvent="enabledBlockChanged">enabledBlock</field>
	<field toGet="tag" toSet="tag:" changeEvent="tagChanged">tag</field>
</fields>'!

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:10'!
action
	"This method was automatically generated"
	<bewareOf: #actionChanged>
	^self propertyValueAt: #action! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:23'!
action: aValue
	"This method was automatically generated"
	^self propertyValueAt: #action put: aValue with: #actionChanged! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:10'!
checked
	"This method was automatically generated"
	<bewareOf: #checkedChanged>
	^self propertyValueAt: #checked! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:23'!
checked: aValue
	"This method was automatically generated"
	^self propertyValueAt: #checked put: aValue with: #checkedChanged! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 9/10/2005 11:18'!
checkedBlock
	"Answer the checkedBlock of the receiver"
	<bewareOf: #checkedBlockChanged>
	^self propertyValueAt: #checkedBlock! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 9/10/2005 11:18'!
checkedBlock: aValue
	"Modify the receiver's checkedBlock"
	^self propertyValueAt: #checkedBlock put: aValue with: #checkedBlockChanged! !

!CMenuItem methodsFor: 'testing' stamp: 'ar 6/29/2005 20:42'!
closeAfterFire
	"Answer true if menus should close after this item has been fired"
	^true! !

!CMenuItem methodsFor: 'initialize' stamp: 'ar 8/19/2005 09:47'!
defaultCostume
	^CWidgetLibrary default menuItemCostume! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/8/2004 15:26'!
disable
	^self enabled: false! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/12/2004 15:10'!
disabled
	^self enabled not! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/12/2004 15:10'!
disabled: aBool
	^self enabled: aBool not! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/8/2004 15:26'!
enable
	^self enabled: true! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:10'!
enabled
	"This method was automatically generated"
	<bewareOf: #enabledChanged>
	^self propertyValueAt: #enabled! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:23'!
enabled: aValue
	"This method was automatically generated"
	^self propertyValueAt: #enabled put: aValue with: #enabledChanged! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 9/10/2005 11:18'!
enabledBlock
	"Answer the enabledBlock of the receiver"
	<bewareOf: #enabledBlockChanged>
	^self propertyValueAt: #enabledBlock! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 9/10/2005 11:18'!
enabledBlock: aValue
	"Modify the receiver's enabledBlock"
	^self propertyValueAt: #enabledBlock put: aValue with: #enabledBlockChanged! !

!CMenuItem methodsFor: 'initialize' stamp: 'bgf 8/25/2008 10:05'!
initialize
	super initialize.
	self font: CWidgetLibrary default menuFont.
	self checked: false.
	self enabled: true.
	self separator: false.
	self label: 'MenuItem'.! !

!CMenuItem methodsFor: 'utilities' stamp: 'bgf 8/25/2007 12:33'!
installFont: aFont
	"Set this font on me and my entire substructure."	
	self font: aFont.
	self subMenu ifNotNilDo: [ : sub | sub installFont: aFont ].
! !

!CMenuItem methodsFor: 'actions' stamp: 'ar 7/7/2005 11:14'!
onFire
	<on: fire>
	action ifNil:[^self].
	action receiver 
		startScript: action selector 
		withArguments: action arguments.! !

!CMenuItem methodsFor: 'actions' stamp: 'ar 9/10/2005 11:22'!
onUpdateChecked
	"Update my checked state"
	checkedBlock ifNil:[^nil].
	checked := checkedBlock value == true.! !

!CMenuItem methodsFor: 'actions' stamp: 'ar 9/10/2005 11:22'!
onUpdateEnabled
	"Update my enabled state"
	enabledBlock ifNil:[^nil].
	enabled := enabledBlock value == true.! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:11'!
separator
	"This method was automatically generated"
	<bewareOf: #separatorChanged>
	^self propertyValueAt: #separator! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:23'!
separator: aValue
	"This method was automatically generated"
	^self propertyValueAt: #separator put: aValue with: #separatorChanged! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:11'!
subMenu
	"This method was automatically generated"
	<bewareOf: #subMenuChanged>
	^self propertyValueAt: #subMenu! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:23'!
subMenu: aValue
	"This method was automatically generated"
	^self propertyValueAt: #subMenu put: aValue with: #subMenuChanged! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 5/17/2007 12:00'!
tag
	"Answer the tag of the receiver"
	<bewareOf: #tagChanged>
	^self propertyValueAt: #tag! !

!CMenuItem methodsFor: 'accessing' stamp: 'ar 5/17/2007 12:00'!
tag: aValue
	"Modify the receiver's tag"
	^self propertyValueAt: #tag put: aValue with: #tagChanged! !

!CMenuItem methodsFor: 'initialize' stamp: 'ar 9/10/2005 11:20'!
updateChecked: aBlock when: eventSpec
	"Update the checked state of the receiver from aBlock when the given event spec occurs. For example:
		item := menu addItem: 'foo enabled'.
		item updateChecked:[foo = true] when:{self. #fooChanged}.
	"
	checkedBlock := aBlock.
	checked := aBlock value.
	self startScript: #onUpdateChecked when: eventSpec.! !

!CMenuItem methodsFor: 'initialize' stamp: 'ar 9/10/2005 11:21'!
updateEnabled: aBlock when: eventSpec
	"Update the checked state of the receiver from aBlock when the given event spec occurs. For example:
		item := menu addItem: 'foo enabled'.
		item updateEnabled:[foo = true] when:{self. #fooChanged}.
	"
	enabledBlock := aBlock.
	enabled := aBlock value.
	self startScript: #onUpdateEnabled when: eventSpec.! !

CMenuItem subclass: #CNonClosingMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus'!

!CNonClosingMenuItem commentStamp: '<historical>' prior: 0!
I am a menu item which causes a menu costume not to close automatically after I have been fired. This is useful to implement segmented menus and similar special features.!

CNonClosingMenuItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CNonClosingMenuItem methodsFor: 'testing' stamp: 'ar 6/29/2005 20:43'!
closeAfterFire
	"Answer true if menus should close after this item has been fired"
	^false! !

CItemWidget subclass: #CPlayerIconListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Sprites'!

!CPlayerIconListItem commentStamp: '<historical>' prior: 0!
An element of a player icon list.!

CPlayerIconListItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CPlayerIconListItem methodsFor: 'initialize' stamp: 'ar 12/10/2005 20:18'!
defaultCostume
	"Answer the default costume maker for this kind of player"
	^CPrimitiveCostume! !

!CPlayerIconListItem methodsFor: 'events' stamp: 'ar 6/22/2005 11:42'!
deselect
	borderColor := CWidgetLibrary default frameColor.! !

!CPlayerIconListItem methodsFor: 'events' stamp: 'ar 6/22/2005 11:57'!
onValueChanged
	<on: valueChanged>
	value ifNil:[^self].
	balloonHelp := self roleNameFor: value.
	self refreshIcon.
! !

!CPlayerIconListItem methodsFor: 'events' stamp: 'ar 6/22/2005 11:42'!
refreshIcon
	graphicForm := value makeIcon.! !

!CPlayerIconListItem methodsFor: 'events' stamp: 'ar 6/22/2005 11:56'!
roleNameFor: aPlayer
	"Describe aPlayer's role"
	| binding basePlayer |
	(binding := aPlayer componentBinding) ifNotNil:[
		^(binding home name),'''s ', binding key.
	].
	basePlayer := aPlayer player ifNil:[^aPlayer name].
	basePlayer getCostume == aPlayer ifFalse:[^aPlayer name].
	aPlayer class == CPlayer ifTrue:[
		^(basePlayer name),'''s costume'
	].
	^(basePlayer name), '''s ', aPlayer class nameForDisplay withFirstCharacterDownshifted! !

!CPlayerIconListItem methodsFor: 'events' stamp: 'ar 6/22/2005 11:42'!
select
	borderColor := Color black.! !

!CPlayerIconListItem methodsFor: 'initialize' stamp: 'ar 6/22/2005 11:42'!
setupCostume
	super setupCostume.
	self color: CWidgetLibrary default paneColor.

	self graphicEnabled := true.
	self graphicFit: #rigid.
	self extent: 32@32.

	self roundCorners := true.
	self borderWidth := 1.
	self borderColor := CWidgetLibrary default frameColor.
	self borderStyle := #simple.! !

CPlayerIconListItem subclass: #CSpriteCostumeListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Sprites'!

!CSpriteCostumeListItem commentStamp: '<historical>' prior: 0!
OBSOLETE. DO NOT USE. WILL BE REMOVED IN THE FUTURE.!

CSpriteCostumeListItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

CItemWidget subclass: #CTreeItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Trees'!

!CTreeItem commentStamp: 'ar 3/27/2004 19:30' prior: 0!
CTreeItem is the abstract base class for items in a tree. Subclasses need to provide some services in order to make it work appropriately, namely:

	getChildren - needs to compute the children of the tree node.
	getLabel - needs to answer the label to use for the tree node.
	getIcon - needs to answer the icon (Form) to be displayed for the tree node.

In addition, tree items can implement the following message

	hasChildren - needs to respond true if this item has children or not.

This message is optional but unless the children can be really easily computed it is useful to implement this message for improved efficency.!

CTreeItem subclass: #CFileDirectoryTreeItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Trees'!

!CFileDirectoryTreeItem commentStamp: 'ar 3/27/2004 19:27' prior: 0!
CFileDirectoryTreeItem is a tree item for file directories.!

CFileDirectoryTreeItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CFileDirectoryTreeItem methodsFor: 'templates' stamp: 'ar 5/10/2005 14:33'!
getChildren
	^[value directories collect:[:each| each asTreeItem]] 
		on: Error do:[:ex| self handleError: ex ifNone:[CDialog abortRetryDebug: ex]].! !

!CFileDirectoryTreeItem methodsFor: 'templates' stamp: 'ar 3/15/2004 12:23'!
getIcon
	"Retrieve the icon for this entry"
	^nil! !

!CFileDirectoryTreeItem methodsFor: 'templates' stamp: 'ar 3/13/2004 00:59'!
getLabel
	^value localName! !

!CFileDirectoryTreeItem methodsFor: 'templates' stamp: 'eem 3/20/2010 12:30'!
hasChildren
	^value exists and: [value hasSubDirectories]! !

CTreeItem subclass: #CPlayerTreeItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Trees'!

!CPlayerTreeItem commentStamp: '<historical>' prior: 0!
CPlayerTreeItem is a tree item example for displaying a player hierarchy. Besides displaying the hierarchy, a player tree item also watches name changes and updates itself when there is a structural change (other players getting added, moved, or removed).!

CPlayerTreeItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CPlayerTreeItem class methodsFor: 'example' stamp: 'ar 3/13/2005 10:57'!
example
	"CPlayerTreeItem example"
	| world tree |
	world := Processor activeProcess hand world.
	tree := CTreeWidget new.
	tree rootNode: (self on: world).
	^tree! !

!CPlayerTreeItem methodsFor: 'accessing' stamp: 'ar 3/13/2005 11:33'!
getChildren
	"Answer the children of this node"
	^value elements asArray reversed collect:[:each| self class on: each].! !

!CPlayerTreeItem methodsFor: 'accessing' stamp: 'ar 3/13/2005 10:50'!
getIcon
	"Retrieve the icon for this entry"
	^value icon! !

!CPlayerTreeItem methodsFor: 'accessing' stamp: 'ar 3/13/2005 10:49'!
getLabel
	"Answer the label of this node"
	^value name! !

!CPlayerTreeItem methodsFor: 'accessing' stamp: 'ar 3/13/2005 10:50'!
hasChildren
	^value elements isEmpty not! !

!CPlayerTreeItem methodsFor: 'events' stamp: 'ar 3/13/2005 10:51'!
onIconChanged
	<on: iconChanged in: value>
	icon := self getIcon! !

!CPlayerTreeItem methodsFor: 'events' stamp: 'ar 3/13/2005 10:50'!
onNameChanged
	<on: nameChanged in: value>
	name := self getName.! !

!CPlayerTreeItem methodsFor: 'events' stamp: 'ar 3/13/2005 11:37'!
onStructureChanged
	<on: structureChanged in: value>
	tree ifNotNil:[self refresh].! !

CTreeItem subclass: #CServerDirectoryTreeItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Trees'!

!CServerDirectoryTreeItem commentStamp: 'ar 3/27/2004 19:27' prior: 0!
CServerDirectoryTreeItem is a tree item for server directories.!

CServerDirectoryTreeItem defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CServerDirectoryTreeItem methodsFor: 'templates' stamp: 'ar 5/10/2005 14:34'!
getChildren
	| list |
	^[Cursor wait showWhile:[
		list := value directoryNames.
		list collect:[:each| self class on: (value directoryNamed: each)]
	]] on: Error do:[:ex| self handleError: ex ifNone:[CDialog abortRetryDebug: ex]].
! !

!CServerDirectoryTreeItem methodsFor: 'templates' stamp: 'ar 3/13/2004 01:30'!
getLabel
	^ServerDirectory servers keyAtIdentityValue: value ifAbsent:[value localName]
! !

!CServerDirectoryTreeItem methodsFor: 'templates' stamp: 'ar 3/13/2004 01:14'!
hasChildren
	"We don't really want to query the server unless we have to"
	^true! !

CTreeItem defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="parent" toSet="parent:" changeEvent="parentChanged">parent</field>
	<field toGet="children" toSet="children:" changeEvent="childrenChanged">children</field>
	<field toGet="tree" toSet="tree:" changeEvent="treeChanged">tree</field>
	<field toGet="indentation" toSet="indentation:" changeEvent="indentationChanged">indentation</field>
	<field toGet="expanded" toSet="expanded:" changeEvent="expandedChanged">expanded</field>
</fields>'!

!CTreeItem methodsFor: 'private' stamp: 'ar 3/12/2004 17:49'!
anyChangedFrom: oldChildren to: newChildren
	"Answer whether there may be any change from oldChildren to newChildren"
	oldChildren size = newChildren size ifFalse:[^true]. "size differs"
	1 to: oldChildren size do:[:i|
		(oldChildren at: i) value == (newChildren at: i) ifFalse:[^true]. "child changed"
	].
	^false "no change"! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:15'!
children
	"This method was automatically generated"
	<bewareOf: #childrenChanged>
	^self propertyValueAt: #children! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/12/2004 18:01'!
children: aCollection
	"This method was automatically generated"
	self installChildren: aCollection.
	^self propertyValueAt: #children put: aCollection with: #childrenChanged! !

!CTreeItem methodsFor: 'operations' stamp: 'ar 3/12/2004 18:11'!
collapse
	"collapse me"
	expanded ifFalse:[^self].
	expanded := false.
	children := #().! !

!CTreeItem methodsFor: 'initialize' stamp: 'ar 3/12/2004 19:18'!
defaultCostume
	^CTreeItemCostume! !

!CTreeItem methodsFor: 'operations' stamp: 'ar 3/13/2004 03:00'!
expand
	"expand me"
	expanded ifTrue:[^self].
	expanded := true.
	children := self getChildren.! !

!CTreeItem methodsFor: 'expanding' stamp: 'jl 3/10/2005 16:54'!
expandFully
	"expand recursively"
	self	expandFullyWhile: [ :item | true ].! !

!CTreeItem methodsFor: 'expanding' stamp: 'jl 3/11/2005 14:04'!
expandFullySafe
	"expand recursively with time limit"
	| start |
	start := Time millisecondClockValue.
	self expandFullyWhile: [ :item | (Time millisecondsSince: start) < 1000 ].

! !

!CTreeItem methodsFor: 'expanding' stamp: 'jl 3/11/2005 14:24'!
expandFullyWhile: aBlock 
	| list item |
	list := OrderedCollection with: self.
	[list notEmpty and: [aBlock value: (item := list removeFirst)]] whileTrue: 
		[item hasChildren ifTrue: 
			[item expand.
			list addAll: item children]]	! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:15'!
expanded
	"This method was automatically generated"
	<bewareOf: #expandedChanged>
	^self propertyValueAt: #expanded! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:27'!
expanded: aValue
	"This method was automatically generated"
	^self propertyValueAt: #expanded put: aValue with: #expandedChanged! !

!CTreeItem methodsFor: 'expanding' stamp: 'bgf 5/3/2008 11:18'!
expandedChildren
	"Collection - subset of my children that are expanded"
	^ self children select: [ : c | c expanded ].
! !

!CTreeItem methodsFor: 'expanding' stamp: 'bgf 5/3/2008 11:18'!
expandedLeaves
	
	"Collection - a depthmost list of expanded items,  minimally sufficient
	 so that if all are expanded (and their parents expanded),
	 this describes the expansion state of my subtree.
	 Assumes I am expanded, so will always return a list
	 including at least one element (me, or a descendant...
	 since expanding to show any descendant, will show me too.)
	 Supports CTreeWidget expandedPaths "

	| eKids result |
	eKids := self expandedChildren.
	eKids ifEmpty: [ ^ CCollection new add: self ].

	result := CCollection new.
	eKids do: [ : eKid |
		result addAll: (eKid expandedLeaves ).
	].
	^ result! !

!CTreeItem methodsFor: 'templates' stamp: 'ar 3/13/2004 01:00'!
getChildren
	"Answer the (computed) children of this tree node"
	^#()! !

!CTreeItem methodsFor: 'templates' stamp: 'ar 3/14/2004 02:19'!
getIcon
	"Retrieve the icon for this item"
	^nil! !

!CTreeItem methodsFor: 'templates' stamp: 'ar 3/13/2004 00:57'!
getLabel
	"Answer the label to be used for this tree item"
	^value displayText! !

!CTreeItem methodsFor: 'templates' stamp: 'ar 3/13/2004 01:00'!
hasChildren
	"Answer true if this tree item has any children"
	^self getChildren isEmpty not! !

!CTreeItem methodsFor: 'private' stamp: 'bgf 1/7/2010 14:37'!
heightForFont: aFont
	"Protocol used by the costume to figure its extent."
	^ (aFont height + 8) max: 16! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/12/2004 17:36'!
indentation
	"Answer the indentation of the receiver"
	<bewareOf: #indentationChanged>
	^self propertyValueAt: #indentation! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/12/2004 17:36'!
indentation: aValue
	"Modify the receiver's indentation"
	^self propertyValueAt: #indentation put: aValue with: #indentationChanged! !

!CTreeItem methodsFor: 'private' stamp: 'ar 3/13/2004 00:39'!
indexOfFirstOpenNode
	^(tree indexOfTreeNode: self) + 1! !

!CTreeItem methodsFor: 'private' stamp: 'ar 3/13/2005 11:22'!
indexOfLastOpenNode
	^tree indexOfTreeNode: self lastOpenNode! !

!CTreeItem methodsFor: 'initialize' stamp: 'ar 3/12/2004 17:38'!
initialize
	super initialize.
	expanded := false.
	children := #().
	indentation := 0.! !

!CTreeItem methodsFor: 'private' stamp: 'ar 3/16/2004 14:40'!
installChildren: newChildren
	"Update my children after they have changed"
	| firstIndex lastIndex |
	"Avoid infinite recursion"
	value == tree ifTrue:[^self].
	tree ifNil:[^self].

	"figure out the range of nodes affected"
	(firstIndex := self indexOfFirstOpenNode) = 1 ifTrue:[
		"either this is a root node or the node was removed"
		(tree isRootNode: self) ifFalse:[^self]. "removed"
	].
	lastIndex := self indexOfLastOpenNode.

	newChildren do:[:each|
		each parent: self.
		each tree: tree.
		each indentation: indentation + 1.
	].
	(lastIndex - firstIndex + 1) = newChildren size
		ifTrue:[tree replaceTreeNodesFrom: firstIndex to: lastIndex with: newChildren].
	(lastIndex >= firstIndex)
		ifTrue:[tree removeTreeNodesFrom: firstIndex to: lastIndex].
	newChildren size = 0 
		ifFalse:[tree addTreeNodes: newChildren at: firstIndex].! !

!CTreeItem methodsFor: 'expanding' stamp: 'bgf 5/3/2008 09:46'!
labelPath
	"CCollection of labels from the root of the tree to me;
	 returns the root -> me path of labels expected by tree-widget selectLabelPath: "

	^ parent ifNotNil: [ 
			parent labelPath addLast: self label
		] ifNil: [
			CCollection new add: (self label); yourself.
		].! !

!CTreeItem methodsFor: 'private' stamp: 'ar 3/13/2005 11:22'!
lastOpenNode
	| lastNode |
	lastNode := self.
	[lastNode children size > 0] whileTrue:[
		lastNode := lastNode children last.
	].
	^lastNode! !

!CTreeItem methodsFor: 'events' stamp: 'bgf 1/9/2010 11:23'!
onExpandedChanged
	"When a node is expanded, attempt to make the contents visible."
	<on: expandedChanged>
	tree ifNil: [ ^ self ].
	expanded ifTrue: [
		self waitTick.				"Have to let the resizing propagate from the expansion."
		expanded ifFalse: [ ^ self ].
		tree ifNil: [ ^ self ].
		children size < 1 ifTrue: [ ^ self ].
		tree costume scrollTarget 
			scrollToShow: (
				(Rectangle merging: {children first fullBounds . children last fullBounds }) 
					expandBy:(0@3)).
	].! !

!CTreeItem methodsFor: 'events' stamp: 'ar 3/13/2005 11:47'!
onValueChanged
	| newLabel |
	<on: valueChanged>
	(newLabel := self getLabel) ifNotNil:[label := newLabel].
	icon := self getIcon.! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/12/2004 17:35'!
parent
	"Answer the parent of the receiver"
	<bewareOf: #parentChanged>
	^self propertyValueAt: #parent! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/12/2004 17:35'!
parent: aValue
	"Modify the receiver's parent"
	^self propertyValueAt: #parent put: aValue with: #parentChanged! !

!CTreeItem methodsFor: 'private' stamp: 'ar 3/15/2004 12:34'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(; print: self label; nextPut:$).! !

!CTreeItem methodsFor: 'operations' stamp: 'ar 3/13/2005 11:37'!
refresh
	"Refresh this node, e.g., install new children and expand accordingly."
	| oldChildren |
	self expanded ifFalse:[^self].
	oldChildren := self children.
	children := self getChildren.
	self refreshFrom: oldChildren.! !

!CTreeItem methodsFor: 'operations' stamp: 'ar 3/13/2005 11:29'!
refreshFrom: oldChildren
	"Refresh this node, e.g., install new children and expand accordingly."
	| map mapped |
	map := IdentityDictionary new.
	oldChildren do:[:node| map at: node value put: node].
	children do:[:node|
		mapped := map at: node value ifAbsent:[node].
		mapped expanded ifTrue:[node expand; refreshFrom: mapped children].
	].
	oldChildren do:[:each| each destroy].! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:15'!
tree
	"This method was automatically generated"
	<bewareOf: #treeChanged>
	^self propertyValueAt: #tree! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:27'!
tree: aValue
	"This method was automatically generated"
	^self propertyValueAt: #tree put: aValue with: #treeChanged! !

!CTreeItem methodsFor: 'accessing' stamp: 'ar 3/9/2004 02:08'!
value: newValue
	"This is left as a reminder that *probably* we will want to have an update operation if a tree item's value changes. If so, this would be a good (and efficient) way to notify our tree to replace any old against new children."
	self value == newValue ifTrue:[^newValue].
	^super value: newValue.
! !

CWidget subclass: #CLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text'!

!CLabel commentStamp: 'tk 2/15/2005 12:46' prior: 0!
A Label is a simple label, which shows just one line of characters.  It is often added as an element to another object.  You cannot edit the text of a label by clicking in it.

### Allow Users to see the above explanation ###

The fields value and text may be different.  The text field must always be equal to (value displayText).  To set the text, the owner (container of this CLabel) stores a string into his own field called 'label'.  The signal onLabelChanged causes the CLabel's value to be set, which causes the text to be changed.!

CLabel defineFields: '<?xml  version="1.0" ?>
<fields>
	<field virtual="true" serializable="false" toGet="numericValue" toSet="numericValue:">numericValue</field>
	<field virtual="true" serializable="false" toGet="contents" toSet="contents:" changeEvent="valueChanged">contents</field>
</fields>'!

!CLabel methodsFor: 'accessing' stamp: 'ar 6/5/2005 14:53'!
contents
	"Answer the contents of the receiver"
	<bewareOf: #valueChanged>
	^value displayText asString! !

!CLabel methodsFor: 'accessing' stamp: 'ar 6/5/2005 14:52'!
contents: aValue
	"Modify the receiver's contents"
	value := aValue! !

!CLabel methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:47'!
defaultCostume
	^CWidgetLibrary default labelCostume! !

!CLabel methodsFor: 'initialize' stamp: 'ar 2/25/2004 00:19'!
initialize
	super initialize.
	self value: 'Label'.! !

!CLabel methodsFor: 'accessing' stamp: 'ar 3/25/2004 21:31'!
label
	^self value displayText! !

!CLabel methodsFor: 'accessing' stamp: 'tk 2/15/2005 12:44'!
label: anObjectOrString
	"label and value may be any object that responds to displayText"
	^self value: anObjectOrString! !

!CLabel methodsFor: 'accessing' stamp: 'ar 6/5/2005 14:51'!
numericValue
	"Answer the numericValue of the receiver"
	^[value asNumber] on: Error do:[:ex| ex return: 0].! !

!CLabel methodsFor: 'accessing' stamp: 'ar 6/5/2005 14:51'!
numericValue: aValue
	"Modify the receiver's numericValue"
	value := aValue! !

CWidget subclass: #CMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus'!

CMenu subclass: #CListMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus'!

CListMenu defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="selectedItem" toSet="selectedItem:" changeEvent="selectedItemChanged">selectedItem</field>
	<field toGet="items" toSet="items:" changeEvent="itemsChanged">items</field>
	<field toGet="itemMaker" toSet="itemMaker:" changeEvent="itemMakerChanged">itemMaker</field>
</fields>'!

!CListMenu class methodsFor: 'instance creation' stamp: 'jl 5/24/2005 11:49'!
from: aCollection
	| menu |
	menu := self new.
	menu items: aCollection.
	^menu! !

!CListMenu methodsFor: 'menu' stamp: 'jl 5/24/2005 15:05'!
defaultItemMaker
	^CListMenuItem! !

!CListMenu methodsFor: 'menu' stamp: 'jl 5/24/2005 15:06'!
itemMaker
	"Answer the itemMaker of the receiver"
	<bewareOf: #itemMakerChanged>
	(self propertyValueAt: #itemMaker) ifNil: [ 
		self propertyValueAt: #itemMaker put: self defaultItemMaker].
	^self propertyValueAt: #itemMaker! !

!CListMenu methodsFor: 'menu' stamp: 'jl 5/24/2005 15:00'!
itemMaker: aValue
	"Modify the receiver's itemMaker"
	^self propertyValueAt: #itemMaker put: aValue with: #itemMakerChanged! !

!CListMenu methodsFor: 'accessing' stamp: 'jl 5/24/2005 12:09'!
items
	"Answer the items of the receiver"
	<bewareOf: #itemsChanged>
	^self propertyValueAt: #items! !

!CListMenu methodsFor: 'accessing' stamp: 'jl 5/24/2005 12:09'!
items: aValue
	"Modify the receiver's items"
	^self propertyValueAt: #items put: aValue with: #itemsChanged! !

!CListMenu methodsFor: 'events' stamp: 'jl 5/24/2005 14:43'!
onItemsChanged
	<on: itemsChanged>
	self update.! !

!CListMenu methodsFor: 'events' stamp: 'jl 5/24/2005 17:22'!
onItemsContentChanged
	<on: changed in: items>
	self update.! !

!CListMenu methodsFor: 'events' stamp: 'ar 5/24/2005 11:50'!
onItemsCursorChanged
	<on: cursorChanged in: items>
	self updateSelectedItem.! !

!CListMenu methodsFor: 'events' stamp: 'jl 5/24/2005 11:47'!
onSelectedItemChanged: newItem from: oldItem
	<on: selectedItemChanged>
	oldItem ifNotNil: [oldItem checked: false].
	newItem ifNotNil: [newItem checked: true].! !

!CListMenu methodsFor: 'open' stamp: 'ar 7/11/2005 14:26'!
openAt: aPosition centeredAt: anItem
	| itemCostume |

	self openAt: aPosition.
	self fullBounds.
	anItem ifNotNil:[itemCostume := anItem costume].

	self openAt:	(itemCostume 
			ifNotNil: [aPosition - itemCostume topLeft]
			ifNil: [aPosition]).! !

!CListMenu methodsFor: 'open' stamp: 'jl 5/24/2005 15:14'!
openItemCenteredAt: aPosition
	self openAt: aPosition centeredAt: selectedItem.! !

!CListMenu methodsFor: 'accessing' stamp: 'jl 5/24/2005 12:09'!
selectedItem
	"Answer the selectedItem of the receiver"
	<bewareOf: #selectedItemChanged>
	^self propertyValueAt: #selectedItem! !

!CListMenu methodsFor: 'accessing' stamp: 'jl 5/24/2005 11:44'!
selectedItem: aValue
	"Modify the receiver's selectedItem"
	^self propertyValueAt: #selectedItem put: aValue with: #selectedItemChanged! !

!CListMenu methodsFor: 'initialize' stamp: 'jl 5/24/2005 11:40'!
setupCostume
	super setupCostume.
	self roundCorners: false.! !

!CListMenu methodsFor: 'menu' stamp: 'ar 5/24/2005 11:50'!
update
	self menuItems removeAll.
	self addMenuItems: 
		(items collect: [:item| self itemMaker item: item list: items]).
	self updateSelectedItem.! !

!CListMenu methodsFor: 'menu' stamp: 'ar 5/24/2005 11:49'!
updateSelectedItem
	selectedItem := menuItems detect: [:item| item value = items selection].
	! !

CMenu defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="itemMaker" toSet="itemMaker:" changeEvent="itemMakerChanged">itemMaker</field>
	<field toGet="menuItems" toSet="menuItems:" changeEvent="menuItemsChanged">menuItems</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
</fields>'!

!CMenu class methodsFor: 'benchmark' stamp: 'ar 8/18/2005 22:57'!
benchmark: count
	"MessageTally spyOnScript:[CMenu benchmark: 10]"
	| menu |
	1 to: count do:[:i|
		menu := self benchmarkMenu.
		menu openAt: 100@100.
		self waitTick.
		"menu menuItems do:[:each| menu menuItems selection: each. self waitTick]."
		menu close.
		self waitTick.
	].
! !

!CMenu class methodsFor: 'benchmark' stamp: 'ar 8/18/2005 23:16'!
benchmarkMenu
	| menu item |
	menu := CMenu new.
	"menu label: 'Benchmark'."
		item := menu addItem: 'Find'.
		item icon: MenuIcons findIcon.
		item := menu addItem: 'Find Next'.
		item icon: MenuIcons findIcon.
		item := menu addItem: 'Find and Replace'.
		item icon: MenuIcons findIcon.
	menu addSeparator.
		item := menu addItem: 'Undo'.
		item icon: MenuIcons undoIcon.
		item := menu addItem: 'Redo'.
		item icon: MenuIcons redoIcon.
	menu addSeparator.
		item := menu addItem: 'Copy'.
		item icon: MenuIcons copyIcon.
		item := menu addItem: 'Cut'.
		item icon: MenuIcons cutIcon.
		item := menu addItem: 'Paste'.
		item icon: MenuIcons pasteIcon.
	menu addSeparator.
		item := menu addItem: 'Evaluate Selection'.
		item icon: MenuIcons doItIcon.
		item := menu addItem: 'Print Selection'.
		item icon: MenuIcons printIcon.
		item := menu addItem: 'Inspect Selection'.
		item icon: MenuIcons inspectIcon.
		item := menu addItem: 'Explore Selection'.
		item icon: MenuIcons inspectIcon.
		item := menu addItem: 'Debug Selection'.
		item icon: MenuIcons doItIcon.
	menu addSeparator.
		item := menu addItem: 'Accept'.
		item icon: MenuIcons okIcon.
		item := menu addItem: 'Cancel'.
		item icon: MenuIcons cancelIcon.
	^menu! !

!CMenu class methodsFor: 'as yet unclassified' stamp: 'ar 6/29/2005 20:26'!
testMenu
	| menu max |
	menu := CMenu new.
	max := 40.
	menu add: 'Item 1' target: CDialog action: #inform: argument: 'You selected the first item'.
	2 to: max-1 do:[:i|
		menu add: 'Item ',i
			 target: CDialog 
			action: #inform: 
			argument: 'Item ', i,' was selected'].
	menu add: 'Item ', max target: CDialog action: #inform: argument: 'The last item was selected'.
	menu label: 'Please choose the item'.
	^menu! !

!CMenu methodsFor: 'construction' stamp: 'ar 2/23/2004 19:12'!
add: aString action: anAction
	^self add: aString target: anAction action: #value! !

!CMenu methodsFor: 'construction' stamp: 'ar 2/23/2004 19:12'!
add: aString subMenu: aMenu
	| item |
	item := self addItem: aString.
	item subMenu: aMenu.
	^item! !

!CMenu methodsFor: 'construction' stamp: 'ar 5/17/2007 15:06'!
add: aString subMenu: aMenu tag: tagValue
	| item |
	item := self add: aString subMenu: aMenu.
	item tag: tagValue.
	^item! !

!CMenu methodsFor: 'construction' stamp: 'ar 2/23/2004 19:12'!
add: aString target: anObject action: aSelector
	^self add: aString target: anObject action: aSelector arguments: #()! !

!CMenu methodsFor: 'construction' stamp: 'ar 2/23/2004 19:12'!
add: aString target: anObject action: aSelector argument: arg
	^self add: aString target: anObject action: aSelector arguments: {arg}! !

!CMenu methodsFor: 'construction' stamp: 'ar 11/13/2006 14:44'!
add: aString target: anObject action: aSelector argument: arg disabled: aBool
	| item |
	item := self add: aString target: anObject action: aSelector arguments: {arg}.
	item disabled: aBool.
	^ item! !

!CMenu methodsFor: 'construction' stamp: 'eem 11/18/2008 16:53'!
add: aString target: anObject action: aSelector argument: arg tag: tagValue
	| item |
	item := self add: aString target: anObject action: aSelector arguments: {arg}.
	item tag: tagValue.
	^ item! !

!CMenu methodsFor: 'construction' stamp: 'ar 12/18/2004 22:09'!
add: aString target: anObject action: aSelector arguments: args
	| item |
	item := self addItem: aString.
	item action: (MessageSend receiver: anObject selector: aSelector arguments: args).
	(anObject respondsTo: aSelector) ifFalse:[item enabled: false].
	^item! !

!CMenu methodsFor: 'construction' stamp: 'ar 2/23/2004 19:13'!
add: aString target: anObject action: aSelector checked: aBool
	| item |
	item := self add: aString target: anObject action: aSelector.
	item checked: aBool.
	^item! !

!CMenu methodsFor: 'construction' stamp: 'ar 2/23/2004 19:13'!
add: aString target: anObject action: aSelector disabled: aBool
	| item |
	item := self add: aString target: anObject action: aSelector.
	item disabled: aBool.
	^item! !

!CMenu methodsFor: 'construction' stamp: 'ar 9/10/2005 11:17'!
addItem: aString
	| item |
	item := itemMaker new.
	item label: aString.
	menuItems add: item.
	self signal: #menuItemsChanged.
	^item! !

!CMenu methodsFor: 'construction' stamp: 'ar 9/21/2007 16:45'!
addItem: aString after: prevItem
	| item |
	item := itemMaker new.
	item label: aString.
	menuItems add: item after: prevItem.
	self signal: #menuItemsChanged.
	^item! !

!CMenu methodsFor: 'construction' stamp: 'sw 2/8/2005 12:37'!
addItemSpec: itemSpec target: aTarget
	"Add an item.  The first parameter, itemSpec, is 
		*  either... the symbol $-, to request a separator
		*  or...an array of two or three items:
				(1)  item label
				(2)  either:
						item selector (what will be sent to the target)
					  or
						an array (defining a submenu)
				(3)  optional - balloon-help string"

	| itemName itemValue item |
	itemSpec == #- ifTrue:[^self addSeparator].
	itemName := itemSpec first.
	itemValue := itemSpec second.
	item := self addItem: itemName.
	(itemValue isMemberOf: Array) ifTrue:[
		item subMenu: (CMenu new addList: itemValue target: aTarget).
	] ifFalse:[
		item action: (MessageSend receiver: aTarget selector: itemValue).
	].
	itemSpec size > 2
		ifTrue: [item balloonHelp: itemSpec third].

	^item! !

!CMenu methodsFor: 'construction' stamp: 'jjl 6/12/2008 10:37'!
addLabelItem: aString
	"Add the label as a disabled (label-only) item."
	^ self add: aString target: self action: #noSuchAction disabled: true.! !

!CMenu methodsFor: 'construction' stamp: 'ar 3/6/2004 22:27'!
addList: itemSpecList target: aTarget
	itemSpecList do:[:itemSpec|
		self addItemSpec: itemSpec target: aTarget.
	].! !

!CMenu methodsFor: 'construction' stamp: 'jl 5/24/2005 10:49'!
addMenuItem: aMenuItem
	menuItems add: aMenuItem.
	self signal: #menuItemsChanged.
	^aMenuItem! !

!CMenu methodsFor: 'construction' stamp: 'jl 5/24/2005 10:49'!
addMenuItems: someMenuItems
	menuItems addAll: someMenuItems.
	self signal: #menuItemsChanged.
	^someMenuItems! !

!CMenu methodsFor: 'construction' stamp: 'ar 8/19/2005 09:43'!
addSeparator
	menuItems size > 0 ifTrue:[menuItems last separator: true].! !

!CMenu methodsFor: 'initialize' stamp: 'ar 6/29/2005 21:14'!
beOnScreen
	"Check to see if we need to segment this menu or not"
	| maxItems |
	maxItems := (self world height // costume itemHeight) * 3 // 4.
	menuItems size > maxItems ifTrue:[self beSegmented: maxItems].
	super beOnScreen.! !

!CMenu methodsFor: 'initialize' stamp: 'bgf 2/26/2009 01:38'!
beSegmented: maxItems
	| max segCount segments item seg |
	max := menuItems size.
	segCount := max + maxItems - 1 // maxItems.
	segments := Array new: segCount.
	1 to: segCount do:[:i|
		
		item := CNonClosingMenuItem new.
		item label: (i = segCount ifTrue:['Start over...'] ifFalse:['Show more...']).

		seg := self menuItems copyFrom: (i-1*maxItems+1) to: (i*maxItems min: max).
		seg ifNotEmpty: [ seg last separator: true ].
		seg := (CCollection new) addAll: seg; add: item; yourself.
		segments at: i put: seg.
	].
	1 to: segCount do:[:i|
		item := (segments at: i) last.
		item action: (MessageSend
			receiver: self
			selector: #showMenuSegment:
			argument: (segments atWrap: i+1)).
	].
	self menuItems: segments first.! !

!CMenu methodsFor: 'utilities' stamp: 'ar 3/6/2004 22:52'!
choose: labelString
	labelString ifNotNil:[self label: labelString].
	^self run: nil! !

!CMenu methodsFor: 'utilities' stamp: 'ar 3/6/2004 22:52'!
choose: labelString from: labels values: values default: defaultAnswer
	labelString ifNotNil:[self label: labelString].
	labels with: values do:[:lbl :val| 
		self add: lbl target: self action: #value: argument: val].
	^self run: defaultAnswer! !

!CMenu methodsFor: 'utilities' stamp: 'ar 3/6/2004 22:52'!
chooseFrom: aCollection
	self chooseFrom: aCollection in: self.
	^self run: nil! !

!CMenu methodsFor: 'utilities' stamp: 'sw 2/8/2005 12:43'!
chooseFrom: aCollection in: aMenu
	"Set the receiver up so that, when presented, it will allow the user to choose an item from the collection provided.  Refer to comment in CMenu>>chooseFrom: to see what the elements of the collection can consist of"
	
	| subLabel item entry |
	aCollection do:[:spec|
		spec = #- ifTrue:[
			self addSeparator.
		] ifFalse:[
			subLabel := spec first.
			item := spec second.
			item class == Array ifTrue:[
				| subMenu |
				subMenu := CMenu new.
				subMenu chooseFrom: item in: aMenu.
				self add: subLabel subMenu: subMenu.
			] ifFalse:[
				entry := self add: subLabel target: aMenu action: #value: argument: item.
				entry checked: aMenu value == item.
			].
		].
	].! !

!CMenu methodsFor: 'utilities' stamp: 'ar 3/7/2004 01:04'!
chooseFromValues: aCollection
	^self chooseFrom: (aCollection collect:[:each| Array with: each with: each]).! !

!CMenu methodsFor: 'utilities' stamp: 'ar 3/7/2004 01:05'!
chooseFromValues: aCollection default: defaultValue
	defaultValue ifNotNil:[
		self add: defaultValue target: self action: #value: argument: defaultValue.
		self addSeparator.
	].
	^self chooseFromValues: aCollection! !

!CMenu methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:48'!
defaultCostume
	^CWidgetLibrary default menuCostume! !

!CMenu methodsFor: 'initialize' stamp: 'bgf 8/25/2008 09:57'!
initialize
	super initialize.
	self define: #menuItems as: CCollection new.
	font := CWidgetLibrary default menuFont.
	itemMaker := CMenuItem.
	label := nil.! !

!CMenu methodsFor: 'utilities' stamp: 'bgf 8/25/2007 12:23'!
installFont: aFont
	"Set this font on me and my entire substructure."	
	self font: aFont.
	self menuItems do: [  : item | 
		item font: aFont.
		item subMenu ifNotNilDo: [ : sub | sub installFont: aFont ].
	].
	self costume invalidate.! !

!CMenu methodsFor: 'accessing' stamp: 'ar 9/10/2005 11:16'!
itemMaker
	"Answer the itemMaker of the receiver"
	<bewareOf: #itemMakerChanged>
	^self propertyValueAt: #itemMaker! !

!CMenu methodsFor: 'accessing' stamp: 'ar 9/10/2005 11:16'!
itemMaker: aValue
	"Modify the receiver's itemMaker"
	^self propertyValueAt: #itemMaker put: aValue with: #itemMakerChanged! !

!CMenu methodsFor: 'utilities' stamp: 'tk 8/17/2004 15:17'!
itemNamed: titleString
	"Return the menu item with this label or nil"

	menuItems do: [:iitem | iitem label = titleString ifTrue: [^ iitem]].
	^ nil! !

!CMenu methodsFor: 'utilities' stamp: 'ar 5/17/2007 12:02'!
itemTagged: tagValue
	"Return the menu item with this tag"
	self itemsTagged: tagValue do:[:item| ^item].
	^nil! !

!CMenu methodsFor: 'utilities' stamp: 'ar 5/22/2007 17:42'!
itemsTagged: tagValue do: aBlock
	"Enumerate this menu and its submenus and find all the items with the given tag value"
	menuItems do:[:each|
		each tag = tagValue ifTrue:[aBlock value: each].
		each subMenu ifNotNil:[each subMenu itemsTagged: tagValue do: aBlock]
	].! !

!CMenu methodsFor: 'accessing' stamp: 'ar 3/24/2004 16:37'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CMenu methodsFor: 'accessing' stamp: 'ar 3/24/2004 16:37'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CMenu methodsFor: 'accessing' stamp: 'ar 3/24/2004 15:11'!
menuItems
	"Answer the menuItems of the receiver"
	<bewareOf: #menuItemsChanged>
	^self propertyValueAt: #menuItems! !

!CMenu methodsFor: 'accessing' stamp: 'ar 3/24/2004 15:11'!
menuItems: aValue
	"Modify the receiver's menuItems"
	^self propertyValueAt: #menuItems put: aValue with: #menuItemsChanged! !

!CMenu methodsFor: 'utilities' stamp: 'tk 2/24/2005 11:29'!
pathToItem: titleString
	"Search the entire tree of menu items and sub-menus for this label.  Return a path of titles to click on."

	| aSubMenu below |
	menuItems do: [:iitem | 
		iitem label = titleString ifTrue: [^ {iitem label}].
		(aSubMenu := iitem subMenu) ifNotNil: [
			below := aSubMenu pathToItem: titleString.
			below size > 0 ifTrue: [^ {iitem label}, below]]].
	^ #()! !

!CMenu methodsFor: 'construction' stamp: 'jcg 1/24/2008 09:47'!
removeMenuItems
	menuItems removeAll.
	self signal: #menuItemsChanged! !

!CMenu methodsFor: 'utilities' stamp: 'ar 3/6/2004 22:53'!
run
	^self run: self value! !

!CMenu methodsFor: 'utilities' stamp: 'ar 3/6/2004 22:53'!
run: defaultValue
	self value: defaultValue.
	self isOpen ifFalse:[self openAt: self hand position].
	self waitUntil: #closed.
	self syncScript. "to get answer for real"
	^self value! !

!CMenu methodsFor: 'utilities' stamp: 'bgf 2/26/2009 01:39'!
showMenuSegment: aCollection
	"Show a new segment in this menu"
	aCollection cursor: (aCollection size).
	self menuItems: aCollection.! !

!CMenu methodsFor: 'utilities' stamp: 'tk 2/24/2005 10:30'!
subItemNamed: titleString
	"Search the entire tree of menu items and sub-menus for this label"

	| aSubMenu below |
	menuItems do: [:iitem | 
		iitem label = titleString ifTrue: [^ iitem].
		(aSubMenu := iitem subMenu) ifNotNil: [
			below := aSubMenu subItemNamed: titleString.
			below ifNotNil: [^ below]]].
	^ nil! !

!CMenu methodsFor: 'utilities' stamp: 'ar 7/8/2006 17:49'!
subMenuNamed: labelString
	"Search the entire tree of menu items and sub-menus for a sub-menu with this label"
	| aSubMenu below |
	menuItems do: [:iitem | 
		aSubMenu := iitem subMenu.
		aSubMenu ifNotNil:[
			(iitem label = labelString) ifTrue: [^aSubMenu].
			below := aSubMenu subMenuNamed: labelString.
			below ifNotNil: [^ below]]].
	^ nil! !

CMenu subclass: #CMenuBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus'!

CMenuBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="passFillToSubMenus" toSet="passFillToSubMenus:" changeEvent="passFillToSubMenusChanged">passFillToSubMenus</field>
</fields>'!

!CMenuBar class methodsFor: 'examples' stamp: 'ar 3/13/2004 17:50'!
example1
	| menu |
	menu := CMenuBar new.
	menu addList: #(
		('File' (
			('New File' yourself)
			('Open File' yourself)
			('Save File' yourself)
			-
			('Print...' yourself)
			-
			('Quit' yourself)
		))
		('Edit' (
			('Undo' yourself)
			('Redo' yourself)
			-
			('Cut' yourself)
			('Copy' yourself)
			('Paste' yourself)
		))
		('Info' (
			('About' yourself)
		))
	) target: self.
	^menu
! !

!CMenuBar methodsFor: 'initialize' stamp: 'ar 8/18/2005 23:30'!
defaultCostume
	^CMenuBarCostume2! !

!CMenuBar methodsFor: 'initialize' stamp: 'bgf 9/13/2008 17:42'!
initialize
	super initialize.
	self passFillToSubMenus: false.
	self label: nil.! !

!CMenuBar methodsFor: 'accessing' stamp: 'bgf 9/13/2008 19:07'!
passFillToSubMenus
	"Answer the passFillToSubMenus of the receiver.
	 If true, the menu bar imposes its own fill upon all its cascades."
	<bewareOf: #passFillToSubMenusChanged>
	^self propertyValueAt: #passFillToSubMenus! !

!CMenuBar methodsFor: 'accessing' stamp: 'bgf 9/13/2008 17:42'!
passFillToSubMenus: aValue
	"Modify the receiver's passFillToSubMenus"
	^self propertyValueAt: #passFillToSubMenus put: aValue with: #passFillToSubMenusChanged! !

CWidget subclass: #CProgressBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

CProgressBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="min" toSet="min:" changeEvent="minChanged">min</field>
	<field toGet="max" toSet="max:" changeEvent="maxChanged">max</field>
	<field virtual="true" serializable="false" toGet="fraction" toSet="fraction:" changeEvent="valueChanged">fraction</field>
	<field toGet="process" toSet="process:" changeEvent="processChanged">process</field>
	<field toGet="allowAbort" toSet="allowAbort:" changeEvent="allowAbortChanged">allowAbort</field>
	<field toGet="allowDebug" toSet="allowDebug:" changeEvent="allowDebugChanged">allowDebug</field>
</fields>'!

!CProgressBar class methodsFor: 'instance creation' stamp: 'ar 10/29/2004 23:52'!
displayProgress: labelString at: aPoint from: minVal to: maxVal during: workBlock
	^self new displayProgress: labelString at: aPoint from: minVal to: maxVal during: workBlock! !

!CProgressBar class methodsFor: 'class initialization' stamp: 'ar 4/24/2005 19:14'!
initialize
	"CProgressBar initialize"
	self initializePreferences.
	self flag: #forceCallToinitialize.! !

!CProgressBar class methodsFor: 'class initialization' stamp: 'ar 4/24/2005 19:14'!
initializePreferences
	"The preference is mostly intended for debugging, e.g., we had an interestingly non-deterministic problem with loading updates which (depending on the exact timing behavior) would trigger an error upon load. Disabling the preference included here will reliably trigger such problems."
	Preferences addPreference: #automaticProgressDelay categories: #('Tweak') default: true balloonHelp: 'When true, the progress bar will only update itself every 50ms'.
	Preferences addPreference: #enableProgressAbort categories: #('Tweak') default: true balloonHelp: 'When true, a progress bar can abort the operation'.
	Preferences addPreference: #enableProgressDebug categories: #('Tweak') default: false balloonHelp: 'When true, a progress bar can debug the operation'.! !

!CProgressBar methodsFor: 'actions' stamp: 'ar 6/2/2007 21:59'!
abort
	"Cancel the currently executing operation"
	process ifNotNil:[
		self close.
		process signalException: CProgressCancel.
		process resume.
	].! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 4/24/2005 19:05'!
allowAbort
	"Answer the allowAbort of the receiver"
	<bewareOf: #allowAbortChanged>
	^self propertyValueAt: #allowAbort! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 4/24/2005 19:05'!
allowAbort: aValue
	"Modify the receiver's allowAbort"
	^self propertyValueAt: #allowAbort put: aValue with: #allowAbortChanged! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 4/24/2005 19:05'!
allowDebug
	"Answer the allowDebug of the receiver"
	<bewareOf: #allowDebugChanged>
	^self propertyValueAt: #allowDebug! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 4/24/2005 19:05'!
allowDebug: aValue
	"Modify the receiver's allowDebug"
	^self propertyValueAt: #allowDebug put: aValue with: #allowDebugChanged! !

!CProgressBar methodsFor: 'actions' stamp: 'ar 4/28/2005 15:57'!
debug
	"Debug the currently executing operation"
	process ifNotNil:[process debug: process suspendedContext title: 'Interrupt' full: false].! !

!CProgressBar methodsFor: 'initialize' stamp: 'ar 10/30/2004 00:06'!
defaultCostume
	^CWidgetLibrary default progressBarCostume! !

!CProgressBar methodsFor: 'initialize' stamp: 'bgf 3/30/2008 02:08'!
displayProgress: labelString at: aPoint from: minVal to: maxVal during: workBlock
	| lastUpdate nextUpdate autoDelay result |
	process := Processor activeProcess.
	autoDelay := Preferences automaticProgressDelay.
	label := labelString.
	self floating: true.
	self openAt: aPoint.
	min := value := minVal.
	max := maxVal.
	self waitTick.
	lastUpdate := Time millisecondClockValue.
	[
		[result := workBlock value: [:newValue|
			value := newValue.
			nextUpdate := Time millisecondClockValue.
			((nextUpdate - lastUpdate between: 0 and: 50) and:[autoDelay]) ifFalse:[
					self waitTick.
					lastUpdate := Time millisecondClockValue..
				]].
		] on: ProgressNotification do:[:ex|
			ex extraParam isString ifTrue:[
				label := ex extraParam.
				costume percentLabel label: ''.	"Don't keep old nums/Done once we've announced a new phase"
				self waitTick.
			].
			ex resume.
		].
	self waitTick.
	] ensure:[
		process := nil.
		self close.
	].
	^ result! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 10/29/2004 23:24'!
fraction
	"Answer the fraction of the receiver"
	| range |
	<bewareOf: #valueChanged>
	range := max - min.
	range > 0.0 ifTrue:[^(value - min) / range min: 1.0 max: 0.0].
	^1.0! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 10/29/2004 23:24'!
fraction: aFraction
	"Modify the receiver's fraction"
	| range frac |
	range := max - min.
	frac := aFraction min: 1.0 max: 0.0.
	range > 0.0 ifTrue:[value := frac * range + min].! !

!CProgressBar methodsFor: 'initialize' stamp: 'ar 4/24/2005 18:47'!
informUserDuring: workBlock
	| lastUpdate nextUpdate autoDelay result |
	process := Processor activeProcess.
	autoDelay := Preferences automaticProgressDelay.
	label := '...'.
	min := 0.
	value := 50.
	max := 100.
	lastUpdate := Time millisecondClockValue - 51.
	[
		result := workBlock value: [:newLabel|
			label := newLabel.
			nextUpdate := Time millisecondClockValue.
			((nextUpdate - lastUpdate between: 0 and: 50) and:[autoDelay]) ifFalse:[
					self world ifNil:[self open].
					self waitTick.
					lastUpdate := Time millisecondClockValue..
				]].
		self waitTick.
	] ensure:[
		process := nil.
		self close.
	].
	^ result! !

!CProgressBar methodsFor: 'initialize' stamp: 'bgf 4/30/2007 12:27'!
initialize
	super initialize.

	font := Preferences standardControlFont.
	label := 'Progress'.
	min := 0.
	max := 100.
	value := 0.
	allowDebug := Preferences enableProgressDebug.
	allowAbort := Preferences enableProgressAbort.! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 10/29/2004 22:56'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 10/29/2004 22:56'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 10/29/2004 23:21'!
max
	"Answer the max of the receiver"
	<bewareOf: #maxChanged>
	^self propertyValueAt: #max! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 10/29/2004 23:21'!
max: aValue
	"Modify the receiver's max"
	^self propertyValueAt: #max put: aValue with: #maxChanged! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 10/29/2004 22:56'!
min
	"Answer the min of the receiver"
	<bewareOf: #minChanged>
	^self propertyValueAt: #min! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 10/29/2004 22:56'!
min: aValue
	"Modify the receiver's min"
	^self propertyValueAt: #min put: aValue with: #minChanged! !

!CProgressBar methodsFor: 'events' stamp: 'bgf 5/30/2007 23:56'!
onMouseDown
	<on: mouseDown>
	self onDrag.	"Be movable."! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 4/24/2005 18:45'!
process
	"Answer the process of the receiver"
	<bewareOf: #processChanged>
	^self propertyValueAt: #process! !

!CProgressBar methodsFor: 'accessing' stamp: 'ar 4/24/2005 18:45'!
process: aValue
	"Modify the receiver's process"
	^self propertyValueAt: #process put: aValue with: #processChanged! !

!CProgressBar methodsFor: 'actions' stamp: 'ar 4/28/2005 15:57'!
resume
	"Resume the currently executing operation"
	process ifNotNil:[process resume].! !

!CProgressBar methodsFor: 'actions' stamp: 'ar 4/28/2005 15:57'!
suspend
	"Suspend the currently executing operation"
	process ifNotNil:[process suspend].! !

CWidget subclass: #CScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling'!

!CScrollPane commentStamp: 'tk 9/13/2004 15:51' prior: 0!
A ScrollPane is an area with contents and two scroll bars.
(How do you hook up a new ScrollPane using the mouse?  Embed contents into it.  What kinds work?)


### Allow Users to see the above explanation ###!

CScrollPane defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="holder" toSet="holder:" changeEvent="holderChanged">holder</field>
</fields>'!

!CScrollPane methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:48'!
defaultCostume
	^CWidgetLibrary default scrollPaneCostume! !

!CScrollPane methodsFor: 'accessing' stamp: 'ar 3/24/2004 17:55'!
elements
	^holder elements! !

!CScrollPane methodsFor: 'accessing' stamp: 'ar 3/24/2004 17:53'!
holder
	"Answer the holder of the receiver"
	<bewareOf: #holderChanged>
	^self propertyValueAt: #holder! !

!CScrollPane methodsFor: 'accessing' stamp: 'ar 3/24/2004 17:53'!
holder: aValue
	"Modify the receiver's holder"
	^self propertyValueAt: #holder put: aValue with: #holderChanged! !

!CScrollPane methodsFor: 'initialize' stamp: 'ar 3/24/2004 18:02'!
initialize
	super initialize.
	self define: #holder as: CHolder new.
	hScrollable := true.
	vScrollable := true.! !

!CScrollPane methodsFor: 'initialize' stamp: 'ar 3/30/2005 00:18'!
setupCostume
	super setupCostume.
	holder clipping: true.! !

CWidget subclass: #CSpinnerButtons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling'!

!CSpinnerButtons commentStamp: 'tk 9/13/2004 17:08' prior: 0!
SpinnerButtons are the up and down arrows on a Spinner.  Look in the ColorTool at the Fill Alpha: control to see a Spinner with SpinnerButtons.


### Allow Users to see the above explanation ###!

CSpinnerButtons defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CSpinnerButtons methodsFor: 'initialize' stamp: 'ar 3/13/2004 23:56'!
defaultCostume
	^CSpinnerButtonsCostume! !

CWidget subclass: #CTextEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text'!

!CTextEditor commentStamp: '<historical>' prior: 0!
A TextEditor is a simple place to edit text.  By default, it will not perform any keystroke actions except cut, copy, and paste (^ x, ^c, ^v).  The user can make the text bold, or italic, and change its size and font by getting a Text Tool from the Tools menu of the menubar.[general]

### Allow Users to see the above explanation ###

Clients can register other keystroke actions via #onKeyDown:signal: and similar messages.

The property acceptAction: is a  single-argument block; if set, this is evaluated 
when the text is accepted.  (It is overridden if save event handlers are used.)
This gives some compatibility with Morphic text editors.!

CTextEditor subclass: #CInputField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text'!

!CInputField commentStamp: 'ar 12/19/2004 19:34' prior: 0!
An InputField is a one line text editor.  The enter key and the return key make it accept and remember its text.  This text is stored in its value field.  It can carry a TextConverter to convert forth and back between its value (any object) and the text it displays.

### Allow Users to see the above explanation ###

Fields:
	converter	<CTextConverter> Converter between object and text representation.
	autoAccept	<Boolean>	If true, the input field will accept its contents when keyboard focuses leaves the input field. Cannot be combined with autoRevert.
	autoRevert	<Boolean>	If true, the input field will revert its contents when keyboard focuses leaves the input field. Cannot be combined with autoAccept.!

CInputField defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="converter" toSet="converter:" changeEvent="converterChanged">converter</field>
	<field toGet="autoAccept" toSet="autoAccept:" changeEvent="autoAcceptChanged">autoAccept</field>
	<field toGet="autoRevert" toSet="autoRevert:" changeEvent="autoRevertChanged">autoRevert</field>
</fields>'!

!CInputField methodsFor: 'events' stamp: 'bf 7/29/2005 18:06'!
accept
	self signal: #accept! !

!CInputField methodsFor: 'accessing' stamp: 'ar 12/19/2004 19:24'!
autoAccept
	"Answer the autoAccept of the receiver"
	<bewareOf: #autoAcceptChanged>
	^self propertyValueAt: #autoAccept! !

!CInputField methodsFor: 'accessing' stamp: 'ar 12/19/2004 19:24'!
autoAccept: aValue
	"Modify the receiver's autoAccept"
	^self propertyValueAt: #autoAccept put: aValue with: #autoAcceptChanged! !

!CInputField methodsFor: 'accessing' stamp: 'ar 12/19/2004 19:22'!
autoRevert
	"Answer the autoRevert of the receiver"
	<bewareOf: #autoRevertChanged>
	^self propertyValueAt: #autoRevert! !

!CInputField methodsFor: 'accessing' stamp: 'ar 12/19/2004 19:22'!
autoRevert: aValue
	"Modify the receiver's autoRevert"
	^self propertyValueAt: #autoRevert put: aValue with: #autoRevertChanged! !

!CInputField methodsFor: 'accessing' stamp: 'ar 3/18/2004 14:20'!
converter
	"Answer the converter of the receiver"
	<bewareOf: #converterChanged>
	^self propertyValueAt: #converter! !

!CInputField methodsFor: 'accessing' stamp: 'ar 3/18/2004 14:20'!
converter: aValue
	"Modify the receiver's converter"
	^self propertyValueAt: #converter put: aValue with: #converterChanged! !

!CInputField methodsFor: 'initialize' stamp: 'ar 5/19/2004 15:30'!
defaultCostume
	^CInputFieldCostume! !

!CInputField methodsFor: 'initialize' stamp: 'ar 6/2/2004 14:18'!
defaultTarget
	^costume! !

!CInputField methodsFor: 'events' stamp: 'ar 8/6/2007 13:57'!
escape
	"Drop keyboard focus on escape"
	self hand releaseKeyboardFocus: self.! !

!CInputField methodsFor: 'testing' stamp: 'ar 1/25/2007 14:46'!
isTabStop
	"Only tab stop here if editing is on"
	^allowEditing! !

!CInputField methodsFor: 'events' stamp: 'ar 8/6/2007 13:57'!
onAccept
	<on: accept>
	"odd logic below prevents double-accept in the case of auto-accepting"
	autoAccept == true ifFalse:[value := self readValue: contents asString].
	self hand releaseKeyboardFocus: self.! !

!CInputField methodsFor: 'events' stamp: 'ar 1/25/2007 15:01'!
onKeyStroke: evt
	<on: keyStroke>
	evt keyValue = 9 ifTrue:[^container handleTab: evt from: self after: self].
	super onKeyStroke: evt.! !

!CInputField methodsFor: 'events' stamp: 'ar 12/19/2004 19:23'!
onKeyboardFocusEnter
	"Select all of the text when the user clicks in the input field"
	self selectAll.
	super onKeyboardFocusEnter.! !

!CInputField methodsFor: 'events' stamp: 'ar 6/3/2005 22:36'!
onKeyboardFocusLeave
	"Select all of the text when the user clicks in the input field"
	autoAccept == true ifTrue:[value := self readValue: contents asString].
	autoRevert == true ifTrue:[contents := self printValue: value].
	editor selectFrom: 1 to: 1. "deselect"
	super onKeyboardFocusLeave.! !

!CInputField methodsFor: 'events' stamp: 'ar 1/25/2007 14:41'!
onTabEnter: evt
	<on: tabEnter>
	hand keyboardFocus: self.! !

!CInputField methodsFor: 'events' stamp: 'ar 1/25/2007 15:01'!
onTabLeave: evt
	<on: tabLeave>
	hand releaseKeyboardFocus: self.! !

!CInputField methodsFor: 'converting' stamp: 'ar 3/19/2004 17:25'!
printValue: aValue
	converter ifNil:[^super printValue: aValue].
	^[converter printValue: aValue] on: Error do:[:ex| ex return: '<error>'].! !

!CInputField methodsFor: 'converting' stamp: 'ar 1/22/2005 22:31'!
readValue: aString
	converter ifNil:[^super readValue: aString].
	^[converter readValue: aString] on: Error do:[:ex| 
		contents := self printValue: value.
		self flash.
		ex return: value].! !

!CInputField methodsFor: 'events' stamp: 'bf 7/19/2005 17:02'!
return
	self signal: #accept! !

CTextEditor defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="allowEditing" toSet="allowEditing:" changeEvent="allowEditingChanged">allowEditing</field>
	<field toGet="readOnly" toSet="readOnly:" changeEvent="readOnlyChanged">readOnly</field>
	<field toGet="mouseCursor" toSet="mouseCursor:" changeEvent="mouseCursorChanged">mouseCursor</field>
	<field toGet="searchText" toSet="searchText:" changeEvent="searchTextChanged">searchText</field>
	<field toGet="caseSensitiveSearch" toSet="caseSensitiveSearch:" changeEvent="caseSensitiveSearchChanged">caseSensitiveSearch</field>
	<field virtual="true" toGet="editor">editor</field>
	<field virtual="true" toGet="selectionStart" toSet="selectionStart:" changeEvent="textSelectionChanged">selectionStart</field>
	<field virtual="true" toGet="selectionStop" toSet="selectionStop:" changeEvent="textSelectionChanged">selectionStop</field>
	<field virtual="true" serializable="false" toGet="selection" toSet="selection:" changeEvent="textSelectionChanged">selection</field>
	<field virtual="true" toGet="contents" toSet="contents:" changeEvent="textModified">contents</field>
	<field virtual="true" serializable="false" toGet="numericValue" toSet="numericValue:" changeEvent="textModified">numericValue</field>
	<field toGet="acceptAction" toSet="acceptAction:" changeEvent="acceptActionChanged">acceptAction</field>
	<field toGet="blinkStart" toSet="blinkStart:" changeEvent="blinkStartChanged">blinkStart</field>
	<field toGet="redButtonDown" toSet="redButtonDown:" changeEvent="redButtonDownChanged">redButtonDown</field>
</fields>'!

!CTextEditor class methodsFor: 'class initialization' stamp: 'ar 12/11/2004 23:22'!
initialize
	"CTextEditor initialize"
	self initializePreferences.! !

!CTextEditor class methodsFor: 'class initialization' stamp: 'ar 11/10/2004 16:29'!
initializePreferences
	Preferences addPreference: #hideTypeInCursor categories: #('Tweak') default: true balloonHelp: 'When true, the mouse cursor will hidden while typing text'.! !

!CTextEditor class methodsFor: 'instance creation' stamp: 'ar 2/6/2005 19:24'!
newSample
	| sample |
	sample := self new.
	sample color: Color white.
	sample borderWidth: 1.
	sample borderColor: CWidgetLibrary default frameColor.
	sample borderStyle: #simple.
	sample hScrollable: false; vScrollable: true.
	sample extent: 100@50.
	^sample! !

!CTextEditor methodsFor: 'operations' stamp: 'bgf 3/24/2010 16:34'!
accept
	"Accept my contents"
	readOnly ifFalse: [
		self save
	].! !

!CTextEditor methodsFor: 'accessing' stamp: 'bgf 6/24/2007 12:22'!
acceptAction
	"A single argument block, evaluated when the user accepts the text;
	 gives some compatibility with morphic text editors."
	<bewareOf: #acceptActionChanged>
	^self propertyValueAt: #acceptAction! !

!CTextEditor methodsFor: 'accessing' stamp: 'bgf 6/24/2007 12:22'!
acceptAction: aValue
	"A single argument block, evaluated when the user accepts the text;
	 gives some compatibility with morphic text editors."
	^self propertyValueAt: #acceptAction put: aValue with: #acceptActionChanged! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:41'!
allowEditing
	"Answer the allowEditing of the receiver"
	<bewareOf: #allowEditingChanged>
	^self propertyValueAt: #allowEditing! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:41'!
allowEditing: aValue
	"Modify the receiver's allowEditing"
	^self propertyValueAt: #allowEditing put: aValue with: #allowEditingChanged! !

!CTextEditor methodsFor: 'operations' stamp: 'ar 3/12/2004 15:02'!
append: aText
	contents := contents, aText! !

!CTextEditor methodsFor: 'operations' stamp: 'bgf 3/24/2010 16:33'!
backspace
	readOnly ifFalse: [
		editor backspace
	].! !

!CTextEditor methodsFor: 'text menu' stamp: 'bgf 1/16/2009 18:27'!
bigEtoysEditMenu
	"The older-style long menu full of etoys-style icons."
	| menu item |
	menu := CMenu new.
	menu label: nil.
	item := menu add: 'Find' target: self action: #findText.
	item icon: MenuIcons findIcon.
	item := menu add: 'Find Next' target: self action: #findNext.
	item icon: MenuIcons findIcon.
	item := menu add: 'Find and Replace' target: self action: #replace.
	item icon: MenuIcons findIcon.
	menu addSeparator.
	item := menu add: 'Undo' target: self action: #undo.
	item icon: MenuIcons undoIcon.
	item := menu add: 'Redo' target: self action: #undo.
	item icon: MenuIcons redoIcon.
	menu addSeparator.
	item := menu add: 'Copy' target: self action: #copySelection.
	item icon: MenuIcons copyIcon.
	item := menu add: 'Cut' target: self action: #cutSelection.
	item icon: MenuIcons cutIcon.
	item := menu add: 'Paste' target: self action: #pasteSelection.
	item icon: MenuIcons pasteIcon.
	menu addSeparator.
	item := menu add: 'Accept' target: self action: #accept.
	item icon: MenuIcons okIcon.
	item := menu add: 'Cancel' target: self action: #revert.
	item icon: MenuIcons cancelIcon.
	^menu! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 8/20/2007 15:33'!
blinkStart
	"Answer the blinkStart of the receiver"
	<bewareOf: #blinkStartChanged>
	^self propertyValueAt: #blinkStart! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 8/20/2007 15:33'!
blinkStart: aValue
	"Modify the receiver's blinkStart"
	^self propertyValueAt: #blinkStart put: aValue with: #blinkStartChanged! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:49'!
caseSensitiveSearch
	"Answer the caseSensitiveSearch of the receiver"
	<bewareOf: #caseSensitiveSearchChanged>
	^self propertyValueAt: #caseSensitiveSearch! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:49'!
caseSensitiveSearch: aValue
	"Modify the receiver's caseSensitiveSearch"
	^self propertyValueAt: #caseSensitiveSearch put: aValue with: #caseSensitiveSearchChanged! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 4/23/2005 16:26'!
contents
	"Answer the text being currently edited"
	<bewareOf: #textModified>
	^editor text! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:54'!
contents: aText
	"Set the text being currently edited"
	^editor text: aText! !

!CTextEditor methodsFor: 'text menu' stamp: 'tk 5/12/2005 14:42'!
copySelection
	| sel |
	editor selectLineIfEmpty.
	sel := editor selection.
	sel isEmpty ifTrue:[^self].
	CClipboard clipboardText: sel.! !

!CTextEditor methodsFor: 'text menu' stamp: 'ar 5/4/2007 16:45'!
cutSelection
	| sel |
	editor selectLineIfEmpty.
	sel := editor selection.
	sel isEmpty ifTrue:[^self].
	CClipboard clipboardText: sel.
	readOnly ifFalse:[editor replaceSelectionWith: ''].! !

!CTextEditor methodsFor: 'text menu' stamp: 'ar 10/9/2005 21:55'!
defaultContextMenu
	^self editMenu! !

!CTextEditor methodsFor: 'initialize' stamp: 'ar 3/25/2004 15:50'!
defaultCostume
	"^CTextEditorCostume"
	^CScrollableTextEditorCostume! !

!CTextEditor methodsFor: 'initialize' stamp: 'ar 6/2/2004 14:58'!
defaultTarget
	^(CTextEditorPane new)
		editor: self;
		yourself! !

!CTextEditor methodsFor: 'text menu' stamp: 'ar 3/12/2004 15:15'!
deleteSelection
	self paste:''.! !

!CTextEditor methodsFor: 'text menu' stamp: 'bgf 1/16/2009 18:27'!
editMenu
	"the default editing conext menu."
	^ (CMenu new)
		add: 'Cut' target: self action: #cutSelection disabled: (self readOnly);
		add: 'Copy' target: self action: #copySelection;
		add: 'Paste' target: self action: #pasteSelection disabled: (self readOnly);
		yourself
! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 5/3/2004 14:43'!
editor
	^target textEditor! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:42'!
emphasis
	^editor emphasis! !

!CTextEditor methodsFor: 'operations' stamp: 'ar 1/31/2007 14:06'!
escape
	"Handle the escape key"
! !

!CTextEditor methodsFor: 'text search' stamp: 'ar 3/12/2004 14:54'!
findNext
	"Find the next occurance of the current search text"
	self searchText isEmptyOrNil 
		ifTrue:[^self flash].
	self findText: self searchText.! !

!CTextEditor methodsFor: 'text search' stamp: 'ar 4/19/2007 18:50'!
findText
	"Find a piece of text"
	| newText |
	newText := CDialog 
				request: 'Find what?' 
				initialAnswer: self selection asString.
	self searchText: newText.
	self findNext.! !

!CTextEditor methodsFor: 'text search' stamp: 'ar 3/12/2004 14:49'!
findText: aString
	"Find the next occurance of the given string and select it. 
	Return true if found, false otherwise."
	^self findText: aString wrapping: nil! !

!CTextEditor methodsFor: 'text search' stamp: 'ar 3/12/2004 16:36'!
findText: aText wrapping: aBool
	^self findText: aText wrapping: aBool caseSensitive: self caseSensitiveSearch! !

!CTextEditor methodsFor: 'text search' stamp: 'ar 3/12/2004 16:36'!
findText: aText wrapping: aBool caseSensitive: sensitive
	"Find the next occurance of the given string and select it. Return true if found, false otherwise. If aBool == nil then query for user response for wrapping, otherwise adhere to aBool."
	| where aString |
	aString := aText asString.
	"The search starts at the selection"
	where := self selectionStart.
	"But not if the selection is what we search for"
	(self selection asString equals: aString caseSensitive: sensitive)
		ifTrue:[where := self selectionStop].
	where := self text 
				findString: aString
				startingAt: where
				caseSensitive: sensitive.
	(where = 0 and:[aBool ~= false]) ifTrue:[
		(aBool == true or:[self confirm:'Reached the end of text.\\Start over?' withCRs]) ifTrue:[
			where := self text 
						findString: aString 
						startingAt: 1
						caseSensitive: sensitive]].
	where = 0 ifTrue:[^false].
	self selectFrom: where to: where + aString size.
	^true! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:42'!
font
	^editor font! !

!CTextEditor methodsFor: 'accessing' stamp: 'tk 5/12/2005 14:42'!
font: aFont
	| sel attr |
	attr := TextFontReference toFont: aFont.
	sel := self selection.
	sel isEmpty ifTrue:[
		self editor changeFontHere: attr.
		^aFont].
	sel := self selection addAttribute: attr.
	self paste: sel select: true.
	^aFont! !

!CTextEditor methodsFor: 'operations' stamp: 'bgf 3/24/2010 16:34'!
forwardDelete
	readOnly ifFalse: [ 
		editor forwardDelete
	].! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 11/10/2004 16:27'!
hideTypeInCursor
	^Preferences valueOfFlag: #hideTypeInCursor! !

!CTextEditor methodsFor: 'initialize' stamp: 'ar 8/20/2007 16:48'!
initialize
	super initialize.
	target := self defaultTarget.
	redButtonDown := false.
	self allowEditing: true.
	self readOnly: false.
	self caseSensitiveSearch: false.
! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:42'!
modified
	"Answer whether the receiver has been modified"
	^editor modified! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:42'!
modified: aBool
	"Indicate whether the receiver has been modified"
	editor modified: aBool.! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 4/19/2005 21:59'!
mouseCursor
	"Answer the mouseCursor of the receiver"
	<bewareOf: #mouseCursorChanged>
	^self propertyValueAt: #mouseCursor! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 4/19/2005 21:59'!
mouseCursor: aValue
	"Modify the receiver's mouseCursor"
	^self propertyValueAt: #mouseCursor put: aValue with: #mouseCursorChanged! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:38'!
moveCursorLeft
	^self editor moveCursorLeft! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:38'!
moveCursorRight
	^self editor moveCursorRight! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:38'!
moveLineDown
	^self editor moveLineDown! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:38'!
moveLineEnd
	^self editor moveLineEnd! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:38'!
moveLineStart
	^self editor moveLineStart! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:38'!
moveLineUp
	^self editor moveLineUp! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 5/9/2005 13:16'!
movePageDown
	^self editor movePageDown! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 5/9/2005 13:16'!
movePageUp
	^self editor movePageUp! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:38'!
moveTextEnd
	^self editor moveTextEnd! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:38'!
moveTextStart
	^self editor moveTextStart! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
moveWordLeft
	^self editor moveWordLeft! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
moveWordRight
	^self editor moveWordRight! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 6/5/2005 14:48'!
numericValue
	"Answer the numericValue of the receiver"
	<bewareOf: #textModified>
	^[self contents asNumber] on: Error do:[:ex| ex return: 0].! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 6/5/2005 14:48'!
numericValue: aValue
	"Modify the receiver's numericValue"
	self value: aValue. "updates automatically"! !

!CTextEditor methodsFor: 'events' stamp: 'bgf 6/24/2007 12:25'!
onAccept
	value := self readValue: contents.

	"Compatibility with text morphs.."
	acceptAction ifNotNil: [
		acceptAction value: value asText.
	].! !

!CTextEditor methodsFor: 'events' stamp: 'ar 1/12/2005 23:13'!
onAllowEditingChanged
	| scripts |
	<on: allowEditingChanged>
	scripts := #(
		onMouseDown: onMouseMove: onMouseUp:
		onKeyboardFocusEnter
		onKeyDown: onKeyStroke:
		onMouseEnter onMouseLeave
	).
	scripts do:[:each|
		allowEditing 
			ifTrue:[self resumeScript: each]
			ifFalse:[self pauseScript: each]].
	self setTextCursor.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 8/20/2007 18:54'!
onBlinkCursor
	"Blink the cursor if needed"
	Time millisecondClockValue - blinkStart < 500 ifTrue:[
		"don't blink yet"
		^editor showCaret: self hasKeyboardFocus.
	].
	editor selectionStart = editor selectionStop ifTrue:[
		editor showCaret: (editor showCaret ifNil:[true]) not
	] ifFalse:[
		editor showCaret: self hasKeyboardFocus.
	].! !

!CTextEditor methodsFor: 'events' stamp: 'ar 1/31/2007 14:00'!
onContextMenu
	<on: yellowButtonDown in: target>
	allowEditing ifTrue:[
		(editor attributesAt: self cursorPoint) do:[:attr|
			attr menu ifNotNil:[
				attr menu openAt: hand position.
				^nil]
		].
	].
	self showContextMenu.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 8/20/2007 15:38'!
onKeyDown: evt
	"Dispatch a keyboard shortcut"
	| action |
	<on: keyDown>
	action := CPlatform current standardEditingKeys lookupEvent: evt.
	action ifNotNil:[
		self resetBlinkCursor.
		self perform: action].

! !

!CTextEditor methodsFor: 'events' stamp: 'bgf 11/11/2009 17:55'!
onKeyStroke: evt
	"Handle a keystroke (typein)"
	<on: keyStroke>
	readOnly ifTrue:[^nil]. "no type-in for read-only text"

	"Note: all of the modifier key combinations are shortcuts and thus handled in onKeyDown. We shouldn't even have to worry about them here but the current VMs pass almost everything up as a 'character' which is plain ridiculous. We may actually loose some characters that could result from special combinations but I don't know how to fix that problem here..."

	"except option key, which is used on Mac for optional characters, like @ on German keyboard layout. The Mac VM does not clear modifier bits on stroke events as the Windows VM does --bf 2/20/2006"
	(evt controlKeyPressed or: [evt commandKeyPressed]) 
		ifTrue: [^self].

	"Due to the current VM behavior, filter out non-printing keys"
	((evt keyValue < 32) or: [ evt keyValue = 127]) ifTrue: [
		"But allow tab (9) for now - should be in keymap"
		(#(9) includes: evt keyValue)
			ifFalse: [^self]].

	editor keyStroke: evt.
	self resetBlinkCursor.
	self hideTypeInCursor ifTrue:[target mouseCursor := Cursor blank].! !

!CTextEditor methodsFor: 'events' stamp: 'ar 8/20/2007 18:55'!
onKeyboardFocusEnter
	"only accept input while having the keyboard focus"
	<on: keyboardFocusEnter>
	self resumeScript: #onKeyStroke:.
	self resumeScript: #onKeyDown:.
	self startTicking: #onBlinkCursor at: 2.
	self resetBlinkCursor.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 8/20/2007 18:55'!
onKeyboardFocusLeave
	"only accept input while having the keyboard focus"
	<on: keyboardFocusLeave>
	self pauseScript: #onKeyStroke:.
	self pauseScript: #onKeyDown:.
	self stopScript: #onBlinkCursor.
	self resetBlinkCursor.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 8/20/2007 16:49'!
onMouseDown: evt
	<on: mouseDown in: target>
	(editor attributesAt: target cursorPoint) do:[:attr|
		attr clickAction ifNotNil:[
			self perform: attr clickAction with: attr.
		].
	].
	editor mouseDown: evt.
	redButtonDown := true.
	hand keyboardFocus: self.
	self resetBlinkCursor.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 11/12/2004 11:06'!
onMouseEnter
	<on: mouseEnter>
	hand autoKeyboardFocus ifTrue:[hand keyboardFocus: self]! !

!CTextEditor methodsFor: 'events' stamp: 'ar 11/12/2004 11:07'!
onMouseLeave
	<on: mouseLeave>
	hand autoKeyboardFocus ifTrue:[hand releaseKeyboardFocus: self].
	self setTextCursor.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 8/20/2007 16:50'!
onMouseMove: evt
	<on: redButtonMove in: target>
	redButtonDown ifTrue:[
		editor mouseMove: evt.
		self resetBlinkCursor.
	].! !

!CTextEditor methodsFor: 'events' stamp: 'ar 6/2/2004 16:12'!
onMouseMoved: evt
	<on: mouseMove>
	self setTextCursor.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 8/20/2007 16:49'!
onMouseUp: evt
	<on: mouseUp in: target>
	redButtonDown := false.
	editor mouseUp: evt.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 4/22/2005 20:16'!
onTextModified
	<on: textModified in: target>
	self signal: #textModified.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 4/22/2005 20:16'!
onTextSelectionChanged
	<on: textSelectionChanged in: target>
	self signal: #textSelectionChanged.! !

!CTextEditor methodsFor: 'events' stamp: 'ar 7/8/2007 13:15'!
openTextUrl: aTextUrl
	"Such as
		http://www.impara.de/
	"
	| response doc |
	Smalltalk at: #ExternalWebBrowser ifPresent:[:browser|
		^browser openOnUrl: aTextUrl url
	].
	response := UIManager default chooseFrom: #('View web page as source' 'Cancel')
		title: 'Couldn''t find a web browser.  View page as source?'.
	response = 1 ifFalse:[^self].
	doc := (HTTPSocket httpGet: aTextUrl url accept: 'application/octet-stream') contents.
	doc size = 0 ifTrue: [^ self error: 'Document could not be fetched'].
	UIManager default edit: doc label: aTextUrl url.! !

!CTextEditor methodsFor: 'operations' stamp: 'ar 3/12/2004 14:47'!
paste: aText
	^self paste: aText select: false! !

!CTextEditor methodsFor: 'operations' stamp: 'ar 5/4/2007 15:55'!
paste: aText select: aBool
	readOnly ifFalse:[
		editor replaceSelectionWith: aText.
		aBool ifTrue:[editor selectFrom: selectionStop - aText size to: selectionStop].
	].! !

!CTextEditor methodsFor: 'text menu' stamp: 'tk 5/12/2005 14:43'!
pasteSelection
	| sel |
	sel := CClipboard clipboardText.
	sel isEmpty ifTrue:[^self].
	self paste: sel.! !

!CTextEditor methodsFor: 'converting' stamp: 'ar 3/18/2004 14:41'!
printValue: aValue
	^value displayText! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 5/4/2007 15:51'!
readOnly
	"Answer the readOnly of the receiver"
	<bewareOf: #readOnlyChanged>
	^self propertyValueAt: #readOnly! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 5/4/2007 15:51'!
readOnly: aValue
	"Modify the receiver's readOnly"
	^self propertyValueAt: #readOnly put: aValue with: #readOnlyChanged! !

!CTextEditor methodsFor: 'converting' stamp: 'ar 3/18/2004 14:41'!
readValue: aString
	^aString! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 8/20/2007 16:48'!
redButtonDown
	"Answer the redButtonDown of the receiver"
	<bewareOf: #redButtonDownChanged>
	^self propertyValueAt: #redButtonDown! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 8/20/2007 16:48'!
redButtonDown: aValue
	"Modify the receiver's redButtonDown"
	^self propertyValueAt: #redButtonDown put: aValue with: #redButtonDownChanged! !

!CTextEditor methodsFor: 'operations' stamp: 'bgf 3/24/2010 16:40'!
redo
	readOnly ifFalse: [
		editor redo.
	].! !

!CTextEditor methodsFor: 'events' stamp: 'ar 8/20/2007 18:54'!
resetBlinkCursor
	"Reset the blinking cursor"
	blinkStart := Time millisecondClockValue.
	editor showCaret: self hasKeyboardFocus.
! !

!CTextEditor methodsFor: 'operations' stamp: 'bgf 3/24/2010 16:34'!
return
	readOnly ifFalse: [
		self paste: String cr
	]! !

!CTextEditor methodsFor: 'operations' stamp: 'ar 12/14/2004 23:55'!
revert
	(self handlesEvent: #revert)
		ifTrue:[self signal: #revert]
		ifFalse:[self contents: self value asText copy].! !

!CTextEditor methodsFor: 'operations' stamp: 'ar 3/12/2004 14:46'!
save
	"If a client is interested in saving text in different ways, just signal #save - otherwise take the text as is."
	(self handlesEvent: #save)
		ifTrue:[self signal: #save with: self text with: self value]
		ifFalse:[self onAccept].! !

!CTextEditor methodsFor: 'moving' stamp: 'bf 7/29/2005 13:29'!
scrollLineDown
	self flag: #fixme. "remove once we have proper scroll events rather than keyboard events"
	self asPrimCostume signal: #mouseScrollDown
! !

!CTextEditor methodsFor: 'moving' stamp: 'bf 7/29/2005 13:29'!
scrollLineUp
	self flag: #fixme. "remove once we have proper scroll events rather than keyboard events"
	self asPrimCostume signal: #mouseScrollUp
! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:48'!
searchText
	"Answer the searchText of the receiver"
	<bewareOf: #searchTextChanged>
	^self propertyValueAt: #searchText! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:48'!
searchText: aValue
	"Modify the receiver's searchText"
	^self propertyValueAt: #searchText put: aValue with: #searchTextChanged! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 3/12/2004 14:46'!
selectAll
	editor selectFrom: 1 to: self editor text size+1.! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 3/12/2004 14:43'!
selectAt: selectionIndex
	editor selectAt: selectionIndex! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectCursorLeft
	^self editor selectCursorLeft! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectCursorRight
	^self editor selectCursorRight! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 3/12/2004 14:43'!
selectFrom: firstIndex to: lastIndex
	editor selectFrom: firstIndex to: lastIndex.! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectLineDown
	^self editor selectLineDown! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectLineEnd
	^self editor selectLineEnd! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 7/24/2007 13:46'!
selectLineInterval: start to: end
	"Select the line interval."
	| string cr index selStart selEnd |
	selStart := selEnd := nil.
	string := self contents asString.
	cr := Character cr.

	"Find the selection start"
	index := (start max: 1).
	[selStart == nil and:[index >= 1]] whileTrue:[
		(string at: index ) = cr ifTrue:[selStart := index].
		index := index-1.
	].
	selStart ifNil:[^nil].

	"Find the selection end"
	index := (end min: string size).
	[selEnd == nil and:[index <= string size]] whileTrue:[
		(string at: index) = cr ifTrue:[selEnd := index].
		index := index+1.
	].
	selEnd ifNil:[^nil].

	self selectFrom: selStart to: selEnd + 1
! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectLineStart
	^self editor selectLineStart! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectLineUp
	^self editor selectLineUp! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectTextEnd
	^self editor selectTextEnd! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectTextStart
	^self editor selectTextStart! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectWordLeft
	^self editor selectWordLeft! !

!CTextEditor methodsFor: 'moving' stamp: 'ar 3/12/2004 14:39'!
selectWordRight
	^self editor selectWordRight! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 4/22/2005 20:28'!
selection
	<bewareOf: #textSelectionChanged>
	^editor selection! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 4/22/2005 20:35'!
selection: aText
	"For convenience - allow setting the selection as a paste-and-select operation"
	self paste: aText select: true.
	^aText! !

!CTextEditor methodsFor: 'selecting' stamp: 'tak 12/21/2005 20:52'!
selectionAsStream
	"Answer a ReadStream on the text in the paragraph that is currently 
	selected."

	^ReadStream
		on: contents
		from: self selectionStart
		to: self selectionStop - 1! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 4/22/2005 20:16'!
selectionStart
	<bewareOf: #textSelectionChanged>
	^editor selectionStart! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 3/12/2004 14:43'!
selectionStart: aNumber
	^self selectFrom: aNumber to: self selectionStop! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 4/22/2005 20:16'!
selectionStop
	<bewareOf: #textSelectionChanged>
	^editor selectionStop! !

!CTextEditor methodsFor: 'selecting' stamp: 'ar 3/12/2004 14:44'!
selectionStop: aNumber
	^self selectFrom: selectionStart to: aNumber! !

!CTextEditor methodsFor: 'events' stamp: 'ar 4/19/2005 22:00'!
setTextCursor
	<on: mouseCursorChanged>
	(editor attributesAt: target cursorPoint) do:[:attr|
		attr mouseCursor ifNotNil:[^target mouseCursor: attr mouseCursor].
	].
	mouseCursor ifNil:[
		target mouseCursor := (allowEditing ifTrue:[Cursor text] ifFalse:[nil]).
	] ifNotNil:[
		target mouseCursor := mouseCursor.
	].! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:44'!
showCaret
	"Answer the value of the receiver's showCaret property.
	Values:
		false	-	never show the caret
		nil		-	show the caret if the receiver has the input focus
		true	-	show the caret unless nothing is selected and not input focus"
	^editor showCaret! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:44'!
showCaret: aBoolOrNil
	"Set the value of the receiver's showCaret property.
	Values:
		false	-	never show the caret
		nil		-	show the caret if the receiver has the input focus
		true	-	show the caret unless nothing is selected and not input focus"
	editor showCaret: aBoolOrNil! !

!CTextEditor methodsFor: 'operations' stamp: 'ar 10/9/2005 21:54'!
showContextMenu
	(self menu ifNil:[self defaultContextMenu]) openAt: hand position.! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 5/3/2004 14:40'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 5/3/2004 14:40'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

!CTextEditor methodsFor: 'operations' stamp: 'bgf 3/24/2010 16:34'!
undo
	readOnly ifFalse: [
		editor undo.
	].! !

!CTextEditor methodsFor: 'accessing' stamp: 'ar 3/18/2004 14:42'!
value: newValue
	value == newValue ifTrue:[^value].
	super value: newValue.
	contents := self printValue: newValue.
	^value! !

CTextEditor subclass: #CTextLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text'!

!CTextLabel commentStamp: '<historical>' prior: 0!
I am an editable label.!

CTextLabel defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="smartEdit" toSet="smartEdit:" changeEvent="smartEditChanged">smartEdit</field>
	<field toGet="autoFit" toSet="autoFit:" changeEvent="autoFitChanged">autoFit</field>
</fields>'!

!CTextLabel class methodsFor: 'instance creation' stamp: 'ar 10/9/2005 23:08'!
newSample
	| sample |
	sample := self new.
	sample text: 'Text'.
	sample addAttribute: (TextEmphasis bold).
	sample addAttribute: (TextFontReference toFont: (StrikeFont familyName: #BitstreamVeraSans pointSize: 24)).
	^sample! !

!CTextLabel methodsFor: 'menu' stamp: 'ar 10/9/2005 22:39'!
addAttribute: attr
	| sel |
	sel := self selection.
	sel isEmpty ifTrue:[self text: (self text copy addAttribute: attr)].
	sel := self selection addAttribute: attr.
	self paste: sel select: true.! !

!CTextLabel methodsFor: 'accessing' stamp: 'ar 10/9/2005 22:01'!
autoFit
	"Answer the autoFit of the receiver"
	<bewareOf: #autoFitChanged>
	^self propertyValueAt: #autoFit! !

!CTextLabel methodsFor: 'accessing' stamp: 'ar 10/9/2005 22:01'!
autoFit: aValue
	"Modify the receiver's autoFit"
	^self propertyValueAt: #autoFit put: aValue with: #autoFitChanged! !

!CTextLabel methodsFor: 'menu' stamp: 'ar 10/9/2005 22:11'!
defaultContextMenu
	^self smartLabelMenu! !

!CTextLabel methodsFor: 'initialize' stamp: 'ar 10/9/2005 21:27'!
defaultCostume
	^CTextEditorCostume! !

!CTextLabel methodsFor: 'initialize' stamp: 'ar 10/9/2005 21:26'!
defaultTarget
	^costume! !

!CTextLabel methodsFor: 'menu' stamp: 'ar 10/9/2005 22:48'!
fontFamilyMenu
	| fontName fontMenu item aFont fontSize attr |
	fontMenu := CMenu new.
	aFont := editor font ifNil:[TextStyle defaultFont].
	fontName := aFont familyName.
	fontSize := aFont pointSize.
	StrikeFont actualFamilyNames do:[:each|
		aFont := StrikeFont familyName: each pointSize: fontSize.
		attr := TextFontReference toFont: aFont.
		item := fontMenu add: each target: self action: #addAttribute: argument: attr.
		item checked: fontName = each.
	].
	^fontMenu! !

!CTextLabel methodsFor: 'menu' stamp: 'ar 10/9/2005 22:49'!
fontSizeMenu
	| fontName fontMenu item aFont fontSize textStyle attr |
	fontMenu := CMenu new.
	aFont := editor font ifNil:[TextStyle defaultFont].
	fontName := aFont familyName asSymbol.
	fontSize := aFont pointSize.
	textStyle := TextStyle named: fontName.
	textStyle pointSizes do:[:ptSize|
		aFont := StrikeFont familyName: fontName pointSize: ptSize.
		attr := TextFontReference toFont: aFont.
		item := fontMenu add: ptSize printString,' pt' target: self 
			action: #addAttribute: argument: attr.
		item checked: fontSize = ptSize.
	].
	^fontMenu! !

!CTextLabel methodsFor: 'menu' stamp: 'ar 10/9/2005 22:59'!
fontStyleMenu
	| fontMenu item fontStyle action attr |
	fontMenu := CMenu new.
	fontStyle := text emphasisAt: (selectionStart max: 1).
	#(1 2 4 16) with: #('bold' 'italic' 'underlined' 'struckout') do:[:code :emph|
		attr := TextEmphasis new emphasisCode: code.
		(fontStyle anyMask: code) 
			ifFalse:[action := #addAttribute:]
			ifTrue:[action := #removeAttribute:].
		item := fontMenu add: emph target: self action: action argument: attr.
		item checked: (fontStyle anyMask: code).
	].
	^fontMenu! !

!CTextLabel methodsFor: 'initialize' stamp: 'ar 10/9/2005 22:01'!
initialize
	super initialize.
	self smartEdit := true.
	self autoFit := true.
	self allowEditing := false.
	text := 'TextLabel'.! !

!CTextLabel methodsFor: 'accessing' stamp: 'ar 10/9/2005 21:49'!
label
	^self value displayText! !

!CTextLabel methodsFor: 'accessing' stamp: 'ar 10/9/2005 21:49'!
label: anObjectOrString
	"label and value may be any object that responds to displayText"
	^self value: anObjectOrString! !

!CTextLabel methodsFor: 'events' stamp: 'ar 10/9/2005 22:02'!
onAutoFitChanged
	<on: autoFitChanged>
	autoFit ifTrue:[
		self hResizing: #shrinkWrap.
		self vResizing: #shrinkWrap.
	] ifFalse:[
		self hResizing: #spaceFill.
		self vResizing: #spaceFill.
	].! !

!CTextLabel methodsFor: 'events' stamp: 'ar 10/9/2005 21:52'!
onDoubleClick: evt
	<on: mouseDoubleClick>
	smartEdit ifFalse:[^nil].
	allowEditing ifFalse:[
		hand keyboardFocus: self.
		self selectAll.
	].! !

!CTextLabel methodsFor: 'events' stamp: 'ar 10/9/2005 23:29'!
onEnableEdit
	"Note: Cannot be done by overriding onKeyboardFocusEnter as this gets paused by superclass when allowEditing changes. Since we want to enable it here, we must do so without being affected by it."
	<on: keyboardFocusEnter>
	smartEdit ifTrue:[self allowEditing: true].! !

!CTextLabel methodsFor: 'events' stamp: 'ar 10/9/2005 21:53'!
onKeyboardFocusLeave
	super onKeyboardFocusLeave.
	smartEdit ifTrue:[
		self allowEditing: false.
		self selectFrom: 0 to: 0.
	].! !

!CTextLabel methodsFor: 'events' stamp: 'ar 10/9/2005 22:06'!
onMouseDrag
	<on: mouseDrag>
	self allowEditing ifFalse:[self onDrag].! !

!CTextLabel methodsFor: 'events' stamp: 'ar 10/9/2005 22:08'!
onSmartEditChanged
	"Turn on editing if not smart; turn off editing if smart and not focus"
	<on: smartEditChanged>
	smartEdit 
		ifTrue:[self hasKeyboardFocus ifFalse:[self allowEditing: false]]
		ifFalse:[self allowEditing: true].! !

!CTextLabel methodsFor: 'menu' stamp: 'ar 10/9/2005 22:48'!
removeAttribute: attr
	| sel |
	sel := self selection.
	sel isEmpty ifTrue:[self text: (self text copy removeAttributesSuchThat:[:a| attr dominates: a])].
	sel := self selection removeAttributesSuchThat:[:a| attr dominates: a].
	self paste: sel select: true.
! !

!CTextLabel methodsFor: 'initialize' stamp: 'ar 10/9/2005 22:11'!
setupCostume
	super setupCostume.
	width := 100.
	self borderWidth: 0.
	self color: Color transparent.
	self vResizing: #shrinkWrap.! !

!CTextLabel methodsFor: 'accessing' stamp: 'ar 10/9/2005 21:51'!
smartEdit
	"Answer the smartEdit of the receiver"
	<bewareOf: #smartEditChanged>
	^self propertyValueAt: #smartEdit! !

!CTextLabel methodsFor: 'accessing' stamp: 'ar 10/9/2005 21:51'!
smartEdit: aValue
	"Modify the receiver's smartEdit"
	^self propertyValueAt: #smartEdit put: aValue with: #smartEditChanged! !

!CTextLabel methodsFor: 'menu' stamp: 'ar 10/9/2005 22:11'!
smartLabelMenu
	| menu item |
	menu := CMenu new.
	menu label: nil.
	item := menu add: 'Smart Edit' target: self 
		action: #smartEdit: arguments:{smartEdit not}.
	item checked: smartEdit.
	item := menu add: 'Auto Fit' target: self 
		action: #autoFit: arguments:{autoFit not}.
	item checked: autoFit.
	item := menu add: 'Allow Editing' target: self 
		action: #allowEditing: arguments:{allowEditing not}.
	item checked: allowEditing.
	item disabled: smartEdit. "disable if smart editing"

	menu addSeparator.
	item := menu add: 'Font Family' subMenu: self fontFamilyMenu.
	item := menu add: 'Font Size' subMenu: self fontSizeMenu.
	item := menu add: 'Font Style' subMenu: self fontStyleMenu.
	^menu! !

CWidget defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="font" toSet="font:" changeEvent="fontChanged">font</field>
</fields>'!

!CWidget methodsFor: 'initialize' stamp: 'ar 7/7/2005 13:03'!
defaultCostume
	^CWidgetCostume! !

!CWidget methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:16'!
font
	"This method was automatically generated"
	<bewareOf: #fontChanged>
	^self propertyValueAt: #font! !

!CWidget methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:28'!
font: aValue
	"This method was automatically generated"
	^self propertyValueAt: #font put: aValue with: #fontChanged! !

!CWidget methodsFor: 'tabbing' stamp: 'ar 1/25/2007 14:48'!
tabStopAfter: aPlayer
	"Widgets are atomic so don't search inside them for tab stops"
	^nil! !

CWidget subclass: #CWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

!CWindow commentStamp: 'tk 9/13/2004 17:47' prior: 0!
Everyone knows what a Window on a computer screen is.  This kind of window comes with a border, a dropshadow, and a title bar.  In the title bar are a close box, the name of the window, and a minimize button.
A window has two places to hold things, a 'front page' and the 'back page'.  The objects in the front page are the window's elements.
After getting a new window, you can add an object to it.  Place the object on the window, and then choose 'embed into' from its red handle menu.
From a script, you can use the use the add: command to put an object inside a window.


### Allow Users to see the above explanation ###

closeBox			<Boolean>	If true, show a close box.
maximizeBox		<Boolean>	If true, show a maximize box.
minimizeBox		<Boolean>	If true, show a minimize box.
label			<String>		The window's label.
!

CWindow defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="closeBox" toSet="closeBox:" changeEvent="closeBoxChanged">closeBox</field>
	<field toGet="maximizeBox" toSet="maximizeBox:" changeEvent="maximizeBoxChanged">maximizeBox</field>
	<field toGet="minimizeBox" toSet="minimizeBox:" changeEvent="minimizeBoxChanged">minimizeBox</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="toolBar" toSet="toolBar:" changeEvent="toolBarChanged">toolBar</field>
	<field toGet="menuBar" toSet="menuBar:" changeEvent="menuBarChanged">menuBar</field>
	<field toGet="statusBar" toSet="statusBar:" changeEvent="statusBarChanged">statusBar</field>
	<field toGet="windowColor" toSet="windowColor:" changeEvent="windowColorChanged">windowColor</field>
	<field toGet="contentPane" toSet="contentPane:" changeEvent="contentPaneChanged">contentPane</field>
	<field toGet="windowState" toSet="windowState:" changeEvent="windowStateChanged">windowState</field>
</fields>'!

!CWindow class methodsFor: 'instance creation' stamp: 'ar 2/6/2005 19:35'!
newSample
	| sample |
	sample := self new.
	sample label: sample name.
	^sample! !

!CWindow methodsFor: 'initialize' stamp: 'ar 5/26/2005 18:23'!
beTopWindow
	"Promote me to be the top window"
	| mgr |
	mgr := self windowManager.
	mgr ifNotNil:[mgr topWindow: self].
! !

!CWindow methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:16'!
closeBox
	"This method was automatically generated"
	<bewareOf: #closeBoxChanged>
	^self propertyValueAt: #closeBox! !

!CWindow methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:28'!
closeBox: aValue
	"This method was automatically generated"
	^self propertyValueAt: #closeBox put: aValue with: #closeBoxChanged! !

!CWindow methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:49'!
collapse
	"Collapse the window"
	windowState := #collapsed.! !

!CWindow methodsFor: 'accessing' stamp: 'ar 2/4/2005 11:04'!
contentBounds
	"Answer the receiver's unadorned bounds"
	^contentPane bounds transformedBy: self transform! !

!CWindow methodsFor: 'accessing' stamp: 'ar 2/4/2005 11:09'!
contentBounds: aRectangle
	"Set the receiver's unadorned bounds."
	| box |
	box := self contentBounds.
	position := position + (aRectangle origin - box origin).
	extent := extent + (aRectangle extent - box extent).! !

!CWindow methodsFor: 'accessing' stamp: 'ar 2/4/2005 10:37'!
contentPane
	"Answer the contentPane of the receiver"
	<bewareOf: #contentPaneChanged>
	^self propertyValueAt: #contentPane! !

!CWindow methodsFor: 'accessing' stamp: 'ar 2/4/2005 11:15'!
contentPane: aValue
	"Modify the receiver's contentPane"
	^self propertyValueAt: #contentPane put: aValue with: #contentPaneChanged! !

!CWindow methodsFor: 'color and fill' stamp: 'ar 12/20/2004 12:13'!
decorate: items color: aColor
	| style bw |
	style := CWidgetLibrary default windowBorderStyle.
	bw := CWidgetLibrary default windowBorderWidth.
	items do:[:each|
		each borderWidth: bw.
		each borderStyle: style.
		each borderColor: aColor.
		each windowColor: aColor.
	].
	self color: aColor.! !

!CWindow methodsFor: 'initialize' stamp: 'ar 3/1/2004 14:49'!
defaultCostume
	^CWidgetLibrary default windowCostume! !

!CWindow methodsFor: 'accessing' stamp: 'ar 2/4/2005 10:40'!
elements
	"Answer the elements of the receiver"
	^contentPane elements! !

!CWindow methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:49'!
expand
	"Expand the window"
	windowState := #expanded.! !

!CWindow methodsFor: 'color and fill' stamp: 'ar 11/24/2004 12:22'!
flash
	"preserve window color"
	| oldColor |
	oldColor := windowColor.
	super flash.
	color := oldColor.! !

!CWindow methodsFor: 'initialize' stamp: 'ar 6/19/2005 11:47'!
initialize
	super initialize.
	windowState := #normal.
	self define: #contentPane as: CHolder new.
	minimizeBox := Preferences defaultWindowCollapseBox.
	maximizeBox := Preferences defaultWindowExpandBox.
	closeBox := Preferences defaultWindowCloseBox.
! !

!CWindow methodsFor: 'testing' stamp: 'ar 6/19/2005 11:47'!
isCollapsed
	"Answer whether this window is collapsed (minimized)"
	^windowState == #collapsed! !

!CWindow methodsFor: 'testing' stamp: 'ar 6/19/2005 11:48'!
isExpanded
	"Answer whether this window is expanded (maximized)"
	^windowState == #expanded! !

!CWindow methodsFor: 'testing' stamp: 'ar 6/19/2005 11:48'!
isNormal
	"Answer whether this window is neither collapsed nor expanded"
	^windowState == #normal! !

!CWindow methodsFor: 'testing' stamp: 'ar 5/26/2005 18:23'!
isTopWindow
	"Answer whether the receiver is the top window"
	| mgr |
	mgr := self windowManager ifNil:[^true].
	^mgr topWindow == self! !

!CWindow methodsFor: 'accessing' stamp: 'ar 3/24/2004 16:58'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CWindow methodsFor: 'accessing' stamp: 'ar 3/24/2004 16:58'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CWindow methodsFor: 'layout' stamp: 'ar 2/4/2005 15:38'!
layout
	^contentPane layout! !

!CWindow methodsFor: 'layout' stamp: 'ar 2/4/2005 15:39'!
layout: aLayout
	^contentPane layout: aLayout! !

!CWindow methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:16'!
maximizeBox
	"This method was automatically generated"
	<bewareOf: #maximizeBoxChanged>
	^self propertyValueAt: #maximizeBox! !

!CWindow methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:28'!
maximizeBox: aValue
	"This method was automatically generated"
	^self propertyValueAt: #maximizeBox put: aValue with: #maximizeBoxChanged! !

!CWindow methodsFor: 'accessing' stamp: 'ar 4/4/2004 18:41'!
menuBar
	"Answer the menuBar of the receiver"
	<bewareOf: #menuBarChanged>
	^self propertyValueAt: #menuBar! !

!CWindow methodsFor: 'accessing' stamp: 'ar 4/4/2004 18:41'!
menuBar: aValue
	"Modify the receiver's menuBar"
	^self propertyValueAt: #menuBar put: aValue with: #menuBarChanged! !

!CWindow methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:16'!
minimizeBox
	"This method was automatically generated"
	<bewareOf: #minimizeBoxChanged>
	^self propertyValueAt: #minimizeBox! !

!CWindow methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:28'!
minimizeBox: aValue
	"This method was automatically generated"
	^self propertyValueAt: #minimizeBox put: aValue with: #minimizeBoxChanged! !

!CWindow methodsFor: 'color and fill' stamp: 'ar 7/29/2004 21:57'!
onColorChanged
	<on: fillChanged>
	windowColor := color.
	self onWindowColorChanged: windowColor.! !

!CWindow methodsFor: 'color and fill' stamp: 'ar 2/4/2005 21:05'!
onWindowColorChanged: aColor
	contentPane windowColor: aColor.
	costume windowColor: aColor.
	toolBar ifNotNil:[toolBar windowColor: aColor].
	menuBar ifNotNil:[menuBar windowColor: aColor].
	statusBar ifNotNil:[statusBar windowColor: aColor].! !

!CWindow methodsFor: 'opening' stamp: 'ar 12/20/2004 18:41'!
open
	"Open and display the receiver"
	CWindowManager default open: self.
	^self! !

!CWindow methodsFor: 'opening' stamp: 'ar 5/24/2005 20:39'!
open: aPlayer in: aContainer at: aPoint
	super open: aPlayer in: aContainer at: aPoint.
	self beTopWindow.! !

!CWindow methodsFor: 'opening' stamp: 'ar 12/20/2004 19:31'!
openIn: aContainer
	"Open and display the receiver"
	CWindowManager default open: self in: aContainer.
	^self! !

!CWindow methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 11:49'!
restore
	"Restore the window"
	windowState := #normal.! !

!CWindow methodsFor: 'initialize' stamp: 'ar 5/10/2005 17:27'!
setupCostume
	super setupCostume.
	color := CWidgetLibrary default windowColor.! !

!CWindow methodsFor: 'accessing' stamp: 'ar 4/4/2004 18:41'!
statusBar
	"Answer the statusBar of the receiver"
	<bewareOf: #statusBarChanged>
	^self propertyValueAt: #statusBar! !

!CWindow methodsFor: 'accessing' stamp: 'ar 4/4/2004 18:41'!
statusBar: aValue
	"Modify the receiver's statusBar"
	^self propertyValueAt: #statusBar put: aValue with: #statusBarChanged! !

!CWindow methodsFor: 'accessing' stamp: 'ar 4/4/2004 18:22'!
toolBar
	"Answer the toolBar of the receiver"
	<bewareOf: #toolBarChanged>
	^self propertyValueAt: #toolBar! !

!CWindow methodsFor: 'accessing' stamp: 'ar 4/4/2004 18:22'!
toolBar: aValue
	"Modify the receiver's toolBar"
	^self propertyValueAt: #toolBar put: aValue with: #toolBarChanged! !

!CWindow methodsFor: 'color and fill' stamp: 'ar 7/29/2004 21:55'!
windowColor
	"Answer the windowColor of the receiver"
	<bewareOf: #windowColorChanged>
	^self propertyValueAt: #windowColor ifAbsent:[self color]! !

!CWindow methodsFor: 'color and fill' stamp: 'ar 7/29/2004 21:55'!
windowColor: aValue
	"Modify the receiver's windowColor"
	^self propertyValueAt: #windowColor put: aValue with: #windowColorChanged! !

!CWindow methodsFor: 'accessing' stamp: 'ar 5/26/2005 18:23'!
windowManager
	^Processor activeProject windowManager! !

!CWindow methodsFor: 'accessing' stamp: 'ar 6/19/2005 11:47'!
windowState
	"Answer the windowState of the receiver"
	<bewareOf: #windowStateChanged>
	^self propertyValueAt: #windowState! !

!CWindow methodsFor: 'accessing' stamp: 'ar 6/19/2005 11:47'!
windowState: aValue
	"Modify the receiver's windowState"
	^self propertyValueAt: #windowState put: aValue with: #windowStateChanged! !

CPlayer subclass: #CWindowCostumeFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

CWindowCostumeFrame subclass: #CTexturedWindowFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

CTexturedWindowFrame defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="leftSpacer" toSet="leftSpacer:" changeEvent="leftSpacerChanged">leftSpacer</field>
	<field toGet="rightSpacer" toSet="rightSpacer:" changeEvent="rightSpacerChanged">rightSpacer</field>
</fields>'!

!CTexturedWindowFrame methodsFor: 'events' stamp: 'ar 12/20/2004 22:38'!
activate
	| cc |
	cc := fillColors last.
	fillStyle := #radialGradient.
	fillColors := {Color white mixed: 0.8 with: cc. cc}.! !

!CTexturedWindowFrame methodsFor: 'initialize' stamp: 'ar 12/19/2004 09:22'!
initialize
	super initialize.
	self define: #leftSpacer as: CPlayer new.
	self define: #rightSpacer as: CPlayer new.
! !

!CTexturedWindowFrame methodsFor: 'accessing' stamp: 'ar 12/19/2004 09:36'!
leftSpacer
	"Answer the leftSpacer of the receiver"
	<bewareOf: #leftSpacerChanged>
	^self propertyValueAt: #leftSpacer! !

!CTexturedWindowFrame methodsFor: 'accessing' stamp: 'ar 12/19/2004 09:36'!
leftSpacer: aValue
	"Modify the receiver's leftSpacer"
	^self propertyValueAt: #leftSpacer put: aValue with: #leftSpacerChanged! !

!CTexturedWindowFrame methodsFor: 'looks' stamp: 'ar 12/19/2004 13:56'!
makeTextureFrom: aColor
	| form bb |
	form := ColorForm extent: 32@32 depth: 2.
	form colors: {Color transparent. Color white. aColor. aColor mixed: 0.8 with: Color white}.
	form pixelValueAt: 0@0 put: 2.
	form pixelValueAt: 0@1 put: 1.
	form pixelValueAt: 2@2 put: 2.
	form pixelValueAt: 2@3 put: 1.
	"Note: If necessary (i.e., slow) the following can be improved by copying increasingly more bits at a time, e.g., in the first run we copy 2 px then 4, then 8 etc. The same holds, of course, for the vertical loop."
	bb := BitBlt toForm: form.
	bb combinationRule: Form over.
	bb sourceForm: form.
	bb sourceX: 0; sourceY: 0; width: 4; height: 4.
	bb destX: 0; destY: 0.
	4 to: form width by: 4 do:[:xx|bb destX: xx; copyBits].
	bb sourceX: 0; sourceY: 0; width: form width; height: 4.
	bb destX: 0; destY: 0.
	4 to: form height by: 4 do:[:yy|bb destY: yy; copyBits].
	leftSpacer graphicForm := form.
	leftSpacer graphicFit := #tile.
	rightSpacer graphicForm := form.
	rightSpacer graphicFit := #tile.! !

!CTexturedWindowFrame methodsFor: 'events' stamp: 'ar 12/20/2004 23:38'!
passivate
	color := Color white mixed: 0.25 with: fillColors last.! !

!CTexturedWindowFrame methodsFor: 'accessing' stamp: 'ar 12/19/2004 09:36'!
rightSpacer
	"Answer the rightSpacer of the receiver"
	<bewareOf: #rightSpacerChanged>
	^self propertyValueAt: #rightSpacer! !

!CTexturedWindowFrame methodsFor: 'accessing' stamp: 'ar 12/19/2004 09:36'!
rightSpacer: aValue
	"Modify the receiver's rightSpacer"
	^self propertyValueAt: #rightSpacer put: aValue with: #rightSpacerChanged! !

!CTexturedWindowFrame methodsFor: 'initialize' stamp: 'ar 12/19/2004 09:30'!
setupCostume
	super setupCostume.
	self layout cellInset: 3@0.
	windowLabel hResizing: #shrinkWrap.
	fillStyle := #radialGradient.
	leftSpacer hResizing: #spaceFill; extent: 16@16.
	self add: leftSpacer before: windowLabel.
	rightSpacer hResizing: #spaceFill; extent: 16@16.
	self add: rightSpacer after: windowLabel.! !

!CTexturedWindowFrame methodsFor: 'looks' stamp: 'ar 12/19/2004 09:25'!
windowColor: aColor
	super windowColor: aColor.
	fillColors := {Color white mixed: 0.8 with: aColor. aColor}.
	self makeTextureFrom: aColor.
! !

CWindowCostumeFrame defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="closeButton" toSet="closeButton:" changeEvent="closeButtonChanged">closeButton</field>
	<field toGet="collapseButton" toSet="collapseButton:" changeEvent="collapseButtonChanged">collapseButton</field>
	<field toGet="expandButton" toSet="expandButton:" changeEvent="expandButtonChanged">expandButton</field>
	<field toGet="windowLabel" toSet="windowLabel:" changeEvent="windowLabelChanged">windowLabel</field>
</fields>'!

!CWindowCostumeFrame methodsFor: 'events' stamp: 'ar 12/20/2004 23:35'!
activate
	"Activate me"
	| cc |
	cc := fillColors last.
	fillStyle := #verticalGradient.
	fillColors := {Color white. cc}.! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 12/20/2004 14:33'!
closeBox: aBool
	closeButton ifNotNil:[closeButton visible: aBool]! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:28'!
closeButton
	"Answer the closeButton of the receiver"
	<bewareOf: #closeButtonChanged>
	^self propertyValueAt: #closeButton! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:28'!
closeButton: aValue
	"Modify the receiver's closeButton"
	^self propertyValueAt: #closeButton put: aValue with: #closeButtonChanged! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
collapseButton
	"Answer the collapseButton of the receiver"
	<bewareOf: #collapseButtonChanged>
	^self propertyValueAt: #collapseButton! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
collapseButton: aValue
	"Modify the receiver's collapseButton"
	^self propertyValueAt: #collapseButton put: aValue with: #collapseButtonChanged! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 12/20/2004 14:11'!
expandButton
	"Answer the expandButton of the receiver"
	<bewareOf: #expandButtonChanged>
	^self propertyValueAt: #expandButton! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 12/20/2004 14:11'!
expandButton: aValue
	"Modify the receiver's expandButton"
	^self propertyValueAt: #expandButton put: aValue with: #expandButtonChanged! !

!CWindowCostumeFrame methodsFor: 'initialize' stamp: 'ar 12/20/2004 14:11'!
initialize
	super initialize.
	self define: #closeButton as: CWindowButton new.
	self define: #windowLabel as: CLabel new.
	self define: #collapseButton as: CWindowButton new.
	self define: #expandButton as: CWindowButton new.! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 3/6/2004 21:08'!
label
	^windowLabel value! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 3/6/2004 21:07'!
label: aString
	windowLabel value: aString.! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 12/20/2004 14:33'!
maximizeBox: aBool
	expandButton ifNotNil:[expandButton visible: aBool].! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 12/20/2004 14:33'!
minimizeBox: aBool
	collapseButton ifNotNil:[collapseButton visible: aBool].! !

!CWindowCostumeFrame methodsFor: 'events' stamp: 'ar 2/16/2004 20:50'!
onClose
	<on: fire in: closeButton>
	self signal: #closeRequest.
! !

!CWindowCostumeFrame methodsFor: 'events' stamp: 'ar 3/10/2004 00:03'!
onCollapse
	<on: fire in: collapseButton>
	self signal: #collapseRequest.
! !

!CWindowCostumeFrame methodsFor: 'events' stamp: 'ar 12/20/2004 14:19'!
onExpand
	<on: fire in: expandButton>
	self signal: #expandRequest.
! !

!CWindowCostumeFrame methodsFor: 'events' stamp: 'ar 12/20/2004 23:35'!
passivate
	"passivate me"
	color := Color white mixed: 0.5 with: fillColors last.! !

!CWindowCostumeFrame methodsFor: 'initialize' stamp: 'ar 2/28/2005 14:13'!
setupCostume
	super setupCostume.
	self asPrimCostume localCache: CFormCache new.
	"self roundCornerSpec: #(1 4)."
	self fillStyle: #verticalGradient.

	closeButton label: 'x'.
	closeButton balloonHelp: 'Close this window'.
	self add: closeButton.

	windowLabel value:'Window'.
	windowLabel clipping: false.
	windowLabel font: Preferences windowTitleFont.
	self add: windowLabel.

	collapseButton label: 'C'.
	collapseButton balloonHelp: 'Collapse this window'.
	self add: collapseButton.

	expandButton label: 'E'.
	expandButton balloonHelp: 'Expand this window'.
	self add: expandButton.

	self layout: CTableLayout new.
	self layout layoutInset: 3.
	self layout listDirection: #leftToRight.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.

	self windowColor: CWidgetLibrary default windowColor.! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 12/20/2004 14:37'!
windowColor: aColor
	fillColors := {Color white. aColor}.
	closeButton ifNotNil:[closeButton windowColor: aColor].
	collapseButton ifNotNil:[collapseButton windowColor: aColor].
	expandButton ifNotNil:[expandButton windowColor: aColor].
	windowLabel ifNotNil:[windowLabel windowColor: aColor].! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
windowLabel
	"Answer the windowLabel of the receiver"
	<bewareOf: #windowLabelChanged>
	^self propertyValueAt: #windowLabel! !

!CWindowCostumeFrame methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
windowLabel: aValue
	"Modify the receiver's windowLabel"
	^self propertyValueAt: #windowLabel put: aValue with: #windowLabelChanged! !

CCostume subclass: #CFileDialogCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-FileDialog-Costumes'!

CFileDialogCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="directoryList" toSet="directoryList:" changeEvent="directoryListChanged">directoryList</field>
	<field toGet="fileList" toSet="fileList:" changeEvent="fileListChanged">fileList</field>
	<field toGet="inputField" toSet="inputField:" changeEvent="inputFieldChanged">inputField</field>
	<field toGet="patternList" toSet="patternList:" changeEvent="patternListChanged">patternList</field>
	<field toGet="okButton" toSet="okButton:" changeEvent="okButtonChanged">okButton</field>
	<field toGet="cancelButton" toSet="cancelButton:" changeEvent="cancelButtonChanged">cancelButton</field>
</fields>'!

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
cancelButton
	"Answer the cancelButton of the receiver"
	<bewareOf: #cancelButtonChanged>
	^self propertyValueAt: #cancelButton! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
cancelButton: aValue
	"Modify the receiver's cancelButton"
	^self propertyValueAt: #cancelButton put: aValue with: #cancelButtonChanged! !

!CFileDialogCostume methodsFor: 'initialize' stamp: 'ar 3/12/2004 20:44'!
defaultPlayer
	^CFileDialog! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
directoryList
	"Answer the directoryList of the receiver"
	<bewareOf: #directoryListChanged>
	^self propertyValueAt: #directoryList! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
directoryList: aValue
	"Modify the receiver's directoryList"
	^self propertyValueAt: #directoryList put: aValue with: #directoryListChanged! !

!CFileDialogCostume methodsFor: 'drawing' stamp: 'ar 3/12/2004 21:40'!
drawDate: item in: itemBox on: aCanvas font: font color: aColor
	| string |
	string := ((Date fromSeconds: item modificationTime)
					printFormat: #(2 1 3 $/ 1 1 2)) , '  ' ,
				(String streamContents: [:s |
					(Time fromSeconds: item modificationTime \\ 86400)
						print24: true showSeconds: false on: s]).
	aCanvas drawString: string in: itemBox font: font color: aColor.! !

!CFileDialogCostume methodsFor: 'drawing' stamp: 'ar 3/27/2004 20:54'!
drawName: item in: itemBox on: aCanvas font: font color: aColor
	| icon itemHeight boxOrigin |
	itemHeight := itemBox height.
	icon := item icon.
	boxOrigin := itemBox origin.
	icon ifNotNil:[icon drawOn: aCanvas in: (boxOrigin extent: itemHeight asPoint)].
	boxOrigin := boxOrigin + (itemHeight + 2 @ 0).
	aCanvas drawString: item fileName in: (boxOrigin corner: itemBox corner) font: font color: aColor.! !

!CFileDialogCostume methodsFor: 'drawing' stamp: 'ar 3/27/2004 20:53'!
drawSize: item in: itemBox on: aCanvas font: font color: aColor
	| boxOrigin boxCorner itemWidth string |
	item isDirectory ifTrue:[^self].
	boxOrigin := itemBox origin.
	boxCorner := itemBox corner.
	item fileSize > 1023 
		ifTrue:[string := (item fileSize // 1024)  asStringWithCommas]
		ifFalse:[string := ((item fileSize  / 1024.0) truncateTo: 0.01) printString].
	string := string,' KB'.
	itemWidth := font widthOfString: string.
	itemWidth := itemWidth min: (boxCorner x - boxOrigin x).
	boxOrigin := boxCorner x - itemWidth @ boxOrigin y.
	aCanvas drawString: string in: (boxOrigin corner: boxCorner) font: font color: aColor.! !

!CFileDialogCostume methodsFor: 'drawing' stamp: 'ar 3/12/2004 21:41'!
drawType: item in: itemBox on: aCanvas font: font color: aColor
	| string |
	item isDirectory
		ifTrue:[string := 'folder']
		ifFalse:[string := item extension].
	aCanvas drawString: string in: itemBox font: font color: aColor.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/26/2004 01:40'!
expandDirectoryTo: aDirectory
	| dir aList parent |
	(aDirectory equals: directoryList selection) ifTrue:[^self].
	directoryList visible ifFalse:[^self].
	aDirectory ifNotNil:[
		dir := aDirectory.
		aList := CCollection new.
		[aList add: dir.
		parent := dir containingDirectory.
		parent == nil or:[parent = dir]] whileFalse:[dir := parent].
		directoryList expandPath: aList reversed.
	].
	self waitTick.
	directoryList selection: aDirectory.
! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
fileList
	"Answer the fileList of the receiver"
	<bewareOf: #fileListChanged>
	^self propertyValueAt: #fileList! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
fileList: aValue
	"Modify the receiver's fileList"
	^self propertyValueAt: #fileList put: aValue with: #fileListChanged! !

!CFileDialogCostume methodsFor: 'initialize' stamp: 'ar 3/17/2004 03:12'!
initialize
	super initialize.
	self define: #directoryList as: CTreeWidget new.
	self define: #fileList as: CMultiColumnList new.
	self define: #inputField as: CInputField new.
	self define: #patternList as: CTabButtonList new.
	self define: #okButton as: CPushButton new.
	self define: #cancelButton as: CPushButton new.

	fileList addColumn: 'Name' for: self
		width: 160 color: CWidgetLibrary default noColor
		action: nil draw: #drawName:in:on:font:color:.
	fileList addColumn: 'Size' for: self
		width: 70 color: CWidgetLibrary default paneColor
		action: nil draw: #drawSize:in:on:font:color:.
	fileList addColumn: 'Type' for: self
		width: 60 color: CWidgetLibrary default noColor
		action: nil draw: #drawType:in:on:font:color:.
	fileList addColumn:'Date' for: self
		width: 130 color: CWidgetLibrary default paneColor
		action: nil draw: #drawDate:in:on:font:color:.
! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
inputField
	"Answer the inputField of the receiver"
	<bewareOf: #inputFieldChanged>
	^self propertyValueAt: #inputField! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
inputField: aValue
	"Modify the receiver's inputField"
	^self propertyValueAt: #inputField put: aValue with: #inputFieldChanged! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
okButton
	"Answer the okButton of the receiver"
	<bewareOf: #okButtonChanged>
	^self propertyValueAt: #okButton! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
okButton: aValue
	"Modify the receiver's okButton"
	^self propertyValueAt: #okButton put: aValue with: #okButtonChanged! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/12/2004 22:40'!
onAccept
	<on: fire in: okButton>
	inputField modified ifTrue:[
		player fileName: inputField contents.
	].
	player accept.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/12/2004 22:41'!
onCancel
	<on: fire in: cancelButton>
	player cancel.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/13/2004 03:22'!
onDirListCursorChanged
	<on: cursorChanged in: directoryList>
	player directory: directoryList selection.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/26/2004 01:37'!
onDirectoryChanged
	<on: directoryChanged in: player>
	self signal: #expandDirectory.
! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/1/2005 09:35'!
onDoubleClick
	<on: mouseDoubleClick in: fileList>
	player doubleClick: fileList selection.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/26/2004 01:40'!
onExpandDirectory
	<on: expandDirectory>
	self waitTick.
	self waitTick.
	self expandDirectoryTo: player directory.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/12/2004 22:39'!
onFileNameChanged
	<on: fileNameChanged in: player>
	inputField value: player fileName.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 5/10/2005 17:22'!
onFilePatternListChanged
	<on: filePatternListChanged in: player>
	patternList items: player filePatternList.
	patternList visible: patternList items isEmpty not.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/12/2004 23:09'!
onInputFieldChanged
	<on: accept in: inputField>
	player fileName: inputField value.
	player accept.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 6/19/2005 01:30'!
onOpen
	<on: open>
	hand keyboardFocus: inputField.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/25/2004 11:29'!
onPatternChanged
	<on: cursorChanged in: patternList>
	player filePatternList cursor: patternList cursor.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 2/21/2007 14:34'!
onPlayerChanged
	super onPlayerChanged.
	self onFileNameChanged.
	self onRootDirectoriesChanged.
	self onFilePatternListChanged.
	fileList items: player fileList.! !

!CFileDialogCostume methodsFor: 'events' stamp: 'ar 3/13/2004 02:38'!
onRootDirectoriesChanged
	| roots |
	<on: rootDirectoriesChanged in: player>
	roots := player rootDirectories.
	directoryList roots: roots.
	self onDirectoryChanged.! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
patternList
	"Answer the patternList of the receiver"
	<bewareOf: #patternListChanged>
	^self propertyValueAt: #patternList! !

!CFileDialogCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 20:43'!
patternList: aValue
	"Modify the receiver's patternList"
	^self propertyValueAt: #patternList put: aValue with: #patternListChanged! !

!CFileDialogCostume methodsFor: 'initialize' stamp: 'bgf 1/19/2007 12:35'!
setupFileOpenCostume
	| row |
	self color: Color transparent.
	self extent: 600@400.
	self layout: CTableLayout new.
	self hResizing: #spaceFill; vResizing: #spaceFill.
	self layout layoutInset: 4.

	self add: patternList.

	row := CPlayer new.
	row color: Color white.
	row layout: CTableLayout new.
	row layout listDirection: #leftToRight; cellInset: 2.
	row hResizing: #spaceFill; vResizing: #spaceFill.

	directoryList color: Color transparent.
	directoryList hResizing: #rigid; vResizing: #spaceFill.
	directoryList width: 200.
	directoryList borderWidth: 1.
	directoryList borderStyle: #simple.
	directoryList borderColor: CWidgetLibrary default frameColor.
	row add: directoryList.

	fileList allowDeselect: false.
	fileList color: Color transparent.
	fileList borderWidth: 1.
	fileList borderStyle: #simple.
	fileList borderColor: CWidgetLibrary default frameColor.
	row add: fileList.

	self add: row.

	okButton label: 'OK'.
	cancelButton label: 'Cancel'.
	{okButton. cancelButton} do:[:button|
		button extent: 100@30.
		button roundCorners: true.
		button borderStyle: #simple.
		button borderColor: CWidgetLibrary default frameColor.
	].
	row := CPlayer new.
	row layout: CTableLayout new.
	row layout listDirection: #leftToRight; layoutInset: 2; cellInset: 2.
	row hResizing: #spaceFill; vResizing: #shrinkWrap.
	row layout listCentering: #center.
	row add: okButton.
	row add: cancelButton.
	self add: row.! !

!CFileDialogCostume methodsFor: 'initialize' stamp: 'ar 2/21/2007 14:35'!
setupFileSaveCostume
	| row spacer |
	self color: Color transparent.
	self extent: 500@350.
	self layout: CTableLayout new.
	self layout layoutInset: 4.
	self hResizing: #spaceFill; vResizing: #spaceFill.

	self add: patternList.

	row := CPlayer new.
	row color: Color white.
	row layout: CTableLayout new.
	row layout listDirection: #leftToRight.
	row hResizing: #spaceFill; vResizing: #spaceFill.

	directoryList color: Color transparent.
	directoryList hResizing: #rigid; vResizing: #spaceFill.
	directoryList width: 200.
	directoryList borderWidth: 1.
	directoryList borderStyle: #simple.
	directoryList borderColor: CWidgetLibrary default frameColor.
	row add: directoryList.

	fileList allowDeselect: false.
	fileList color: Color transparent.
	fileList borderWidth: 1.
	fileList borderStyle: #simple.
	fileList borderColor: CWidgetLibrary default frameColor.
	row add: fileList.

	self add: row.

	spacer := CPlayer new.  spacer height: 2.
	self add: spacer.

	inputField allowEditing: true.
	inputField borderColor: CWidgetLibrary default frameColor.
	self add: inputField.

	okButton label: 'OK'.
	cancelButton label: 'Cancel'.
	{okButton. cancelButton} do:[:button|
		button extent: 100@30.
		button roundCorners: true.
		button borderStyle: #simple.
		button borderColor: CWidgetLibrary default frameColor.
	].
	row := CPlayer new.
	row layout: CTableLayout new.
	row layout listDirection: #leftToRight; layoutInset: 2; cellInset: 2.
	row hResizing: #spaceFill; vResizing: #shrinkWrap.
	row layout listCentering: #center.
	row add: okButton.
	row add: cancelButton.
	self add: row.! !

CFileDialogCostume subclass: #CFileOpenDialogCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-FileDialog-Costumes'!

CFileOpenDialogCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CFileOpenDialogCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:50'!
setupCostume
	super setupCostume.
	self setupFileOpenCostume.! !

CFileDialogCostume subclass: #CFileSaveDialogCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-FileDialog-Costumes'!

CFileSaveDialogCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CFileSaveDialogCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:51'!
setupCostume
	super setupCostume.
	self setupFileSaveCostume.! !

CCostume subclass: #CWidgetCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

CWidgetCostume subclass: #CButtonCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons-Costumes'!

CButtonCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="buttonLabel" toSet="buttonLabel:" changeEvent="buttonLabelChanged">buttonLabel</field>
	<field toGet="buttonImage" toSet="buttonImage:" changeEvent="buttonImageChanged">buttonImage</field>
</fields>'!

!CButtonCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:08'!
cssTag
	"Answer the receiver's default css tag"
	^#button! !

!CButtonCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
buttonImage
	"Answer the buttonImage of the receiver"
	<bewareOf: #buttonImageChanged>
	^self propertyValueAt: #buttonImage! !

!CButtonCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
buttonImage: aValue
	"Modify the receiver's buttonImage"
	^self propertyValueAt: #buttonImage put: aValue with: #buttonImageChanged! !

!CButtonCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
buttonLabel
	"Answer the buttonLabel of the receiver"
	<bewareOf: #buttonLabelChanged>
	^self propertyValueAt: #buttonLabel! !

!CButtonCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
buttonLabel: aValue
	"Modify the receiver's buttonLabel"
	^self propertyValueAt: #buttonLabel put: aValue with: #buttonLabelChanged! !

!CButtonCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:01'!
defaultPlayer
	^CButton! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:30'!
focusHighlight
	| focusHighlight |
	focusHighlight := CFramingHighlight new.
	focusHighlight name: #focusHighlight.
	focusHighlight border: (CSimpleBorder width: 1 color: CWidgetLibrary default frameColor).
	focusHighlight inset: 2.
	^focusHighlight! !

!CButtonCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:24'!
image
	^self player image! !

!CButtonCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:24'!
image: aForm
	self player image: aForm! !

!CButtonCostume methodsFor: 'initialize' stamp: 'ar 2/9/2004 23:55'!
initialize
	super initialize.
	buttonImage := self.
	buttonLabel := self.! !

!CButtonCostume methodsFor: 'testing' stamp: 'ar 8/21/2007 17:33'!
isTabStop
	"Stop at buttons as long as they are not disabled"
	^false "not yet; there are still a few issues to be worked out"
	"^player disabled not"! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:22'!
onButtonStateChanged
	"Update the receiver's appearance after the button state has changed"
	| css |
	<on: stateChanged in: player>
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 2/24/2004 14:06'!
onFontChanged
	<on: fontChanged in: player>
	self player font ifNotNil:[buttonLabel textFont: self player font].! !

!CButtonCostume methodsFor: 'events' stamp: 'bf 5/5/2004 15:50'!
onImageChanged
	| aForm |
	<on: imageChanged in: player>
	aForm := self player image.
	buttonImage graphicForm: aForm.
	buttonImage == self ifFalse:[buttonImage visible: aForm notNil].
	! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:12'!
onKeyDown: evt
	<on: keyDown>
	evt keyCharacter = Character space ifTrue:[
		player disabled ifTrue:[^self].
		player state: #pressed.
	].! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:05'!
onKeyStroke: evt
	<on: keyStroke>
	evt keyValue = 9 ifTrue:[^container handleTab: evt from: self after: self].! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:13'!
onKeyUp: evt
	<on: keyUp>
	evt keyCharacter = Character space ifTrue:[
		(self containsPoint: self cursorPoint) 
			ifTrue:[player state: #over]
			ifFalse:[player state: #normal].
		self fire.
	].! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:21'!
onKeyboardFocusEnter
	<on: keyboardFocusEnter>
	self addHighlight: self focusHighlight.
! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:01'!
onKeyboardFocusLeave
	<on: keyboardFocusLeave>
	self removeHighlight: #focusHighlight.
! !

!CButtonCostume methodsFor: 'events' stamp: 'tk 2/14/2005 18:57'!
onLabelChanged
	| aString |
	<on: labelChanged in: player>
	aString := self player label.
	buttonLabel == self 
		ifTrue: ["my own text"
			buttonLabel text: (aString ifNil:[''])]
		ifFalse:["A separate label"
			buttonLabel value: (aString ifNil:['']).
			buttonLabel visible: aString notNil].! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 3/29/2004 22:53'!
onMouseDown
	<on: mouseDown>
	player disabled ifTrue:[^self].
	player state: #pressed.! !

!CButtonCostume methodsFor: 'events' stamp: 'bgf 1/10/2009 09:57'!
onMouseEnter
	<on: mouseEnter>
	player disabled ifTrue:[^self].
	(hand mouseFocus == self asPrimCostume)
		ifTrue:[player state: #pressed]
		ifFalse:[player state: #over].

	player mouseOverHighlight ifNotNilDo: [ : hilite |
		hilite name: #mouseOverHighlight.	
		self addHighlight: hilite.
	].
! !

!CButtonCostume methodsFor: 'events' stamp: 'bgf 1/10/2009 09:52'!
onMouseLeave
	<on: mouseLeave>
	player disabled ifTrue:[^self].
	player state: #normal.
	self removeHighlight: #mouseOverHighlight.! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 6/25/2005 23:48'!
onMouseMove
	<on: mouseMove>
	player disabled ifTrue:[^self].
	(self containsPoint: self cursorPoint) 
		ifTrue:[self onMouseEnter]
		ifFalse:[self onMouseLeave].! !

!CButtonCostume methodsFor: 'events' stamp: 'bgf 1/10/2009 09:53'!
onMouseUp
	<on: mouseUp>
	player disabled ifTrue:[^self].
	(self containsPoint: self cursorPoint) ifTrue:[
		player state: #over.
		self fire.
	] ifFalse:[
		player state: #normal.
	].
	self removeHighlight: #mouseOverHighlight.	
			"In case the container gets hidden before more events come in."! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 3/29/2004 22:58'!
onPlayerChanged
	super onPlayerChanged.
	self onFontChanged.
	self onImageChanged.
	self onLabelChanged.
	self onSelectedChanged.
	self onButtonStateChanged.! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:23'!
onSelectedChanged
	"Update the receiver's appearance after the selected state has changed"
	| css |
	<on: selectedChanged in: player>
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:06'!
onTabEnter: evt
	<on: tabEnter>
	hand keyboardFocus: self.! !

!CButtonCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:07'!
onTabLeave: evt
	<on: tabLeave>
	hand releaseKeyboardFocus: self.
	(self containsPoint: self cursorPoint) 
		ifTrue:[player state: #over]
		ifFalse:[player state: #normal]! !

!CButtonCostume methodsFor: 'initialize' stamp: 'bgf 7/10/2009 22:32'!
setupCostume
	super setupCostume.
	buttonLabel textEnabled: true.
	buttonLabel textAnchorPoint: #center.
	buttonImage graphicEnabled: true.
	self textFont: (Preferences standardControlFont).! !

!CButtonCostume methodsFor: 'accessing' stamp: 'ar 4/28/2004 18:30'!
textHolder
	buttonLabel == self ifTrue:[^costume textHolder] ifFalse:[^buttonLabel textHolder]! !

!CButtonCostume methodsFor: 'accessing' stamp: 'ar 4/28/2004 18:30'!
textHolder: aTextHolder
	buttonLabel == self ifTrue:[
		costume textHolder: aTextHolder.
	] ifFalse:[
		buttonLabel textHolder: aTextHolder.
	].! !

!CButtonCostume methodsFor: 'styling' stamp: 'ar 7/11/2005 11:08'!
visualState
	"Answer the visual state selector for the receiver."
	player isSelected ifTrue:[^#selected].
	player disabled ifTrue:[^#disabled].
	player state == #over ifTrue:[^#over].
	player state == #pressed ifTrue:[^#pressed].
	^#normal! !

CButtonCostume subclass: #CCheckBoxCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons-Costumes'!

CCheckBoxCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="checkMark" toSet="checkMark:" changeEvent="checkMarkChanged">checkMark</field>
</fields>'!

!CCheckBoxCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:08'!
cssTag
	"Answer the receiver's default css tag"
	^#checkbox! !

!CCheckBoxCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
checkMark
	"Answer the checkMark of the receiver"
	<bewareOf: #checkMarkChanged>
	^self propertyValueAt: #checkMark! !

!CCheckBoxCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
checkMark: aValue
	"Modify the receiver's checkMark"
	^self propertyValueAt: #checkMark put: aValue with: #checkMarkChanged! !

!CCheckBoxCostume methodsFor: 'events' stamp: 'ar 8/21/2007 17:27'!
focusHighlight
	^(super focusHighlight) inset: -3@0; yourself! !

!CCheckBoxCostume methodsFor: 'styling' stamp: 'be 8/30/2005 14:18'!
initStyle

	self elements removeAll.
	self elements do:[:each | each close].
	super initStyle! !

!CCheckBoxCostume methodsFor: 'initialize' stamp: 'ar 3/17/2004 03:09'!
initialize
	super initialize.
	self define: #checkMark as: CPlayer new.
	self define: #buttonLabel as: CLabel new.! !

!CCheckBoxCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:08'!
onButtonStateChanged
	"Update from my player's state"
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player state == #pressed 
		ifTrue:[checkMark color: Color veryLightGray].
	player state == #disabled
		ifTrue:[buttonLabel textColor: Color gray]
		ifFalse:[buttonLabel textColor: Color black]
! !

!CCheckBoxCostume methodsFor: 'events' stamp: 'ar 2/1/2008 18:13'!
onSelectedChanged
	"Update the receiver's appearance after the selected state has changed"
	| css selected |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	selected := player selected.
	selected ifNil:[
		checkMark color: Color gray.
		checkMark textColor: Color transparent.
		^self].
	selected ifTrue:[
		checkMark color: Color white.
		checkMark textColor: (Color gray: 0.25).
	] ifFalse:[
		checkMark color: Color white.
		checkMark textColor: Color transparent.
	].! !

!CCheckBoxCostume methodsFor: 'initialize' stamp: 'tk 6/21/2004 09:20'!
setupCostume
	"Initial tweaks which really should go away before too long"
	super setupCostume.
	self add: checkMark.
	self add: buttonLabel.
"	self color: Color transparent."
	self fillStyle: #none.	"transparent"
	self clipping: false.
	buttonLabel clipping: false.
	checkMark extent: 11@11.
	checkMark text: 'V'.
	checkMark textInset: -1.
	checkMark textFont: (TextStyle named: 'WindowFont') defaultFont.
	checkMark borderStyle: #simple.
	checkMark borderWidth: 1.
	checkMark borderColor: Color black.
	checkMark color: Color white.
	self layout: CTableLayout new.
	self layout listDirection: #leftToRight.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
! !

!CCheckBoxCostume methodsFor: 'styling' stamp: 'be 8/30/2005 11:35'!
visualState

	player selected == nil ifTrue:[^#disabled].
	player isSelected ifTrue:[^#selected].
	player disabled ifTrue:[^#disabled].
	^#normal! !

CButtonCostume subclass: #CPushButtonCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons-Costumes'!

CPushButtonCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CPushButtonCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:09'!
cssTag
	"Answer the receiver's default css tag"
	^#pushbutton! !

!CPushButtonCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:01'!
defaultPlayer
	^CPushButton! !

!CPushButtonCostume methodsFor: 'events' stamp: 'ar 8/18/2004 13:01'!
deselect
	borderStyle := #simple.
! !

!CPushButtonCostume methodsFor: 'events' stamp: 'bgf 7/11/2009 18:10'!
onButtonStateChanged
	"Update from my player's state"
	| css baseOffset fhe me |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player isSelected
		ifTrue:[borderStyle := #inset]
		ifFalse:[borderStyle := #simple].
	player state == #disabled
		ifTrue:[buttonLabel textColor: Color gray]
		ifFalse:[buttonLabel textColor: Color black].

	"I'm not sure how general this is, but it helps me empirically in several places where fits are tight."	
	baseOffset := 0.
	self height < 21 ifTrue: [
		fhe := self font height even.
		me := self height even.
		me not ifTrue: [ baseOffset := 1 ].
		me & (fhe not) ifTrue: [ baseOffset := 1].
		].

	player state == #pressed ifTrue:[
		borderStyle := #inset.
		buttonLabel textOffset: 0@baseOffset.
		buttonImage graphicOffset: 1.
	] ifFalse:[
		buttonLabel textOffset: -1@(baseOffset-1).
		buttonImage graphicOffset: 0.
	].! !

!CPushButtonCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:23'!
onSelectedChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	self onButtonStateChanged! !

!CPushButtonCostume methodsFor: 'events' stamp: 'ar 8/18/2004 13:05'!
select
	borderStyle := #inset.! !

!CPushButtonCostume methodsFor: 'initialize' stamp: 'bgf 4/30/2007 12:28'!
setupCostume
	super setupCostume.
	self textEnabled: true.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self fillStyle: #verticalGradient.
	self fillColors: CWidgetLibrary default gradientColors.
	self extent: 80@20.
	self asPrimCostume localCache: CFormCache new.! !

!CPushButtonCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 00:05'!
windowColor: aColor
	super windowColor: aColor.
	self fillColors: {Color white. aColor}.! !

CButtonCostume subclass: #CRadioButtonCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons-Costumes'!

CRadioButtonCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="checkMark" toSet="checkMark:" changeEvent="checkMarkChanged">checkMark</field>
</fields>'!

!CRadioButtonCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:09'!
cssTag
	"Answer the receiver's default css tag"
	^#radiobutton! !

!CRadioButtonCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:34'!
checkMark
	"Answer the checkMark of the receiver"
	<bewareOf: #checkMarkChanged>
	^self propertyValueAt: #checkMark! !

!CRadioButtonCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:34'!
checkMark: aValue
	"Modify the receiver's checkMark"
	^self propertyValueAt: #checkMark put: aValue with: #checkMarkChanged! !

!CRadioButtonCostume methodsFor: 'styling' stamp: 'be 8/30/2005 11:42'!
initStyle

	self elements removeAll.
	super initStyle! !

!CRadioButtonCostume methodsFor: 'initialize' stamp: 'ar 3/30/2004 18:01'!
initialize
	super initialize.
	self define: #checkMark as: CPlayer new.
	self define: #buttonLabel as: CLabel new.! !

!CRadioButtonCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:08'!
onButtonStateChanged
	"Update from my player's state"
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player state == #disabled
		ifTrue:[buttonLabel textColor: Color gray]
		ifFalse:[buttonLabel textColor: Color black]
! !

!CRadioButtonCostume methodsFor: 'events' stamp: 'bgf 2/28/2009 00:31'!
onSelectedChanged
	"Update the receiver's appearance after the selected state has changed"
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player isSelected
		ifTrue:[checkMark text: 'o'; textColor: (Color gray: 0.35).]
		ifFalse:[checkMark text: 'q'; textColor: (Color gray: 0.3) ].! !

!CRadioButtonCostume methodsFor: 'initialize' stamp: 'bgf 2/28/2009 00:25'!
setupCostume
	"Initial tweaks which really should go away before too long"
	super setupCostume.
	self add: checkMark.
	self add: buttonLabel.
	self color: Color transparent.
	self clipping: false.
	buttonLabel clipping: false.
	checkMark extent: 11@11.
	checkMark text: 'q'.
	checkMark textInset: -1.
	checkMark textFont: (TextStyle named: 'WindowFont') defaultFont.
	checkMark textColor: (Color gray: 0.15).
	self layout: CTableLayout new.
	self layout listDirection: #leftToRight.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
! !

!CRadioButtonCostume methodsFor: 'styling' stamp: 'be 8/30/2005 11:55'!
visualState

	player isSelected ifTrue:[^#selected].
	player disabled ifTrue:[^#disabled].
	^#normal! !

CButtonCostume subclass: #CScrollButtonCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling-Costumes'!

CScrollButtonCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CScrollButtonCostume methodsFor: 'events' stamp: 'ar 3/26/2004 20:58'!
deselect
	borderStyle := #raised.
	buttonLabel textOffset: 0.
	buttonImage graphicOffset: 0.! !

!CScrollButtonCostume methodsFor: 'events' stamp: 'ar 2/1/2008 18:14'!
onButtonStateChanged
	"Update from my player's state"
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player state == #disabled
		ifTrue:[buttonLabel textColor: Color gray]
		ifFalse:[buttonLabel textColor: (Color gray: 0.25)].
	player state == #normal ifTrue:[^self deselect].
	player state == #over ifTrue:[^self deselect].
	player state == #pressed ifTrue:[^self select].! !

!CScrollButtonCostume methodsFor: 'events' stamp: 'ar 3/26/2004 20:56'!
select
	borderStyle := #inset.
	buttonLabel textOffset: 1.
	buttonImage graphicOffset: 1.! !

!CScrollButtonCostume methodsFor: 'initialize' stamp: 'tk 7/14/2004 11:28'!
setupCostume
	super setupCostume.
	self textEnabled: true.
	self borderStyle: #raised.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self fillStyle: #verticalGradient.
	self fillColors: CWidgetLibrary default gradientColors.
	self textEmphasis: 1.
	self extent: 80@20.
	self asPrimCostume localCache: CFormCache new.! !

!CScrollButtonCostume methodsFor: 'accessing' stamp: 'ar 3/26/2004 20:56'!
windowColor: aColor
	super windowColor: aColor.
	self fillColors: {Color white. aColor}.! !

CButtonCostume subclass: #CTabButtonCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons-Costumes'!

CTabButtonCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CTabButtonCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:09'!
cssTag
	"Answer the receiver's default css tag"
	^#tabbutton! !

!CTabButtonCostume methodsFor: 'initialize' stamp: 'ar 3/13/2004 04:17'!
defaultPlayer
	^CTabButton! !

!CTabButtonCostume methodsFor: 'initialize' stamp: 'ar 4/28/2004 18:28'!
initialize
	super initialize.
	self define: #buttonImage as: CPlayer new.
	self define: #buttonLabel as: CLabel new.! !

!CTabButtonCostume methodsFor: 'events' stamp: 'ar 7/13/2005 11:20'!
onButtonStateChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player state == #disabled
		ifTrue:[buttonLabel textColor: Color gray]
		ifFalse:[buttonLabel textColor: Color black].
	player state == #pressed ifTrue:[
		borderStyle := #inset.
		buttonLabel textOffset: 1.
		buttonImage graphicOffset: 1.
	].
	(player state == #normal or:[player state == #over]) ifTrue:[
		borderStyle := player isSelected ifTrue:[#raised] ifFalse:[#simple].
		buttonLabel textOffset: 0.
		buttonImage graphicOffset: 0.
	].
! !

!CTabButtonCostume methodsFor: 'events' stamp: 'ar 4/28/2004 18:45'!
onImageChanged
	"Updates the receiver's image from the player without changing the size of the button image"
	| aForm |
	aForm := self player image.
	buttonImage graphicForm: aForm.
	buttonImage == self ifFalse:[buttonImage visible: aForm notNil].! !

!CTabButtonCostume methodsFor: 'events' stamp: 'ar 7/11/2005 11:10'!
onSelectedChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player isSelected ifTrue:[
		fillStyle := #verticalGradient.
		fillColors := CWidgetLibrary default gradientColors.
	] ifFalse:[
		color := CWidgetLibrary default paneColor.
	].
	self onButtonStateChanged. "to update the border"! !

!CTabButtonCostume methodsFor: 'initialize' stamp: 'bgf 4/30/2007 12:33'!
setupCostume
	super setupCostume.

	buttonImage graphicEnabled: true.
	buttonImage graphicFit: #autoScale.
	buttonImage extent: 20@20.
	self addLast: buttonImage.

	buttonLabel clipping: false.
	buttonLabel hResizing: #shrinkWrap.
	self addLast: buttonLabel.

	self layout: CTableLayout new.
	self layout listDirection: #leftToRight.
	self layout cellInset: 2.
	self borderStyle: #raised.
	self hResizing: #shrinkWrap; vResizing: #rigid.
	self layoutInset: 15@5.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self deselect.
	self extent: 100@30.
	self roundCornerSpec: #(1 4).

	self asPrimCostume localCache: CFormCache new.! !

CButtonCostume subclass: #CToolBarButtonCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons-Costumes'!

CToolBarButtonCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CToolBarButtonCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:08'!
onButtonStateChanged
	"Update from my player's state"
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player state == #disabled
		ifTrue:[buttonLabel textColor: Color gray]
		ifFalse:[buttonLabel textColor: Color black].
	player state == #pressed ifTrue:[
		buttonLabel textOffset: 1.
		buttonImage graphicOffset: 1.
		borderStyle := #inset.
	] ifFalse:[
		buttonLabel textOffset: 0.
		buttonImage graphicOffset: 0.
		borderStyle := player selected ifTrue:[#inset] ifFalse:[#raised].
	].! !

!CToolBarButtonCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:23'!
onSelectedChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	borderStyle := player selected ifTrue:[#inset] ifFalse:[#raised].! !

!CToolBarButtonCostume methodsFor: 'initialize' stamp: 'bgf 4/30/2007 12:33'!
setupCostume
	super setupCostume.
	self textEnabled: true.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self fillStyle: #verticalGradient.
	self fillColors: CWidgetLibrary default gradientColors.
	self extent: 80@20.
	self asPrimCostume localCache: CFormCache new.! !

!CToolBarButtonCostume methodsFor: 'accessing' stamp: 'ar 4/4/2004 18:04'!
windowColor: aColor
	super windowColor: aColor.
	self fillColors: {Color white. aColor}.! !

CButtonCostume subclass: #CWindowButtonCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

CWindowButtonCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CWindowButtonCostume methodsFor: 'initialize' stamp: 'ar 12/19/2004 00:32'!
defaultPlayer
	^CWindowButton! !

!CWindowButtonCostume methodsFor: 'events' stamp: 'ar 12/19/2004 00:31'!
obsoleteButtonStateChanged
	"Backward compatibility. Method will be removed at the next full version."
	player state == #normal ifTrue:[
		borderColor := Color gray.
		color := Color white.
	].
	player state == #pressed ifTrue:[
		borderColor := Color black.
		color := Color veryLightGray.
	].
	player state == #over ifTrue:[
		borderColor := Color black.
		color := Color white.
	].! !

!CWindowButtonCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:09'!
onButtonStateChanged
	| css |
	(player isKindOf: CWindowButton) ifFalse:[^self obsoleteButtonStateChanged].
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player state == #normal ifTrue:[
		borderColor := player normalBorderColor ifNil:[Color black].
		textColor := player normalTextColor ifNil:[Color black].
		fillAngle := 90.
	].
	player state == #pressed ifTrue:[
		borderColor := player pressedBorderColor ifNil:[Color black].
		textColor := player pressedTextColor ifNil:[Color white].
		fillAngle := -90.
	].
	player state == #over ifTrue:[
		borderColor := Color black.
		textColor := player pressedTextColor ifNil:[Color white].
		fillAngle := 90.
	].! !

!CWindowButtonCostume methodsFor: 'events' stamp: 'ar 12/19/2004 00:47'!
onNormalBorderColorChanged
	<on: normalBorderColorChanged in: player>
	self onButtonStateChanged. "updates all"! !

!CWindowButtonCostume methodsFor: 'events' stamp: 'ar 12/19/2004 00:47'!
onNormalTextColorChanged
	<on: normalTextColorChanged in: player>
	self onButtonStateChanged. "updates all"! !

!CWindowButtonCostume methodsFor: 'events' stamp: 'ar 12/19/2004 00:47'!
onPressedBorderColorChanged
	<on: pressedBorderColorChanged in: player>
	self onButtonStateChanged. "updates all"! !

!CWindowButtonCostume methodsFor: 'events' stamp: 'ar 12/19/2004 00:47'!
onPressedTextColorChanged
	<on: pressedTextColorChanged in: player>
	self onButtonStateChanged. "updates all"! !

!CWindowButtonCostume methodsFor: 'initialize' stamp: 'ar 12/19/2004 09:03'!
setupCostume
	super setupCostume.
	self extent: 20@20.
	self hResizing: #rigid; vResizing: #rigid.
	self roundCorners: true.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: Color black.
	fillStyle := #verticalGradient.
	fillColors := {Color white. CWidgetLibrary default baseColor}.
	self textFont: (TextStyle named: 'WindowFont') defaultFont.
! !

!CWindowButtonCostume methodsFor: 'events' stamp: 'ar 12/19/2004 08:37'!
windowColor: aColor
	fillStyle := #verticalGradient.
	fillColors := {Color white. aColor}.! !

CWidgetCostume subclass: #CDropDownListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

CDropDownListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="button" toSet="button:" changeEvent="buttonChanged">button</field>
</fields>'!

!CDropDownListCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:10'!
cssTag
	"Answer the receiver's default css tag"
	^#dropdownlist! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:30'!
button
	"Answer the button of the receiver"
	<bewareOf: #buttonChanged>
	^self propertyValueAt: #button! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:30'!
button: aValue
	"Modify the receiver's button"
	^self propertyValueAt: #button put: aValue with: #buttonChanged! !

!CDropDownListCostume methodsFor: 'initialize' stamp: 'ar 5/6/2005 13:55'!
defaultPlayer
	^CDropDownList! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'bgf 6/26/2009 13:54'!
font: aFont
	super font: aFont.
	label textFont: aFont! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'ar 4/20/2007 14:25'!
hResizing: aSymbol
	costume hResizing: aSymbol.
	aSymbol == #shrinkWrap
		ifTrue:[label hResizing: aSymbol]
		ifFalse:[label hResizing: #spaceFill].! !

!CDropDownListCostume methodsFor: 'initialize' stamp: 'be 9/2/2005 12:25'!
initialize
	super initialize.
	self define: #label as: CInputField new.
	self define: #button as: CWidget new.
! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 15:39'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 15:39'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 11/10/2004 11:25'!
onAccept
	"Resignal accept"
	<on: accept in: label>
	self signal: #accept.! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 3/12/2004 15:37'!
onAllowEditingChanged
	<on: allowEditingChanged in: player>
	label allowEditing: player allowEditing.! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 12/19/2004 20:51'!
onAutoAcceptChanged
	<on: autoAcceptChanged in: player>
	label autoAccept: player autoAccept.
! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 12/19/2004 20:51'!
onAutoRevertChanged
	<on: autoRevertChanged in: player>
	label autoRevert: player autoRevert.
! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:12'!
onButtonStateChanged
	"Update from my button's state"
	| css |
	<on: stateChanged in: button>
	(css := self styleSheet) ifNotNil:[^css applyTo: self].! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 12/19/2004 21:05'!
onConverterChanged
	<on: converterChanged in: player>
	label converter: player converter.! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:32'!
onCssTagChanged
	label cssTag:  (cssTag,'.text') asSymbol.
	button cssTag:  (cssTag,'.button') asSymbol.
	super onCssTagChanged.! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 10/8/2005 12:20'!
onCursorChanged
	<on: cursorChanged in: player>
	player value: player selection.! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:14'!
onElementsChanged
	<on: elementsChanged in: player>
	self onCursorChanged.
! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 3/12/2004 15:39'!
onLabelValueChanged
	<on: valueChanged in: label>
	player value: label value! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 4/21/2010 16:19'!
onMouseDown
	| menu list |
	<on: mouseDown>

	"Delay showing the menu by a tick so that any listener for #showMenu can update 
	the drop down's elements before we show them."
	self player signal: #showMenu.
	self waitTick.

	menu := CMenu new.
	menu label: nil.
	list := self player items.
	list do:[:item| menu add: item displayText target: list action: #selection: argument: item].
	menu roundCorners: false.
	menu width: self width.
	menu hResizing: #spaceFill.
	menu openAt: (self localToGlobal: 0@(self height - borderWidth)).
! !

!CDropDownListCostume methodsFor: 'events' stamp: 'bgf 1/12/2009 08:49'!
onMouseEnter
	<on: mouseEnter>
	button addHighlight: (
			(CWidgetLibrary default mouseOverHighlightForButton: button)
				name: #mouseOverHighlight;
				yourself ).! !

!CDropDownListCostume methodsFor: 'events' stamp: 'bgf 1/12/2009 08:50'!
onMouseLeave
	<on: mouseLeave>
	button removeHighlight: #mouseOverHighlight.
	! !

!CDropDownListCostume methodsFor: 'events' stamp: 'bgf 1/12/2009 08:50'!
onMouseUp
	<on: mouseUp>
	button removeHighlight: #mouseOverHighlight.	
			"In case the container gets hidden before more events come in."! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 4/22/2005 18:50'!
onPlayerChanged
	super onPlayerChanged.
	self onValueChanged.
	self onAllowEditingChanged.
	self onAutoAcceptChanged.
	self onAutoRevertChanged.
	self onConverterChanged.! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:30'!
onStyleSheetChanged
	button styleSheet: self styleSheet.
	label styleSheet: self styleSheet.
	super onStyleSheetChanged.! !

!CDropDownListCostume methodsFor: 'events' stamp: 'ar 4/22/2005 17:54'!
onValueChanged
	<on: valueChanged>
	"avoid pushing the value back to my player"
	self pauseScript: #onLabelValueChanged.
	label value: player value.
	self resumeScript: #onLabelValueChanged.! !

!CDropDownListCostume methodsFor: 'initialize' stamp: 'bgf 7/10/2009 23:01'!
setupCostume
	"Initial tweaks - need to go away"
	super setupCostume.
	label cssTag: #dropdowntext.
	button cssTag: #dropdownbutton.

	self color: Color white.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self extent: 100@5.

	self add: label.
	label color: Color transparent.
	label borderColor: Color transparent.
	label clipping: false.

	self add: button.
	button height: 5.
	button fillStyle: #verticalGradient.
	button fillColors: (CWidgetLibrary default gradientColors).
	button graphicForm: (CIconLibrary default at: #DropDownIcon).
	button hResizing: #rigid; vResizing: #spaceFill; width: 16.

	self layout: CTableLayout new.
	self layout listDirection: #leftToRight.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layoutInset: -1. "compensate for text editor border"
	label clipping: true. "do not allow growing the input field"

	self font: CWidgetLibrary default menuFont.
	label textFont: (Preferences standardControlFont).! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'ar 3/30/2004 03:06'!
textHolder
	^label textHolder! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'ar 3/30/2004 03:06'!
textHolder: aTextHolder
	label textHolder: aTextHolder! !

!CDropDownListCostume methodsFor: 'accessing' stamp: 'ar 12/10/2005 20:48'!
vResizing: aSymbol
	costume vResizing: aSymbol.
	label vResizing: aSymbol.! !

!CDropDownListCostume methodsFor: 'styling' stamp: 'ar 7/7/2005 13:05'!
visualState
	"Answer the visual state selector for the receiver."
	^button visualState! !

!CDropDownListCostume methodsFor: 'color and fill' stamp: 'ar 4/4/2004 18:33'!
windowColor: aColor
	super windowColor: aColor.
	button fillColors: {Color white. aColor}.! !

CWidgetCostume subclass: #CItemWidgetCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

CItemWidgetCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CItemWidgetCostume methodsFor: 'initialize' stamp: 'ar 7/7/2005 09:52'!
defaultPlayer
	^CItemWidget! !

!CItemWidgetCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:52'!
onIconChanged
	"Update myself after a change"
	<on: iconChanged in: player>! !

!CItemWidgetCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:52'!
onLabelChanged
	"Update myself after a change"
	<on: labelChanged in: player>! !

!CItemWidgetCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:52'!
onPlayerChanged
	"Update myself after a change"
	<on: playerChanged>
	super onPlayerChanged.
	self onLabelChanged.
	self onIconChanged.
	self onStateChanged.
	self onSelectedChanged.
! !

!CItemWidgetCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:52'!
onSelectedChanged
	"Update myself after a change"
	<on: selectedChanged in: player>! !

!CItemWidgetCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:52'!
onStateChanged
	"Update myself after a change"
	<on: stateChanged in: player>! !

!CItemWidgetCostume methodsFor: 'styling' stamp: 'ar 7/7/2005 13:05'!
visualState
	"Answer the visual state selector for the receiver."
	player selected ifTrue:[^#selected].
	player disabled ifTrue:[^#disabled].
	player state == #over ifTrue:[^#over].
	player state == #pressed ifTrue:[^#pressed].
	^#normal! !

CItemWidgetCostume subclass: #CListItemCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

!CListItemCostume commentStamp: '<historical>' prior: 0!
I am a very, very dumb list item costume.!

CListItemCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="normalColor" toSet="normalColor:" changeEvent="normalColorChanged">normalColor</field>
	<field toGet="selectedColor" toSet="selectedColor:" changeEvent="selectedColorChanged">selectedColor</field>
	<field toGet="normalTextColor" toSet="normalTextColor:" changeEvent="normalTextColorChanged">normalTextColor</field>
	<field toGet="selectedTextColor" toSet="selectedTextColor:" changeEvent="selectedTextColorChanged">selectedTextColor</field>
</fields>'!

!CListItemCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 13:04'!
cssTag
	"Answer the receiver's default css tag"
	^#listitem! !

!CListItemCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 11:38'!
defaultColor
	^Color transparent! !

!CListItemCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 11:38'!
defaultPlayer
	^CListItem! !

!CListItemCostume methodsFor: 'drawing' stamp: 'ar 1/29/2009 23:06'!
drawOn: aCanvas in: itemBox
	| icon itemColor pos font x y offset |
	super drawOn: aCanvas in: itemBox.
	offset := player iconOffset.
	(icon := player icon) ifNotNil:[
		x := itemBox left + offset.
		y := (itemBox top + (itemBox height // 2)) - (icon height // 2).
		aCanvas translucentImage: icon at: x@y.
		offset := offset + icon width.
	].
	itemColor := player selected
		ifTrue:[self selectedTextColor] 
		ifFalse:[self normalTextColor].
	font := player font ifNil:[TextStyle defaultFont]. "@@@@ FIX THIS @@@@"
	pos := itemBox leftCenter.
	pos := (pos x + offset + 4) @ (pos y - (font height // 2)).

	aCanvas drawString: player label asString
			at: pos
			font: font
			color: itemColor.
! !

!CListItemCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:43'!
normalColor
	"Answer the normalColor of the receiver"
	<bewareOf: #normalColorChanged>
	^self propertyValueAt: #normalColor ifAbsent:[Color transparent]! !

!CListItemCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:43'!
normalColor: aValue
	"Modify the receiver's normalColor"
	^self propertyValueAt: #normalColor put: aValue with: #normalColorChanged! !

!CListItemCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:43'!
normalTextColor
	"Answer the normalTextColor of the receiver"
	<bewareOf: #normalTextColorChanged>
	^self propertyValueAt: #normalTextColor ifAbsent:[Color black]! !

!CListItemCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:43'!
normalTextColor: aValue
	"Modify the receiver's normalTextColor"
	^self propertyValueAt: #normalTextColor put: aValue with: #normalTextColorChanged! !

!CListItemCostume methodsFor: 'events' stamp: 'ar 10/8/2005 11:47'!
onIconChanged
	<on: iconChanged in: player>
	self updateExtent.! !

!CListItemCostume methodsFor: 'events' stamp: 'ar 10/8/2005 11:46'!
onLabelChanged
	<on: labelChanged in: player>
	self updateExtent.
! !

!CListItemCostume methodsFor: 'events' stamp: 'ar 10/8/2005 11:47'!
onPlayerChanged
	super onPlayerChanged.
	self updateExtent.! !

!CListItemCostume methodsFor: 'events' stamp: 'bgf 12/28/2008 10:07'!
onSelectedChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player selected 
		ifTrue:[	
			"A gentle gradient that is strongest in mid-body for legibility."
			fillStyle := #verticalGradient.
			fillColors := (self selectedColor) itemSelectionGradient.
			fillAlpha :=  (self selectedColor alpha)]
		ifFalse:[
			fillStyle := player fillStyle.
			color :=  self normalColor. 
			fillAlpha := player fillAlpha].! !

!CListItemCostume methodsFor: 'events' stamp: 'ar 7/7/2005 13:05'!
onStateChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
! !

!CListItemCostume methodsFor: 'accessing' stamp: 'ar 12/10/2005 21:00'!
selectedColor
	"Answer the selectedColor of the receiver"
	<bewareOf: #selectedColorChanged>
	^self propertyValueAt: #selectedColor ifAbsent:[
		(container ifNil:[^CWidgetLibrary default selectionColor]) selectionColor]! !

!CListItemCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:43'!
selectedColor: aValue
	"Modify the receiver's selectedColor"
	^self propertyValueAt: #selectedColor put: aValue with: #selectedColorChanged! !

!CListItemCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:44'!
selectedTextColor
	"Answer the selectedTextColor of the receiver"
	<bewareOf: #selectedTextColorChanged>
	^self propertyValueAt: #selectedTextColor ifAbsent:[Color white]! !

!CListItemCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:43'!
selectedTextColor: aValue
	"Modify the receiver's selectedTextColor"
	^self propertyValueAt: #selectedTextColor put: aValue with: #selectedTextColorChanged! !

!CListItemCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 12:12'!
setupCostume
	super setupCostume.
	self clipping: false.
	self userDraw: true.
	self color: Color transparent.
	self hResizing: #spaceFill.
	self updateExtent.! !

!CListItemCostume methodsFor: 'events' stamp: 'ar 10/8/2005 11:55'!
updateExtent
	| font offset icon w |
	font := player font ifNil:[TextStyle defaultFont].
	self height := font height + 2 max: 16.
	offset := 0.
	(icon := player icon) ifNotNil:[offset := offset + icon width].
	w := (font widthOfString: player label asString) + offset + 8.
	self clipping ifFalse:[self minWidth: w].! !

CItemWidgetCostume subclass: #CMenuItemCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus-Costumes'!

CMenuItemCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="normalTextColor" toSet="normalTextColor:" changeEvent="normalTextColorChanged">normalTextColor</field>
	<field toGet="selectedTextColor" toSet="selectedTextColor:" changeEvent="selectedTextColorChanged">selectedTextColor</field>
	<field toGet="disabledTextColor" toSet="disabledTextColor:" changeEvent="disabledTextColorChanged">disabledTextColor</field>
	<field toGet="normalColor" toSet="normalColor:" changeEvent="normalColorChanged">normalColor</field>
	<field toGet="selectedColor" toSet="selectedColor:" changeEvent="selectedColorChanged">selectedColor</field>
	<field toGet="checkMarkIcon" toSet="checkMarkIcon:" changeEvent="checkMarkIconChanged">checkMarkIcon</field>
	<field toGet="subMenuIcon" toSet="subMenuIcon:" changeEvent="subMenuIconChanged">subMenuIcon</field>
	<field toGet="separatorColor" toSet="separatorColor:" changeEvent="separatorColorChanged">separatorColor</field>
	<field toGet="extraWidth" toSet="extraWidth:" changeEvent="extraWidthChanged">extraWidth</field>
</fields>'!

!CMenuItemCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 13:04'!
cssTag
	"Answer the receiver's default css tag"
	^#menuitem! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:01'!
checkMarkIcon
	"Answer the checkMarkIcon of the receiver"
	<bewareOf: #checkMarkIconChanged>
	^self propertyValueAt: #checkMarkIcon ifAbsent:[CIconLibrary default at: #CheckMark].! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:00'!
checkMarkIcon: aValue
	"Modify the receiver's checkMarkIcon"
	^self propertyValueAt: #checkMarkIcon put: aValue with: #checkMarkIconChanged! !

!CMenuItemCostume methodsFor: 'private' stamp: 'bgf 8/25/2007 00:15'!
checkMarkSpace
	^ ((self extraWidth ifNil:[40])/2) rounded	"The portion of extraWidth that is used on the left"! !

!CMenuItemCostume methodsFor: 'initialize' stamp: 'ar 7/7/2005 11:14'!
defaultPlayer
	^CMenuItem! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:01'!
disabledTextColor
	"Answer the disabledTextColor of the receiver"
	<bewareOf: #disabledTextColorChanged>
	^self propertyValueAt: #disabledTextColor ifAbsent:[Color gray]! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:00'!
disabledTextColor: aValue
	"Modify the receiver's disabledTextColor"
	^self propertyValueAt: #disabledTextColor put: aValue with: #disabledTextColorChanged! !

!CMenuItemCostume methodsFor: 'drawing' stamp: 'ar 1/22/2009 12:30'!
drawOn: aCanvas in: itemBox
	| icon itemColor pos font x y emph |
	super drawOn: aCanvas in: itemBox.
	icon := player icon.
	player checked ifTrue:[icon := self checkMarkIcon].
	icon ifNotNil:[
		x := (itemBox left + (self checkMarkSpace/2) truncated) - (icon width // 2).
		y := (itemBox top + (itemBox height // 2)) - (icon height // 2).
		aCanvas translucentImage: icon at: x@y.
	].
	itemColor := player selected
			ifTrue:[self selectedTextColor] 
			ifFalse:[self normalTextColor].
	player disabled ifTrue:[itemColor := self disabledTextColor].
	font := player font ifNil:[TextStyle defaultFont].
	(emph := player emphasis) 
		ifNotNil:[font := font emphasized: emph]. 
	pos := itemBox leftCenter.
	pos := (pos x + self checkMarkSpace) @ (pos y - (font height // 2)).

	aCanvas drawString: player label asString
			at: pos
			font: font
			color: itemColor.

	player subMenu ifNotNil:[
		icon := self subMenuIcon.
		icon ifNotNil:[aCanvas paintImage: icon 
			at: itemBox rightCenter - ((icon width + 3)@(icon height // 2))].
	].

	player separator ifTrue:[
		aCanvas fillRectangle: (itemBox bottomLeft extent: itemBox width @ 1)
			color: self separatorColor.
	].! !

!CMenuItemCostume methodsFor: 'private' stamp: 'bgf 8/25/2007 01:03'!
extraWidth
	"Answer the extraWidth of the receiver"
	<bewareOf: #extraWidthChanged>
	^self propertyValueAt: #extraWidth! !

!CMenuItemCostume methodsFor: 'private' stamp: 'bgf 8/25/2007 01:03'!
extraWidth: aValue
	"Modify the receiver's extraWidth"
	^self propertyValueAt: #extraWidth put: aValue with: #extraWidthChanged! !

!CMenuItemCostume methodsFor: 'initialize' stamp: 'bgf 8/23/2008 19:50'!
initialize
	super initialize.	
	extraWidth := 40.! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 8/19/2005 09:46'!
isSeparator
	^false! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'bgf 8/24/2007 23:24'!
minHeight: h
	"We honor these to facililate menu bar layout."
	super minHeight: h.
	self updateExtent.! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:38'!
normalColor
	"Answer the normalColor of the receiver"
	<bewareOf: #normalColorChanged>
	^self propertyValueAt: #normalColor ifAbsent:[Color transparent]! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:38'!
normalColor: aValue
	"Modify the receiver's normalColor"
	^self propertyValueAt: #normalColor put: aValue with: #normalColorChanged! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:03'!
normalTextColor
	"Answer the normalTextColor of the receiver"
	<bewareOf: #normalTextColorChanged>
	^self propertyValueAt: #normalTextColor ifAbsent:[Color black]! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:00'!
normalTextColor: aValue
	"Modify the receiver's normalTextColor"
	^self propertyValueAt: #normalTextColor put: aValue with: #normalTextColorChanged! !

!CMenuItemCostume methodsFor: 'events' stamp: 'be 10/18/2005 14:06'!
onCheckMarkIconChanged

	<on: checkMarkIconChanged>
	self invalidate.! !

!CMenuItemCostume methodsFor: 'events' stamp: 'ar 7/11/2005 13:47'!
onCheckedChanged
	| css |
	<on: checkedChanged in: player>
	(css := self styleSheet) ifNotNil:[css applyTo: self].
	self invalidate.! !

!CMenuItemCostume methodsFor: 'events' stamp: 'ar 7/11/2005 13:47'!
onEnabledChanged
	| css |
	<on: enabledChanged in: player>
	(css := self styleSheet) ifNotNil:[css applyTo: self].
	self invalidate.! !

!CMenuItemCostume methodsFor: 'events' stamp: 'bgf 8/25/2007 12:25'!
onExtraWidthChanged

	<on: extraWidthChanged>
	self updateExtent.
	self invalidate.! !

!CMenuItemCostume methodsFor: 'events' stamp: 'ar 7/7/2005 11:33'!
onFire
	"Fallback for old menu items -- remove this soon!!"
	<on: fire>
	player ifNil:[
		value ifNotNil:[value fire].
	].! !

!CMenuItemCostume methodsFor: 'events' stamp: 'bgf 8/25/2007 12:27'!
onFontChanged
	<on: fontChanged in: player>
	self updateExtent.
	self invalidate.! !

!CMenuItemCostume methodsFor: 'events' stamp: 'ar 7/11/2005 13:48'!
onIconChanged
	<on: iconChanged in: player>
	self invalidate.! !

!CMenuItemCostume methodsFor: 'events' stamp: 'ar 7/11/2005 13:48'!
onLabelChanged
	<on: labelChanged in: player>
	self invalidate.! !

!CMenuItemCostume methodsFor: 'events' stamp: 'ar 7/7/2005 11:26'!
onPlayerChanged
	<on: playerChanged>
	self onCheckedChanged.
	self onEnabledChanged.
	self onSubMenuChanged.
	self onLabelChanged.
	self onIconChanged.! !

!CMenuItemCostume methodsFor: 'events' stamp: 'bgf 8/9/2009 12:49'!
onSelectedChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	(player selected and: [player enabled])	"No hilite if disabled"
		ifTrue:[	
			fillStyle := #verticalGradient.
			fillColors := self selectionGradient ]
		ifFalse:[color :=  self normalColor].
! !

!CMenuItemCostume methodsFor: 'styling' stamp: 'be 7/14/2005 11:19'!
onStyleSheetChanged

	player subMenu ifNotNil:[player subMenu styleSheet: self styleSheet].
	super onStyleSheetChanged
! !

!CMenuItemCostume methodsFor: 'events' stamp: 'ar 7/11/2005 13:48'!
onSubMenuChanged
	<on: subMenuChanged in: player>
	self invalidate.! !

!CMenuItemCostume methodsFor: 'drawing' stamp: 'ar 1/11/2008 11:22'!
preferredExtent
	"Answer my preferred extent"
	| font emph |
	font := player font ifNil:[TextStyle defaultFont].
	(emph := player emphasis) ifNotNil:[font := font emphasized: emph].
	^((font widthOfString: player label asString) + self extraWidth) @ self height 
			"leave height untouched - MenuItem uses some hard layout numbers"! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 12/10/2005 21:00'!
selectedColor
	"Answer the selectedColor of the receiver"
	<bewareOf: #selectedColorChanged>
	^self propertyValueAt: #selectedColor ifAbsent:[
		(container ifNil:[^CWidgetLibrary default selectionColor]) selectionColor]! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:38'!
selectedColor: aValue
	"Modify the receiver's selectedColor"
	^self propertyValueAt: #selectedColor put: aValue with: #selectedColorChanged! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:03'!
selectedTextColor
	"Answer the selectedTextColor of the receiver"
	<bewareOf: #selectedTextColorChanged>
	^self propertyValueAt: #selectedTextColor ifAbsent:[Color white]! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:00'!
selectedTextColor: aValue
	"Modify the receiver's selectedTextColor"
	^self propertyValueAt: #selectedTextColor put: aValue with: #selectedTextColorChanged! !

!CMenuItemCostume methodsFor: 'private' stamp: 'bgf 8/9/2009 12:57'!
selectionGradient
	| basis |
	basis := self selectionColor.
	^ { 
		basis adjustSaturation: -0.01 brightness: 0.02 .
		basis adjustSaturation: 0.04 brightness: -0.12 .
	}! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'bgf 2/9/2007 10:12'!
separatorColor
	"Answer the separatorColor of the receiver"
	<bewareOf: #separatorColorChanged>
	^self propertyValueAt: #separatorColor ifAbsent:[CWidgetLibrary default separatorColor]! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:00'!
separatorColor: aValue
	"Modify the receiver's separatorColor"
	^self propertyValueAt: #separatorColor put: aValue with: #separatorColorChanged! !

!CMenuItemCostume methodsFor: 'initialize' stamp: 'bgf 6/26/2009 14:07'!
setupCostume
	super setupCostume.
	self userDraw: true.
	self hResizing: #spaceFill.
	self minHeight: 14.
	self clipping: true.
	self color: Color transparent.

! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:04'!
subMenuIcon
	"Answer the subMenuIcon of the receiver"
	<bewareOf: #subMenuIconChanged>
	^self propertyValueAt: #subMenuIcon ifAbsent:[CIconLibrary default at: #SubMenu]! !

!CMenuItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:00'!
subMenuIcon: aValue
	"Modify the receiver's subMenuIcon"
	^self propertyValueAt: #subMenuIcon put: aValue with: #subMenuIconChanged! !

!CMenuItemCostume methodsFor: 'events' stamp: 'bgf 6/26/2009 14:08'!
updateExtent
	| font w h emph |
	font := player font ifNil:[TextStyle defaultFont].
	(emph := player emphasis) 
		ifNotNil:[font := font emphasized: emph].
	w := (font widthOfString: player label asString) + self extraWidth.
	h := font height + 4 max: (self minHeight).
	self width: w.
	self height: h.
	self clipping ifFalse:[self minWidth: w].! !

CItemWidgetCostume subclass: #CTreeItemCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Trees-Costumes'!

!CTreeItemCostume commentStamp: '<historical>' prior: 0!
A simple costume for a tree item!

CTreeItemCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="normalColor" toSet="normalColor:" changeEvent="normalColorChanged">normalColor</field>
	<field toGet="selectedColor" toSet="selectedColor:" changeEvent="selectedColorChanged">selectedColor</field>
	<field toGet="normalTextColor" toSet="normalTextColor:" changeEvent="normalTextColorChanged">normalTextColor</field>
	<field toGet="selectedTextColor" toSet="selectedTextColor:" changeEvent="selectedTextColorChanged">selectedTextColor</field>
	<field toGet="openMarker" toSet="openMarker:" changeEvent="openMarkerChanged">openMarker</field>
	<field toGet="openSelectedMarker" toSet="openSelectedMarker:" changeEvent="openSelectedMarkerChanged">openSelectedMarker</field>
	<field toGet="closedMarker" toSet="closedMarker:" changeEvent="closedMarkerChanged">closedMarker</field>
	<field toGet="closedSelectedMarker" toSet="closedSelectedMarker:" changeEvent="closedSelectedMarkerChanged">closedSelectedMarker</field>
</fields>'!

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 2/11/2008 13:43'!
closedMarker
	"Answer the closedMarker of the receiver"
	<bewareOf: #closedMarkerChanged>
	^self propertyValueAt: #closedMarker ifAbsent:[CIconLibrary default at: #TreeClosedIcon].! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:57'!
closedMarker: aValue
	"Modify the receiver's closedMarker"
	^self propertyValueAt: #closedMarker put: aValue with: #closedMarkerChanged! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'bgf 12/24/2008 16:48'!
closedSelectedMarker
	"Answer the closedSelectedMarker of the receiver"
	<bewareOf: #closedSelectedMarkerChanged>
	^self propertyValueAt: #closedSelectedMarker 
		  ifAbsent:[CIconLibrary default at: #TreeClosedSelectedIcon].! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'bgf 12/24/2008 16:47'!
closedSelectedMarker: aValue
	"Modify the receiver's closedSelectedMarker"
	^self propertyValueAt: #closedSelectedMarker put: aValue with: #closedSelectedMarkerChanged! !

!CTreeItemCostume methodsFor: 'initialize' stamp: 'ar 3/13/2004 01:40'!
defaultColor
	^Color transparent! !

!CTreeItemCostume methodsFor: 'initialize' stamp: 'ar 3/12/2004 19:14'!
defaultPlayer
	^CTreeItem! !

!CTreeItemCostume methodsFor: 'drawing' stamp: 'bgf 2/13/2008 11:21'!
drawLinesOn: aCanvas in: box
	| x y lineColor prevNode nextNode start |

	player parent ifNil:[^nil].
	"@@@@: FIXME - need to get the line color from somewhere but where???"
	lineColor := Color veryLightGray.
	x := (player indentation * openMarker width) + (openMarker width // 2).
	y := box height // 2.
	(player hasChildren and:[player expanded not]) ifFalse:[
		start := player hasChildren ifTrue: [ x+5 ] ifFalse: [ x ].
		aCanvas drawLineFrom: start@y to: (player indentation + 1 * openMarker width) @ y
			width: 1 color: lineColor.
	].

	player parent ifNil:[^nil].

	"Vertical lines through this item"
	player hasChildren ifFalse: [
		(player parent children last == player) 
			ifTrue:[aCanvas drawLineFrom: x@(box top) to: x@y width: 1 color: lineColor]
			ifFalse:[aCanvas drawLineFrom: x@(box top) to: x@box bottom width: 1 color: lineColor].
	] ifTrue: [
		"vertical from previous to above arrow"
		player expanded ifTrue: [
			aCanvas drawLineFrom: x@(box top) to: x@(box top+4) width: 1 color: lineColor
		] ifFalse: [
			aCanvas drawLineFrom: x@(box top) to: x@(box top+6) width: 1 color: lineColor
		].
		
		"vertical from below arrow to bottom of box."
		(player parent children last == player) ifFalse: [
			player expanded ifTrue: [
				aCanvas drawLineFrom: x@(box bottom-4) to: x@box bottom width: 1 color: lineColor
			] ifFalse: [
				aCanvas drawLineFrom: x@(box bottom-7) to: x@box bottom width: 1 color: lineColor
			].
		].
	].

	"Vertical lines passing to the left of this item, for the containment scopes of its ancestors."
	nextNode := player parent.
	[prevNode := nextNode.
	nextNode := prevNode parent.
	nextNode == nil] whileFalse:[
		x := x - openMarker width.
		x < 0 ifTrue:[^nil].
		nextNode children last == prevNode ifFalse:[
			aCanvas drawLineFrom: x@box top to: x@box bottom width: 1 color: lineColor
		].
	].! !

!CTreeItemCostume methodsFor: 'drawing' stamp: 'bgf 12/24/2008 16:50'!
drawOn: aCanvas in: itemBox
	| icon itemColor pos font x y offset emph |
	super drawOn: aCanvas in: itemBox.
	self drawLinesOn: aCanvas in: itemBox.
	offset := player indentation * openMarker width.
	player hasChildren ifTrue:[
		icon := player selected ifTrue: [
					player expanded ifTrue:[openSelectedMarker] ifFalse:[closedSelectedMarker]
				] ifFalse: [
					player expanded ifTrue:[openMarker] ifFalse:[closedMarker]
				]].
	icon ifNotNil:[
		"1px offset to keep Brad happy."
		x := itemBox left + offset + 1.
		y := (itemBox top + (itemBox height // 2)) - (icon height // 2) + 1.
		icon depth = 32 
			ifTrue:[aCanvas translucentImage: icon at: x@y]
			ifFalse:[aCanvas paintImage: icon at: x@y].
	].
	offset := offset + openMarker width.

	icon := player icon.
	icon ifNotNil:[
		x := itemBox left + offset.
		y := (itemBox top + (itemBox height // 2)) - (icon height // 2).
		aCanvas paintImage: icon at: x@y.
		offset := offset + icon width.
	].
	itemColor := player selected
			ifTrue:[self selectedTextColor] 
			ifFalse:[self normalTextColor].
	font := player font ifNil:[TextStyle defaultFont]. "@@@@ FIX THIS @@@@"
	(emph := player emphasis) 
		ifNotNil:[font := font emphasized: emph]. 
	pos := itemBox leftCenter.
	pos := (pos x + offset + 4) @ (pos y - (font height // 2)).

	aCanvas drawString: player label asString
			at: pos
			font: font
			color: itemColor.
! !

!CTreeItemCostume methodsFor: 'drawing' stamp: 'ar 7/11/2005 15:19'!
inToggleArea: aPoint
	"Answer whether aPoint is in the receiver's toggle area"
	| offset |
	player hasChildren ifFalse:[^false].
	offset := player indentation * openMarker width.
	^aPoint x > offset and:[aPoint x <= (offset + openMarker width)].! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:51'!
normalColor
	"Answer the normalColor of the receiver"
	<bewareOf: #normalColorChanged>
	^self propertyValueAt: #normalColor ifAbsent:[Color transparent]! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:51'!
normalColor: aValue
	"Modify the receiver's normalColor"
	^self propertyValueAt: #normalColor put: aValue with: #normalColorChanged! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:51'!
normalTextColor
	"Answer the normalTextColor of the receiver"
	<bewareOf: #normalTextColorChanged>
	^self propertyValueAt: #normalTextColor ifAbsent:[Color black]! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:51'!
normalTextColor: aValue
	"Modify the receiver's normalTextColor"
	^self propertyValueAt: #normalTextColor put: aValue with: #normalTextColorChanged! !

!CTreeItemCostume methodsFor: 'events' stamp: 'ar 11/12/2004 16:37'!
onChildrenChanged
	<on: childrenChanged in: player>
	self onExpandedChanged.! !

!CTreeItemCostume methodsFor: 'events' stamp: 'ar 7/11/2005 14:52'!
onExpandedChanged
	<on: expandedChanged in: player>
	self invalidate.! !

!CTreeItemCostume methodsFor: 'events' stamp: 'ar 10/8/2005 10:56'!
onIconChanged
	<on: iconChanged in: player>
	self updateExtent.! !

!CTreeItemCostume methodsFor: 'events' stamp: 'ar 10/8/2005 10:56'!
onIndentationChanged
	<on: indentationChanged in: player>
	self updateExtent.
! !

!CTreeItemCostume methodsFor: 'events' stamp: 'ar 10/8/2005 10:56'!
onLabelChanged
	<on: labelChanged in: player>
	self updateExtent.
! !

!CTreeItemCostume methodsFor: 'events' stamp: 'ar 10/8/2005 10:57'!
onPlayerChanged
	super onPlayerChanged.
	self updateExtent.! !

!CTreeItemCostume methodsFor: 'events' stamp: 'bgf 12/28/2008 10:06'!
onSelectedChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].
	player selected 
		ifTrue:[	
			"A gentle gradient that is strongest in mid-body for legibility."
			fillStyle := #verticalGradient.
			fillColors := (self selectedColor) itemSelectionGradient.
			fillAlpha :=  (self selectedColor alpha)]
		ifFalse:[
			color :=  self normalColor. 
			fillAlpha := player fillAlpha].! !

!CTreeItemCostume methodsFor: 'events' stamp: 'ar 7/11/2005 15:45'!
onStateChanged
	| css |
	(css := self styleSheet) ifNotNil:[^css applyTo: self].! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 2/11/2008 13:43'!
openMarker
	"Answer the openMarker of the receiver"
	<bewareOf: #openMarkerChanged>
	^self propertyValueAt: #openMarker ifAbsent:[CIconLibrary default at: #TreeOpenIcon].! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:57'!
openMarker: aValue
	"Modify the receiver's openMarker"
	^self propertyValueAt: #openMarker put: aValue with: #openMarkerChanged! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'bgf 12/24/2008 16:48'!
openSelectedMarker
	"Answer the openSelectedMarker of the receiver"
	<bewareOf: #openSelectedMarkerChanged>
	^self propertyValueAt: #openSelectedMarker
		  ifAbsent:[CIconLibrary default at: #TreeOpenSelectedIcon].! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'bgf 12/24/2008 16:47'!
openSelectedMarker: aValue
	"Modify the receiver's openSelectedMarker"
	^self propertyValueAt: #openSelectedMarker put: aValue with: #openSelectedMarkerChanged! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 12/10/2005 21:00'!
selectedColor
	"Answer the selectedColor of the receiver"
	<bewareOf: #selectedColorChanged>
	^self propertyValueAt: #selectedColor ifAbsent:[
		(container ifNil:[^CWidgetLibrary default selectionColor]) selectionColor]! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:51'!
selectedColor: aValue
	"Modify the receiver's selectedColor"
	^self propertyValueAt: #selectedColor put: aValue with: #selectedColorChanged! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:52'!
selectedTextColor
	"Answer the selectedTextColor of the receiver"
	<bewareOf: #selectedTextColorChanged>
	^self propertyValueAt: #selectedTextColor ifAbsent:[Color white]! !

!CTreeItemCostume methodsFor: 'accessing' stamp: 'ar 7/11/2005 14:51'!
selectedTextColor: aValue
	"Modify the receiver's selectedTextColor"
	^self propertyValueAt: #selectedTextColor put: aValue with: #selectedTextColorChanged! !

!CTreeItemCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 12:15'!
setupCostume
	super setupCostume.
	self clipping: false.
	self userDraw: true.
	self color: Color transparent.
	self hResizing: #spaceFill.
	self updateExtent.! !

!CTreeItemCostume methodsFor: 'events' stamp: 'bgf 1/7/2010 14:35'!
updateExtent
	| font offset icon w emph |
	font := player font ifNil:[TextStyle defaultFont].
	(emph := player emphasis) 
		ifNotNil:[font := font emphasized: emph].
	self height: (player heightForFont: font).
	offset := (player indentation + 1) * openMarker width.
	(icon := player icon) ifNotNil:[offset := offset + icon width].
	w := (font widthOfString: player label asString) + offset + 8.
	self clipping ifFalse:[self minWidth: w].! !

CWidgetCostume subclass: #CLabelCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text-Costumes'!

CLabelCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CLabelCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:10'!
cssTag
	"Answer the receiver's default css tag"
	^#label! !

!CLabelCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:01'!
defaultPlayer
	^CLabel! !

!CLabelCostume methodsFor: 'events' stamp: 'ar 5/24/2005 12:05'!
onFontChanged
	<on: fontChanged in: player>
	self player font ifNotNil:[self textFont: self player font].! !

!CLabelCostume methodsFor: 'events' stamp: 'ar 5/24/2005 12:08'!
onLabelChanged
	<on: labelChanged in: player>
	self value: self player label.! !

!CLabelCostume methodsFor: 'events' stamp: 'ar 3/8/2004 22:03'!
onPlayerChanged
	super onPlayerChanged.
	self onValueChanged.
	self onFontChanged.! !

!CLabelCostume methodsFor: 'events' stamp: 'ar 5/24/2005 12:08'!
onValueChanged
	<on: valueChanged>
	self text: value displayText asText copy.! !

!CLabelCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:51'!
setupCostume
	super setupCostume.
	self textEnabled: true.
	self color: Color transparent.
	self hResizing: #spaceFill.
	self vResizing: #shrinkWrap.
	self textAnchorPoint: #leftCenter.! !

CWidgetCostume subclass: #CMenuCostume
	instanceVariableNames: 'activeChild activeParent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Obsolete'!

CMenuCostume subclass: #CMenuBarCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Obsolete'!

CMenuBarCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CMenuBarCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:10'!
cssTag
	"Answer the receiver's default css tag"
	^#menubar! !

!CMenuBarCostume methodsFor: 'initialize' stamp: 'ar 7/11/2005 14:19'!
asMenuItemCostume: menuItem
	| item |
	item := menuItem costume.
	item subMenuIcon: (Form extent: 1@1).
	item checkMarkIcon: (Form extent: 1@1).
	item hResizing: #shrinkWrap.
	item roundCornerSpec: #(1 4).
	item layoutInset: 16@2.
	^item! !

!CMenuBarCostume methodsFor: 'events' stamp: 'ar 3/13/2004 17:55'!
isMenuBar
	^true! !

!CMenuBarCostume methodsFor: 'events' stamp: 'ar 3/13/2004 18:43'!
onMouseDown
	| item |
	item := self menuSelection ifNil:[^self].
	item subMenu ifNotNil:[^self showSubMenu: item].
! !

!CMenuBarCostume methodsFor: 'events' stamp: 'ar 6/3/2005 22:26'!
onMouseLeave
	<on: mouseLeave>
	self flag: #fixMe.
	"This test was added to experiment with mouseLeave handling"
	(self asPrimCostume isOrIn: hand mouseFocus)
		ifTrue:[self menuCursor: 0].! !

!CMenuBarCostume methodsFor: 'initialize' stamp: 'ar 10/31/2004 13:17'!
setupCostume
	"We want to use this menu as a menu bar.
	This implies a slightly different setup."
	super setupCostume.
	sticky := true.
	borderWidth := 0.
	holder layout
		listDirection: #leftToRight;
		wrapDirection: #none;
		listCentering: #topLeft.
	holder
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	self
		dropShadowEnabled: false;
		borderStyle: #none;
		roundCorners: false.! !

!CMenuBarCostume methodsFor: 'events' stamp: 'ar 3/13/2004 20:26'!
updateSelectionSubMenu: menuItem
	"Only show a new submenu if a previous one was showing"
	activeChild ifNil:[^self].
	super updateSelectionSubMenu: menuItem.! !

!CMenuBarCostume methodsFor: 'accessing' stamp: 'ar 4/4/2004 18:51'!
windowColor: aColor
	fillColors := {Color white. (Color white mixed: 0.5 with: aColor)}.
	borderWidth := 1.
	borderStyle := #simple.
	borderColor := aColor.! !

CMenuCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="activeChild" toSet="activeChild:">activeChild</field>
	<field instanceVariable="true" toGet="activeParent" toSet="activeParent:">activeParent</field>
	<field toGet="selectedPlayer" toSet="selectedPlayer:" changeEvent="selectedPlayerChanged">selectedPlayer</field>
	<field toGet="menuLabel" toSet="menuLabel:" changeEvent="menuLabelChanged">menuLabel</field>
	<field toGet="menuCursor" toSet="menuCursor:" changeEvent="menuCursorChanged">menuCursor</field>
	<field toGet="holder" toSet="holder:" changeEvent="holderChanged">holder</field>
	<field toGet="upButton" toSet="upButton:" changeEvent="upButtonChanged">upButton</field>
	<field toGet="downButton" toSet="downButton:" changeEvent="downButtonChanged">downButton</field>
	<field toGet="moreButton" toSet="moreButton:" changeEvent="moreButtonChanged">moreButton</field>
	<field toGet="menuSegments" toSet="menuSegments:" changeEvent="menuSegmentsChanged">menuSegments</field>
	<field toGet="thisSegment" toSet="thisSegment:" changeEvent="thisSegmentChanged">thisSegment</field>
	<field toGet="scrollMenu" toSet="scrollMenu:" changeEvent="scrollMenuChanged">scrollMenu</field>
</fields>'!

!CMenuCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:10'!
cssTag
	"Answer the receiver's default css tag"
	^#menu! !

!CMenuCostume class methodsFor: 'class initialization' stamp: 'ar 6/29/2005 21:05'!
initialize
	"CMenuCostume initialize"
	Preferences removePreference: #scrollLongMenus.! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/23/2004 20:29'!
activeChild
	^activeChild! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/23/2004 20:29'!
activeChild: aMenu
	activeChild := aMenu! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/23/2004 20:29'!
activeParent
	^activeParent! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/23/2004 20:29'!
activeParent: aMenu
	activeParent := aMenu! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/13/2004 20:08'!
activeParentMenu
	| menu |
	(self containsPoint: self cursorPoint) ifTrue:[^nil].
	menu := activeParent.
	[menu == nil] whileFalse:[
		(menu containsPoint: menu cursorPoint) 
			ifTrue:[^menu].
		menu := menu activeParent.
	].
	^nil! !

!CMenuCostume methodsFor: 'initialize' stamp: 'ar 7/7/2005 11:16'!
asMenuItemCostume: menuItem
	^menuItem costume! !

!CMenuCostume methodsFor: 'initialize' stamp: 'ar 12/18/2004 23:12'!
close
	activeParent ifNotNil:[
		activeParent activeChild: nil.
		activeParent sticky
			ifTrue:[activeParent menuSelection: nil]
			ifFalse:[activeParent close].
		activeParent := nil.
	].
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild close.
		activeChild := nil.
	].
	super close.! !

!CMenuCostume methodsFor: 'initialize' stamp: 'ar 5/6/2005 13:56'!
defaultPlayer
	^CMenu! !

!CMenuCostume methodsFor: 'initialize' stamp: 'ar 12/18/2004 23:14'!
destroy
	activeParent ifNotNil:[
		activeParent activeChild: nil.
		activeParent sticky
			ifTrue:[activeParent menuSelection: nil]
			ifFalse:[activeParent destroy].
		activeParent := nil.
	].
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild destroy.
		activeChild := nil.
	].
	super destroy.! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 01:23'!
downButton
	"Answer the downButton of the receiver"
	<bewareOf: #downButtonChanged>
	^self propertyValueAt: #downButton! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 01:23'!
downButton: aValue
	"Modify the receiver's downButton"
	^self propertyValueAt: #downButton put: aValue with: #downButtonChanged! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 7/7/2005 11:35'!
fireItem: item
	"Fire the selected menu item"
	item ifNil:[^self].

	(item == moreButton) ifTrue:[^self showMore].

	"see if item responds to #fire"
	(item action notNil or:[item handlesEvent: #fire]) ifFalse:[^self].

	"check for disabled items"
	item enabled ifFalse:[^self].

	item closeAfterFire ifTrue:[
		"don't keep mouse focus after firing"
		self hand releaseMouseFocus: self.
		self sticky ifFalse:[self close].
	].
	item fire.
! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 18:07'!
holder
	"Answer the holder of the receiver"
	<bewareOf: #holderChanged>
	^self propertyValueAt: #holder! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 18:07'!
holder: aValue
	"Modify the receiver's holder"
	^self propertyValueAt: #holder put: aValue with: #holderChanged! !

!CMenuCostume methodsFor: 'initialize' stamp: 'ar 7/7/2005 11:19'!
initialize
	super initialize.
	self define: #menuLabel as: CLabel new.
	self define: #upButton as: CPlayer new.
	self define: #downButton as: CPlayer new.
	self define: #moreButton as: CMenuItem new.
	self define: #holder as: CHolder new.
	self menuCursor: 0.
	moreButton label:'more...'.! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/13/2004 20:08'!
isMenuBar
	^false! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 21:02'!
itemHeight
	^self menuFont height + 8 max: 16! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:26'!
menuCursor
	"Answer the menuCursor of the receiver"
	<bewareOf: #menuCursorChanged>
	^self propertyValueAt: #menuCursor! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:27'!
menuCursor: aValue
	"Modify the receiver's menuCursor"
	| newCursor |
	newCursor := aValue min: self menuItems size max: 0.
	^self propertyValueAt: #menuCursor put: newCursor with: #menuCursorChanged! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 21:02'!
menuFont
	^player font ifNil:[TextStyle defaultFont]! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 18:08'!
menuItems
	^holder elements! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:26'!
menuLabel
	"Answer the menuLabel of the receiver"
	<bewareOf: #menuLabelChanged>
	^self propertyValueAt: #menuLabel! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:26'!
menuLabel: aValue
	"Modify the receiver's menuLabel"
	^self propertyValueAt: #menuLabel put: aValue with: #menuLabelChanged! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 03:10'!
menuSegments
	"Answer the menuSegments of the receiver"
	<bewareOf: #menuSegmentsChanged>
	^self propertyValueAt: #menuSegments! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 03:10'!
menuSegments: aValue
	"Modify the receiver's menuSegments"
	^self propertyValueAt: #menuSegments put: aValue with: #menuSegmentsChanged! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/23/2004 22:14'!
menuSelection
	menuCursor = 0 ifTrue:[^nil].
	^self menuItems at: menuCursor! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/23/2004 22:15'!
menuSelection: anObject
	self menuCursor: (self menuItems indexOf: anObject)
! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 02:53'!
moreButton
	"Answer the moreButton of the receiver"
	<bewareOf: #moreButtonChanged>
	^self propertyValueAt: #moreButton! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 02:53'!
moreButton: aValue
	"Modify the receiver's moreButton"
	^self propertyValueAt: #moreButton put: aValue with: #moreButtonChanged! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 2/28/2007 22:10'!
onKeyDown: event
	"React to a key event"
	| action max cc |
	<on: keyDown>
	action := CPlatform current standardEditingKeys lookupEvent: event.

	action == #escape ifTrue:[self sticky ifFalse:[^self close]]. "escape - close menu"
	action == #return ifTrue:[^self fireItem: self menuSelection].
	action == #accept ifTrue:[^self fireItem: self menuSelection].

	"Cursor key navigation"
	cc := self menuCursor.
	max := self menuItems size.
	max = 0 ifTrue:[^self].
	action == #moveLineStart ifTrue: [cc := 1].  "home"
	action == #moveLineEnd ifTrue: [cc := max].   "end"
	(action == #moveLineDown) ifTrue:[ "down"
		[cc := cc + 1. cc > max ifTrue:[cc := 1].
		(holder elements at: cc) isSeparator] whileTrue.
	].
	(action == #moveLineUp) ifTrue:[ "up"
		[cc := cc - 1. cc < 1 ifTrue:[cc := max].
		(holder elements at: cc) isSeparator] whileTrue.
	].
	self menuCursor: cc.! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/24/2004 18:40'!
onLabelChanged
	| aString |
	<on: labelChanged in: player>
	aString := player label.
	menuLabel visible: aString notNil.
	aString ifNotNil:[
		menuLabel value: aString asText.
	].! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/13/2004 22:38'!
onLabelDrag
	"Allow dragging this menu when we click in its label"
	<on: mouseDown in: menuLabel>
	self onDrag.
	self sticky ifFalse:[self hand mouseFocus: self].! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/13/2004 20:25'!
onMenuCursorChanged
	| selected |
	<on: menuCursorChanged>
	self sticky ifFalse:[self hand mouseFocus: self].
	selected := self selectedPlayer.
	selected ifNotNil:[selected deselect].
	selected := self menuSelection.
	selected ifNotNil:[selected select].
	self selectedPlayer: selected.
	self updateSelectionSubMenu: selected.! !

!CMenuCostume methodsFor: 'events' stamp: 'be 7/14/2005 11:07'!
onMenuItemsChanged
	<on: menuItemsChanged in: player>
	holder removeAll.
	player menuItems do:[:each|
		self asMenuItemCostume: each.
		holder add: each.
		each styleSheet: self styleSheet.
		each separator ifTrue:[holder add: CMenuItemSeparator new].
	].
	self onMenuCursorChanged.! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 12/18/2004 23:14'!
onMouseDown
	<on: mouseDown>
	"Check if the user clicked outside this menu"
	(self containsPoint: self cursorPoint) ifFalse:[
		self hand releaseMouseFocus: self.
		self sticky ifFalse:[^self close]. "bump me"
		^self].! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/24/2004 18:08'!
onMouseMove
	| item parent selected |
	<on: mouseMove>
	parent := self activeParentMenu.
	parent ifNotNil:[
		"Allow the parent to track the menu instead.
		If this results in a different selection, I will be closed."
		^parent onMouseMove].
	item := holder findPlayerAt: holder cursorPoint.
	item ifNotNil:[item isSeparator ifTrue:[item := nil]]. "ignore separators"
	item ifNil:[
		"Be careful before not to close open sub-menus"
		selected := self menuSelection.
		(selected notNil and:[selected subMenu notNil]) ifTrue:[^self].
	].
	self menuCursor: (holder elements indexOf: item).! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/14/2004 15:36'!
onMouseUp
	<on: mouseUp>
	self fireItem: self menuSelection.
	self sticky ifFalse:[self hand mouseFocus: self].! !

!CMenuCostume methodsFor: 'initialize' stamp: 'ar 6/29/2005 21:06'!
onOpen
	<on: opened>
	self sticky ifFalse:[self hand mouseFocus: self].
	self menuCursor: 0.! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/24/2004 18:11'!
onPlayerChanged
	super onPlayerChanged.
	self onMenuItemsChanged.
	self onLabelChanged.
	self menuCursor: 0.
	self selectedPlayer: nil.! !

!CMenuCostume methodsFor: 'scroll menu' stamp: 'ar 2/7/2005 02:50'!
onScrollDownEnter
	"Scroll up"
	| scrollScript |
	<on: mouseEnter in: downButton>
	downButton textColor: Color white.
	scrollScript := self startScript:[self scrollDown].
	downButton waitUntil: #mouseLeave.
	self stopScript: scrollScript.
	downButton textColor: Color black.
! !

!CMenuCostume methodsFor: 'scroll menu' stamp: 'ar 2/7/2005 02:50'!
onScrollUpEnter
	"Scroll up"
	| scrollScript |
	<on: mouseEnter in: upButton>
	upButton textColor: Color white.
	scrollScript := self startScript:[self scrollUp].
	upButton waitUntil: #mouseLeave.
	self stopScript: scrollScript.
	upButton textColor: Color black.
! !

!CMenuCostume methodsFor: 'styling' stamp: 'be 7/14/2005 11:09'!
onStyleSheetChanged

	holder do:[:each | each styleSheet: self styleSheet].
	super onStyleSheetChanged
! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/14/2004 15:37'!
onYellowButtonDown
	"Treat yellow equivalent to red since context menus are popped up that way"
	<on: yellowButtonDown>
	^self onMouseDown! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 3/14/2004 15:37'!
onYellowButtonUp
	"Treat yellow equivalent to red since context menus are popped up that way"
	<on: yellowButtonUp>
	^self onMouseUp! !

!CMenuCostume methodsFor: 'scroll menu' stamp: 'ar 2/7/2005 02:50'!
scrollDown
	| idx topPlayer yScroll |
	[true] whileTrue:[
		topPlayer := holder findPlayerAt: holder scrollOffset + 5.
		idx := holder elements indexOf: topPlayer.
		(topPlayer notNil and:[topPlayer isSeparator]) ifTrue:[idx := idx+1].
		(idx between: 1 and: holder size-1) ifTrue:[
			yScroll := (holder elements at: idx+1) top.
			holder scrollArea height > holder visibleScrollArea bottom
				ifTrue:[holder scrollOffset: 0@yScroll].

		].
		(Delay forMilliseconds: 20) wait.
		self waitTick.
	].
! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 03:20'!
scrollMenu
	"Answer the scrollMenu of the receiver"
	<bewareOf: #scrollMenuChanged>
	^self propertyValueAt: #scrollMenu! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 03:20'!
scrollMenu: aValue
	"Modify the receiver's scrollMenu"
	^self propertyValueAt: #scrollMenu put: aValue with: #scrollMenuChanged! !

!CMenuCostume methodsFor: 'scroll menu' stamp: 'ar 2/7/2005 02:50'!
scrollUp
	| idx topPlayer yScroll |
	[true] whileTrue:[
		topPlayer := holder findPlayerAt: holder scrollOffset + 5.
		idx := holder elements indexOf: topPlayer.
		idx > 1 ifTrue:[
			idx := idx - 1.
			topPlayer := holder elements at: idx.
			(topPlayer isSeparator) ifTrue:[idx := idx-1].
			(idx between: 2 and: holder size) ifTrue:[
				yScroll := (holder elements at: idx) top.
				holder scrollOffset: 0@(yScroll max: 0).
			].
		].
		(Delay forMilliseconds: 20) wait.
		self waitTick.
	].
! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 20:11'!
selectedPlayer
	"Answer the selectedPlayer of the receiver"
	<bewareOf: #selectedPlayerChanged>
	^self propertyValueAt: #selectedPlayer! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 20:11'!
selectedPlayer: aValue
	"Modify the receiver's selectedPlayer"
	^self propertyValueAt: #selectedPlayer put: aValue with: #selectedPlayerChanged! !

!CMenuCostume methodsFor: 'initialize' stamp: 'ar 8/18/2005 22:45'!
setupCostume
	| btnColor |
	super setupCostume.

	menuLabel clipping: false.
	menuLabel fillStyle: #verticalGradient.
	menuLabel fillColors: CWidgetLibrary default gradientColors.
	menuLabel fillAlpha: 1.0.
	menuLabel textAnchorPoint: #center.
	menuLabel textInset: 3.
	menuLabel textEmphasis: 1.
	menuLabel textColor: CWidgetLibrary default menuLabelTextColor.
	menuLabel roundCornerSpec: #(1 4).
	self add: menuLabel.

	btnColor := CWidgetLibrary default frameColor mixed: 0.5 with: CWidgetLibrary default paneColor.
	upButton text: 'u'; font: (TextStyle named:'WindowFont') defaultFont.
	upButton hResizing: #rigid; vResizing: #shrinkWrap.
	upButton color: btnColor.
	upButton visible: false.
	self add: upButton.

	holder hResizing: #spaceFill; vResizing: #shrinkWrap.
	holder clipping: false.
	holder layout: CTableLayout new.
	holder layout cellPositioning: #topLeft.
	holder layout layoutInset: 3.
	self add: holder.

	downButton text: 'd'; font: (TextStyle named:'WindowFont') defaultFont.
	downButton hResizing: #rigid; vResizing: #shrinkWrap.
	downButton visible: false.
	downButton color: btnColor.
	self add: downButton.

	self layout: CTableLayout new.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.
	self floating: true.
	self fillStyle: #verticalGradient.
 	self fillColors: CWidgetLibrary default menuColors.
	self dropShadowEnabled: true.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self roundCorners: true.
	self clipping: false.
	self width: 100.! !

!CMenuCostume methodsFor: 'more menu' stamp: 'ar 2/7/2005 03:16'!
setupMoreMenu: maxHeight
	| maxY ht segment |
	holder clipping: true.
	segment := #().
	menuSegments := #().
	maxY := 0.
	holder elements do:[:item|
		ht := item height.
		maxY + ht > maxHeight ifTrue:[
			"start new segments"
			menuSegments := menuSegments copyWith: segment.
			segment := Array with: item.
			maxY := ht.
		] ifFalse:[
			"item fits in this segment"
			segment := segment copyWith: item.
			maxY := maxY + ht.
		].
	].
	segment size > 0 ifTrue:[menuSegments := menuSegments copyWith: segment].
	thisSegment := 0.
	self showMore.
! !

!CMenuCostume methodsFor: 'scroll menu' stamp: 'ar 2/7/2005 02:53'!
setupScrollMenu: maxHeight
	| w |
	upButton visible: true; width: holder width.
	downButton visible: true; width: holder width.
	holder clipping: true.
	holder hResizing: #rigid; vResizing: #rigid.
	holder elements do:[:each| each bottom < maxHeight ifTrue:[w := each bottom]].
	holder height: w.! !

!CMenuCostume methodsFor: 'more menu' stamp: 'ar 2/7/2005 03:18'!
showMore
	"Show more items"
	| segment |
	(thisSegment := thisSegment + 1) > menuSegments size ifTrue:[thisSegment := 1].
	thisSegment = menuSegments size 
		ifTrue:[moreButton label: 'start over...']
		ifFalse:[moreButton label: 'more...'].	
	segment := menuSegments at: thisSegment.
	holder elements: segment.
	holder addFirst: CMenuItemSeparator new.
	holder addFirst: moreButton.
! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 6/29/2005 19:45'!
showSubMenu: item
	| pos |
	item enabled ifFalse:[^self].
	self isMenuBar
		ifTrue:[pos := item localBounds bottomLeft - (6@0)]
		ifFalse:[pos := item localBounds topRight + (2@0)].
	activeChild := item subMenu costume.
	self activeChild activeParent: self.
	self activeChild menuSelection: nil.
"	self activeChild fill: self fill."
	self activeChild transform: item localToWorld.
	self activeChild topLeft: (item localToWorld: pos).
	self world add: self activeChild.
	self activeChild beOnScreen.! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 03:13'!
thisSegment
	"Answer the thisSegment of the receiver"
	<bewareOf: #thisSegmentChanged>
	^self propertyValueAt: #thisSegment! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 03:13'!
thisSegment: aValue
	"Modify the receiver's thisSegment"
	^self propertyValueAt: #thisSegment put: aValue with: #thisSegmentChanged! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 01:23'!
upButton
	"Answer the upButton of the receiver"
	<bewareOf: #upButtonChanged>
	^self propertyValueAt: #upButton! !

!CMenuCostume methodsFor: 'accessing' stamp: 'ar 2/7/2005 01:23'!
upButton: aValue
	"Modify the receiver's upButton"
	^self propertyValueAt: #upButton put: aValue with: #upButtonChanged! !

!CMenuCostume methodsFor: 'events' stamp: 'ar 5/24/2005 15:05'!
updateSelectionSubMenu: menuItem
	"Update any child menus after menuItem was selected"
	activeChild ifNotNil:[
		"Close old child"
		activeChild activeParent: nil.
		activeChild menuCursor: 0.
		activeChild close.
		activeChild := nil.
	].
	"Show new submenu if present"
	(menuItem isNil or:[menuItem subMenu isNil]) ifTrue:[^self].
	self showSubMenu: menuItem.! !

CWidgetCostume subclass: #CMenuCostume2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus-Costumes'!

CMenuCostume2 subclass: #CMenuBarCostume2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Menus-Costumes'!

CMenuBarCostume2 defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CMenuBarCostume2 class methodsFor: 'styling' stamp: 'ar 8/18/2005 23:26'!
cssTag
	"Answer the receiver's default css tag"
	^#menubar! !

!CMenuBarCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 23:26'!
isMenuBar
	^true! !

!CMenuBarCostume2 methodsFor: 'events' stamp: 'bgf 8/25/2007 13:52'!
onFontChanged
	<on: fontChanged in: player>
	"This updates geometry after a new font is installed with installFont;
	 we lay out the bar height and spacing based on bar's font."
	self onMenuItemsChanged.! !

!CMenuBarCostume2 methodsFor: 'layout' stamp: 'ar 8/18/2005 23:35'!
onHolderLayoutChanged
	"Layout the items in the holder"
	| x y max sz inset |
	inset := holder layoutInset asPoint.
	x := y := max := 0.
	holder elements do:[:each|
		each topLeft: (x@y) + inset.
		sz := each extent.
		max := max max: sz y.
		x := x + sz x.
	].
	sz := (x@max) + (inset*2).
	sz y > holder height ifTrue:[
		holder elements do:[:each| each height: max].
		holder height: sz y.
	].
	holder width: sz x.! !

!CMenuBarCostume2 methodsFor: 'layout' stamp: 'ar 8/18/2005 23:50'!
onLayoutChanged
	"Layout the items in the holder"
	| inset sz |
	<on: layoutChanged>
	inset := borderWidth asPoint + self layoutInset asPoint.
	holder topLeft: inset.
	sz := holder bottomRight + inset.
	self hResizing == #shrinkWrap
		ifTrue:[self width: sz x].
	self vResizing == #shrinkWrap
		ifTrue:[self height: sz y].! !

!CMenuBarCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 23:44'!
onMenuCursorChanged
	| menuItem activate |
	<on: cursorChanged in: menuItems>
	self sticky ifFalse:[self hand mouseFocus: self].
	activate := false.
	"Close old child menu"
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild menuCursor: 0.
		activeChild close.
		activeChild := nil.
		activate := true.
	].
	"Deselect old and select new index"
	self deselectIndex: self selectionIndex.
	self selectionIndex: self menuCursor.
	self selectIndex: self selectionIndex.

	"Show new submenu"
	menuItem := self menuSelection.
	menuItem ifNil:[^self].
	menuItem subMenu ifNil:[^self].
	menuItem disabled ifTrue:[^self].
	activate ifTrue:[self showSubMenu].
! !

!CMenuBarCostume2 methodsFor: 'events' stamp: 'bgf 6/24/2009 22:39'!
onMenuItemsChanged
	| item |
	super onMenuItemsChanged.
	menuItems do:[:each|
		item := each costume.
		item subMenuIcon: (Form extent: 1@1 depth: 8).
		item checkMarkIcon: (Form extent: 1@1 depth: 8).
		"Base overall layout constraints on my player font, which usually matches
 		 all the item fonts.  (The item fonts may not have propagated at time of calling.)"
		item extraWidth: (player font pointSize * 2) rounded.
		item minHeight: (player font pointSize * 2 + 3).
		item hResizing: #shrinkWrap.
		"item roundCornerSpec: #(1 4)."
	].! !

!CMenuBarCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 23:45'!
onMouseDown
	| item |
	item := self menuSelection ifNil:[^self].
	item subMenu ifNotNil:[^self showSubMenu].
! !

!CMenuBarCostume2 methodsFor: 'initialize' stamp: 'bgf 9/13/2008 18:28'!
setupCostume
	"We want to use this menu as a menu bar.
	This implies a slightly different setup."
	super setupCostume.
	sticky := true.
	self layoutInset: 0@0.
	holder
		layoutInset: 5@0;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	self
		dropShadowEnabled: false;
		fillStyle: #verticalGradient;
		fillColors: CWidgetLibrary default menuColors;
		borderWidth: 1;
		borderStyle: #simple;
		roundCorners: false.
! !

!CMenuBarCostume2 methodsFor: 'initialize' stamp: 'ar 8/18/2005 23:29'!
setupMenuLabel
	"ignore"! !

!CMenuBarCostume2 methodsFor: 'events' stamp: 'bgf 9/13/2008 17:43'!
showSubMenu
	| pos rect item |
	item := self menuSelection.
	rect := item bounds.
	self isMenuBar 
		ifTrue:[pos := rect bottomLeft]
		ifFalse:[pos := rect topRight + (2@-2)].
	activeChild := item subMenu costume.
	activeChild activeParent: self.
	activeChild menuCursor: 0.
	self player passFillToSubMenus ifTrue: [ activeChild fill: self fill ].
	activeChild transform: holder localToWorld.
	activeChild topLeft: (holder localToWorld: pos).
	self world add: activeChild.! !

!CMenuBarCostume2 methodsFor: 'accessing' stamp: 'bgf 9/13/2008 17:57'!
windowColor: aColor
	false ifTrue: [
		"Predates custom fill in MBC2"
		fillColors := {Color white. (Color white mixed: 0.5 with: aColor)}.
	].
	borderWidth := 1.
	borderStyle := #simple.
! !

CMenuCostume2 defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="activeChild" toSet="activeChild:" changeEvent="activeChildChanged">activeChild</field>
	<field toGet="activeParent" toSet="activeParent:" changeEvent="activeParentChanged">activeParent</field>
	<field toGet="menuItems" toSet="menuItems:" changeEvent="menuItemsChanged">menuItems</field>
	<field toGet="menuLabel" toSet="menuLabel:" changeEvent="menuLabelChanged">menuLabel</field>
	<field toGet="holder" toSet="holder:" changeEvent="holderChanged">holder</field>
	<field toGet="selectionIndex" toSet="selectionIndex:" changeEvent="selectionIndexChanged">selectionIndex</field>
</fields>'!

!CMenuCostume2 class methodsFor: 'styling' stamp: 'ar 8/18/2005 21:20'!
cssTag
	"Answer the receiver's default css tag"
	^#menu! !

!CMenuCostume2 class methodsFor: 'class initialization' stamp: 'ar 8/18/2005 21:20'!
initialize
	"CMenuCostume initialize"
	Preferences removePreference: #scrollLongMenus.! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:32'!
activeChild
	"Answer the activeChild of the receiver"
	<bewareOf: #activeChildChanged>
	^self propertyValueAt: #activeChild! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:32'!
activeChild: aValue
	"Modify the receiver's activeChild"
	^self propertyValueAt: #activeChild put: aValue with: #activeChildChanged! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:32'!
activeParent
	"Answer the activeParent of the receiver"
	<bewareOf: #activeParentChanged>
	^self propertyValueAt: #activeParent! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:32'!
activeParent: aValue
	"Modify the receiver's activeParent"
	^self propertyValueAt: #activeParent put: aValue with: #activeParentChanged! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 21:20'!
activeParentMenu
	| menu |
	(self containsPoint: self cursorPoint) ifTrue:[^nil].
	menu := activeParent.
	[menu == nil] whileFalse:[
		(menu containsPoint: menu cursorPoint) 
			ifTrue:[^menu].
		menu := menu activeParent.
	].
	^nil! !

!CMenuCostume2 methodsFor: 'initialize' stamp: 'ar 8/18/2005 21:20'!
close
	activeParent ifNotNil:[
		activeParent activeChild: nil.
		activeParent sticky
			ifTrue:[activeParent menuSelection: nil]
			ifFalse:[activeParent close].
		activeParent := nil.
	].
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild close.
		activeChild := nil.
	].
	super close.! !

!CMenuCostume2 methodsFor: 'initialize' stamp: 'ar 8/18/2005 21:20'!
defaultPlayer
	^CMenu! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/7/2006 14:37'!
deselectIndex: index
	(index between: 1 and: menuItems size) ifTrue:[(menuItems at: index) deselect]! !

!CMenuCostume2 methodsFor: 'initialize' stamp: 'ar 8/18/2005 21:20'!
destroy
	activeParent ifNotNil:[
		activeParent activeChild: nil.
		activeParent sticky
			ifTrue:[activeParent menuSelection: nil]
			ifFalse:[activeParent destroy].
		activeParent := nil.
	].
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild destroy.
		activeChild := nil.
	].
	super destroy.! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 22:15'!
fireItem: item
	"Fire the selected menu item"
	item ifNil:[^self].

	"see if item responds to #fire"
	(item action notNil or:[item handlesEvent: #fire]) ifFalse:[^self].

	"check for disabled items"
	item enabled ifFalse:[^self].

	item closeAfterFire ifTrue:[
		"don't keep mouse focus after firing"
		self hand releaseMouseFocus: self.
		self sticky ifFalse:[self close].
	].
	item fire.
! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 22:15'!
hideSubMenu
	self wait: 0.25.
	self close.! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:32'!
holder
	"Answer the holder of the receiver"
	<bewareOf: #holderChanged>
	^self propertyValueAt: #holder! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:32'!
holder: aValue
	"Modify the receiver's holder"
	^self propertyValueAt: #holder put: aValue with: #holderChanged! !

!CMenuCostume2 methodsFor: 'initialize' stamp: 'ar 8/18/2005 22:44'!
initialize
	super initialize.
	self define: #holder as: CHolder new.
	selectionIndex := 0.! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 21:20'!
isMenuBar
	^false! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'bgf 6/26/2009 11:59'!
itemHeight
	^self menuFont height + 6 max: 14! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:40'!
menuCursor
	^self menuItems cursor! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:40'!
menuCursor: aNumber
	^self menuItems cursor: aNumber! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'bgf 8/25/2008 09:59'!
menuFont
	^player font ifNil:[CWidgetLibrary default menuFont]! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:48'!
menuItems
	"Answer the menuItems of the receiver"
	<bewareOf: #menuItemsChanged>
	^self propertyValueAt: #menuItems! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:48'!
menuItems: aValue
	"Modify the receiver's menuItems"
	^self propertyValueAt: #menuItems put: aValue with: #menuItemsChanged! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:32'!
menuLabel
	"Answer the menuLabel of the receiver"
	<bewareOf: #menuLabelChanged>
	^self propertyValueAt: #menuLabel! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:32'!
menuLabel: aValue
	"Modify the receiver's menuLabel"
	^self propertyValueAt: #menuLabel put: aValue with: #menuLabelChanged! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:43'!
menuSelection
	^self menuItems selection! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 21:20'!
menuSelection: anObject
	self menuCursor: (self menuItems indexOf: anObject)
! !

!CMenuCostume2 methodsFor: 'layout' stamp: 'ar 5/18/2007 10:13'!
onHolderLayoutChanged
	"Layout the items in the holder"
	| x y max sz inset |
	<on: layoutChanged in: holder>
	inset := holder layoutInset asPoint.
	x := y := 0.
	max := holder width - (inset x * 2).
	holder elements do:[:each|
		each topLeft: (x@y) + inset.
		sz := each preferredExtent.
		max := max max: sz x.
		y := y + sz y.
	].
	sz := (max@y) + (inset*2).
	holder elements do:[:each| each width: max].
	holder width: sz x.
	holder height: sz y.! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 4/25/2007 11:11'!
onKeyDown: event
	"React to a key event"
	| action max cc |
	<on: keyDown>
	action := CPlatform current standardEditingKeys lookupEvent: event.

	action == #escape ifTrue:[self sticky ifFalse:[^self close]]. "escape - close menu"
	action == #return ifTrue:[^self fireItem: self menuSelection].
	action == #accept ifTrue:[^self fireItem: self menuSelection].

	"Cursor key navigation"
	cc := self menuCursor.
	max := self menuItems size.
	max = 0 ifTrue:[^self].
	action == #moveLineStart ifTrue: [cc := 1].  "home"
	action == #moveLineEnd ifTrue: [cc := max].   "end"
	(action == #moveLineDown) ifTrue:[ "down"
		cc := cc + 1. cc > max ifTrue:[cc := 1].
	].
	(action == #moveLineUp) ifTrue:[ "up"
		cc := cc - 1. cc < 1 ifTrue:[cc := max].
	].
	self menuCursor: cc.! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 23:06'!
onLabelChanged
	| aString |
	<on: labelChanged in: player>
	menuLabel ifNotNil:[
		menuLabel close.
		menuLabel destroy.
		menuLabel := nil.
	].
	aString := player label.
	aString ifNil:[^nil].
	self define: #menuLabel as: CLabel new.
	menuLabel value: aString asText.
	self setupMenuLabel.
! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 21:20'!
onLabelDrag
	"Allow dragging this menu when we click in its label"
	<on: mouseDown in: menuLabel>
	self onDrag.
	self sticky ifFalse:[self hand mouseFocus: self].! !

!CMenuCostume2 methodsFor: 'layout' stamp: 'ar 12/6/2005 15:40'!
onLayoutChanged
	"Layout the items in the holder"
	| x y max sz inset |
	<on: layoutChanged>
	inset := self layoutInset asPoint + borderWidth asPoint.
	x := y := 0.
	max := self width - (inset x * 2).
	max := max max: holder width.
	menuLabel ifNotNil:[
		menuLabel topLeft: (x@y) + inset.
		y := y + menuLabel height.
		max := max max: menuLabel preferredWidth.
		menuLabel width: max.
	].
	holder topLeft: (x@y) + inset.
	holder width: max.
	sz := holder bottomRight + inset.
	self hResizing == #shrinkWrap
		ifTrue:[self width: sz x].
	self vResizing == #shrinkWrap
		ifTrue:[self height: sz y].
	self sticky ifFalse:[self beOnScreen]. ! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 6/28/2006 13:00'!
onMenuCursorChanged
	| menuItem |
	<on: cursorChanged in: menuItems>
	self stopScript: #showSubMenu.
	(self isOpen and:[self sticky not]) ifTrue:[self hand mouseFocus: self].
	"Close old child menu"
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild menuCursor: 0.
		activeChild startScript: #hideSubMenu.
		activeChild := nil.
	].
	"Deselect old and select new index"
	self deselectIndex: self selectionIndex.
	self selectionIndex: self menuCursor.
	self selectIndex: self selectionIndex.

	"Show new submenu"
	menuItem := self menuSelection.
	menuItem ifNil:[^self].
	menuItem subMenu ifNil:[^self].
	menuItem disabled ifTrue:[^self].
	self startScript: #showSubMenu.
! !

!CMenuCostume2 methodsFor: 'events' stamp: 'bgf 8/25/2007 20:22'!
onMenuItemsChanged
	<on: menuItemsChanged in: player>
	menuItems := player menuItems.
	holder removeAll.
	holder width: 100.
	menuItems do:[:each|
		holder add: each.
		each styleSheet: self styleSheet.
		each separator ifTrue:[holder add: CMenuItemSeparator new].
	].
	self onMenuCursorChanged.! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/4/2006 17:51'!
onMouseDown
	<on: mouseDown>
	"Check if the user clicked outside this menu or its parent"
	((self containsPoint: self cursorPoint) or:[self activeParentMenu notNil]) ifFalse:[
		self hand releaseMouseFocus: self.
		self sticky ifFalse:[^self close]. "bump me"
		^self].! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/28/2006 17:56'!
onMouseLeave
	"Deselect if and only if we're in a menu bar with no active subMenu"
	<on: mouseLeave>
	(self isMenuBar and:[activeChild == nil]) ifTrue:[self menuCursor: 0].! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/19/2005 09:49'!
onMouseMove
	| item parent selected |
	<on: mouseMove>
	parent := self activeParentMenu.
	parent ifNotNil:[
		"Allow the parent to track the menu instead.
		If this results in a different selection, I will be closed."
		^parent onMouseMove].
	item := holder findPlayerAt: holder cursorPoint.
	item ifNotNil:[item isSeparator ifTrue:[item := nil]]. "ignore separators"
	item ifNil:[
		"Be careful before not to close open sub-menus"
		selected := self menuSelection.
		(selected notNil and:[selected subMenu notNil]) ifTrue:[^self].
		^self menuCursor: 0].
	self menuCursor: (menuItems indexOf: item player).! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 21:20'!
onMouseUp
	<on: mouseUp>
	self fireItem: self menuSelection.
	self sticky ifFalse:[self hand mouseFocus: self].! !

!CMenuCostume2 methodsFor: 'initialize' stamp: 'bgf 5/19/2010 14:08'!
onOpen
	<on: open>
	self sticky ifFalse:[
		self beOnScreen.
		self hand mouseFocus: self].
	self menuCursor: 0.
	self isMenuBar ifFalse: [
		self roundCornerSpec: (
			activeParent 
				ifNil: [ #(1 2 3 4) ]
				ifNotNil: [ activeParent isMenuBar ifTrue: [ #(2 3) ] ifFalse: [ #(2 3 4 ) ] ]).
		].! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 22:20'!
onPlayerChanged
	super onPlayerChanged.
	self onMenuItemsChanged.
	self onLabelChanged.! !

!CMenuCostume2 methodsFor: 'styling' stamp: 'be 9/2/2005 14:02'!
onStyleSheetChanged

	holder do:[:each | each styleSheet: self styleSheet].
	super onStyleSheetChanged
! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 21:20'!
onYellowButtonDown
	"Treat yellow equivalent to red since context menus are popped up that way"
	<on: yellowButtonDown>
	^self onMouseDown! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 21:20'!
onYellowButtonUp
	"Treat yellow equivalent to red since context menus are popped up that way"
	<on: yellowButtonUp>
	^self onMouseUp! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/7/2006 14:38'!
selectIndex: index
	(index between: 1 and: menuItems size) ifTrue:[(menuItems at: index) select]! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:27'!
selectionIndex
	"Answer the selectionIndex of the receiver"
	<bewareOf: #selectionIndexChanged>
	^self propertyValueAt: #selectionIndex! !

!CMenuCostume2 methodsFor: 'accessing' stamp: 'ar 8/18/2005 22:27'!
selectionIndex: aValue
	"Modify the receiver's selectionIndex"
	^self propertyValueAt: #selectionIndex put: aValue with: #selectionIndexChanged! !

!CMenuCostume2 methodsFor: 'initialize' stamp: 'bgf 5/19/2010 13:54'!
setupCostume
	super setupCostume.

	menuLabel ifNotNil:[self setupMenuLabel].

	holder clipping: true.
	holder layoutInset: 0@5.	 " For visual margin top and bottom. "
	self add: holder.

	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self floating: true.
 	self color: (CWidgetLibrary default menuColor).
	self dropShadowEnabled: true.
	dropShadow direction: (1@(dropShadow offset -3)).	"Stay off the menu bar!!"
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default menuFrameColor.

	self clipping: false.! !

!CMenuCostume2 methodsFor: 'initialize' stamp: 'ar 8/18/2005 23:20'!
setupMenuLabel
	menuLabel clipping: false.
	menuLabel color: CWidgetLibrary default menuLabelColor.
	menuLabel textColor: CWidgetLibrary default menuLabelTextColor.

	"menuLabel fillStyle: #verticalGradient.
	menuLabel fillColors: CWidgetLibrary default gradientColors.
	menuLabel fillAlpha: 1.0.
	menuLabel textColor: CWidgetLibrary default menuLabelTextColor."

	menuLabel textAnchorPoint: #center.
	menuLabel textInset: 3.
	menuLabel textEmphasis: 1.
	menuLabel roundCornerSpec: #(1 4).
	self addFirst: menuLabel.
! !

!CMenuCostume2 methodsFor: 'events' stamp: 'bgf 8/25/2007 00:18'!
showSubMenu
	| pos rect item |
	self wait: 0.25. "sec - might get terminated here if user moves quickly through"
	self world ifNil:[^nil]. "might be removed due to programmatic changes"
	item := self menuSelection.
	item subMenu ifNil:[^nil]. "selection changed in .25 secs above"
	rect := item bounds.
	self isMenuBar 
		ifTrue:[pos := rect bottomLeft]
		ifFalse:[pos := rect topRight + (-2@2)].
	activeChild := item subMenu costume.
	activeChild activeParent: self.
	activeChild menuCursor: 0.
	activeChild fill: self fill.
	activeChild transform: holder localToWorld.
	activeChild topLeft: (holder localToWorld: pos).
	self world add: activeChild.! !

!CMenuCostume2 methodsFor: 'events' stamp: 'ar 8/18/2005 22:22'!
windowColor: aColor
	super windowColor: aColor.
	selectionColor := aColor.! !

CWidgetCostume subclass: #CPopUpListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

CPopUpListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="button" toSet="button:" changeEvent="buttonChanged">button</field>
	<field toGet="menu" toSet="menu:" changeEvent="menuChanged">menu</field>
</fields>'!

!CPopUpListCostume methodsFor: 'accessing' stamp: 'jl 5/23/2005 15:48'!
button
	"Answer the button of the receiver"
	<bewareOf: #buttonChanged>
	^self propertyValueAt: #button! !

!CPopUpListCostume methodsFor: 'accessing' stamp: 'jl 5/23/2005 15:48'!
button: aValue
	"Modify the receiver's button"
	^self propertyValueAt: #button put: aValue with: #buttonChanged! !

!CPopUpListCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 12:29'!
defaultPlayer
	^CPopUpList! !

!CPopUpListCostume methodsFor: 'accessing' stamp: 'ar 12/10/2005 20:52'!
hResizing: aSymbol
	costume hResizing: aSymbol.
	label hResizing: aSymbol.
	! !

!CPopUpListCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 12:57'!
initialize
	super initialize.
	self define: #label as: CLabel new.
	self define: #button as: CPlayer new.
	label value: ' '.! !

!CPopUpListCostume methodsFor: 'accessing' stamp: 'jl 5/23/2005 13:46'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CPopUpListCostume methodsFor: 'accessing' stamp: 'jl 5/23/2005 13:46'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CPopUpListCostume methodsFor: 'accessing' stamp: 'jl 5/24/2005 14:09'!
menu
	"Answer the menu of the receiver"
	<bewareOf: #menuChanged>
	^self propertyValueAt: #menu! !

!CPopUpListCostume methodsFor: 'accessing' stamp: 'jl 5/24/2005 14:09'!
menu: aValue
	"Modify the receiver's menu"
	^self propertyValueAt: #menu put: aValue with: #menuChanged! !

!CPopUpListCostume methodsFor: 'events' stamp: 'jl 5/24/2005 15:04'!
onItemMakerChanged
	<on: itemMakerChanged in: player>
	self updateMenu.! !

!CPopUpListCostume methodsFor: 'events' stamp: 'jl 5/24/2005 14:46'!
onItemsChanged
	<on: itemsChanged in: player>
	self updateMenu.
! !

!CPopUpListCostume methodsFor: 'events' stamp: 'jl 5/24/2005 14:46'!
onItemsContentChanged
	<on: itemsContentChanged in: player>
	self updateMenu.
! !

!CPopUpListCostume methodsFor: 'events' stamp: 'ar 5/24/2005 12:14'!
onMouseDown
	<on: mouseDown>
	"menu clipping: true."	"@@@: uncomment this to clip menu if too wide"
	menu width: self width.
	menu openItemCenteredAt: (self localToGlobal: 0@0).! !

!CPopUpListCostume methodsFor: 'events' stamp: 'jl 5/24/2005 14:11'!
onPlayerChanged
	super onPlayerChanged.
	self onValueChanged.
	self updateMenu.! !

!CPopUpListCostume methodsFor: 'events' stamp: 'jl 5/24/2005 15:34'!
onValueChanged
	<on: valueChanged>
	label value := player value ifNil: [ ' ' ].
	! !

!CPopUpListCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 13:07'!
setupCostume
	"Initial tweaks - need to go away"
	super setupCostume.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self extent: 100@5.

	self layout: CTableLayout new.
	self layout listDirection: #leftToRight.
	self vResizing: #shrinkWrap.

	self add: label.
	label borderColor: Color transparent.

	self add: button.
	button height: 5.
	button fillStyle: #verticalGradient.
	button fillColors: {Color white. CWidgetLibrary default baseColor}.
	button text: 'w'.
	button textFont: (TextStyle named:'WindowFont') defaultFont.
	button hResizing: #rigid; vResizing: #spaceFill; width: 16.
! !

!CPopUpListCostume methodsFor: 'menu' stamp: 'ar 8/27/2005 19:41'!
updateMenu
	menu := CListMenu from: player items.
	menu hResizing: #spaceFill.
	menu itemMaker: player itemMaker.
! !

!CPopUpListCostume methodsFor: 'accessing' stamp: 'ar 12/10/2005 20:52'!
vResizing: aSymbol
	costume vResizing: aSymbol.
	label vResizing: aSymbol.! !

CWidgetCostume subclass: #CPopUpMenuCostume
	instanceVariableNames: 'activeChild activeParent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Obsolete'!

!CPopUpMenuCostume commentStamp: '<historical>' prior: 0!
I am made specifically for pop up menus. For efficiency, I use custom drawing operations.!

CPopUpMenuCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="activeChild" toSet="activeChild:">activeChild</field>
	<field instanceVariable="true" toGet="activeParent" toSet="activeParent:">activeParent</field>
	<field toGet="menuLabel" toSet="menuLabel:" changeEvent="menuLabelChanged">menuLabel</field>
	<field toGet="itemArea" toSet="itemArea:" changeEvent="itemAreaChanged">itemArea</field>
	<field toGet="selectionIndex" toSet="selectionIndex:" changeEvent="selectionIndexChanged">selectionIndex</field>
	<field toGet="menuItems" toSet="menuItems:" changeEvent="menuItemsChanged">menuItems</field>
</fields>'!

!CPopUpMenuCostume class methodsFor: 'examples' stamp: 'ar 6/28/2005 22:38'!
testMenu
	| menu max |
	menu := CMenu new.
	max := 10.
	menu add: 'Item 1' target: CDialog action: #inform: argument: 'You selected the first item'.
	2 to: max-1 do:[:i|
		menu add: 'Item ',i
			 target: CDialog 
			action: #inform: 
			argument: 'Item ', i,' was selected'].
	menu add: 'Item ', max target: CDialog action: #inform: argument: 'The last item was selected'.
	menu costume: CPopUpMenuCostume.
	menu label: 'Please choose the item'.
	^menu! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/28/2005 22:48'!
activeChild
	"Answer the activeChild of the receiver"
	^activeChild! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/28/2005 22:48'!
activeChild: aValue
	"Modify the receiver's activeChild"
	activeChild := aValue! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/28/2005 22:48'!
activeParent
	"Answer the activeParent of the receiver"
	^activeParent! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/28/2005 22:48'!
activeParent: aValue
	"Modify the receiver's activeParent"
	activeParent := aValue! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/28/2005 21:19'!
activeParentMenu
	| menu |
	(self containsPoint: self cursorPoint) ifTrue:[^nil].
	menu := activeParent.
	[menu == nil] whileFalse:[
		(menu containsPoint: menu cursorPoint) 
			ifTrue:[^menu].
		menu := menu activeParent.
	].
	^nil! !

!CPopUpMenuCostume methodsFor: 'initialize' stamp: 'ar 6/28/2005 21:19'!
close
	activeParent ifNotNil:[
		activeParent activeChild: nil.
		activeParent sticky
			ifTrue:[activeParent menuSelection: nil]
			ifFalse:[activeParent close].
		activeParent := nil.
	].
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild close.
		activeChild := nil.
	].
	super close.! !

!CPopUpMenuCostume methodsFor: 'selecting' stamp: 'ar 6/28/2005 22:07'!
cursorFromPoint: targetPoint
	targetPoint y < 0 ifTrue:[^nil].
	targetPoint y >= (self menuItems size * self itemHeight) ifTrue:[^nil].
	^targetPoint y // self itemHeight + 1! !

!CPopUpMenuCostume methodsFor: 'initialize' stamp: 'ar 6/28/2005 21:19'!
defaultPlayer
	^CMenu! !

!CPopUpMenuCostume methodsFor: 'selecting' stamp: 'ar 6/29/2005 19:55'!
deselectIndex: index
	index = 0 ifFalse:[itemArea invalidate: (self invalidationRect: index)].! !

!CPopUpMenuCostume methodsFor: 'initialize' stamp: 'ar 6/28/2005 21:19'!
destroy
	activeParent ifNotNil:[
		activeParent activeChild: nil.
		activeParent sticky
			ifTrue:[activeParent menuSelection: nil]
			ifFalse:[activeParent destroy].
		activeParent := nil.
	].
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild destroy.
		activeChild := nil.
	].
	super destroy.! !

!CPopUpMenuCostume methodsFor: 'drawing' stamp: 'ar 8/18/2005 23:22'!
drawItem: menuItem in: itemBox on: aCanvas selected: selected
	| icon itemColor pos font x y |
	menuItem separator ifTrue:[
		^aCanvas fillRectangle: (itemBox leftCenter extent: itemBox width @ 1)
			color: selectionColor.
	].
	icon := menuItem icon.
	menuItem checked 
		ifTrue:[icon := CIconLibrary default at: #CheckMark].
	icon ifNotNil:[
		x := (itemBox left + 10) - (icon width // 2).
		y := (itemBox top + (itemBox height // 2)) - (icon height // 2).
		aCanvas paintImage: icon at: x@y.
	].
	itemColor := selected
			ifTrue:[Color white] 
			ifFalse:[Color black].
	menuItem disabled ifTrue:[itemColor := Color gray].
	font := self menuFont.
	pos := itemBox leftCenter.
	pos := (pos x + 20) @ (pos y - (font height // 2)).
	aCanvas drawString: menuItem label asString
			at: pos
			font: font
			color: itemColor.
	menuItem subMenu ifNotNil:[
		icon := CIconLibrary default at: #SubMenu.
		icon ifNotNil:[aCanvas paintImage: icon 
			at: itemBox rightCenter - ((icon width + 2)@(icon height // 2))].
	].
! !

!CPopUpMenuCostume methodsFor: 'drawing' stamp: 'ar 6/29/2005 19:30'!
drawMenu: target on: aCanvas in: drawingBounds
	"Draw the receiver"
	| firstIndex lastIndex box localBox itemHeight visibleArea myCursor itemList selected |
	itemList := self menuItems.
	myCursor := self menuCursor.
	itemHeight := self itemHeight.
	box := drawingBounds.
	visibleArea := (box  intersect: aCanvas clipRect).
	firstIndex := (visibleArea top // itemHeight) max: 1.
	lastIndex := (visibleArea bottom // itemHeight) + 1 min: itemList size.
	firstIndex to: lastIndex do:[:i|
		localBox := box left @ (i-1*itemHeight) extent: box width @ itemHeight.
		i = myCursor ifTrue:[
			self drawSelectionIn: localBox on: aCanvas.
			selected := true.
		] ifFalse:[
			selected := false.
		].
		self drawItem: (itemList at: i) in: localBox on: aCanvas selected: selected.
	].
! !

!CPopUpMenuCostume methodsFor: 'drawing' stamp: 'ar 6/28/2005 21:39'!
drawSelectionIn: itemBox on: aCanvas
	aCanvas fillRectangle: itemBox color: selectionColor! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/29/2005 21:09'!
fireItem: item
	"Fire the selected menu item"
	item ifNil:[^self].

	"see if item responds to #fire"
	(item action notNil or:[item handlesEvent: #fire]) ifFalse:[^self].

	"check for disabled items"
	item enabled ifFalse:[^self].

	item closeAfterFire ifTrue:[
		"don't keep mouse focus after firing"
		self hand releaseMouseFocus: self.
		self sticky ifFalse:[self close].
	].
	item fire.
! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/29/2005 16:41'!
hideSubMenu
	self wait: 0.25.
	self close.! !

!CPopUpMenuCostume methodsFor: 'initialize' stamp: 'ar 6/29/2005 19:36'!
initialize
	super initialize.
	self define: #menuLabel as: CLabel new.
	self define: #itemArea as: CCustomDrawingArea new.
	itemArea drawAction: 
		(MessageSend 
			receiver: self 
			selector: #drawMenu:on:in:
			arguments: #(nil nil nil)).
	selectionIndex := 0.! !

!CPopUpMenuCostume methodsFor: 'selecting' stamp: 'ar 6/28/2005 22:06'!
invalidationRect: index
	"Answer the rectangle for drawing the item at index"
	^(self selectionRect: index) translateBy: itemArea scrollOffset negated! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/28/2005 21:19'!
isMenuBar
	^false! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/28/2005 21:35'!
itemArea
	"Answer the itemArea of the receiver"
	<bewareOf: #itemAreaChanged>
	^self propertyValueAt: #itemArea! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/28/2005 21:35'!
itemArea: aValue
	"Modify the receiver's itemArea"
	^self propertyValueAt: #itemArea put: aValue with: #itemAreaChanged! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 21:02'!
itemHeight
	^self menuFont height + 8 max: 16! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 16:27'!
menuCursor
	^menuItems cursor! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 16:27'!
menuCursor: aNumber
	^menuItems cursor: aNumber! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'bgf 8/25/2008 10:00'!
menuFont
	^player font ifNil:[CWidgetLibrary default menuFont]! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 16:25'!
menuItems
	"Answer the menuItems of the receiver"
	<bewareOf: #menuItemsChanged>
	^self propertyValueAt: #menuItems! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 16:25'!
menuItems: aValue
	"Modify the receiver's menuItems"
	^self propertyValueAt: #menuItems put: aValue with: #menuItemsChanged! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/28/2005 21:19'!
menuLabel
	"Answer the menuLabel of the receiver"
	<bewareOf: #menuLabelChanged>
	^self propertyValueAt: #menuLabel! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/28/2005 21:19'!
menuLabel: aValue
	"Modify the receiver's menuLabel"
	^self propertyValueAt: #menuLabel put: aValue with: #menuLabelChanged! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 16:27'!
menuSelection
	^menuItems selection! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 16:27'!
menuSelection: anObject
	menuItems selection: anObject! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 1/31/2007 14:02'!
onKeyDown: event
	"React to a key event"
	| action max cc |
	<on: keyDown>
	action := CPlatform current standardEditingKeys lookupEvent: event.

	action == #escape ifTrue:[^self close]. "escape - close menu"
	action == #return ifTrue:[^self fireItem: self menuSelection].
	action == #accept ifTrue:[^self fireItem: self menuSelection].

	"Cursor key navigation"
	cc := self menuCursor.
	max := self menuItems size.
	max = 0 ifTrue:[^self].
	action == #moveLineStart ifTrue: [cc := 1].  "home"
	action == #moveLineEnd ifTrue: [cc := max].   "end"
	(action == #moveLineDown) ifTrue:[ "down"
		cc := cc + 1. cc > max ifTrue:[cc := 1].
	].
	(action == #moveLineUp) ifTrue:[ "up"
		cc := cc - 1. cc < 1 ifTrue:[cc := max].
	].
	self menuCursor: cc.! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/29/2005 19:32'!
onLabelChanged
	| aString |
	<on: labelChanged in: player>
	aString := player label.
	menuLabel visible: aString notNil.
	aString ifNotNil:[
		menuLabel value: aString asText.
	].
	self roundCorners ifTrue:[
		menuLabel visible
			ifTrue:[itemArea roundCornerSpec: #(2 3)]
			ifFalse:[itemArea roundCornerSpec: #(1 2 3 4)].
	].! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/28/2005 21:19'!
onLabelDrag
	"Allow dragging this menu when we click in its label"
	<on: mouseDown in: menuLabel>
	self onDrag.
	self sticky ifFalse:[self hand mouseFocus: self].! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/29/2005 16:40'!
onMenuCursorChanged
	| menuItem |
	<on: cursorChanged in: menuItems>
	self stopScript: #showSubMenu.
	self sticky ifFalse:[self hand mouseFocus: self].
	"Close old child menu"
	activeChild ifNotNil:[
		activeChild activeParent: nil.
		activeChild menuCursor: 0.
		activeChild startScript: #hideSubMenu.
		activeChild := nil.
	].
	"Deselect old and select new index"
	self deselectIndex: self selectionIndex.
	self selectionIndex: self menuCursor.
	self selectIndex: self selectionIndex.

	"Show new submenu"
	menuItem := self menuSelection.
	menuItem ifNil:[^self].
	menuItem subMenu ifNil:[^self].
	menuItem disabled ifTrue:[^self].
	self startScript: #showSubMenu.
! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/29/2005 21:02'!
onMenuItemsChanged
	"Recompute the size required"
	| font max |
	<on: menuItemsChanged in: player>
	menuItems := player menuItems.
	font := self menuFont.
	max := 0.
	menuItems do:[:item| max := max max: (font widthOfString: item label asString) ].
	itemArea asPrimCostume minWidth: max + 40. "icons and submenu"
	itemArea height: menuItems size * self itemHeight.
	itemArea invalidate.! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/28/2005 21:19'!
onMouseDown
	<on: mouseDown>
	"Check if the user clicked outside this menu"
	(self containsPoint: self cursorPoint) ifFalse:[
		self hand releaseMouseFocus: self.
		self sticky ifFalse:[^self close]. "bump me"
		^self].! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/28/2005 22:08'!
onMouseLeave
	<on: mouseLeave>
	self menuCursor: 0.! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 8/18/2005 23:24'!
onMouseMove
	| item parent selected index cp |
	<on: mouseMove>
	parent := self activeParentMenu.
	parent ifNotNil:[
		"Allow the parent to track the menu instead.
		If this results in a different selection, I will be closed."
		^parent onMouseMove].
	cp := itemArea cursorPoint.
	(itemArea containsPoint: cp) ifTrue:[
		index := itemArea cursorPoint y // self itemHeight + 1.
		(index between: 1 and: player menuItems size) ifTrue:[
			item := player menuItems at: index.
		].
	] ifFalse:[index := 0].
	item ifNotNil:[item separator ifTrue:[item := nil. index := 0]]. "ignore separators"
	item ifNil:[
		"Be careful before not to close open sub-menus"
		selected := self menuSelection.
		(selected notNil and:[selected subMenu notNil]) ifTrue:[^self].
	].
	self menuCursor: index.! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/28/2005 21:19'!
onMouseUp
	<on: mouseUp>
	self fireItem: self menuSelection.
	self sticky ifFalse:[self hand mouseFocus: self].! !

!CPopUpMenuCostume methodsFor: 'initialize' stamp: 'ar 6/29/2005 16:46'!
onOpen
	<on: opened>
	self sticky ifFalse:[self hand mouseFocus: self].
! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/29/2005 16:28'!
onPlayerChanged
	super onPlayerChanged.
	self onMenuItemsChanged.
	self onLabelChanged.! !

!CPopUpMenuCostume methodsFor: 'styling' stamp: 'be 7/14/2005 14:59'!
onStyleSheetChanged

	menuItems do:[:each | each styleSheet: self styleSheet].
	super onStyleSheetChanged
! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/28/2005 21:19'!
onYellowButtonDown
	"Treat yellow equivalent to red since context menus are popped up that way"
	<on: yellowButtonDown>
	^self onMouseDown! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/28/2005 21:19'!
onYellowButtonUp
	"Treat yellow equivalent to red since context menus are popped up that way"
	<on: yellowButtonUp>
	^self onMouseUp! !

!CPopUpMenuCostume methodsFor: 'selecting' stamp: 'ar 6/28/2005 22:07'!
scrollToSelection: idx
	"Make the current selection visible"
	idx = 0 ifTrue:[^self].
	itemArea scrollToShow: ((self selectionRect: idx) translateBy: itemArea origin negated).! !

!CPopUpMenuCostume methodsFor: 'selecting' stamp: 'ar 6/29/2005 19:55'!
selectIndex: index
	index = 0 ifFalse:[itemArea invalidate: (self invalidationRect: index)]! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 16:02'!
selectionIndex
	"Answer the selectionIndex of the receiver"
	<bewareOf: #selectionIndexChanged>
	^self propertyValueAt: #selectionIndex! !

!CPopUpMenuCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 16:02'!
selectionIndex: aValue
	"Modify the receiver's selectionIndex"
	^self propertyValueAt: #selectionIndex put: aValue with: #selectionIndexChanged! !

!CPopUpMenuCostume methodsFor: 'selecting' stamp: 'ar 6/29/2005 19:56'!
selectionRect: index
	"Answer the rectangle for drawing the item at index"
	| box |
	box := itemArea localBounds.
	^box left @ (index-1*self itemHeight + box top) extent: box width @ self itemHeight.! !

!CPopUpMenuCostume methodsFor: 'initialize' stamp: 'ar 8/18/2005 22:10'!
setupCostume
	"Setup my costume"
	super setupCostume.

	menuLabel clipping: false.
	menuLabel color: CWidgetLibrary default menuLabelColor.
	menuLabel textAnchorPoint: #center.
	menuLabel textInset: 3.
	menuLabel textEmphasis: 1.
	menuLabel textColor: CWidgetLibrary default menuLabelTextColor.
	menuLabel roundCornerSpec: #(1 4).
	self add: menuLabel.

	itemArea hResizing: #spaceFill; vResizing: #rigid.
	itemArea roundCornerSpec: #(1 2 3 4).
	itemArea asPrimCostume cacheEnabled: true.
	self add: itemArea.

	self layout: CTableLayout new.
	self layout cellPositioning: #topLeft.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.
	self floating: true.
 	self color: Color white.
	self dropShadowEnabled: true.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self roundCorners: true.
	self clipping: false.
	self width: 100.! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 6/26/2007 22:37'!
showSubMenu
	| pos index rect item |
	self wait: 0.25. "sec - might get terminated here if user moves quickly through"
	index := self menuCursor.
	item := self menuSelection.
	item subMenu ifNil:[^nil]. "selection changed in .25 secs above"
	index := self menuItems indexOf: item.
	rect := self selectionRect: index.
	pos := rect topRight - (2@1).
	activeChild := item subMenu costume.
	activeChild activeParent: self.
	activeChild menuCursor: 0.
	activeChild fill: self fill.
	activeChild transform: self localToWorld.
	activeChild topLeft: (itemArea localToWorld: pos).
	self world add: activeChild.
	activeChild beOnScreen.! !

!CPopUpMenuCostume methodsFor: 'events' stamp: 'ar 7/16/2005 01:06'!
windowColor: aColor
	super windowColor: aColor.
	selectionColor := aColor.! !

CWidgetCostume subclass: #CProgressBarCostume
	instanceVariableNames: ''
	classVariableNames: 'BeginBottomColor BeginTopColor EndBottomColor EndTopColor'
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

CProgressBarCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="progressLabel" toSet="progressLabel:" changeEvent="progressLabelChanged">progressLabel</field>
	<field toGet="progressValue" toSet="progressValue:" changeEvent="progressValueChanged">progressValue</field>
	<field toGet="progressShadow" toSet="progressShadow:" changeEvent="progressShadowChanged">progressShadow</field>
	<field toGet="percentLabel" toSet="percentLabel:" changeEvent="percentLabelChanged">percentLabel</field>
	<field toGet="labelRow" toSet="labelRow:" changeEvent="labelRowChanged">labelRow</field>
	<field toGet="buttonRow" toSet="buttonRow:" changeEvent="buttonRowChanged">buttonRow</field>
	<field toGet="abortButton" toSet="abortButton:" changeEvent="abortButtonChanged">abortButton</field>
	<field toGet="debugButton" toSet="debugButton:" changeEvent="debugButtonChanged">debugButton</field>
</fields>'!

!CProgressBarCostume class methodsFor: 'class initialization' stamp: 'bgf 12/27/2008 20:00'!
initialize
	"  CProgressBarCostume initialize "

	BeginTopColor :=  (Color r: 0.45 g: 0.55 b: 0.95).		"Start of progress, top of gradient."
	BeginBottomColor := (Color r: 0.2 g: 0.3 b: 0.5).		"Start of progress, bottom of gradient."
	EndTopColor :=  (Color r: 0.5 g: 0.95 b: 0.5).			"End of progress, top of gradient."
	EndBottomColor := (Color r: 0.25 g: 0.55 b: 0.3).		"End of progress, bottom of gradient."! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 4/24/2005 18:52'!
abortButton
	"Answer the abortButton of the receiver"
	<bewareOf: #abortButtonChanged>
	^self propertyValueAt: #abortButton! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 4/24/2005 18:52'!
abortButton: aValue
	"Modify the receiver's abortButton"
	^self propertyValueAt: #abortButton put: aValue with: #abortButtonChanged! !

!CProgressBarCostume methodsFor: 'initialize' stamp: 'bgf 1/3/2009 10:08'!
beOnScreen
	position := self world dialogCenter.! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 4/24/2005 18:52'!
buttonRow
	"Answer the buttonRow of the receiver"
	<bewareOf: #buttonRowChanged>
	^self propertyValueAt: #buttonRow! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 4/24/2005 18:52'!
buttonRow: aValue
	"Modify the receiver's buttonRow"
	^self propertyValueAt: #buttonRow put: aValue with: #buttonRowChanged! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 4/24/2005 18:52'!
debugButton
	"Answer the debugButton of the receiver"
	<bewareOf: #debugButtonChanged>
	^self propertyValueAt: #debugButton! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 4/24/2005 18:52'!
debugButton: aValue
	"Modify the receiver's debugButton"
	^self propertyValueAt: #debugButton put: aValue with: #debugButtonChanged! !

!CProgressBarCostume methodsFor: 'initialize' stamp: 'ar 10/29/2004 22:59'!
defaultPlayer
	^CProgressBar! !

!CProgressBarCostume methodsFor: 'initialize' stamp: 'bgf 3/29/2008 21:39'!
initialize
	super initialize.
	self define: #progressLabel as: CLabel new.
	self define: #percentLabel as: (CLabel on: '').
	self define: #labelRow as: CPlayer new.

	self define: #progressShadow as: CPlayer new.
	self define: #progressValue as: CPlayer new.

	self define: #buttonRow as: CPlayer new.
	self define: #debugButton as: CPushButton new.
	self define: #abortButton as: CPushButton new.! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'bgf 3/29/2008 21:36'!
labelRow
	"Answer the labelRow of the receiver"
	<bewareOf: #labelRowChanged>
	^self propertyValueAt: #labelRow! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'bgf 3/29/2008 21:36'!
labelRow: aValue
	"Modify the receiver's labelRow"
	^self propertyValueAt: #labelRow put: aValue with: #labelRowChanged! !

!CProgressBarCostume methodsFor: 'events' stamp: 'bgf 11/9/2008 10:38'!
onAbortButtonFire
	<on: fire in: abortButton>
	player suspend.
	self disable.
	(CDialog confirm: 'Really cancel this operation?' yes: 'Yes' no: 'No' label: ('Cancel ', (player label))) 
		ifTrue:[player abort]
		ifFalse:[player resume. self enable.].! !

!CProgressBarCostume methodsFor: 'events' stamp: 'ar 4/24/2005 19:09'!
onAllowAbortChanged
	"Abort button will be disabled/enabled depending on value"
	<on: allowAbortChanged in: player>
	player allowAbort 
		ifTrue:[abortButton enable]
		ifFalse:[abortButton disable].
! !

!CProgressBarCostume methodsFor: 'events' stamp: 'ar 4/24/2005 19:09'!
onAllowDebugChanged
	"Debug button will be hidden for average users"
	<on: allowDebugChanged in: player>
	debugButton visible: player allowDebug.
! !

!CProgressBarCostume methodsFor: 'events' stamp: 'ar 4/28/2005 15:58'!
onDebugButtonFire
	<on: fire in: debugButton>
	player suspend.
	(self confirm: 'Really debug this operation?') 
		ifTrue:[player debug]
		ifFalse:[player suspend].! !

!CProgressBarCostume methodsFor: 'events' stamp: 'ar 10/31/2004 15:24'!
onFontChanged
	<on: fontChanged in: player>
	progressLabel font: player font.! !

!CProgressBarCostume methodsFor: 'events' stamp: 'ar 10/29/2004 23:37'!
onLabelChanged
	<on: labelChanged in: player>
	progressLabel value: player label.! !

!CProgressBarCostume methodsFor: 'events' stamp: 'bgf 3/29/2008 21:45'!
onLabelExtentChanged
	| delta max |
	<on: extentChanged in: progressLabel>
	delta := self layoutInset asPoint x + self borderWidth asPoint x.
	max := progressLabel width + (percentLabel width) + (delta * 2).
	max > width 
		ifTrue:[width := max].! !

!CProgressBarCostume methodsFor: 'events' stamp: 'ar 4/24/2005 19:10'!
onPlayerChanged
	self onLabelChanged.
	self onValueChanged.
	self onFontChanged.
	self onAllowDebugChanged.
	self onAllowAbortChanged.! !

!CProgressBarCostume methodsFor: 'events' stamp: 'ar 10/29/2004 23:27'!
onShadowLayoutChanged
	<on: layoutChanged in: progressShadow>
	self onValueChanged.! !

!CProgressBarCostume methodsFor: 'events' stamp: 'bgf 12/27/2008 19:58'!
onValueChanged
	| sz frac topc botc |
	<on: valueChanged>

	progressValue topLeft: progressShadow borderWidth asPoint.
	sz := progressShadow extent - (progressShadow borderWidth asPoint y * 2).
	frac := player fraction.
	progressValue width: (sz x * frac) truncated.
	progressValue height: sz y.

	"Colors for shifting fill - changes from cool to bright+warm as we make progress."
	topc := 	(EndTopColor * frac) + (BeginTopColor * (1.0 - frac)).
	botc := (EndBottomColor * frac) + (BeginBottomColor * (1.0 -frac)).
	progressValue 
		fillColors: {	topc . botc . ((topc*0.25)+(botc*0.75)) };	"Grading back toward the top color at the bottom,	
															 makes a slight liquid-crystal effect."
		fillAlpha: (0.8 + (frac/10.0)).

	"Reinforced with a percent-progress report..."
	frac > 0.99 ifTrue: [
		percentLabel label: 'Done'
	] ifFalse: [
		"Don't draw attention to slow starts... let it get going before we put the percentage up..."
		frac > 0.02 ifTrue: [
			percentLabel label: ('', ((frac * 100.0) rounded), '%').
		].
	].
! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'bgf 3/29/2008 21:30'!
percentLabel
	"Answer the percentLabel of the receiver"
	<bewareOf: #percentLabelChanged>
	^self propertyValueAt: #percentLabel! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'bgf 3/29/2008 21:30'!
percentLabel: aValue
	"Modify the receiver's percentLabel"
	^self propertyValueAt: #percentLabel put: aValue with: #percentLabelChanged! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 10/29/2004 22:59'!
progressLabel
	"Answer the progressLabel of the receiver"
	<bewareOf: #progressLabelChanged>
	^self propertyValueAt: #progressLabel! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 10/29/2004 22:59'!
progressLabel: aValue
	"Modify the receiver's progressLabel"
	^self propertyValueAt: #progressLabel put: aValue with: #progressLabelChanged! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 10/29/2004 23:11'!
progressShadow
	"Answer the progressShadow of the receiver"
	<bewareOf: #progressShadowChanged>
	^self propertyValueAt: #progressShadow! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 10/29/2004 23:11'!
progressShadow: aValue
	"Modify the receiver's progressShadow"
	^self propertyValueAt: #progressShadow put: aValue with: #progressShadowChanged! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 10/29/2004 22:59'!
progressValue
	"Answer the progressValue of the receiver"
	<bewareOf: #progressValueChanged>
	^self propertyValueAt: #progressValue! !

!CProgressBarCostume methodsFor: 'accessing' stamp: 'ar 10/29/2004 22:59'!
progressValue: aValue
	"Modify the receiver's progressValue"
	^self propertyValueAt: #progressValue put: aValue with: #progressValueChanged! !

!CProgressBarCostume methodsFor: 'initialize' stamp: 'bgf 4/4/2009 18:36'!
setupCostume
	| clr |
	super setupCostume.
	self floating: true.

	self extent: ((398@64) min: (World extent - 8)).
	self roundCorners:true.
	clr := CWidgetLibrary default paneColor.
	self fillColors: {clr lighter . clr slightlyDarker };
		fillStyle: #verticalGradient;
		fillAlpha: 0.92.
	self borderWidth: 1.
	self borderStyle: #simple.
	self borderColor: CWidgetLibrary default frameColor.
	self vResizing: #shrinkWrap.
	self dropShadowEnabled: true.
	self layout: CTableLayout new.
	self layout cellInset: 8@9.
	self layout layoutInset: 8@8.

	labelRow layout: CTableLayout new.
	labelRow hResizing: #spaceFill; vResizing: #spaceFill.
	labelRow layout listDirection: #leftToRight.
	labelRow layout listCentering: #topLeft.
	labelRow layout cellInset: 12@2.
	labelRow layout layoutInset: 0@1.
	self add: labelRow.

	labelRow addLast: progressLabel.
	labelRow addLast: percentLabel.

	self addLast: progressShadow.
	progressShadow addLast: progressValue.

	progressLabel font: player font.
	progressLabel hResizing: #spaceFill.	
	progressLabel vResizing: #rigid.
	progressLabel height: 24.
	progressLabel textAnchorPoint:#bottomLeft.

	percentLabel font: player font.
	percentLabel hResizing: #rigid.
	percentLabel vResizing: #rigid.
	percentLabel height: 24.
	percentLabel width: 60.		"Bit of a shortcut... big enough to hold 100.0% in typical fonts."
	percentLabel textColor: (Color gray: 0.25).
	percentLabel textAnchorPoint:#bottomRight.

	progressShadow height: 20.
	progressShadow hResizing: #spaceFill.
	progressShadow borderWidth: 1.
	progressShadow borderColor: Color gray.
	progressShadow borderStyle: #inset.
	progressShadow color: Color white.

	progressValue 
		fillColors: { (Color r: 0.45 g: 0.9 b: 0.55) . (Color r: 0.2 g: 0.5 b: 0.35) };
		fillStyle: #verticalGradient;
		extent: 0@18;
		borderWidth: 0;
		borderStyle: #none.

	buttonRow layout: CTableLayout new.
	buttonRow hResizing: #spaceFill; vResizing: #spaceFill.
	buttonRow layout listDirection: #leftToRight.
	buttonRow layout listCentering: #bottomRight.
	buttonRow layout cellInset: 12@4.
	buttonRow layout layoutInset: 0@4.
	self add: buttonRow.

	debugButton label: 'Debug'.
	debugButton roundCorners: true.
	debugButton height: 22.
	buttonRow add: debugButton.

	abortButton label: 'Cancel'.
	abortButton roundCorners: true.
	abortButton height: 22.
	buttonRow add: abortButton.

! !

CWidgetCostume subclass: #CScrollableCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling-Costumes'!

!CScrollableCostume commentStamp: 'ar 3/24/2004 22:58' prior: 0!
CScrollableCostume is an abstract class provided for convenience to implement costumes requiring scrolling.!

CScrollableCostume subclass: #CListLikeCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

!CListLikeCostume commentStamp: '<historical>' prior: 0!
I am the common superclass for all "list-like" costumes. I handle the updating from the player when the player's items change and provide trigger methods for handling the events from the player's item collection.

Fields:
	playerItems	<CCollection>	The player's items.
!

CListLikeCostume subclass: #CCustomDrawListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

!CCustomDrawListCostume commentStamp: '<historical>' prior: 0!
I represent a list costume which uses custom drawing operations for better performance. Not as flexible as the generic list costume it does not support itemMakers but rather describes a single way in which to draw the items of a list.!

CCustomDrawListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="selectionIndex" toSet="selectionIndex:" changeEvent="selectionIndexChanged">selectionIndex</field>
</fields>'!

!CCustomDrawListCostume methodsFor: 'accessing' stamp: 'ar 2/18/2004 11:23'!
cursor
	^self player cursor! !

!CCustomDrawListCostume methodsFor: 'accessing' stamp: 'ar 2/18/2004 11:31'!
cursor: newCursor
	^self player cursor: newCursor! !

!CCustomDrawListCostume methodsFor: 'selecting' stamp: 'ar 2/18/2004 11:33'!
cursorFromPoint: targetPoint
	targetPoint y < 0 ifTrue:[^nil].
	targetPoint y >= (self player size * self itemHeight) ifTrue:[^nil].
	^targetPoint y // self itemHeight + 1! !

!CCustomDrawListCostume methodsFor: 'selecting' stamp: 'ar 2/18/2004 12:23'!
deselectIndex: index
	index = 0 ifFalse:[self invalidate: (self invalidationRect: index)].! !

!CCustomDrawListCostume methodsFor: 'drawing' stamp: 'ar 2/18/2004 11:24'!
drawItem: index in: itemBox on: aCanvas
	^self subclassResponsibility! !

!CCustomDrawListCostume methodsFor: 'drawing' stamp: 'ar 3/27/2004 20:54'!
drawListOn: aCanvas in: drawingBounds
	"Draw the receiver"
	| firstIndex lastIndex box localBox itemHeight visibleArea myCursor |
	myCursor := self cursor.
	itemHeight := self itemHeight.
	box := drawingBounds.
	visibleArea := (box  intersect: aCanvas clipRect).
	firstIndex := (visibleArea top // itemHeight) max: 1.
	lastIndex := (visibleArea bottom // itemHeight) + 1 min: self player size.
	firstIndex to: lastIndex do:[:i|
		localBox := box left @ (i-1*itemHeight) extent: box width @ itemHeight.
		i = myCursor ifTrue:[self drawSelectionIn: localBox on: aCanvas].
		self drawItem: i in: localBox on: aCanvas.
	].
! !

!CCustomDrawListCostume methodsFor: 'drawing' stamp: 'ar 11/12/2004 21:05'!
drawSelectionIn: itemBox on: aCanvas
	aCanvas fillRectangle: itemBox color: selectionColor! !

!CCustomDrawListCostume methodsFor: 'initialize' stamp: 'ar 2/29/2004 22:34'!
initialize
	super initialize.
	self selectionIndex: 0.
! !

!CCustomDrawListCostume methodsFor: 'initialize' stamp: 'ar 3/25/2004 11:37'!
initializeDefaultScrollTarget
	"Initialize the default scroll target if one is needed"
	self define: #scrollTarget as: CCustomDrawListTarget new.! !

!CCustomDrawListCostume methodsFor: 'selecting' stamp: 'ar 3/24/2004 23:12'!
invalidationRect: index
	"Answer the rectangle for drawing the item at index"
	^(self selectionRect: index) translateBy: scrollTarget scrollOffset negated! !

!CCustomDrawListCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 21:03'!
itemHeight
	^self listFont height + 4! !

!CCustomDrawListCostume methodsFor: 'accessing' stamp: 'ar 6/29/2005 21:02'!
listFont
	^self player font ifNil:[TextStyle defaultFont]! !

!CCustomDrawListCostume methodsFor: 'events' stamp: 'ar 4/23/2005 15:48'!
onCursorChanged
	self deselectIndex: self selectionIndex.
	self selectionIndex: self cursor.
	self selectIndex: self selectionIndex.
	self scrollToSelection: self selectionIndex.! !

!CCustomDrawListCostume methodsFor: 'events' stamp: 'ar 4/23/2005 15:49'!
onItemsChanged
	scrollTarget invalidate.
	self onUpdateScrollRange.! !

!CCustomDrawListCostume methodsFor: 'events' stamp: 'bf 7/29/2005 18:03'!
onKeyDown: event
	"React to a key event"
	| action |
	<on: keyDown>
	action := CPlatform current standardEditingKeys lookupEvent: event.

	"Basic cursor key navigation"
	action == #moveLineStart 
		ifTrue: [^self cursor: 1].  "home"
	action == #moveLineEnd 
		ifTrue: [^self cursor: self player size].   "end"
	(action == #moveLineDown and:[self cursor < self player size])
		ifTrue:[^self cursor: self cursor + 1]. "down"
	(action == #moveLineUp and:[self cursor > 1])
		ifTrue:[^self cursor: self cursor - 1]. "up"

! !

!CCustomDrawListCostume methodsFor: 'events' stamp: 'ar 11/12/2004 10:53'!
onMouseDown
	"React to a mouse event"
	| idx |
	<on: mouseDown in: scrollTarget>
	hand keyboardFocus: self.
	"Figure out the selection"
	idx := self cursorFromPoint: scrollTarget cursorPoint.
	idx ifNil:[^self].
	"And set newly selected player"
	player allowDeselect ifTrue:[
		self cursor = idx ifTrue:[^self cursor: 0].
	].
	self cursor: idx.
! !

!CCustomDrawListCostume methodsFor: 'events' stamp: 'ar 11/12/2004 11:06'!
onMouseEnter
	<on: mouseEnter>
	hand autoKeyboardFocus ifTrue:[hand keyboardFocus: self]! !

!CCustomDrawListCostume methodsFor: 'events' stamp: 'ar 11/12/2004 11:06'!
onMouseLeave
	<on: mouseLeave>
	hand autoKeyboardFocus ifTrue:[hand releaseKeyboardFocus: self].! !

!CCustomDrawListCostume methodsFor: 'events' stamp: 'ar 11/12/2004 21:19'!
onPlayerChanged
	super onPlayerChanged.
	self selectionIndex: self cursor.
	self invalidate.! !

!CCustomDrawListCostume methodsFor: 'events' stamp: 'ar 3/24/2004 23:12'!
onUpdateScrollRange
	scrollTarget scrollArea: (0@0 extent: scrollTarget width @ (self player size * self itemHeight)).
	super onUpdateScrollRange! !

!CCustomDrawListCostume methodsFor: 'selecting' stamp: 'ar 3/24/2004 23:12'!
scrollToSelection: idx
	"Make the current selection visible"
	idx = 0 ifTrue:[^self].
	scrollTarget scrollToShow: ((self selectionRect: idx) translateBy: scrollTarget origin negated).! !

!CCustomDrawListCostume methodsFor: 'selecting' stamp: 'ar 2/18/2004 12:22'!
selectIndex: index
	index = 0 ifFalse:[self invalidate: (self invalidationRect: index)]! !

!CCustomDrawListCostume methodsFor: 'accessing' stamp: 'ar 3/19/2004 13:33'!
selectionIndex
	"This method was automatically generated"
	<bewareOf: #selectionIndexChanged>
	^self propertyValueAt: #selectionIndex! !

!CCustomDrawListCostume methodsFor: 'accessing' stamp: 'ar 3/19/2004 13:33'!
selectionIndex: aValue
	"This method was automatically generated"
	^self propertyValueAt: #selectionIndex put: aValue with: #selectionIndexChanged! !

!CCustomDrawListCostume methodsFor: 'selecting' stamp: 'ar 3/24/2004 23:13'!
selectionRect: index
	"Answer the rectangle for drawing the item at index"
	| box |
	box := scrollTarget bounds.
	^box left @ (index-1*self itemHeight + box top) extent: box width @ self itemHeight.! !

!CCustomDrawListCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:49'!
setupCostume
	super setupCostume.
	scrollTarget userDraw: true.
	scrollTarget scrollDelta: 1@self itemHeight.
	scrollTarget list: self.! !

!CCustomDrawListCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 00:05'!
windowColor: aColor
	super windowColor: aColor.
	self selectionColor: aColor.
	self invalidate.! !

CCustomDrawListCostume subclass: #CMultiColumnListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

CMultiColumnListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field virtual="true" toGet="columns" toSet="columns:">columns</field>
	<field toGet="header" toSet="header:" changeEvent="headerChanged">header</field>
</fields>'!

!CMultiColumnListCostume methodsFor: 'initialize' stamp: 'ar 4/2/2004 14:52'!
buildHeader
	"WARNING: UNFINISHED!!"
	| holder button aColor action |
	aColor := (Color r: 0.9 g: 0.95 b: 0.9).
	holder := CPlayer new.
	(holder costume) 
		layout: CTableLayout new;
		listDirection: #leftToRight.
	holder
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	holder
		color: aColor;
		border: (CBorder inset width: 2);
		extent: 2@2.
	columns do:[:colSpec|
		button := CButton new.
		button label: colSpec label.
		action := colSpec action.
		action ifNotNil:[
			action receiver 
				startScript: action selector 
				withArguments: action arguments
				when: {button. #fire}.
		].
		(button costume)
			width: colSpec width;
			roundCorners: false;
			color: aColor;
			border: (CBorder raised width: 1).
		holder costume add: button costume.
	].
	button := CPlayer new.
	button extent: 2@2.
	button
		color: aColor;
		border: (CBorder raised width: 1).
	holder costume add: button costume.	
	^holder! !

!CMultiColumnListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 21:37'!
columns
	^player columns! !

!CMultiColumnListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 21:37'!
columns: aCollection
	^player columns: aCollection! !

!CMultiColumnListCostume methodsFor: 'initialize' stamp: 'ar 5/6/2005 13:52'!
defaultPlayer
	^CMultiColumnList! !

!CMultiColumnListCostume methodsFor: 'drawing' stamp: 'ar 3/27/2004 20:58'!
drawBackgroundStripesOn: aCanvas in: box
	"Draw the background column stripes"
	| leftX colWidth colColor |
	leftX := 0.
	columns do:[:colSpec|
		colWidth := colSpec width.
		colColor := colSpec color.
		colColor ifNotNil:[
			aCanvas 
				fillRectangle: (leftX@box top extent: colWidth@box height) 
				color: colColor].
		leftX := leftX + colWidth.
		leftX > box right ifTrue:[^self].
	].! !

!CMultiColumnListCostume methodsFor: 'drawing' stamp: 'ar 6/29/2005 21:03'!
drawItem: index in: itemBox on: aCanvas
	| item itemColor boxOrigin boxCorner itemWidth itemHeight args drawSelector drawer |
	item := player at: index.
	itemColor := index = selectionIndex 
			ifTrue:[Color white] 
			ifFalse:[Color black].
	boxOrigin := itemBox origin + (5@1).
	boxCorner := itemBox corner - (0@1).
	itemHeight := boxCorner y - boxOrigin y.
	args := Array with: item with: nil with: aCanvas with: self listFont with: itemColor.
	columns do:[:colSpec|
		boxOrigin x > boxCorner x ifTrue:[^self].
		itemWidth := colSpec width.
		drawSelector := colSpec drawSelector.
		args at: 2 put: (boxOrigin extent: itemWidth - 10 @ itemHeight).
		drawer := colSpec drawer.
		(drawer == nil or:[drawSelector == nil]) 
			ifFalse:[drawer perform: drawSelector withArguments: args].
		boxOrigin := boxOrigin + (itemWidth @ 0).
	].! !

!CMultiColumnListCostume methodsFor: 'drawing' stamp: 'ar 3/12/2004 21:51'!
drawListOn: aCanvas in: drawingBounds
	"Draw the receiver"
	self drawBackgroundStripesOn: aCanvas in: drawingBounds.
	super drawListOn: aCanvas in: drawingBounds.! !

!CMultiColumnListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:05'!
header
	"Answer the header of the receiver"
	<bewareOf: #headerChanged>
	^self propertyValueAt: #header! !

!CMultiColumnListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:54'!
header: aValue
	"Modify the receiver's header"
	^self propertyValueAt: #header put: aValue with: #headerChanged! !

CCustomDrawListCostume subclass: #CStringListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

CStringListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CStringListCostume methodsFor: 'initialize' stamp: 'ar 4/24/2005 17:58'!
defaultPlayer
	^CStringList! !

!CStringListCostume methodsFor: 'drawing' stamp: 'ar 6/29/2005 21:03'!
drawItem: index in: itemBox on: aCanvas
	| itemColor string |
	itemColor := index = selectionIndex 
			ifTrue:[Color white] 
			ifFalse:[Color black].
	string := (self player items at: index) displayText.
	aCanvas drawString: string asString
			in: (itemBox insetBy: (3@1 corner: 0@1)) 
			font: self listFont 
			color: itemColor.! !

!CStringListCostume methodsFor: 'drawing' stamp: 'ar 4/24/2005 18:27'!
drawListOn: aCanvas in: drawingBounds
	"Overridden for efficency; avoid querying player for drawAction all the time"
	| firstIndex lastIndex box localBox itemHeight visibleArea myCursor drawAction args |
	drawAction := player drawAction 
		ifNil:[^super drawListOn: aCanvas in: drawingBounds].
	myCursor := self cursor.
	itemHeight := self itemHeight.
	box := drawingBounds.
	visibleArea := (box  intersect: aCanvas clipRect).
	firstIndex := (visibleArea top // itemHeight) max: 1.
	lastIndex := (visibleArea bottom // itemHeight) + 1 min: self player size.
	args := Array new: 3. "cache args"
	args at: 3 put: aCanvas.
	firstIndex to: lastIndex do:[:i|
		localBox := box left @ (i-1*itemHeight) extent: box width @ itemHeight.
		i = myCursor ifTrue:[self drawSelectionIn: localBox on: aCanvas].
		args at: 1 put: i. args at: 2 put: localBox.
		drawAction valueWithArguments: args.
	].
! !

!CStringListCostume methodsFor: 'events' stamp: 'ar 4/24/2005 18:11'!
onDrawActionChanged
	<on: drawActionChanged in: player>
	self invalidate.! !

CListLikeCostume subclass: #CListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

!CListCostume commentStamp: '<historical>' prior: 0!
I represent the generic list costume using a list's itemMaker to create the appropriate view representation for an item.!

CListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="selectedPlayer" toSet="selectedPlayer:" changeEvent="selectedPlayerChanged">selectedPlayer</field>
	<field toGet="overPlayer" toSet="overPlayer:" changeEvent="overPlayerChanged">overPlayer</field>
</fields>'!

!CListCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:11'!
cssTag
	"Answer the receiver's default css tag"
	^#list! !

!CListCostume methodsFor: 'initialize' stamp: 'ar 4/3/2004 20:10'!
defaultPlayer
	^CList! !

!CListCostume methodsFor: 'events' stamp: 'bgf 3/19/2009 14:12'!
onCursorChanged
	| selected clippedCursor |
	selected := self selectedPlayer.
	selected ifNotNil:[selected deselect].
	clippedCursor := player cursor min: scrollTarget elements size max: 0.
	clippedCursor > 0
		ifTrue:[selected := scrollTarget elements at: clippedCursor]
		ifFalse:[selected := nil].
	self selectedPlayer: selected.
	selected ifNotNil:[
		selected select.
		(player keepCursorInView == false) ifFalse: [ scrollTarget scrollToShow: selected ].
	].! !

!CListCostume methodsFor: 'events' stamp: 'ar 3/14/2005 22:49'!
onItemMakerChanged
	<on: itemMakerChanged in: player>
	self onItemsChanged.! !

!CListCostume methodsFor: 'events' stamp: 'ar 8/25/2010 14:34'!
onItemsChanged
	| item itemMaker off elems numReused items |
	itemMaker := player itemMaker ifNil:[CListItem].

	off := self scrollOffset.

	"Reuse element-items as much as possible, 
	 to avoid creating items+costumes for each list entry."

	numReused := (player items size min: (scrollTarget elements size)).
	items := player items.
	elems := ((scrollTarget elements copyFrom: 1 to: numReused)
			   	withIndexCollect: [ : each : i | 
					each listItemValue: (items at: i). 
					each]),
			  ((items copyFrom: numReused+1 to: (items size)) 	
				 collect: [ :each|
					item := itemMaker new.
					item listItemValue: each. "see comment in listItemValue:"
					item styleSheet: self styleSheet.
					item]).
	scrollTarget elements: elems.

	"Update layout synchronously so that onCursorChanged scrolls to the right location"
	scrollTarget fullBounds.
	(self selectedPlayer notNil and: [ player keepCursorInView ~= false ])
	ifTrue: [
		self onCursorChanged.
	] ifFalse: [
		"Just keep the old position, if it still obtains..."
		self scrollOffset: off.
	].
	self signal: #listItemsChanged.	"So the costume content reconstruction is observable"! !

!CListCostume methodsFor: 'events' stamp: 'bf 7/29/2005 13:36'!
onKeyDown: event
	"React to a key event"
	| action |
	<on: keyDown>
	action := CPlatform current standardEditingKeys lookupEvent: event.

	"Basic cursor key navigation"
	action == #moveLineStart 
		ifTrue: [^player cursor: 1].  "home"
	action == #moveLineEnd
		ifTrue: [^player cursor: player size].   "end"
	(action == #moveLineDown)
		ifTrue:[player next]. "down"
	(action == #moveLineUp)
		ifTrue:[player prev]. "up"! !

!CListCostume methodsFor: 'events' stamp: 'bgf 4/8/2009 14:57'!
onKeyStroke: event
	"See if we have an entry which starts with the key character"
	| keyChar cc max item |
	<on: keyStroke>
	keyChar := event keyCharacter asLowercase.
	"Search from cursor to end"
	cc := player cursor + 1.
	max := player size.
	[cc <= max] whileTrue:[
		item := scrollTarget elements at: cc.
		(item label isEmptyOrNil not and: [
		  item label asString first asLowercase = keyChar])
			ifTrue:[^player cursor: cc].
		cc := cc + 1.
	].
	"Search from start to cursor"
	cc := 1.
	max := player cursor - 1.
	[cc <= max] whileTrue:[
		item := scrollTarget elements at: cc.
		(item label isEmptyOrNil not and: [
		  item label asString first asLowercase = keyChar])
			ifTrue:[^player cursor: cc].
		cc := cc + 1.
	].
! !

!CListCostume methodsFor: 'events' stamp: 'bgf 1/24/2008 23:49'!
onLayoutChanged
	"Make sure we're still showing the right selection when the layout 
	of any of our elements get updated."
	<on: layoutChanged in: scrollTarget>

	(player keepCursorInView == false) ifFalse: [
		selectedPlayer ifNotNil:[scrollTarget scrollToShow: selectedPlayer].
	].! !

!CListCostume methodsFor: 'events' stamp: 'ar 11/12/2004 10:58'!
onMouseDown
	"React to a mouse event"
	| selected idx |
	<on: mouseDown>
	hand keyboardFocus: self.
	"Figure out the selection"
	selected := scrollTarget findPlayerAt: scrollTarget cursorPoint.
	selected ifNil:[^self].
	idx := scrollTarget elements indexOf: selected.
	player allowDeselect ifTrue:[
		player cursor = idx ifTrue:[^player cursor: 0].
	].
	"And set newly selected player"
	player cursor: idx.
! !

!CListCostume methodsFor: 'events' stamp: 'ar 10/8/2005 12:05'!
onMouseEnter
	<on: mouseEnter>
	hand autoKeyboardFocus ifTrue:[hand keyboardFocus: self].
	self onMouseMove.! !

!CListCostume methodsFor: 'events' stamp: 'ar 10/8/2005 12:04'!
onMouseLeave
	<on: mouseLeave>
	hand autoKeyboardFocus ifTrue:[hand releaseKeyboardFocus: self].
	self onMouseMove.! !

!CListCostume methodsFor: 'events' stamp: 'ar 10/8/2005 12:04'!
onMouseMove
	| over |
	<on: mouseMove>
	hand anyButtonPressed ifTrue:[^nil].
	"Figure out the selection"
	over := scrollTarget findPlayerAt: scrollTarget cursorPoint.
	over ifNotNil:[over := over asPlayer].
	over == overPlayer ifTrue:[^nil].
	overPlayer ifNotNil:[overPlayer state := #normal].
	overPlayer := over.
	overPlayer ifNotNil:[overPlayer state := #over].
! !

!CListCostume methodsFor: 'events' stamp: 'ar 4/23/2005 15:45'!
onPlayerChanged
	self selectedPlayer: nil.
	super onPlayerChanged.! !

!CListCostume methodsFor: 'events' stamp: 'ar 7/7/2005 13:04'!
onStyleSheetChanged
	super onStyleSheetChanged.
	self onItemsChanged.! !

!CListCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 12:04'!
overPlayer
	"Answer the overPlayer of the receiver"
	<bewareOf: #overPlayerChanged>
	^self propertyValueAt: #overPlayer! !

!CListCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 12:04'!
overPlayer: aValue
	"Modify the receiver's overPlayer"
	^self propertyValueAt: #overPlayer put: aValue with: #overPlayerChanged! !

!CListCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 23:18'!
selectedPlayer
	"This method was automatically generated"
	<bewareOf: #selectedPlayerChanged>
	^self propertyValueAt: #selectedPlayer! !

!CListCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 23:18'!
selectedPlayer: aValue
	"This method was automatically generated"
	^self propertyValueAt: #selectedPlayer put: aValue with: #selectedPlayerChanged! !

!CListCostume methodsFor: 'initialize' stamp: 'bf 7/29/2005 13:21'!
setupCostume
	super setupCostume.
	scrollTarget layout: CTableLayout new.
	scrollTarget layout cellPositioning: #topLeft.
! !

!CListCostume methodsFor: 'accessing' stamp: 'ar 11/12/2004 21:12'!
windowColor: aColor
	| prior |
	super windowColor: aColor.
	scrollTarget selectionColor: aColor.
	prior := self selectedPlayer. 
	prior ifNotNil:[prior deselect; select].
! !

CListLikeCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="playerItems" toSet="playerItems:" changeEvent="playerItemsChanged">playerItems</field>
</fields>'!

!CListLikeCostume methodsFor: 'initialize' stamp: 'ar 5/6/2005 14:07'!
defaultPlayer
	^CList! !

!CListLikeCostume methodsFor: 'events' stamp: 'ar 4/23/2005 15:44'!
onCursorChanged
	"The cursor has changed; update accordingly."
	<on: cursorChanged in: playerItems>! !

!CListLikeCostume methodsFor: 'events' stamp: 'ar 4/23/2005 15:44'!
onItemsChanged
	"The player items have changed; reconstruct me."
	<on: changed in: playerItems>! !

!CListLikeCostume methodsFor: 'private' stamp: 'ar 4/23/2005 15:47'!
onItemsChangedInPlayer
	"There should be no need for subclasses to override this method;
	It merely ensures that changes in the player are propagated accordingly."
	<on: itemsChanged in: player>
	playerItems := player items.
	self onItemsChanged.! !

!CListLikeCostume methodsFor: 'events' stamp: 'ar 4/23/2005 15:44'!
onPlayerChanged
	"My player has changed, update the items"
	super onPlayerChanged.
	self onItemsChangedInPlayer.
	self onCursorChanged.! !

!CListLikeCostume methodsFor: 'accessing' stamp: 'ar 4/23/2005 15:37'!
playerItems
	"Answer the playerItems of the receiver"
	<bewareOf: #playerItemsChanged>
	^self propertyValueAt: #playerItems! !

!CListLikeCostume methodsFor: 'accessing' stamp: 'ar 4/23/2005 15:37'!
playerItems: aValue
	"Modify the receiver's playerItems"
	^self propertyValueAt: #playerItems put: aValue with: #playerItemsChanged! !

CScrollableCostume subclass: #CScrollPaneCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling-Costumes'!

CScrollPaneCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CScrollPaneCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:01'!
defaultPlayer
	^CScrollPane! !

!CScrollPaneCostume methodsFor: 'initialize' stamp: 'ar 3/24/2004 23:19'!
initializeDefaultScrollTarget
	"We don't want a default target since our player will provide the holder to use for this scrollpane"! !

!CScrollPaneCostume methodsFor: 'events' stamp: 'ar 3/26/2004 04:19'!
onHolderChanged
	| oldHolder newHolder |
	<on: holderChanged in: player>
	oldHolder := scrollTarget.
	newHolder := player holder ifNil:[CHolder new].
	oldHolder == newHolder ifTrue:[^self].
	elements replace: oldHolder with: newHolder.
	scrollTarget := newHolder.! !

!CScrollPaneCostume methodsFor: 'events' stamp: 'ar 3/24/2004 23:06'!
onScrollTargetChanged
	self onHolderChanged.! !

CScrollableCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="hScrollBar" toSet="hScrollBar:" changeEvent="hScrollBarChanged">hScrollBar</field>
	<field toGet="vScrollBar" toSet="vScrollBar:" changeEvent="vScrollBarChanged">vScrollBar</field>
	<field toGet="scrollTarget" toSet="scrollTarget:" changeEvent="scrollTargetChanged">scrollTarget</field>
</fields>'!

!CScrollableCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:11'!
cssTag
	"Answer the receiver's default css tag"
	^#scroller! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 22:57'!
hScrollBar
	"Answer the hScrollBar of the receiver"
	<bewareOf: #hScrollBarChanged>
	^self propertyValueAt: #hScrollBar! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 22:57'!
hScrollBar: aValue
	"Modify the receiver's hScrollBar"
	^self propertyValueAt: #hScrollBar put: aValue with: #hScrollBarChanged! !

!CScrollableCostume methodsFor: 'initialize' stamp: 'ar 3/24/2004 23:09'!
initialize
	super initialize.
	self define: #hScrollBar as: CScrollBar new.
	self define: #vScrollBar as: CScrollBar new.
	self initializeDefaultScrollTarget.! !

!CScrollableCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 10:57'!
initializeDefaultScrollTarget
	"Initialize the default scroll target if one is needed"
	self define: #scrollTarget as: CPlayer new.! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 9/8/2004 22:57'!
layout
	^scrollTarget layout! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 9/8/2004 22:57'!
layout: aLayout
	^scrollTarget layout: aLayout! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 3/25/2004 19:54'!
onContextMenu
	| aMenu |
	<on: yellowButtonDown>
	player ifNil:[^self].
	aMenu := player menu ifNil:[^self].
	aMenu openAt: hand position.! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:34'!
onCssTagChanged
	| newTag |
	newTag := (cssTag,'.scrollbar') asSymbol.
	hScrollBar cssTag:  newTag.
	vScrollBar cssTag:  newTag.
	super onCssTagChanged.! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 3/24/2004 22:57'!
onHScrollableChanged
	<on: hScrollableChanged in: player>
	player hScrollable == true
		ifTrue:[hScrollBar visible: true].
	player hScrollable == false
		ifTrue:[hScrollBar visible: false].
	self onUpdateScrollRange.
	self onUpdateLayout.

! !

!CScrollableCostume methodsFor: 'events' stamp: 'bf 7/29/2005 13:20'!
onMouseScrollDown
	| scrollY ht |
	<on: mouseScrollDown>
	ht := (player font ifNil:[TextStyle defaultFont]) height + 4.
	scrollY := scrollTarget scrollOffset y + ht.
	scrollTarget scrollOffset: scrollTarget scrollOffset x @ scrollY.
! !

!CScrollableCostume methodsFor: 'events' stamp: 'bf 7/29/2005 13:19'!
onMouseScrollUp
	| scrollY ht |
	<on: mouseScrollUp>
	ht := (player font ifNil:[TextStyle defaultFont]) height + 4.
	scrollY := scrollTarget scrollOffset y - ht.
	scrollTarget scrollOffset: scrollTarget scrollOffset x @ scrollY.
! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 3/24/2004 23:05'!
onPlayerChanged
	super onPlayerChanged.
	self onScrollTargetChanged.
	self onHScrollableChanged.
	self onVScrollableChanged.
	self onUpdateScrollRange.
	self onUpdateLayout.
! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 3/24/2004 23:02'!
onScrollAbsoluteX
	<on: valueChanged in: hScrollBar>
	scrollTarget ifNil:[^self].
	self pauseScript: #onScrollOffsetChanged.
	scrollTarget scrollOffset: hScrollBar value @ scrollTarget scrollOffset y.
	self resumeScript: #onScrollOffsetChanged.! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 3/24/2004 23:03'!
onScrollAbsoluteY
	<on: valueChanged in: vScrollBar>
	scrollTarget ifNil:[^self].
	self pauseScript: #onScrollOffsetChanged.
	scrollTarget scrollOffset: scrollTarget scrollOffset x @ vScrollBar value.
	self resumeScript: #onScrollOffsetChanged.
! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 3/25/2004 15:56'!
onScrollOffsetChanged
	"Someone scrolled my target programmatically"
	<on: scrollOffsetChanged in: scrollTarget>
	"This is inefficient, but what the hey..."
	self onUpdateScrollRange.
! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 3/24/2004 23:06'!
onScrollTargetChanged
	"If needed, subclasses can insert the appropriate update for a potential change in the scroll target."! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:31'!
onStyleSheetChanged
	hScrollBar styleSheet: self styleSheet.
	vScrollBar styleSheet: self styleSheet.
	super onStyleSheetChanged.! !

!CScrollableCostume methodsFor: 'layout' stamp: 'ar 3/24/2004 22:57'!
onUpdateLayout
	"update the position of all the elements"
	| inset box |
	<on: layoutChanged>
	box := self costume innerBounds.
	inset := 0@0.
	hScrollBar visible ifTrue:[inset := inset x @ hScrollBar height].
	vScrollBar visible ifTrue:[inset := vScrollBar width @ inset y].
	self positionTarget: inset in: box.
	hScrollBar visible ifTrue:[self positionHScrollBar: inset in: box].
	vScrollBar visible ifTrue:[self positionVScrollBar: inset in: box].! !

!CScrollableCostume methodsFor: 'layout' stamp: 'bgf 12/28/2008 01:00'!
onUpdateScrollRange
	"update the scroll range of my scroll bars"
	| visibleArea targetArea scrollExtent visibleExtent delta leftOver visibleFraction offset showScrollBar |
	<on: layoutChanged in: scrollTarget>

	"Be sure to base this on the most recent available layout info..."
	scrollTarget fullBounds.
	offset := scrollTarget scrollOffset.
	delta := scrollTarget scrollDelta.
	targetArea := scrollTarget scrollArea.
	visibleArea := scrollTarget visibleScrollArea.

	"Truncate scrollArea to scrollDelta"
	scrollExtent := targetArea extent.
	visibleExtent := visibleArea extent.

	"make sure we don't divide by zero"
	scrollExtent := scrollExtent max: 1@1.
	visibleExtent := visibleExtent max: 1@1.

	"compute the visible fraction"
	visibleFraction := (visibleExtent / scrollExtent) asFloatPoint.
	visibleFraction := visibleFraction max: 0@0.
	visibleFraction := visibleFraction min: 1@1.

	"compute left over area rounded up to scroll delta"
	leftOver := scrollExtent - visibleExtent.
	"make sure it's not negative"
	leftOver := leftOver max: 0@0.

	hScrollBar min: targetArea left.
	hScrollBar max: leftOver x.
	hScrollBar value: offset x.
	hScrollBar step: delta x.
	hScrollBar pageStep: visibleExtent x.
	hScrollBar visibleFraction: visibleFraction x.
	player hScrollable isNil ifTrue:[
		showScrollBar := visibleFraction x < 1.0.
		showScrollBar = hScrollBar visible ifFalse:[
			hScrollBar visible: showScrollBar.
			self onUpdateLayout]].

	vScrollBar min: targetArea top.
	vScrollBar max: leftOver y.
	vScrollBar value: offset y.
	vScrollBar step: delta y.
	vScrollBar pageStep: visibleExtent y.
	vScrollBar visibleFraction: visibleFraction y.
	player vScrollable isNil ifTrue:[
		showScrollBar := visibleFraction y < 1.0.
		showScrollBar = vScrollBar visible ifFalse:[
			vScrollBar visible: showScrollBar.
			self onUpdateLayout]].! !

!CScrollableCostume methodsFor: 'events' stamp: 'ar 3/24/2004 22:57'!
onVScrollableChanged
	<on: vScrollableChanged in: player>
	player vScrollable == true
		ifTrue:[vScrollBar visible: true].
	player vScrollable == false
		ifTrue:[vScrollBar visible: false].
	self onUpdateScrollRange.
	self onUpdateLayout.! !

!CScrollableCostume methodsFor: 'layout' stamp: 'ar 3/24/2004 22:57'!
positionHScrollBar: inset in: box
	"position my hScrollBar within the box"
	hScrollBar left: box left.
	hScrollBar top: box bottom - inset y.
	hScrollBar width: box width - inset x.
	hScrollBar height: inset y.! !

!CScrollableCostume methodsFor: 'layout' stamp: 'ar 3/24/2004 23:00'!
positionTarget: inset in: box
	"position my target within the box"
	scrollTarget ifNil:[^self].
	scrollTarget left: box left.
	scrollTarget top: box top.
	scrollTarget extent: box extent - inset.! !

!CScrollableCostume methodsFor: 'layout' stamp: 'ar 3/24/2004 22:57'!
positionVScrollBar: inset in: box
	"position my vScrollBar within the box"
	vScrollBar left: box right - inset x.
	vScrollBar top: box top.
	vScrollBar width: inset x.
	vScrollBar height: box height - inset y.! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 8/3/2004 20:07'!
scrollOffset
	^scrollTarget scrollOffset! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 8/3/2004 20:07'!
scrollOffset: aPoint
	scrollTarget scrollOffset: aPoint.! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 22:59'!
scrollTarget
	"Answer the scrollTarget of the receiver"
	<bewareOf: #scrollTargetChanged>
	^self propertyValueAt: #scrollTarget! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 22:59'!
scrollTarget: aValue
	"Modify the receiver's scrollTarget"
	^self propertyValueAt: #scrollTarget put: aValue with: #scrollTargetChanged! !

!CScrollableCostume methodsFor: 'scrolling' stamp: 'ar 11/10/2006 10:57'!
scrollToShow: aRectangleOrPlayer
	"Scroll the receiver to show the given player"
	| box |
	aRectangleOrPlayer ifNil:[^self].
	aRectangleOrPlayer isPlayer 
		ifTrue:[box := aRectangleOrPlayer bounds]
		ifFalse:[box := aRectangleOrPlayer].
	^scrollTarget scrollToShow: (box translateBy: scrollTarget topLeft negated)! !

!CScrollableCostume methodsFor: 'initialize' stamp: 'bgf 6/5/2009 17:33'!
setupCostume
	super setupCostume.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self extent: 100@100.

	self hResizing: #spaceFill; vResizing: #spaceFill.
	self add: hScrollBar.
	hScrollBar orientation: #horizontal; height: hScrollBar buttonHeight asPoint y.
	self add: vScrollBar.
	vScrollBar orientation: #vertical; width: hScrollBar buttonHeight asPoint x.
	scrollTarget ifNotNil:[
		scrollTarget color: Color transparent.
		scrollTarget clipping: true.
		self add: scrollTarget].
! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 22:57'!
vScrollBar
	"Answer the vScrollBar of the receiver"
	<bewareOf: #vScrollBarChanged>
	^self propertyValueAt: #vScrollBar! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 22:57'!
vScrollBar: aValue
	"Modify the receiver's vScrollBar"
	^self propertyValueAt: #vScrollBar put: aValue with: #vScrollBarChanged! !

!CScrollableCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 22:57'!
windowColor: aColor
	super windowColor: aColor.
	hScrollBar windowColor: aColor.
	vScrollBar windowColor: aColor.! !

CScrollableCostume subclass: #CScrollableTextEditorCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text-Costumes'!

!CScrollableTextEditorCostume commentStamp: 'ar 3/27/2004 19:15' prior: 0!
CScrollableTextEditorCostume is a costume for a text editor which provides scrollbars. It delegates the textHolder aspect to its scrollTarget since that's the guy who holds the text for the editor.!

CScrollableTextEditorCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CScrollableTextEditorCostume methodsFor: 'initialize' stamp: 'ar 3/25/2004 16:24'!
defaultColor
	^Color transparent.! !

!CScrollableTextEditorCostume methodsFor: 'initialize' stamp: 'ar 3/25/2004 15:51'!
defaultPlayer
	^CTextEditor! !

!CScrollableTextEditorCostume methodsFor: 'events' stamp: 'ar 5/19/2004 15:13'!
onPlayerChanged
	"scrollTarget player: player."
	scrollTarget := player target.
	super onPlayerChanged.! !

!CScrollableTextEditorCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:53'!
setupCostume
	super setupCostume.
	scrollTarget borderColor: Color transparent.! !

!CScrollableTextEditorCostume methodsFor: 'accessing' stamp: 'ar 3/25/2004 15:50'!
textHolder
	^scrollTarget textHolder! !

CScrollableCostume subclass: #CTreeWidgetCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Trees-Costumes'!

!CTreeWidgetCostume commentStamp: '<historical>' prior: 0!
A scrolling tree widget costume.!

CTreeWidgetCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="selectedPlayer" toSet="selectedPlayer:" changeEvent="selectedPlayerChanged">selectedPlayer</field>
	<field toGet="overPlayer" toSet="overPlayer:" changeEvent="overPlayerChanged">overPlayer</field>
</fields>'!

!CTreeWidgetCostume methodsFor: 'accessing' stamp: 'ar 3/9/2004 02:15'!
cursor
	^self player cursor! !

!CTreeWidgetCostume methodsFor: 'accessing' stamp: 'ar 3/9/2004 02:15'!
cursor: newCursor
	^self player cursor: newCursor! !

!CTreeWidgetCostume methodsFor: 'initialize' stamp: 'ar 3/9/2004 02:15'!
defaultPlayer
	^CTreeWidget! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'bgf 8/14/2008 15:14'!
onContextMenu
	| aMenu |
	"Provides select-under-pointer behavior,
	 so the context menu refers to what you pointed at,
	 not what you might previously have selected.
	 (In line with more recent desktop conventions.)"
	<on: yellowButtonDown>
	player ifNil:[^self].
	self selectUnderPointer ifTrue: [ self waitTick ].  "Allow the cursor change to propagate."
	aMenu := player menu ifNil:[^self].
	aMenu openAt: hand position.! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'bgf 1/9/2010 11:27'!
onCursorChanged
	| selected clippedCursor |
	<on: cursorChanged in: player>
	selected := self selectedPlayer.
	selected ifNotNil:[selected deselect].
	clippedCursor := player cursor min: scrollTarget elements size max: 0.
	clippedCursor > 0
		ifTrue:[selected := scrollTarget elements at: clippedCursor]
		ifFalse:[selected := nil].
	self selectedPlayer: selected.
	selected ifNotNil:[
		selected select.
		player keepCursorInView ifTrue: [
			scrollTarget scrollToShow: selected.
		].
	].! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'ar 3/14/2005 22:51'!
onItemsChanged
	<on: changed in: player>
	scrollTarget elements: player treeNodes.
	self onCursorChanged.! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'bgf 11/23/2009 09:34'!
onKeyDown: event
	"React to a key event"
	| action item |
	<on: keyDown>
	action := CPlatform current standardEditingKeys lookupEvent: event.
	"Basic cursor key navigation"
	action == #moveLineStart 
		ifTrue: [^self cursor: 1].  "home"
	action == #moveLineEnd 
		ifTrue: [^self cursor: self scrollTarget elements size].   "end"
	(action == #moveLineDown and:[self cursor < self player size])
		ifTrue:[self cursor: self cursor + 1]. "down"
	(action == #moveLineUp and:[self cursor > 1])
		ifTrue:[self cursor: self cursor - 1]. "up"
	selectedPlayer ifNil:[^self].
	item := selectedPlayer.
	(action == #moveCursorLeft) ifTrue:["left"
		item expanded 
			ifTrue:[^item collapse]
			ifFalse:[^self cursor: (player indexOfTreeNode: item parent)].
	].
	(action == #moveCursorRight) ifTrue:["right"
		item expanded 
			ifFalse:[^item expand].
	].
! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'bf 7/29/2005 13:45'!
onKeyStroke: event
	"See if we have an entry which starts with the key character"
	| keyChar nodes cc max item |
	<on: keyStroke>
	keyChar := event keyCharacter asLowercase.
	nodes := player treeNodes.
	"Search from cursor to end"
	cc := self cursor + 1.
	max := nodes size.
	[cc <= max] whileTrue:[
		item := nodes at: cc.
		item label asString first asLowercase = keyChar 
			ifTrue:[^self cursor: cc].
		cc := cc + 1.
	].
	"Search from start to cursor"
	cc := 1.
	max := self cursor - 1.
	[cc <= max] whileTrue:[
		item := nodes at: cc.
		item label asString first asLowercase = keyChar 
			ifTrue:[^self cursor: cc].
		cc := cc + 1.
	].
! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'bgf 1/9/2010 11:40'!
onMouseDown: evt
	"React to a mouse event"
	| selected idx |
	<on: mouseDown>
	hand keyboardFocus: self.
	"Figure out the selection"
	selected := scrollTarget findPlayerAt: scrollTarget cursorPoint.
	selected ifNil:[^self].
	(selected inToggleArea: selected cursorPoint) ifTrue:[
		selected := selected player.
		selected expanded 
			ifTrue:[selected collapse]
			ifFalse:[evt shiftPressed
				ifTrue:[selected expandFullySafe] 
				ifFalse:[selected expand]].
		player keepCursorInView ifTrue: [scrollTarget scrollToShow: selected].
		^ self ].
	idx := scrollTarget elements indexOf: selected.
	player allowDeselect ifTrue:[
		self cursor = idx ifTrue:[^self cursor: 0].
	].
	"And set newly selected player"
	self cursor: idx.
! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'ar 10/8/2005 11:18'!
onMouseEnter
	<on: mouseEnter>
	hand autoKeyboardFocus ifTrue:[hand keyboardFocus: self].
	self onMouseMove.! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'ar 10/8/2005 11:18'!
onMouseLeave
	<on: mouseLeave>
	hand autoKeyboardFocus ifTrue:[hand releaseKeyboardFocus: self].
	self onMouseMove.! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'ar 10/8/2005 11:35'!
onMouseMove
	| over |
	<on: mouseMove>
	hand anyButtonPressed ifTrue:[^nil].
	"Figure out the selection"
	over := scrollTarget findPlayerAt: scrollTarget cursorPoint.
	over ifNotNil:[over := over asPlayer].
	over == overPlayer ifTrue:[^nil].
	overPlayer ifNotNil:[overPlayer state := #normal].
	overPlayer := over.
	overPlayer ifNotNil:[overPlayer state := #over].
! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'ar 3/14/2005 22:51'!
onPlayerChanged
	super onPlayerChanged.
	self selectedPlayer: nil.
	self onItemsChanged.
! !

!CTreeWidgetCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:15'!
overPlayer
	"Answer the overPlayer of the receiver"
	<bewareOf: #overPlayerChanged>
	^self propertyValueAt: #overPlayer! !

!CTreeWidgetCostume methodsFor: 'accessing' stamp: 'ar 10/8/2005 11:15'!
overPlayer: aValue
	"Modify the receiver's overPlayer"
	^self propertyValueAt: #overPlayer put: aValue with: #overPlayerChanged! !

!CTreeWidgetCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 00:46'!
playerCopyFrom: start to: stop
	^player treeNodes copyFrom: start to: stop! !

!CTreeWidgetCostume methodsFor: 'events' stamp: 'bgf 8/14/2008 15:07'!
selectUnderPointer
	"If the pointer is over an item in the tree, select it; else do nothing;
	 return true if the cursor was changed."
	| st item idx |
	st :=  scrollTarget ifNil: [ ^ false ].
	item := st findPlayerAt: st cursorPoint.
	item ifNotNil: [
		idx := st elements indexOf: item.
		(idx > 0 and: [ self cursor ~= idx]) ifTrue: [
			self cursor: idx.
			^ true
		].
	].
	^ false! !

!CTreeWidgetCostume methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:16'!
selectedPlayer
	"This method was automatically generated"
	<bewareOf: #selectedPlayerChanged>
	^self propertyValueAt: #selectedPlayer! !

!CTreeWidgetCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 18:30'!
selectedPlayer: aValue
	"This method was automatically generated"
	^self propertyValueAt: #selectedPlayer put: aValue with: #selectedPlayerChanged! !

!CTreeWidgetCostume methodsFor: 'initialize' stamp: 'bgf 2/3/2008 10:22'!
setupCostume
	super setupCostume.
	scrollTarget layout: CTableLayout new.
	scrollTarget layout cellPositioning: #topLeft.
	scrollTarget layoutInset: 2@1.	"So the icons don't bump the borders."
! !

!CTreeWidgetCostume methodsFor: 'accessing' stamp: 'ar 11/12/2004 21:12'!
windowColor: aColor
	| prior |
	super windowColor: aColor.
	scrollTarget selectionColor: aColor.
	prior := self selectedPlayer. 
	prior ifNotNil:[prior deselect; select].
! !

CWidgetCostume subclass: #CSliderCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling-Costumes'!

CSliderCostume subclass: #CScrollBarCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling-Costumes'!

CScrollBarCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="forwardButton" toSet="forwardButton:" changeEvent="forwardButtonChanged">forwardButton</field>
	<field toGet="backButton" toSet="backButton:" changeEvent="backButtonChanged">backButton</field>
	<field toGet="knob" toSet="knob:" changeEvent="knobChanged">knob</field>
	<field toGet="knobShadow" toSet="knobShadow:" changeEvent="knobShadowChanged">knobShadow</field>
</fields>'!

!CScrollBarCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:12'!
cssTag
	"Answer the receiver's default css tag"
	^#scrollbar! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
backButton
	"Answer the backButton of the receiver"
	<bewareOf: #backButtonChanged>
	^self propertyValueAt: #backButton! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
backButton: aValue
	"Modify the receiver's backButton"
	^self propertyValueAt: #backButton put: aValue with: #backButtonChanged! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:24'!
buttonHeight
	^self player buttonHeight! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:24'!
buttonHeight: aNumber
	self player buttonHeight: aNumber! !

!CScrollBarCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:01'!
defaultPlayer
	^CScrollBar! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
forwardButton
	"Answer the forwardButton of the receiver"
	<bewareOf: #forwardButtonChanged>
	^self propertyValueAt: #forwardButton! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
forwardButton: aValue
	"Modify the receiver's forwardButton"
	^self propertyValueAt: #forwardButton put: aValue with: #forwardButtonChanged! !

!CScrollBarCostume methodsFor: 'initialize' stamp: 'ar 7/7/2005 13:03'!
initialize
	super initialize.
	self define: #knobShadow as: CWidget new.
	self define: #forwardButton as: CPushButton new.
	self define: #backButton as: CPushButton new.
	self define: #knob as: CWidget new.
! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 2/9/2004 17:58'!
innerBounds
	"Answer the inner bounds for positioning the knob"
	self isHorizontal
		ifTrue:[^backButton topRight corner: forwardButton bottomLeft]
		ifFalse:[^backButton bottomLeft corner: forwardButton topRight].! !

!CScrollBarCostume methodsFor: 'testing' stamp: 'ar 2/8/2004 20:26'!
isHorizontal
	self orientation ifNil:[^self width >= self height].
	^self orientation == #horizontal.! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
knob
	"Answer the knob of the receiver"
	<bewareOf: #knobChanged>
	^self propertyValueAt: #knob! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
knob: aValue
	"Modify the receiver's knob"
	^self propertyValueAt: #knob put: aValue with: #knobChanged! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
knobShadow
	"Answer the knobShadow of the receiver"
	<bewareOf: #knobShadowChanged>
	^self propertyValueAt: #knobShadow! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:29'!
knobShadow: aValue
	"Modify the receiver's knobShadow"
	^self propertyValueAt: #knobShadow put: aValue with: #knobShadowChanged! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/13/2004 21:30'!
onButtonHeightChanged
	<on: buttonHeightChanged in: player>
	self onUpdateScrollBar.
	self onExtentChanged.! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:34'!
onCssTagChanged
	knob cssTag:  (cssTag,'.scrollpane') asSymbol.
	forwardButton cssTag:  (cssTag,'.scrollbuttondown') asSymbol.
	backButton cssTag:  (cssTag,'.scrollbuttonup') asSymbol.
	super onCssTagChanged.! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/9/2004 17:47'!
onExtentChanged
	<on: extentChanged>
	self isHorizontal 
		ifTrue:[self height: self buttonHeight asPoint y]
		ifFalse:[self width: self buttonHeight asPoint x]
! !

!CScrollBarCostume methodsFor: 'layout' stamp: 'ar 2/8/2004 20:38'!
onLayoutChanged
	<on: layoutChanged>
	self onUpdateScrollBar.
! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/13/2004 21:30'!
onMaxChanged
	<on: maxChanged in: player>
	self onValueChanged.
	self onUpdateScrollBar.
! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/13/2004 21:30'!
onMinChanged
	<on: minChanged in: player>
	self onValueChanged.
	self onUpdateScrollBar.
! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/13/2004 21:30'!
onOrientationChanged
	<on: orientationChanged in: player>
	self onUpdateScrollBar.! !

!CScrollBarCostume methodsFor: 'events' stamp: 'bgf 2/22/2009 20:39'!
onScrollAbsolute
	"Scroll to the given point (relative to the KnobHolder)"
	| offset |
	<on: mouseDown in: knob>
	knobShadow bounds: knob bounds.
	knobShadow visible: false.	"BGF experiment (Shadow mostly creates distracting flicker.)"
	offset := knob cursorPoint.
	self hand forEach: #mouseMove do:[
		self onScrollAbsolute: offset.
	] until: #mouseUp.
	knobShadow visible: false.
! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/8/2004 20:30'!
onScrollAbsolute: offset
	"Scroll to the given point (relative to the KnobHolder)"
	| innerRect innerPoint relativeValue absValue aPoint |

	"Compute the inner rectangle for the slider"
	innerRect := self innerBounds.
	innerRect := innerRect insetBy: (0@0 extent: knob extent).

	"Check if the knob is larger than the slider(huh!!)"
	self isHorizontal
		ifTrue: [innerRect width <= 0 ifTrue: [^ self]]
		ifFalse: [innerRect height <= 0 ifTrue: [^ self]].

	aPoint := self cursorPoint - offset.

	"Make sure the point is within the inner rectangle,
	and compute its offset from the top-left of the slider"
	innerPoint := (aPoint adhereTo: innerRect) - innerRect topLeft.

	"Compute the relative (fractional) value"
	self isHorizontal
		ifTrue:[relativeValue := innerPoint x / innerRect width]
		ifFalse:[relativeValue := innerPoint y / innerRect height].

	"Compute the absolute (rounded) value"
	absValue := self min + (self range * relativeValue).

	"And set my value appropriately"
	self value: absValue.! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/8/2004 20:30'!
onScrollBack
	| scrollScript |
	<on: mouseDown in: backButton>
	scrollScript := self startScript:[self onScrollBy: self step negated].
	self hand waitUntil: #mouseUp.
	self stopScript: scrollScript.
! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/8/2004 20:31'!
onScrollBy: delta
	| initialDelay finalDelay delayTime |
	initialDelay := 400.
	finalDelay := 20.
	delayTime := initialDelay.
	[true] whileTrue:[
		self value: self value + delta.
		(Delay forMilliseconds: delayTime) wait.
		self waitTick.
		"Decrease delay time to delay2"
		delayTime := delayTime * 9 // 10 max: finalDelay.
	].
! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 3/26/2004 00:38'!
onScrollByPage
	| scrollScript delta oldFill pageDelta |
	<on: mouseDown>
	pageDelta := self pageStep.
	pageDelta ifNil:[
		self onScrollAbsolute: knob extent // 2.
		self hand forEach: #mouseMove do:[
			self onScrollAbsolute: knob extent // 2.
		] until: #mouseUp.
		^self].

	"scroll by page"
	self isHorizontal ifTrue:[
		knob cursorPoint x < 0
			ifTrue:[delta := pageDelta negated]
			ifFalse:[delta := pageDelta].
	] ifFalse:[
		knob cursorPoint y < 0
			ifTrue:[delta := pageDelta negated]
			ifFalse:[delta := pageDelta].
	].
	oldFill := fill copy.
	color := Color veryLightGray.
	scrollScript := self startScript: [self onScrollByPage: delta].
	hand waitUntil: #mouseUp.
	self stopScript: scrollScript.
	fill := oldFill.! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 3/26/2004 00:53'!
onScrollByPage: delta
	| initialDelay finalDelay delayTime startValue stopValue startTime stopTime nowTime fraction |
	initialDelay := 400.
	finalDelay := 20.
	delayTime := initialDelay.
	[true] whileTrue:[
		startValue := self value.
		stopValue := startValue + delta.
		startTime := Time millisecondClockValue.
		stopTime := startTime + delayTime.
		[nowTime := Time millisecondClockValue.
		nowTime < stopTime] whileTrue:[
			fraction := (nowTime - startTime) / delayTime asFloat.
			value := startValue + (delta * fraction).
			self waitTick.
		].
		value := stopValue.
		"Decrease delay time to delay2"
		delayTime := delayTime * 9 // 10 max: finalDelay.
	].! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/8/2004 20:33'!
onScrollForward
	| scrollScript |
	<on: mouseDown in: forwardButton>
	scrollScript := self startScript:[self onScrollBy: self step].
	self hand waitUntil: #mouseUp.
	self stopScript: scrollScript.
! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:31'!
onStyleSheetChanged
	forwardButton styleSheet: self styleSheet.
	backButton styleSheet: self styleSheet.
	knob styleSheet: self styleSheet.
	super onStyleSheetChanged.! !

!CScrollBarCostume methodsFor: 'layout' stamp: 'bgf 3/30/2009 21:50'!
onUpdateScrollBar
	"Re-arrange my contents when the layout changes"
	| box buttonExtent aFraction maxExtent |
	box := self costume innerBounds.
	maxExtent := (box extent // 3) min: self buttonHeight asPoint.
	self isHorizontal ifTrue:[
		buttonExtent := maxExtent x @ box height.
		backButton topLeft: box topLeft.
		backButton extent: buttonExtent.
		forwardButton topRight: box topRight.
		forwardButton extent: buttonExtent.
		knob top: box top.
		knob height: box height.
		(forwardButton image == (CIconLibrary default at: #ScrollRightIcon)) ifFalse:[
			forwardButton image:  (CIconLibrary default at: #ScrollRightIcon).
			forwardButton fillAngle: 90.
			backButton image:  (CIconLibrary default at: #ScrollLeftIcon).
			backButton fillAngle: 90.
			knob fillAngle: 90.
		].
	] ifFalse:[
		buttonExtent := box width @ maxExtent y.
		backButton topLeft: box topLeft.
		backButton extent: buttonExtent.
		forwardButton bottomLeft: box bottomLeft.
		forwardButton extent: buttonExtent.
		knob left: box left.
		knob width: box width.
		(forwardButton image == (CIconLibrary default at: #ScrollDownIcon)) ifFalse:[
			forwardButton image: (CIconLibrary default at: #ScrollDownIcon).
			forwardButton fillAngle: 0.
			backButton image: (CIconLibrary default at: #ScrollUpIcon).
			backButton fillAngle: 0.
			knob fillAngle: 0.
		].
	].
	"Update the knob's size"
	self visibleFraction ifNil:[
		self isHorizontal 
			ifTrue:[knob width: buttonExtent x//2]
			ifFalse:[knob height: buttonExtent y//2].
	] ifNotNil:[
		aFraction := self visibleFraction min: 1.0 max: 0.0.
		knob visible: aFraction < 1.
		buttonExtent := (self innerBounds extent * aFraction) truncated.
		self isHorizontal 
			ifTrue:[knob width: (buttonExtent x  max: (maxExtent x //2))]
			ifFalse:[knob height: (buttonExtent y  max: (maxExtent y//2))].
	].
	self positionKnob.! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 3/17/2004 17:34'!
onValueChanged
	<on: valueChanged>
	self positionKnob.! !

!CScrollBarCostume methodsFor: 'events' stamp: 'ar 2/13/2004 21:30'!
onVisibleFractionChanged
	<on: visibleFractionChanged in: player>
	self onUpdateScrollBar.
! !

!CScrollBarCostume methodsFor: 'layout' stamp: 'ar 2/8/2004 20:38'!
positionKnob
	"Position the knob appropriately"
	| box innerRect |
	box := self innerBounds.
	innerRect := box insetBy: (0@0 extent: knob extent).
	self isHorizontal ifTrue:[
		knob left: innerRect left + (innerRect width * self fraction) truncated.
	] ifFalse:[
		knob top: innerRect top + (innerRect height * self fraction) truncated.
	].! !

!CScrollBarCostume methodsFor: 'initialize' stamp: 'bgf 9/12/2009 03:10'!
setupCostume
	super setupCostume.
	self extent: 100@10.

	self asPrimCostume localCache: CFormCache new.

	self add: knobShadow.
	knobShadow visible: false.
	knobShadow color: (CWidgetLibrary default paneColor 
							adjustSaturation: 0.04 brightness: -0.18).
	knobShadow borderStyle: #inset.
	knobShadow borderWidth: 1.

	self add: knob.
	knob borderStyle: #raised.
	knob borderWidth: 1.
	knob fillStyle: #verticalGradient.
	knob fillColors: CWidgetLibrary default scrollbarGradientColors.

	forwardButton costume: CScrollButtonCostume new.
	forwardButton image: (CIconLibrary default at: #ScrollDownIcon).
	self add: forwardButton.

	backButton costume: CScrollButtonCostume new.
	backButton image: (CIconLibrary default at: #ScrollUpIcon).
	self add: backButton.

	forwardButton cssTag: #scrollbuttondown.
	backButton cssTag: #scrollbuttonup.
	knob cssTag: #scrollpane.

	self color: (CWidgetLibrary default paneColor adjustSaturation: 0.02 brightness: -0.11).! !

!CScrollBarCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 00:06'!
windowColor: aColor
	super windowColor: aColor.
	forwardButton windowColor: aColor.
	backButton windowColor: aColor.
	knob windowColor: aColor.
	knob fillColors: {Color white. aColor}.! !

CSliderCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CSliderCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:11'!
cssTag
	"Answer the receiver's default css tag"
	^#slider! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
adoptValue: newValue
	^self player adoptValue: newValue! !

!CSliderCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:01'!
defaultPlayer
	^CSlider! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
fraction
	^self player fraction! !

!CSliderCostume methodsFor: 'testing' stamp: 'ar 2/9/2004 18:52'!
isHorizontal
	self orientation ifNil:[^self width >= self height].
	^self orientation == #horizontal.! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:22'!
max
	^self player max! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
max: aValue
	self player max: aValue! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
min
	^self player min! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
min: aValue
	^self player min: aValue! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
orientation
	^self player orientation! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
orientation: aSymbol
	self player orientation: aSymbol! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/26/2004 16:50'!
pageStep
	^self player pageStep! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
pageStep: aNumber
	self player pageStep: aNumber! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:22'!
range
	^self player range! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
step
	^self player step! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
step: aValue
	^self player step: aValue! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:22'!
visibleFraction
	^self player visibleFraction! !

!CSliderCostume methodsFor: 'accessing' stamp: 'ar 2/13/2004 21:23'!
visibleFraction: newFraction
	self player visibleFraction: newFraction! !

CSliderCostume subclass: #CWheelWidgetCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling-Costumes'!

CWheelWidgetCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="maxAngle" toSet="maxAngle:" changeEvent="maxAngleChanged">maxAngle</field>
	<field toGet="wheelAngle" toSet="wheelAngle:" changeEvent="wheelAngleChanged">wheelAngle</field>
</fields>'!

!CWheelWidgetCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:02'!
defaultPlayer
	^CWheelWidget! !

!CWheelWidgetCostume methodsFor: 'drawing' stamp: 'ar 3/26/2004 23:40'!
drawOn: aCanvas in: box
	| interval delta frame x0 x1 y0 y1 deltaX deltaY  hilitColor shadowColor |
	super drawOn: aCanvas in: box.		"border & background"
	hilitColor := self color lighter lighter.
	shadowColor := self color darker darker.
	frame := self costume innerBounds insetBy: 2.
	aCanvas frameAndFillRectangle: frame fillColor: Color transparent
		borderWidth: 1 topLeftColor: hilitColor bottomRightColor: shadowColor.
	frame := frame insetBy: 2.
	x0 := frame origin x.
	x1 := frame corner x.
	y0 := frame origin y.
	y1 := frame corner y.
	deltaX := (x1 - x0) / 2.
	deltaY := (y1 - y0) / 2.
	interval := 10.
	delta := self wheelAngle \\ interval.
	self isHorizontal ifTrue:[delta := delta asPoint x] ifFalse:[delta := delta asPoint y].
	1 to: (self maxAngle / (2 * interval)) rounded do: [ :i |
		| xx yy |
		self isHorizontal ifTrue: [
			xx := x0 + deltaX - (((i * interval + delta) * (2 * Float pi / 360.0)) cos * deltaX).
			aCanvas fillRectangle: (Rectangle origin: (xx-1)@y0 corner: xx@y1) color: hilitColor.
			aCanvas fillRectangle: (Rectangle origin: xx@y0 corner: (xx+1)@y1) color: shadowColor
		] ifFalse:[
			yy := y0 + deltaY - (((i * interval + delta) * (2 * Float pi / 360.0)) cos * deltaY).
			aCanvas fillRectangle: (Rectangle origin: x0@(yy-1) corner: x1@yy) color: hilitColor.
			aCanvas fillRectangle: (Rectangle origin: x0@yy corner: x1@(yy+1)) color: shadowColor.
		].
	].! !

!CWheelWidgetCostume methodsFor: 'initialize' stamp: 'ar 3/29/2004 14:54'!
initialize
	super initialize.
	self userDraw: true.
	self maxAngle: 360.
	self wheelAngle: 0.! !

!CWheelWidgetCostume methodsFor: 'field access' stamp: 'ar 3/17/2004 15:16'!
maxAngle
	"This method was automatically generated"
	<bewareOf: #maxAngleChanged>
	^self propertyValueAt: #maxAngle! !

!CWheelWidgetCostume methodsFor: 'field access' stamp: 'ar 3/11/2004 14:28'!
maxAngle: aValue
	"This method was automatically generated"
	^self propertyValueAt: #maxAngle put: aValue with: #maxAngleChanged! !

!CWheelWidgetCostume methodsFor: 'events' stamp: 'ar 2/9/2004 19:07'!
onMouseDown
	| old new delta oldValue |
	<on: mouseDown>
	old := self cursorPoint.
	oldValue := self value.
	self hand forEach: #mouseMove do:[
		new := self cursorPoint.
		delta := new - old.
		self isHorizontal ifTrue:[delta := delta x] ifFalse:[delta := delta y].
		self wheelAngle: delta.
		self value: oldValue + delta.
		self invalidate.
	] until: #mouseUp.
! !

!CWheelWidgetCostume methodsFor: 'field access' stamp: 'ar 3/17/2004 15:16'!
wheelAngle
	"This method was automatically generated"
	<bewareOf: #wheelAngleChanged>
	^self propertyValueAt: #wheelAngle! !

!CWheelWidgetCostume methodsFor: 'field access' stamp: 'ar 3/11/2004 14:28'!
wheelAngle: aValue
	"This method was automatically generated"
	^self propertyValueAt: #wheelAngle put: aValue with: #wheelAngleChanged! !

CWidgetCostume subclass: #CSpinnerButtonsCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling-Costumes'!

CSpinnerButtonsCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="upButton" toSet="upButton:" changeEvent="upButtonChanged">upButton</field>
	<field toGet="downButton" toSet="downButton:" changeEvent="downButtonChanged">downButton</field>
</fields>'!

!CSpinnerButtonsCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:16'!
downButton
	"Answer the downButton of the receiver"
	<bewareOf: #downButtonChanged>
	^self propertyValueAt: #downButton! !

!CSpinnerButtonsCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:16'!
downButton: aValue
	"Modify the receiver's downButton"
	^self propertyValueAt: #downButton put: aValue with: #downButtonChanged! !

!CSpinnerButtonsCostume methodsFor: 'initialize' stamp: 'be 9/26/2005 16:57'!
initialize
	super initialize.
	self define: #upButton as: CPushButton new.
	upButton cssTag: #spinnerup.
	self define: #downButton as: CPushButton new.
	downButton cssTag: #spinnerdown.
! !

!CSpinnerButtonsCostume methodsFor: 'events' stamp: 'be 9/27/2005 13:24'!
onCssTagChanged

	upButton cssTag: (cssTag,'up' ) asSymbol.
	downButton cssTag: (cssTag,'down' ) asSymbol.
	super onCssTagChanged.
! !

!CSpinnerButtonsCostume methodsFor: 'events' stamp: 'ar 3/25/2004 21:57'!
onSpinDown
	<on: mouseDown in: downButton>
	self signal: #spinDown.! !

!CSpinnerButtonsCostume methodsFor: 'events' stamp: 'ar 3/25/2004 22:29'!
onSpinUp
	<on: mouseDown in: upButton>
	self signal: #spinUp.! !

!CSpinnerButtonsCostume methodsFor: 'events' stamp: 'be 9/26/2005 17:28'!
onStyleSheetChanged

	upButton styleSheet: self styleSheet.
	downButton styleSheet: self styleSheet.
	super onStyleSheetChanged! !

!CSpinnerButtonsCostume methodsFor: 'initialize' stamp: 'tk 7/14/2004 11:28'!
setupCostume
	super setupCostume.
	self layout: CTableLayout new.
	self asPrimCostume localCache: CFormCache new.
	self hResizing: #rigid; vResizing: #spaceFill.
	self extent: 16@22.

	upButton font: (TextStyle named:'WindowFont') defaultFont.
	upButton hResizing: #spaceFill; vResizing: #spaceFill.
	upButton label: 'u'.
	upButton fillAngle: 0.
	self add: upButton.


	downButton font: (TextStyle named:'WindowFont') defaultFont.
	downButton hResizing: #spaceFill; vResizing: #spaceFill.
	downButton label: 'd'.
	downButton fillAngle: 0.
	self add: downButton.
! !

!CSpinnerButtonsCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:16'!
upButton
	"Answer the upButton of the receiver"
	<bewareOf: #upButtonChanged>
	^self propertyValueAt: #upButton! !

!CSpinnerButtonsCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:16'!
upButton: aValue
	"Modify the receiver's upButton"
	^self propertyValueAt: #upButton put: aValue with: #upButtonChanged! !

CWidgetCostume subclass: #CSpinnerCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Scrolling-Costumes'!

CSpinnerCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="spinnerLabel" toSet="spinnerLabel:" changeEvent="spinnerLabelChanged">spinnerLabel</field>
	<field toGet="spinnerButtons" toSet="spinnerButtons:" changeEvent="spinnerButtonsChanged">spinnerButtons</field>
	<field toGet="spinnerValue" toSet="spinnerValue:" changeEvent="spinnerValueChanged">spinnerValue</field>
</fields>'!

!CSpinnerCostume methodsFor: 'initialize' stamp: 'ar 3/13/2004 23:59'!
defaultPlayer
	^CSpinner! !

!CSpinnerCostume methodsFor: 'initialize' stamp: 'ar 3/17/2004 03:15'!
initialize
	super initialize.
	self define: #spinnerLabel as: CLabel new.
	self define: #spinnerValue as: CInputField new.
	self define: #spinnerButtons as: CSpinnerButtonsCostume new.! !

!CSpinnerCostume methodsFor: 'events' stamp: 'be 9/27/2005 13:25'!
onCssTagChanged

	spinnerLabel cssTag:  (cssTag,'.spinnerlabel' ) asSymbol.
	spinnerValue  cssTag:  (cssTag,'.spinnerinputfield' ) asSymbol.
	spinnerButtons  cssTag:  (cssTag,'.spinnerbutton' ) asSymbol.
	super onCssTagChanged.
! !

!CSpinnerCostume methodsFor: 'events' stamp: 'ar 3/14/2004 00:45'!
onInputValueChanged
	| newValue |
	<on: accept in: spinnerValue>
	newValue := [Number readFrom: spinnerValue contents asString] on: Error do:[:ex|
		spinnerValue flash.
		ex return: nil].
	newValue ifNotNil:[player value: newValue].
	spinnerValue value: player value.! !

!CSpinnerCostume methodsFor: 'events' stamp: 'ar 3/23/2004 23:17'!
onLabelChanged
	<on: labelChanged in: player>
	spinnerLabel value: player label.
	spinnerLabel visible: player label notNil.
	spinnerValue hResizing: (spinnerLabel visible ifTrue:[#rigid] ifFalse:[#spaceFill]).! !

!CSpinnerCostume methodsFor: 'events' stamp: 'ar 3/25/2004 21:58'!
onPlayerChanged
	<on: playerChanged>
	super onPlayerChanged.
	self onLabelChanged.
	self onValueChanged.! !

!CSpinnerCostume methodsFor: 'events' stamp: 'ar 9/27/2005 13:33'!
onSpinDown
	<on: spinDown in: spinnerButtons>
	player value: ((player value - player step) roundTo: player step)! !

!CSpinnerCostume methodsFor: 'events' stamp: 'ar 9/27/2005 13:33'!
onSpinUp
	<on: spinUp in: spinnerButtons>
	player value: ((player value + player step) roundTo: player step)! !

!CSpinnerCostume methodsFor: 'events' stamp: 'ar 3/14/2004 00:04'!
onSpinnerValueChanged
	<on: valueChanged in: player>
	spinnerValue value: player value.! !

!CSpinnerCostume methodsFor: 'events' stamp: 'be 9/26/2005 17:26'!
onStyleSheetChanged

	spinnerLabel styleSheet: self styleSheet.
	spinnerValue styleSheet: self styleSheet.
	spinnerButtons styleSheet: self styleSheet.
	super onStyleSheetChanged! !

!CSpinnerCostume methodsFor: 'events' stamp: 'ar 3/17/2004 17:34'!
onValueChanged
	<on: valueChanged>
	spinnerValue value: player value.! !

!CSpinnerCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:54'!
setupCostume
	super setupCostume.
	self height: 20.
	self color: Color transparent.
	self clipping: false.
	self layout: CTableLayout new.
	self layout listDirection: #leftToRight.
	self vResizing: #shrinkWrap; hResizing: #spaceFill.

	spinnerLabel clipping: false.
	spinnerLabel textAnchorPoint: #rightCenter.
	self add: spinnerLabel.

	spinnerValue hResizing: #rigid.
	spinnerValue vResizing: #spaceFill.
	self add: spinnerValue.

	self add: spinnerButtons.
! !

!CSpinnerCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:57'!
spinnerButtons
	"Answer the spinnerButtons of the receiver"
	<bewareOf: #spinnerButtonsChanged>
	^self propertyValueAt: #spinnerButtons! !

!CSpinnerCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:57'!
spinnerButtons: aValue
	"Modify the receiver's spinnerButtons"
	^self propertyValueAt: #spinnerButtons put: aValue with: #spinnerButtonsChanged! !

!CSpinnerCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:57'!
spinnerLabel
	"Answer the spinnerLabel of the receiver"
	<bewareOf: #spinnerLabelChanged>
	^self propertyValueAt: #spinnerLabel! !

!CSpinnerCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:57'!
spinnerLabel: aValue
	"Modify the receiver's spinnerLabel"
	^self propertyValueAt: #spinnerLabel put: aValue with: #spinnerLabelChanged! !

!CSpinnerCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:57'!
spinnerValue
	"Answer the spinnerValue of the receiver"
	<bewareOf: #spinnerValueChanged>
	^self propertyValueAt: #spinnerValue! !

!CSpinnerCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 23:57'!
spinnerValue: aValue
	"Modify the receiver's spinnerValue"
	^self propertyValueAt: #spinnerValue put: aValue with: #spinnerValueChanged! !

CWidgetCostume subclass: #CSpinnerListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

CSpinnerListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="spinner" toSet="spinner:" changeEvent="spinnerChanged">spinner</field>
</fields>'!

!CSpinnerListCostume methodsFor: 'initialize' stamp: 'ar 4/3/2004 20:10'!
defaultPlayer
	^CList! !

!CSpinnerListCostume methodsFor: 'accessing' stamp: 'ar 12/10/2005 20:52'!
hResizing: aSymbol
	costume hResizing: aSymbol.
	label hResizing: aSymbol.! !

!CSpinnerListCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 12:46'!
initialize
	super initialize.
	self define: #label as: CLabel new.
	self define: #spinner as: CSpinnerButtons new.
	label value: ' '.! !

!CSpinnerListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CSpinnerListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CSpinnerListCostume methodsFor: 'events' stamp: 'ar 10/8/2005 12:23'!
onCursorChanged
	<on: cursorChanged in: player>
	player value: player selection.! !

!CSpinnerListCostume methodsFor: 'events' stamp: 'ar 3/26/2004 04:14'!
onPlayerChanged
	super onPlayerChanged.
	self onCursorChanged.! !

!CSpinnerListCostume methodsFor: 'events' stamp: 'ar 10/8/2005 13:11'!
onSpinDown
	<on: spinDown in: spinner>
	player next.! !

!CSpinnerListCostume methodsFor: 'events' stamp: 'ar 10/8/2005 13:11'!
onSpinUp
	<on: spinUp in: spinner>
	player prev.! !

!CSpinnerListCostume methodsFor: 'events' stamp: 'ar 10/8/2005 12:24'!
onValueChanged
	<on: valueChanged>
	label value: player value.! !

!CSpinnerListCostume methodsFor: 'initialize' stamp: 'ar 10/8/2005 13:06'!
setupCostume
	super setupCostume.
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self extent: 100@5.

	self layout: CTableLayout new.
	self layout listDirection: #leftToRight.
	self vResizing: #shrinkWrap.
	self add: label.
	self add: spinner.! !

!CSpinnerListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
spinner
	"Answer the spinner of the receiver"
	<bewareOf: #spinnerChanged>
	^self propertyValueAt: #spinner! !

!CSpinnerListCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:31'!
spinner: aValue
	"Modify the receiver's spinner"
	^self propertyValueAt: #spinner put: aValue with: #spinnerChanged! !

!CSpinnerListCostume methodsFor: 'accessing' stamp: 'ar 12/10/2005 20:52'!
vResizing: aSymbol
	costume vResizing: aSymbol.
	label vResizing: aSymbol.! !

CWidgetCostume subclass: #CTabButtonListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists-Costumes'!

CTabButtonListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="selectedPlayer" toSet="selectedPlayer:" changeEvent="selectedPlayerChanged">selectedPlayer</field>
</fields>'!

!CTabButtonListCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:12'!
cssTag
	"Answer the receiver's default css tag"
	^#tablist! !

!CTabButtonListCostume methodsFor: 'initialize' stamp: 'ar 3/13/2004 05:50'!
defaultColor
	^Color transparent! !

!CTabButtonListCostume methodsFor: 'initialize' stamp: 'ar 3/13/2004 22:35'!
defaultPlayer
	^CTabButtonList! !

!CTabButtonListCostume methodsFor: 'events' stamp: 'ar 3/30/2004 03:29'!
onButtonSelected
	<on: cursorChanged in: elements>
	player selection: elements selection value.! !

!CTabButtonListCostume methodsFor: 'events' stamp: 'ar 3/30/2004 03:25'!
onCursorChanged
	<on: cursorChanged in: player>
	player cursor > 0 
		ifTrue:[(elements at: player cursor) select].! !

!CTabButtonListCostume methodsFor: 'events' stamp: 'be 8/30/2005 13:43'!
onItemsChanged
	| button itemMaker |
	<on: changed in: player>
	itemMaker := player itemMaker ifNil:[CTabButton].
	elements := player items collect:[:each|
		button := itemMaker new.
		button listItemValue: each. "see comment in listItemValue:"
		button label: each displayText.
		button styleSheet: self styleSheet.
		button group: elements.
		button].
	self onCursorChanged.! !

!CTabButtonListCostume methodsFor: 'events' stamp: 'ar 5/10/2005 17:26'!
onItemsChangedInPlayer
	"There should be no need for subclasses to override this method;
	It merely ensures that changes in the player are propagated accordingly."
	<on: itemsChanged in: player>
	self onItemsChanged.! !

!CTabButtonListCostume methodsFor: 'events' stamp: 'ar 3/14/2005 22:50'!
onPlayerChanged
	super onPlayerChanged.
	self onItemsChanged.! !

!CTabButtonListCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:31'!
onStyleSheetChanged
	self elements do:[:each | each styleSheet: self styleSheet].
	super onStyleSheetChanged.! !

!CTabButtonListCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 04:57'!
selectedPlayer
	"Answer the selectedPlayer of the receiver"
	<bewareOf: #selectedPlayerChanged>
	^self propertyValueAt: #selectedPlayer! !

!CTabButtonListCostume methodsFor: 'accessing' stamp: 'ar 3/13/2004 04:57'!
selectedPlayer: aValue
	"Modify the receiver's selectedPlayer"
	^self propertyValueAt: #selectedPlayer put: aValue with: #selectedPlayerChanged! !

!CTabButtonListCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:54'!
setupCostume
	"Initial tweaks which really should go away before too long"
	super setupCostume.
	self layout: CTableLayout new.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight.
	self layout layoutInset: (0@0 corner: 0@-1).! !

CWidgetCostume subclass: #CTextEditorCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text-Costumes'!

!CTextEditorCostume commentStamp: 'ar 3/27/2004 19:15' prior: 0!
CTextEditorCostume is a costume for a text editor which provides no scrollbars.!

CTextEditorCostume subclass: #CInputFieldCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text-Costumes'!

CInputFieldCostume defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CInputFieldCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:12'!
cssTag
	"Answer the receiver's default css tag"
	^#textbox! !

!CInputFieldCostume methodsFor: 'initialize' stamp: 'ar 3/12/2004 14:22'!
defaultPlayer
	^CInputField! !

!CInputFieldCostume methodsFor: 'events' stamp: 'ar 3/27/2004 19:14'!
onKeyboardFocusEnter
	"Select all of the text when the user clicks in the input field"
	player selectAll.
	super onKeyboardFocusEnter.! !

!CInputFieldCostume methodsFor: 'events' stamp: 'ar 7/7/2005 10:16'!
onKeyboardFocusLeave
	"UnSelect all of the text when the user clicks in the input field"
	player selectFrom: 0 to: 0.
	super onKeyboardFocusLeave.! !

!CInputFieldCostume methodsFor: 'initialize' stamp: 'ar 8/18/2007 20:20'!
setupCostume
	super setupCostume.
	self textEnabled: true. "force text"
	self hResizing: #spaceFill.
	self vResizing: #shrinkWrap.
	self textAnchorPoint: #topLeft.
	self textWrap: false.
! !

CTextEditorCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="oldBorder" toSet="oldBorder:" changeEvent="oldBorderChanged">oldBorder</field>
</fields>'!

!CTextEditorCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:12'!
cssTag
	"Answer the receiver's default css tag"
	^#texteditor! !

!CTextEditorCostume methodsFor: 'initialize' stamp: 'ar 3/25/2004 15:51'!
defaultPlayer
	^CTextEditor! !

!CTextEditorCostume methodsFor: 'accessing' stamp: 'ar 5/6/2004 16:37'!
oldBorder
	"Answer the oldBorder of the receiver"
	<bewareOf: #oldBorderChanged>
	^self propertyValueAt: #oldBorder! !

!CTextEditorCostume methodsFor: 'accessing' stamp: 'ar 5/6/2004 16:37'!
oldBorder: aValue
	"Modify the receiver's oldBorder"
	^self propertyValueAt: #oldBorder put: aValue with: #oldBorderChanged! !

!CTextEditorCostume methodsFor: 'events' stamp: 'ar 5/6/2004 16:38'!
onKeyboardFocusEnter
	"only accept input while having the keyboard focus"
	<on: keyboardFocusEnter in: player>
	oldBorder := border copy.
	oldBorder width > 0 ifTrue:[
		borderStyle := #inset.
		borderWidth := 1 max: oldBorder width.
		borderColor isTransparent 
			ifTrue:[borderColor := Color gray: 0.5].
	].
! !

!CTextEditorCostume methodsFor: 'events' stamp: 'ar 5/6/2004 16:38'!
onKeyboardFocusLeave
	"only accept input while having the keyboard focus"
	<on: keyboardFocusLeave in: player>
	border := oldBorder.
! !

!CTextEditorCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:54'!
setupCostume
	super setupCostume.
	self text: ''.
	self mouseCursor: Cursor text.
	self borderWidth: 1.
	self borderColor: CWidgetLibrary default frameColor.
	self borderStyle: #simple.
	self textAnchorPoint: #topLeft.
	self textWrap: true.! !

CWidgetCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="styleSheet" toSet="styleSheet:" changeEvent="styleSheetChanged">styleSheet</field>
	<field toGet="cssTag" toSet="cssTag:" changeEvent="cssTagChanged">cssTag</field>
</fields>'!

!CWidgetCostume class methodsFor: 'styling' stamp: 'ar 7/7/2005 09:08'!
cssTag
	"Answer the receiver's default css tag"
	^#widget! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/6/2005 18:37'!
backColor
	"Answer the receiver's backColor"
	^self fillColor! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/6/2005 18:38'!
backColor2
	"Answer the receivers gradient back color"
	^ self fillColors size > 1 ifTrue:[self fillColors second]
		ifFalse:[^self fillColor]! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/6/2005 18:38'!
backColor2: aColor
	"Set the receiver's gradient back color"
	self fillColors: (Array with:(self fillColor) with: aColor)! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/6/2005 18:38'!
backColor: aColor
	"Set the receiver's backColor"
	self fillColors size > 1 
		ifTrue:[self fillColors: (Array with:aColor with: self fillColors second)]
		ifFalse:[self fillColor: aColor]! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/7/2005 09:13'!
css
	"backward compatibility"
	^self styleSheet! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/7/2005 09:13'!
css: aStyleSheet
	"backward compatibility"
	^self styleSheet: aStyleSheet! !

!CWidgetCostume methodsFor: 'accessing' stamp: 'ar 7/7/2005 09:07'!
cssTag
	"Answer the cssTag of the receiver"
	<bewareOf: #cssTagChanged>
	^(self propertyValueAt: #cssTag) ifNil:[self class cssTag]! !

!CWidgetCostume methodsFor: 'accessing' stamp: 'ar 7/6/2005 18:37'!
cssTag: aValue
	"Modify the receiver's cssTag"
	^self propertyValueAt: #cssTag put: aValue with: #cssTagChanged! !

!CWidgetCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:02'!
defaultPlayer
	^CWidget! !

!CWidgetCostume methodsFor: 'accessing' stamp: 'ar 2/29/2004 22:46'!
enabled
	^self player enabled! !

!CWidgetCostume methodsFor: 'accessing' stamp: 'ar 2/29/2004 22:46'!
enabled: aBool
	^self player enabled: aBool! !

!CWidgetCostume methodsFor: 'initialize' stamp: 'ar 7/7/2005 09:15'!
initStyle
	| css |
	(css := self styleSheet) ifNotNil:[css initialApplyTo: self].! !

!CWidgetCostume methodsFor: 'accessing' stamp: 'ar 2/29/2004 22:46'!
label
	^self player label! !

!CWidgetCostume methodsFor: 'accessing' stamp: 'ar 2/29/2004 22:47'!
label: aString
	self player label: aString! !

!CWidgetCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:33'!
onCssTagChanged
	<on: cssTagChanged>
	self initStyle.! !

!CWidgetCostume methodsFor: 'events' stamp: 'ar 7/7/2005 09:23'!
onStyleSheetChanged
	<on: styleSheetChanged>
	self initStyle.! !

!CWidgetCostume methodsFor: 'initialize' stamp: 'ar 7/7/2005 11:47'!
setupCostume
	| css |
	super setupCostume.
	(css := self styleSheet) ifNil:["query for default css"
		"css := CWidgetLibrary default styleSheetFor: self."
		css ifNotNil:[self styleSheet: css].
	].! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/7/2005 13:14'!
state
	^self visualState! !

!CWidgetCostume methodsFor: 'accessing' stamp: 'ar 7/6/2005 18:37'!
styleSheet
	"Answer the styleSheet of the receiver"
	<bewareOf: #styleSheetChanged>
	^self propertyValueAt: #styleSheet! !

!CWidgetCostume methodsFor: 'accessing' stamp: 'ar 7/6/2005 18:37'!
styleSheet: aValue
	"Modify the receiver's styleSheet"
	^self propertyValueAt: #styleSheet put: aValue with: #styleSheetChanged! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/6/2005 18:39'!
textOffsetX
	"Answer the receiver's x offset"
	^self textOffset x! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/6/2005 18:40'!
textOffsetX: aValue
	"Set the receiver's text offset"
	self textOffset: (aValue @ self textOffsetY)! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/6/2005 18:40'!
textOffsetY
	"Answer the receiver's text x offset"
	^self textOffset y! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/6/2005 18:40'!
textOffsetY: aValue
	"Set the receiver's text offset"
	self textOffset: (self textOffsetY @ aValue)! !

!CWidgetCostume methodsFor: 'initialize' stamp: 'ar 7/7/2005 09:35'!
updateStyle
	"Update myself from the style sheet"
	| css |
	(css := self styleSheet) ifNotNil:[css applyTo: self].! !

!CWidgetCostume methodsFor: 'styling' stamp: 'ar 7/7/2005 13:06'!
visualState
	"Answer the visual state selector for the receiver."
	^nil! !

CWidgetCostume subclass: #CWindowCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic-Costumes'!

CWindowCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="windowFrame" toSet="windowFrame:" changeEvent="windowFrameChanged">windowFrame</field>
	<field toGet="backPage" toSet="backPage:" changeEvent="backPageChanged">backPage</field>
	<field toGet="frontPage" toSet="frontPage:" changeEvent="frontPageChanged">frontPage</field>
	<field toGet="normalBounds" toSet="normalBounds:" changeEvent="normalBoundsChanged">normalBounds</field>
</fields>'!

!CWindowCostume methodsFor: 'animating' stamp: 'ar 6/24/2005 21:09'!
animateBoundsFrom: rect1 to: rect2
	"Show an animation from rect1 to rect2"
	| rect deltaPos deltaExt pos ext maxSteps time |
	rect := CPlayer new.
	rect borderWidth: 4; borderStyle: #simple; borderColor: self borderColor.
	rect roundCornerSpec: self roundCornerSpec.
	deltaPos := rect2 origin - rect1 origin.
	deltaExt := rect2 extent - rect1 extent.
	container add: rect.
	maxSteps := 5.
	rect bounds: self bounds.
	time := [self waitTick] timeToRun max: 1. "measure roughly how fast machine is"
	maxSteps := 250 // time max: 3.
	1 to: maxSteps do:[:i|
		pos := rect1 origin + (deltaPos * i // maxSteps).
		ext := rect1 extent + (deltaExt * i // maxSteps).
		rect topLeft: pos.
		rect extent: ext.
		self waitTick.
	].
	rect close.! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:28'!
backPage
	"Answer the backPage of the receiver"
	<bewareOf: #backPageChanged>
	^self propertyValueAt: #backPage! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:28'!
backPage: aValue
	"Modify the receiver's backPage"
	^self propertyValueAt: #backPage put: aValue with: #backPageChanged! !

!CWindowCostume methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 12:02'!
collapse
	"Delegate collapseRequest to the model if it is interested"
	| newWidth newHeight newExtent box pos |
	self isCollapsed ifTrue:[^self]. "already collapsed"
	self isExpanded ifTrue:[self restore]. "restore" 
	newWidth := width + windowFrame asPrimCostume minExtent x - windowFrame width.
	newWidth := newWidth max: 200.
	newHeight := height - frontPage height.
	newExtent := newWidth@newHeight.
	true ifTrue:[
		"DEFAULT: Collapse at proposed position"
		pos := CWindowManager default altCollapsePositionFor: self.
		box := pos x @ (pos y - newExtent y) extent: newExtent.
	].
	false ifTrue:[
		"EXPERIMENTAL: Collapse so that center is under mouse:"
		box := container cursorPoint - (newExtent // 2) extent: newExtent.
	].
	self animateBoundsFrom: bounds to: box.
	normalBounds ifNil:[normalBounds := bounds].
	frontPage visible: false.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self dropShadowEnabled: false.
	bounds := box.! !

!CWindowCostume methodsFor: 'initialize' stamp: 'ar 3/14/2004 23:56'!
defaultColor
	^CWidgetLibrary default paneColor! !

!CWindowCostume methodsFor: 'initialize' stamp: 'ar 3/7/2004 22:02'!
defaultPlayer
	^CWindow! !

!CWindowCostume methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 12:04'!
expand
	| box |
	self isExpanded ifTrue:[^self].
	self isCollapsed ifTrue:[self restore; waitTick]. "restore"
	box := self world localBounds.
	normalBounds := bounds.
	self animateBoundsFrom: bounds to: box.
	bounds := box.! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 18:50'!
frontPage
	"Answer the frontPage of the receiver"
	<bewareOf: #frontPageChanged>
	^self propertyValueAt: #frontPage! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 18:50'!
frontPage: aValue
	"Modify the receiver's frontPage"
	^self propertyValueAt: #frontPage put: aValue with: #frontPageChanged! !

!CWindowCostume methodsFor: 'initialize' stamp: 'ar 2/4/2005 10:59'!
initialize
	| resizer |
	super initialize.
	self define: #windowFrame as: CWidgetLibrary default windowFrame new.
	frontPage := CHolder new.
	backPage := CPlayer new.

	"ar 4/30/2004:
	Hm... this is certainly not correct but I don't quite understand how it needs to work.
	Shouldn't we rather keep the resize behavior around as a component?
	It would allow us for example, to enable/disable resizing merely by turning
	it on or off (e.g., setting/resetting the target)."
	resizer := CWindowResizeBehavior attachTo: self.
	resizer automaticDragging: false.
! !

!CWindowCostume methodsFor: 'testing' stamp: 'ar 12/20/2004 21:07'!
isCollapsed
	"Answer whether this window is in the 'collapsed' state"
	^frontPage visible not! !

!CWindowCostume methodsFor: 'testing' stamp: 'ar 12/20/2004 21:06'!
isExpanded
	"Answer whether this window is in the 'expanded' state"
	^(self isNormal or:[self isCollapsed]) not! !

!CWindowCostume methodsFor: 'testing' stamp: 'ar 12/20/2004 21:06'!
isNormal
	"Answer whether this window is in the 'normal' state"
	^normalBounds == nil! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/24/2004 18:59'!
layout
	"Use my frontPage's layout"
	^frontPage layout! !

!CWindowCostume methodsFor: 'accessing' stamp: 'bf 3/30/2004 11:35'!
layout: aLayout
	"Use my frontPage's layout"
	^frontPage layout: aLayout! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 12/20/2004 20:01'!
normalBounds
	"Answer the normalBounds of the receiver"
	<bewareOf: #normalBoundsChanged>
	^self propertyValueAt: #normalBounds! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 12/20/2004 20:01'!
normalBounds: aValue
	"Modify the receiver's normalBounds"
	^self propertyValueAt: #normalBounds put: aValue with: #normalBoundsChanged! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 12/20/2004 23:42'!
onActivate
	<on: activate in: player>
	frontPage locked: false.
	windowFrame activate.
! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 6/19/2005 12:08'!
onClose
	<on: closeRequest in: windowFrame>
	(player handlesEvent: #closeRequest)
		ifTrue:[player signal: #closeRequest]
		ifFalse:[player close].! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 2/18/2004 13:38'!
onCloseBoxChanged
	<on: closeBoxChanged in: player>
	windowFrame closeBox: player closeBox.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 6/19/2005 11:54'!
onCollapseRequest
	"Delegate collapseRequest to the model if it is interested"
	<on: collapseRequest in: windowFrame>
	(player handlesEvent: #collapseRequest)
		ifTrue:[^player signal: #collapseRequest].
	(player windowState == #normal) 
		ifTrue:[player windowState := #collapsed]
		ifFalse:[player windowState := #normal].! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 2/4/2005 11:01'!
onContentPaneChanged
	<on: contentPaneChanged in: player>
	elements replace: frontPage with: player contentPane.
	frontPage := player contentPane.
	frontPage clipping: true.
	frontPage hResizing: #spaceFill.
	frontPage vResizing: #spaceFill.
! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 5/22/2005 12:33'!
onDragEnter
	"Allow drag and drop transaction while not the active window"
	| wasLocked |
	<on: dragEnter>
	wasLocked := frontPage locked.
	frontPage locked: false.
	self waitUntil: #dragLeave.
	frontPage locked: wasLocked.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 6/19/2005 11:54'!
onExpandRequest
	"Delegate collapseRequest to the model if it is interested"
	<on: expandRequest in: windowFrame>
	(player handlesEvent: #expandRequest)
		ifTrue:[^player signal: #expandRequest].
	(player windowState == #normal)
		ifTrue:[player windowState := #expanded]
		ifFalse:[player windowState := #normal].
! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 6/19/2005 12:07'!
onFrameDoubleClick
	"Maximize or restore the receiver on double click. Note: This method must not interact badly with onFrameDrag (see comment there)."
	<on: mouseDoubleClick in: windowFrame>
	"Check for relabeling"
	Preferences doubleClickOnLabelToEdit ifTrue:[
		(windowFrame windowLabel containsPoint: 
			windowFrame windowLabel cursorPoint) ifTrue:[
				| newLabel |
				newLabel := self 
					request: 'New label?' 
					initialAnswer: player label.
				newLabel ifNotNil:[player label: newLabel].
				^self]].
	"Restore or expand accordingly"
	player isNormal ifTrue:[^player expand].
	player isExpanded ifTrue:[^player restore].
	player isCollapsed ifTrue:[^player restore].! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 5/24/2005 20:39'!
onFrameDrag
	"Drag this window. Note: This method does not use the dragStart event as one might perhaps expect for better UI feel (change it and try to drag a window around to see what I mean). Using #mouseDown makes this feel much nicer but we must make sure that we have no user-visible interactions with the doubleClick behavior (which we don't so we're fine here). Something to keep in mind if the drag behavior ever blows up and you wonder why strange things are happening: Check the interaction with onFrameDoubleClick!!"
	<on: mouseDown in: windowFrame>
	player beTopWindow.
	self isExpanded ifFalse:[self onDrag].! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 3/6/2004 21:08'!
onLabelChanged
	<on: labelChanged in: player>
	windowFrame label: player label.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 2/18/2004 13:38'!
onMaximizeBoxChanged
	<on: maximizeBoxChanged in: player>
	windowFrame maximizeBox: player maximizeBox.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 4/4/2004 18:42'!
onMenuBarChanged
	<on: menuBarChanged in: player>
	self onUpdateAll.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 2/18/2004 13:38'!
onMinimizeBoxChanged
	<on: minimizeBoxChanged in: player>
	windowFrame minimizeBox: player minimizeBox.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 5/24/2005 20:40'!
onMouseDown
	"Raise the window on mouse down"
	| focus floater |
	<on: mouseDown>
	player beTopWindow.
	floater := container elements detect: [:each | each floating].
	(floater == nil or:[self floating])
		ifTrue:[container add: self]
		ifFalse:[container add: self before: floater].
	focus := hand keyboardFocus.
	focus ifNotNil:[
		(focus asPrimCostume isIn: self asPrimCostume) 
			ifFalse:[hand keyboardFocus: nil].
	].! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 5/24/2005 20:40'!
onOpen
	<on: open>
	player beTopWindow.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 12/20/2004 23:42'!
onPassivate
	<on: passivate in: player>
	windowFrame passivate.
	frontPage locked: true.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 2/4/2005 10:41'!
onPlayerChanged
	super onPlayerChanged.
	self onContentPaneChanged.
	self onMinimizeBoxChanged.
	self onMaximizeBoxChanged.
	self onCloseBoxChanged.
	self onLabelChanged.
	self onUpdateAll.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 4/4/2004 18:42'!
onStatusBarChanged
	<on: statusBarChanged in: player>
	self onUpdateAll.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 4/4/2004 18:42'!
onToolBarChanged
	<on: toolBarChanged in: player>
	self onUpdateAll.! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 4/4/2004 18:42'!
onUpdateAll
	self removeAll.
	self add: windowFrame.
	player menuBar ifNotNil:[self add: player menuBar].
	player toolBar ifNotNil:[self add: player toolBar].
	self add: backPage.
	self add: frontPage.
	player statusBar ifNotNil:[self add: player statusBar].! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 5/24/2005 20:43'!
onWindowFrameChanged
	<on: windowFrameChanged>
	self addFirst: windowFrame.
	self onMinimizeBoxChanged.
	self onMaximizeBoxChanged.
	self onCloseBoxChanged.
	self onLabelChanged.
	windowFrame windowColor: player windowColor.
	player isTopWindow ifFalse:[windowFrame passivate].! !

!CWindowCostume methodsFor: 'events' stamp: 'ar 6/19/2005 11:56'!
onWindowStateChanged
	"Delegate collapseRequest to the model if it is interested"
	<on: windowStateChanged in: player>
	(player windowState == #normal) ifTrue:[self restore].
	(player windowState == #collapsed) ifTrue:[self collapse].
	(player windowState == #expanded) ifTrue:[self expand].! !

!CWindowCostume methodsFor: 'serializing' stamp: 'ar 3/25/2004 23:56'!
readFieldsOn: deSerializer
	super readFieldsOn: deSerializer.
	frontPage elements: (deSerializer readField: #windowContents).! !

!CWindowCostume methodsFor: 'expand/collapse' stamp: 'ar 6/19/2005 12:06'!
restore
	self isNormal ifTrue:[^self].
	self animateBoundsFrom: bounds to: normalBounds.
	bounds := normalBounds.
	frontPage visible: true.
	self hResizing: #rigid; vResizing: #rigid.
	self dropShadowEnabled: true.
	normalBounds := nil.
! !

!CWindowCostume methodsFor: 'initialize' stamp: 'ar 2/7/2005 17:52'!
setupCostume
	super setupCostume.
	self floating: true.
	self asPrimCostume localCache: CFormCache new.
	self dropShadowEnabled: true.

	self extent: 200@200.
	self add: windowFrame.
	self add: backPage.
	self borderStyle: #raised.
	self borderWidth: CWidgetLibrary default windowBorderWidth.
	self borderColor: CWidgetLibrary default frameColor.
	self roundCornerSpec: #(1 4).
	self add: frontPage.

	frontPage color: Color white.
	frontPage clipping: true.
	frontPage hResizing: #spaceFill.
	frontPage vResizing: #spaceFill.

	backPage extent: 100@100.
	backPage visible: false.

	costume layout: CTableLayout new.
	costume vResizing: #shrinkWrap.
! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 2/4/2005 20:55'!
windowColor: aColor
	self borderColor: aColor.
	self color: aColor veryMuchLighter.
	windowFrame windowColor: aColor.! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/25/2004 23:54'!
windowContents
	^frontPage elements! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:28'!
windowFrame
	"Answer the windowFrame of the receiver"
	<bewareOf: #windowFrameChanged>
	^self propertyValueAt: #windowFrame! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:28'!
windowFrame: aValue
	"Modify the receiver's windowFrame"
	^self propertyValueAt: #windowFrame put: aValue with: #windowFrameChanged! !

!CWindowCostume methodsFor: 'accessing' stamp: 'ar 3/25/2004 11:39'!
windowLayout
	^frontPage layout! !

!CWindowCostume methodsFor: 'accessing' stamp: 'bf 3/30/2004 11:37'!
windowLayout: aLayout
	^frontPage layout: aLayout! !

!CWindowCostume methodsFor: 'serializing' stamp: 'ar 3/25/2004 23:55'!
writeFieldsOn: aSerializer
	super writeFieldsOn: aSerializer.
	aSerializer writeField: #windowContents value: self windowContents.
! !

!FileDirectory methodsFor: '*Tweak-Widgets' stamp: 'ar 1/22/2005 15:36'!
asTreeItem
	^CFileDirectoryTreeItem on: self! !

TextAttribute subclass: #CBalloonTextAttribute
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Text'!

!CBalloonTextAttribute commentStamp: 'tk 7/29/2004 15:59' prior: 0!
An attribute of text that holds the text for a balloon.  A script might put up the balloon on mouseOver of this attribute a text.  The balloon might be for explaining something referred to in the text.  See CPlayer>>openHowToBuild

text		The string or text to put into the balloon.!

!CBalloonTextAttribute methodsFor: 'accessing' stamp: 'tk 7/29/2004 16:00'!
text
	"Answer the value of text"

	^ text! !

!CBalloonTextAttribute methodsFor: 'accessing' stamp: 'tk 7/29/2004 16:00'!
text: anObject
	"Set the value of text"

	text := anObject! !

CObject subclass: #CDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

!CDialog commentStamp: 'ar 3/27/2004 17:55' prior: 0!
CDialog is a facade to allow redirection of certain UI requests to specific clients. It is never instantiated nor subclassed.!

CDialog defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CDialog class methodsFor: 'debugging' stamp: 'ar 3/13/2004 15:21'!
abortRetryDebug: anException
	"Raise a dialog giving the user the chance to abort, retry, or debug an exception"
	^self abortRetryDebug: anException centerAt: nil! !

!CDialog class methodsFor: 'debugging' stamp: 'ar 3/13/2004 15:28'!
abortRetryDebug: anException centerAt: aPoint
	"Raise a dialog giving the user the chance to abort, retry, or debug an exception"
	^self abortRetryDebug: anException 
		label:  'An problem has occurred:'
		centerAt: aPoint! !

!CDialog class methodsFor: 'debugging' stamp: 'ar 3/13/2004 15:22'!
abortRetryDebug: anException label: labelString
	"Raise a dialog giving the user the chance to abort, retry, or debug an exception"
	^self abortRetryDebug: anException 
		label: labelString
		centerAt: nil.! !

!CDialog class methodsFor: 'debugging' stamp: 'ar 3/13/2004 15:22'!
abortRetryDebug: anException label: labelString centerAt: aPoint
	"Raise a dialog giving the user the chance to abort, retry, or debug an exception"
	^CUserDialog new abortRetryDebug: anException label: labelString centerAt: aPoint! !

!CDialog class methodsFor: 'confirming' stamp: 'ar 3/13/2004 15:14'!
confirm: aString
	^self confirm: aString centerAt: nil! !

!CDialog class methodsFor: 'confirming' stamp: 'ar 3/13/2004 15:13'!
confirm: aString centerAt: aPoint
	^self confirm: aString label:'Attention:' centerAt: aPoint! !

!CDialog class methodsFor: 'confirming' stamp: 'ar 3/13/2004 15:14'!
confirm: aString label: labelString
	^self confirm: aString label: labelString centerAt: nil! !

!CDialog class methodsFor: 'confirming' stamp: 'bgf 3/29/2008 22:20'!
confirm: aString label: labelString centerAt: aPoint
	"The general-purpose confirm dialog uses OK / Cancel buttons."
	^ self confirm: aString yes: 'OK' no: 'Cancel' label: labelString centerAt: aPoint! !

!CDialog class methodsFor: 'confirming' stamp: 'bgf 12/7/2008 15:46'!
confirm: aString yes: yesLabel no: noLabel cancel: canLabel label: labelString centerAt: aPoint
	^CUserDialog new confirm: aString yes: yesLabel no: noLabel cancel: canLabel label: labelString centerAt: aPoint! !

!CDialog class methodsFor: 'confirming' stamp: 'bgf 3/29/2008 22:19'!
confirm: aString yes: yesLabel no: noLabel label: labelString
	^ self confirm: aString yes: yesLabel no: noLabel label: labelString centerAt: nil! !

!CDialog class methodsFor: 'confirming' stamp: 'bgf 3/29/2008 22:18'!
confirm: aString yes: yesLabel no: noLabel label: labelString centerAt: aPoint
	^CUserDialog new confirm: aString yes: yesLabel no: noLabel label: labelString centerAt: aPoint! !

!CDialog class methodsFor: 'informing' stamp: 'ar 3/13/2004 15:13'!
inform: aString
	^self inform: aString centerAt: nil! !

!CDialog class methodsFor: 'informing' stamp: 'jcg 11/17/2009 15:20'!
inform: aString centerAt: aPoint
	^self inform: aString label: 'Note' centerAt: aPoint! !

!CDialog class methodsFor: 'informing' stamp: 'ar 3/13/2004 15:13'!
inform: aString label: labelString
	^self inform: aString label: labelString centerAt: nil! !

!CDialog class methodsFor: 'informing' stamp: 'ar 3/13/2004 16:45'!
inform: aString label: labelString centerAt: aPoint
	^CUserDialog new inform: aString label: labelString centerAt: aPoint! !

!CDialog class methodsFor: 'instance creation' stamp: 'ar 7/29/2004 13:42'!
new
	"See the class comment"
	^self shouldNotImplement! !

!CDialog class methodsFor: 'requesting' stamp: 'ar 3/13/2004 15:11'!
request: aString
	^self request: aString initialAnswer: nil! !

!CDialog class methodsFor: 'requesting' stamp: 'ar 3/13/2004 15:11'!
request: aString centerAt: aPoint
	^self request: aString initialAnswer: nil centerAt: aPoint! !

!CDialog class methodsFor: 'requesting' stamp: 'ar 3/13/2004 15:11'!
request: aString initialAnswer: default
	^self request: aString initialAnswer: default centerAt: nil! !

!CDialog class methodsFor: 'requesting' stamp: 'ar 3/13/2004 15:10'!
request: aString initialAnswer: default centerAt: aPoint
	^CUserDialog new request: aString initialAnswer: default centerAt: aPoint! !

!CDialog class methodsFor: 'requesting' stamp: 'ar 3/13/2004 15:12'!
requestPassword: queryString
	^self requestPassword: queryString centerAt: nil! !

!CDialog class methodsFor: 'requesting' stamp: 'ar 3/13/2004 15:16'!
requestPassword: queryString centerAt: aPoint
	^CUserDialog new requestPassword: queryString centerAt: aPoint! !

CObject subclass: #CImageButtonSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Buttons'!

!CImageButtonSet commentStamp: '<historical>' prior: 0!
A set of images used by CImageButton.!

CImageButtonSet defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="disabledImage" toSet="disabledImage:" changeEvent="disabledImageChanged">disabledImage</field>
	<field toGet="normalImage" toSet="normalImage:" changeEvent="normalImageChanged">normalImage</field>
	<field toGet="overImage" toSet="overImage:" changeEvent="overImageChanged">overImage</field>
	<field toGet="pressedImage" toSet="pressedImage:" changeEvent="pressedImageChanged">pressedImage</field>
</fields>'!

!CImageButtonSet methodsFor: 'initialize' stamp: 'ar 12/18/2006 12:44'!
defaultImage: aForm
	"Initialize the receiver with the given form"
	normalImage := aForm.
	overImage := aForm.
	pressedImage := aForm.
	disabledImage := aForm.! !

!CImageButtonSet methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:18'!
disabledImage
	"Answer the disabledImage of the receiver"
	<bewareOf: #disabledImageChanged>
	^self propertyValueAt: #disabledImage! !

!CImageButtonSet methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:18'!
disabledImage: aValue
	"Modify the receiver's disabledImage"
	^self propertyValueAt: #disabledImage put: aValue with: #disabledImageChanged! !

!CImageButtonSet methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:18'!
normalImage
	"Answer the normalImage of the receiver"
	<bewareOf: #normalImageChanged>
	^self propertyValueAt: #normalImage! !

!CImageButtonSet methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:18'!
normalImage: aValue
	"Modify the receiver's normalImage"
	^self propertyValueAt: #normalImage put: aValue with: #normalImageChanged! !

!CImageButtonSet methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:18'!
overImage
	"Answer the overImage of the receiver"
	<bewareOf: #overImageChanged>
	^self propertyValueAt: #overImage! !

!CImageButtonSet methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:18'!
overImage: aValue
	"Modify the receiver's overImage"
	^self propertyValueAt: #overImage put: aValue with: #overImageChanged! !

!CImageButtonSet methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:18'!
pressedImage
	"Answer the pressedImage of the receiver"
	<bewareOf: #pressedImageChanged>
	^self propertyValueAt: #pressedImage! !

!CImageButtonSet methodsFor: 'accessing' stamp: 'ar 12/18/2006 12:18'!
pressedImage: aValue
	"Modify the receiver's pressedImage"
	^self propertyValueAt: #pressedImage put: aValue with: #pressedImageChanged! !

CObject subclass: #CMultiColumnListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Lists'!

CMultiColumnListSpec defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="action" toSet="action:" changeEvent="actionChanged">action</field>
	<field toGet="color" toSet="color:" changeEvent="colorChanged">color</field>
	<field toGet="drawSelector" toSet="drawSelector:" changeEvent="drawSelectorChanged">drawSelector</field>
	<field toGet="drawer" toSet="drawer:" changeEvent="drawerChanged">drawer</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="width" toSet="width:" changeEvent="widthChanged">width</field>
</fields>'!

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:06'!
action
	"Answer the action of the receiver"
	<bewareOf: #actionChanged>
	^self propertyValueAt: #action! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:49'!
action: aValue
	"Modify the receiver's action"
	^self propertyValueAt: #action put: aValue with: #actionChanged! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:06'!
color
	"Answer the color of the receiver"
	<bewareOf: #colorChanged>
	^self propertyValueAt: #color! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:49'!
color: aValue
	"Modify the receiver's color"
	^self propertyValueAt: #color put: aValue with: #colorChanged! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:06'!
drawSelector
	"Answer the drawSelector of the receiver"
	<bewareOf: #drawSelectorChanged>
	^self propertyValueAt: #drawSelector! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:49'!
drawSelector: aValue
	"Modify the receiver's drawSelector"
	^self propertyValueAt: #drawSelector put: aValue with: #drawSelectorChanged! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:06'!
drawer
	"Answer the drawer of the receiver"
	<bewareOf: #drawerChanged>
	^self propertyValueAt: #drawer! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:49'!
drawer: aValue
	"Modify the receiver's drawer"
	^self propertyValueAt: #drawer put: aValue with: #drawerChanged! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:06'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:49'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 14:06'!
width
	"Answer the width of the receiver"
	<bewareOf: #widthChanged>
	^self propertyValueAt: #width! !

!CMultiColumnListSpec methodsFor: 'accessing' stamp: 'ar 3/12/2004 10:49'!
width: aValue
	"Modify the receiver's width"
	^self propertyValueAt: #width put: aValue with: #widthChanged! !

CObject subclass: #CWindowManager
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

!CWindowManager commentStamp: 'ar 12/20/2004 18:39' prior: 0!
A window manager is responsible for certain management functions such as handling collapse request etc.!

CWindowManager defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CWindowManager class methodsFor: 'accessing' stamp: 'ar 12/20/2004 18:37'!
default
	^Default ifNil:[self new].! !

!CWindowManager class methodsFor: 'accessing' stamp: 'ar 12/20/2004 18:38'!
default: aWindowManager
	Default := aWindowManager! !

!CWindowManager methodsFor: 'window collapsing' stamp: 'ar 5/22/2005 18:07'!
altCollapsePositionFor: aWindow
	"Offer up a location along the left edge of the screen for a collapsed window. Make sure it doesn't overlap any other collapsed frames."
	| otherFrames viewBox other bottomLeft top |
	otherFrames := (self windowsIn: aWindow container 
						satisfying: [:w | w ~= aWindow])
							collect: [:w | w bounds].
	viewBox := aWindow container localBounds.
	top := viewBox bottom.
	[top > viewBox top] whileTrue:[
		bottomLeft := viewBox left@top.
		[other := otherFrames detect:[:any| any bottomLeft = bottomLeft] ifNone:[nil].
		other notNil and:[other right + 100 < viewBox right]] whileTrue:[
			top := top min: other top.
			bottomLeft := other bottomRight.
		].
		other ifNil:[^bottomLeft].
	].
	^aWindow bottomLeft! !

!CWindowManager methodsFor: 'window opening' stamp: 'ar 5/22/2005 18:07'!
boundsToOpen: aWindow in: aWorld
	"This method implements a staggered window placement policy that I (di) like.
	Basically it provides for up to 4 windows, staggered from each of the 4 corners.
	The windows are staggered so that there will always be a corner visible."

	| allowedArea grid initialFrame otherFrames cornerSel corner delta putativeCorner free maxLevel initialExtent |
	[aWindow layoutNeeded] "force layout computation NOW"
		whileTrue:[aWindow asPrimCostume fullBounds].
	initialExtent := aWindow fullBounds extent.
	allowedArea := aWorld localBounds.
	"Number to be staggered at each corner (less on small screens)"
	maxLevel := allowedArea area > 300000 ifTrue: [3] ifFalse: [2].
	"Amount by which to stagger (less on small screens)"
	grid := allowedArea area > 500000 ifTrue: [40] ifFalse: [20].
	initialFrame := allowedArea topLeft extent: ((initialExtent
							"min: (allowedArea extent - (grid*(maxLevel+1*2) + (grid//2))))
							min: 600@400")).
	otherFrames := (self windowsIn: aWorld) collect: [:w | w fullBounds].
	0 to: maxLevel do:[:level | 
		1 to: 4 do:[:ci | 
			cornerSel := #(topLeft topRight bottomRight bottomLeft) at: ci.
			corner := allowedArea perform: cornerSel.
			"The extra grid//2 in delta helps to keep title tabs distinct"
			delta := (maxLevel-level*grid+(grid//2)) @ (level*grid).
			1 to: ci-1 do: [:i | delta := delta rotateBy: #right centerAt: 0@0]. "slow way"
			putativeCorner := corner + delta.
			free := true.
			otherFrames do:[:w | free := free & ((w perform: cornerSel) ~= putativeCorner)].
			free ifTrue:[^ (initialFrame align: (initialFrame perform: cornerSel) with: putativeCorner) translatedAndSquishedToBeWithin: allowedArea]]].
	"If all else fails..."
	^(0@0 extent: initialFrame extent) translatedAndSquishedToBeWithin: allowedArea! !

!CWindowManager methodsFor: 'window collapsing' stamp: 'ar 5/22/2005 18:07'!
collapsePositionFor: aWindow
	"Offer up a location along the left edge of the screen for a collapsed window. Make sure it doesn't overlap any other collapsed frames."
	| otherFrames topLeft viewBox other |
	otherFrames := (self windowsIn: aWindow container 
						satisfying: [:w | w ~= aWindow])
							collect: [:w | w bounds].
	viewBox := aWindow container localBounds.
	topLeft := viewBox topLeft.
	[other := otherFrames detect:[:any| any topLeft = topLeft] ifNone:[nil].
	other notNil and:[other bottom < viewBox bottom]] whileTrue:[
		topLeft := other bottomLeft.
	].
	other ifNil:[^topLeft].
	"could try in another row but really don't care..."
	^aWindow topLeft! !

!CWindowManager methodsFor: 'window opening' stamp: 'ar 5/24/2005 19:19'!
open: aWindow
	| root |
	root := Processor activeProcess hand world.
	^self open: aWindow in: root! !

!CWindowManager methodsFor: 'window opening' stamp: 'ar 12/20/2004 19:22'!
open: aWindow in: aWorld
	"Place window on the screen; position appropriately"
	| frame |
	frame := self boundsToOpen: aWindow in: aWorld.
	frame extent = aWindow fullBounds extent ifFalse:[
		"The following is incorrect since it needs to apply to fullBounds instead of bounds. That's why we have the explicit test above since the case is exceptionally rare (only encountered on tiny displays) so we hope nobody will notice (ho, hum)."
		aWindow extent: frame extent
	].
	aWindow open: aWindow in: aWorld at: frame origin ! !

!CWindowManager methodsFor: 'window queries' stamp: 'ar 12/20/2004 19:05'!
windowsIn: aWorld
	^self windowsIn: aWorld satisfying:[:w| true].! !

!CWindowManager methodsFor: 'window queries' stamp: 'ar 12/20/2004 19:04'!
windowsIn: aWorld satisfying: windowBlock
	| windows |
	windows := OrderedCollection new.
	aWorld elements do:[:pp|
		[pp == nil] whileFalse:[
			((pp isKindOf: CWindow) and:[windowBlock value: pp]) ifTrue:[
				windows add: pp.
				pp := nil.
			] ifFalse:[ pp := pp getCostume].
		].
	].
	^windows! !

Exception subclass: #CProgressCancel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Widgets-Basic'!

!CProgressCancel methodsFor: 'accessing' stamp: 'ar 6/2/2007 21:54'!
defaultAction
	"Terminate the currently executing script"
	Processor activeProcess terminate.! !

!CProgressCancel methodsFor: 'accessing' stamp: 'ar 6/2/2007 21:59'!
isResumable
	"Cancels are not resumable"
	^false! !

!CProgressCancel methodsFor: 'accessing' stamp: 'ar 6/2/2007 21:55'!
messageText
	"Answer the message text for this exception"
	^messageText ifNil:['Operation canceled'].! !

!ServerDirectory methodsFor: '*Tweak-Widgets' stamp: 'ar 1/22/2005 15:36'!
asTreeItem
	^CServerDirectoryTreeItem on: self! !
CDefaultWidgetLibrary initialize!
CProgressBar initialize!
CTextEditor initialize!
CMenuCostume initialize!
CMenuCostume2 initialize!
CProgressBarCostume initialize!
